#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 5
#define STATE_COUNT 1432
#define SYMBOL_COUNT 118
#define ALIAS_COUNT 1
#define TOKEN_COUNT 75
#define EXTERNAL_TOKEN_COUNT 9
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym__simple_heredoc = 1,
  sym__heredoc_beginning = 2,
  sym__heredoc_middle = 3,
  sym__heredoc_end = 4,
  sym_file_descriptor = 5,
  sym__empty_value = 6,
  sym__concat = 7,
  sym_variable_name = 8,
  anon_sym_for = 9,
  anon_sym_in = 10,
  anon_sym_while = 11,
  anon_sym_do = 12,
  anon_sym_done = 13,
  anon_sym_if = 14,
  anon_sym_then = 15,
  anon_sym_fi = 16,
  anon_sym_elif = 17,
  anon_sym_else = 18,
  anon_sym_case = 19,
  anon_sym_esac = 20,
  anon_sym_PIPE = 21,
  anon_sym_RPAREN = 22,
  anon_sym_SEMI_SEMI = 23,
  anon_sym_function = 24,
  anon_sym_LPAREN = 25,
  anon_sym_LBRACE = 26,
  anon_sym_RBRACE = 27,
  anon_sym_PIPE_AMP = 28,
  anon_sym_AMP_AMP = 29,
  anon_sym_PIPE_PIPE = 30,
  anon_sym_LBRACK = 31,
  anon_sym_RBRACK = 32,
  anon_sym_LBRACK_LBRACK = 33,
  anon_sym_RBRACK_RBRACK = 34,
  anon_sym_local = 35,
  anon_sym_EQ = 36,
  anon_sym_PLUS_EQ = 37,
  anon_sym_LT = 38,
  anon_sym_GT = 39,
  anon_sym_GT_GT = 40,
  anon_sym_AMP_GT = 41,
  anon_sym_AMP_GT_GT = 42,
  anon_sym_LT_AMP = 43,
  anon_sym_GT_AMP = 44,
  anon_sym_LT_LT = 45,
  anon_sym_LT_LT_DASH = 46,
  anon_sym_DQUOTE = 47,
  aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH = 48,
  sym_raw_string = 49,
  anon_sym_DOLLAR = 50,
  anon_sym_DOLLAR_LBRACE = 51,
  anon_sym_POUND = 52,
  anon_sym_AT = 53,
  anon_sym_COLON = 54,
  anon_sym_COLON_QMARK = 55,
  anon_sym_COLON_DASH = 56,
  anon_sym_PERCENT = 57,
  anon_sym_SLASH = 58,
  anon_sym_DOLLAR_LPAREN = 59,
  anon_sym_BQUOTE = 60,
  anon_sym_LT_LPAREN = 61,
  anon_sym_GT_LPAREN = 62,
  sym_word = 63,
  sym_comment = 64,
  sym_simple_variable_name = 65,
  anon_sym_STAR = 66,
  anon_sym_QMARK = 67,
  anon_sym_DASH = 68,
  anon_sym_BANG = 69,
  anon_sym_0 = 70,
  anon_sym__ = 71,
  anon_sym_SEMI = 72,
  anon_sym_LF = 73,
  anon_sym_AMP = 74,
  sym_program = 75,
  sym__terminated_statement = 76,
  sym_for_statement = 77,
  sym_while_statement = 78,
  sym_do_group = 79,
  sym_if_statement = 80,
  sym_elif_clause = 81,
  sym_else_clause = 82,
  sym_case_statement = 83,
  sym_case_item = 84,
  sym_function_definition = 85,
  sym_compound_statement = 86,
  sym_subshell = 87,
  sym_pipeline = 88,
  sym_list = 89,
  sym_bracket_command = 90,
  sym_command = 91,
  sym_command_name = 92,
  sym_environment_variable_assignment = 93,
  sym_local_variable_declaration = 94,
  sym__assignment = 95,
  sym_subscript = 96,
  sym_file_redirect = 97,
  sym_heredoc_redirect = 98,
  sym_heredoc = 99,
  sym_concatenation = 100,
  sym_string = 101,
  sym_array = 102,
  sym_simple_expansion = 103,
  sym_expansion = 104,
  sym_command_substitution = 105,
  sym_process_substitution = 106,
  sym_special_variable_name = 107,
  aux_sym_program_repeat1 = 108,
  aux_sym_for_statement_repeat1 = 109,
  aux_sym_if_statement_repeat1 = 110,
  aux_sym_case_statement_repeat1 = 111,
  aux_sym_case_item_repeat1 = 112,
  aux_sym_command_repeat1 = 113,
  aux_sym_command_repeat2 = 114,
  aux_sym_heredoc_repeat1 = 115,
  aux_sym_concatenation_repeat1 = 116,
  aux_sym_string_repeat1 = 117,
  alias_sym_variable_name = 118,
};

static const char *ts_symbol_names[] = {
  [sym__simple_heredoc] = "_simple_heredoc",
  [sym__heredoc_beginning] = "_heredoc_beginning",
  [sym__heredoc_middle] = "_heredoc_middle",
  [sym__heredoc_end] = "_heredoc_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_local] = "local",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = "/[^\"`$]+/",
  [sym_raw_string] = "raw_string",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_POUND] = "#",
  [anon_sym_AT] = "@",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_word] = "word",
  [sym_comment] = "comment",
  [sym_simple_variable_name] = "simple_variable_name",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_bracket_command] = "bracket_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_environment_variable_assignment] = "environment_variable_assignment",
  [sym_local_variable_declaration] = "local_variable_declaration",
  [sym__assignment] = "_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc] = "heredoc",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [sym_special_variable_name] = "special_variable_name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_repeat1] = "heredoc_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [alias_sym_variable_name] = "variable_name",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__simple_heredoc] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_variable_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_bracket_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_environment_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_local_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_variable_name] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[3][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [1] = alias_sym_variable_name,
  },
  [2] = {
    [2] = alias_sym_variable_name,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '/')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == ':')
        ADVANCE(24);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '@')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(41);
      if (lookahead == '\\')
        SKIP(43);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '_')
        ADVANCE(46);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(6);
      if (lookahead == '{')
        ADVANCE(7);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 13:
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead != 0)
        ADVANCE(13);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 18:
      if (lookahead == '=')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_simple_variable_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(25);
      if (lookahead == '?')
        ADVANCE(26);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '(')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(32);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(36);
      if (lookahead == '(')
        ADVANCE(37);
      if (lookahead == '>')
        ADVANCE(38);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 43:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(50);
      if (lookahead == '|')
        ADVANCE(51);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 53:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'l')
        ADVANCE(78);
      if (lookahead == 'w')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(53);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(54);
      END_STATE();
    case 55:
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '(')
        ADVANCE(31);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(58);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 59:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 61:
      if (lookahead == '\n')
        SKIP(53);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'a')
        ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 's')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'o')
        ADVANCE(67);
      if (lookahead == 'u')
        ADVANCE(69);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'r')
        ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'n')
        ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'c')
        ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 't')
        ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'i')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'o')
        ADVANCE(74);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'n')
        ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(77);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'o')
        ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'c')
        ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'a')
        ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'l')
        ADVANCE(82);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_local);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'h')
        ADVANCE(84);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'l')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 88:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(89);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '/')
        ADVANCE(21);
      if (lookahead == ':')
        ADVANCE(24);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '@')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(90);
      if (lookahead == '\\')
        SKIP(91);
      if (lookahead == ']')
        ADVANCE(92);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(93);
      if (lookahead == 'e')
        ADVANCE(95);
      if (lookahead == 'f')
        ADVANCE(101);
      if (lookahead == 'i')
        ADVANCE(103);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(88);
      END_STATE();
    case 89:
      if (lookahead == '&')
        ADVANCE(10);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 91:
      if (lookahead == '\n')
        SKIP(88);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 93:
      if (lookahead == 'o')
        ADVANCE(94);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 95:
      if (lookahead == 'l')
        ADVANCE(96);
      END_STATE();
    case 96:
      if (lookahead == 'i')
        ADVANCE(97);
      if (lookahead == 's')
        ADVANCE(99);
      END_STATE();
    case 97:
      if (lookahead == 'f')
        ADVANCE(98);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 99:
      if (lookahead == 'e')
        ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 101:
      if (lookahead == 'i')
        ADVANCE(102);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 103:
      if (lookahead == 'n')
        ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 105:
      if (lookahead == 'h')
        ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == 'e')
        ADVANCE(107);
      END_STATE();
    case 107:
      if (lookahead == 'n')
        ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 109:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(109);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 110:
      if (lookahead == '\n')
        SKIP(109);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 111:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '\\')
        SKIP(112);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 112:
      if (lookahead == '\n')
        SKIP(111);
      END_STATE();
    case 113:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(114);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(117);
      if (lookahead != 0)
        ADVANCE(115);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(115);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(114);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(115);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(117);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(115);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '#')
        ADVANCE(114);
      if (lookahead == '\\')
        ADVANCE(116);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(117);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(115);
      END_STATE();
    case 118:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(120);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(118);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        SKIP(118);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(50);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == '|')
        ADVANCE(122);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 123:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '/')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == ':')
        ADVANCE(24);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '@')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(90);
      if (lookahead == '\\')
        SKIP(125);
      if (lookahead == '_')
        ADVANCE(46);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 125:
      if (lookahead == '\n')
        SKIP(123);
      END_STATE();
    case 126:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(127);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 127:
      if (lookahead == '\n')
        SKIP(126);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 128:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(129);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(130);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'l')
        ADVANCE(78);
      if (lookahead == 'w')
        ADVANCE(83);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(128);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != '{')
        ADVANCE(60);
      END_STATE();
    case 129:
      if (lookahead == ';')
        ADVANCE(28);
      END_STATE();
    case 130:
      if (lookahead == '\n')
        SKIP(128);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 131:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(133);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(131);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(10);
      END_STATE();
    case 133:
      if (lookahead == '\n')
        SKIP(131);
      END_STATE();
    case 134:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(135);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 135:
      if (lookahead == '\n')
        SKIP(134);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 136:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 137:
      if (lookahead == '\n')
        SKIP(136);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 138:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(141);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(138);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 139:
      if (lookahead == '(')
        ADVANCE(31);
      END_STATE();
    case 140:
      if (lookahead == '(')
        ADVANCE(37);
      END_STATE();
    case 141:
      if (lookahead == '\n')
        SKIP(138);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 142:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 143:
      if (lookahead == '\n')
        SKIP(142);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 144:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(145);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(146);
      if (lookahead == 'i')
        ADVANCE(103);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 146:
      if (lookahead == '\n')
        SKIP(144);
      END_STATE();
    case 147:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(148);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(147);
      if (lookahead != 0 &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 148:
      if (lookahead == '\n')
        SKIP(147);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 149:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(150);
      if (lookahead == ']')
        ADVANCE(151);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(149);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 150:
      if (lookahead == '\n')
        SKIP(149);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 152:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(153);
      if (lookahead == ']')
        ADVANCE(154);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(152);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        SKIP(152);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == ']')
        ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 156:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(158);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(156);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 157:
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 158:
      if (lookahead == '\n')
        SKIP(156);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 159:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(160);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(159);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 160:
      if (lookahead == '\n')
        SKIP(159);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 161:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(162);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(161);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 162:
      if (lookahead == '\n')
        SKIP(161);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 163:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(164);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 164:
      if (lookahead == '\n')
        SKIP(163);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 165:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(166);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(165);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 166:
      if (lookahead == '\n')
        SKIP(165);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 167:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(168);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(167);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 168:
      if (lookahead == '\n')
        SKIP(167);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 169:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(170);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'l')
        ADVANCE(78);
      if (lookahead == 'w')
        ADVANCE(83);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(169);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{')
        ADVANCE(60);
      END_STATE();
    case 170:
      if (lookahead == '\n')
        SKIP(169);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 171:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(174);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(38);
      END_STATE();
    case 174:
      if (lookahead == '\n')
        SKIP(171);
      END_STATE();
    case 175:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '\\')
        SKIP(176);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      END_STATE();
    case 176:
      if (lookahead == '\n')
        SKIP(175);
      END_STATE();
    case 177:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(178);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(179);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '<')
        ADVANCE(32);
      END_STATE();
    case 179:
      if (lookahead == '\n')
        SKIP(177);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(178);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(181);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(180);
      END_STATE();
    case 181:
      if (lookahead == '\n')
        SKIP(180);
      END_STATE();
    case 182:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '\\')
        SKIP(183);
      if (lookahead == ']')
        ADVANCE(92);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      END_STATE();
    case 183:
      if (lookahead == '\n')
        SKIP(182);
      END_STATE();
    case 184:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(185);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{')
        ADVANCE(60);
      END_STATE();
    case 185:
      if (lookahead == '\n')
        SKIP(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 186:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(187);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'd')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'l')
        ADVANCE(78);
      if (lookahead == 'w')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 187:
      if (lookahead == '\n')
        SKIP(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'o')
        ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'n')
        ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 192:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(193);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'e')
        ADVANCE(194);
      if (lookahead == 'f')
        ADVANCE(200);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'l')
        ADVANCE(78);
      if (lookahead == 'w')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 193:
      if (lookahead == '\n')
        SKIP(192);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'l')
        ADVANCE(195);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'i')
        ADVANCE(196);
      if (lookahead == 's')
        ADVANCE(198);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'i')
        ADVANCE(201);
      if (lookahead == 'o')
        ADVANCE(67);
      if (lookahead == 'u')
        ADVANCE(69);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(203);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(202);
      END_STATE();
    case 203:
      if (lookahead == '\n')
        SKIP(202);
      END_STATE();
    case 204:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(205);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'l')
        ADVANCE(78);
      if (lookahead == 'w')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 205:
      if (lookahead == '\n')
        SKIP(204);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 206:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(207);
      if (lookahead == ']')
        ADVANCE(151);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{')
        ADVANCE(60);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(206);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 208:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(209);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      END_STATE();
    case 209:
      if (lookahead == '\n')
        SKIP(208);
      END_STATE();
    case 210:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(178);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(211);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      END_STATE();
    case 211:
      if (lookahead == '\n')
        SKIP(210);
      END_STATE();
    case 212:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(178);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 213:
      if (lookahead == '\n')
        SKIP(212);
      END_STATE();
    case 214:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '<')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(215);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        SKIP(214);
      END_STATE();
    case 216:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '<')
        ADVANCE(178);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(217);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      END_STATE();
    case 217:
      if (lookahead == '\n')
        SKIP(216);
      END_STATE();
    case 218:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(219);
      if (lookahead == '\\')
        SKIP(220);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(218);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(7);
      END_STATE();
    case 220:
      if (lookahead == '\n')
        SKIP(218);
      END_STATE();
    case 221:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(222);
      if (lookahead == ']')
        ADVANCE(92);
      if (lookahead == '|')
        ADVANCE(223);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        SKIP(221);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 224:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(225);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 225:
      if (lookahead == '\n')
        SKIP(224);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 226:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(145);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(227);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 227:
      if (lookahead == '\n')
        SKIP(226);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 228:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(229);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(200);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'l')
        ADVANCE(78);
      if (lookahead == 'w')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 229:
      if (lookahead == '\n')
        SKIP(228);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 230:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(231);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'e')
        ADVANCE(232);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(230);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 231:
      if (lookahead == '\n')
        SKIP(230);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 's')
        ADVANCE(233);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'a')
        ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'c')
        ADVANCE(235);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 236:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(237);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      END_STATE();
    case 237:
      if (lookahead == '\n')
        SKIP(236);
      END_STATE();
    case 238:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(238);
      END_STATE();
    case 239:
      if (lookahead == '\n')
        SKIP(238);
      END_STATE();
    case 240:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '\\')
        SKIP(241);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        SKIP(240);
      END_STATE();
    case 242:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == '|')
        ADVANCE(223);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      END_STATE();
    case 243:
      if (lookahead == '\n')
        SKIP(242);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        ADVANCE(119);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(245);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      END_STATE();
    case 245:
      if (lookahead == '\n')
        SKIP(244);
      END_STATE();
    case 246:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(89);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(247);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        SKIP(246);
      END_STATE();
    case 248:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(249);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(248);
      END_STATE();
    case 249:
      if (lookahead == '\n')
        SKIP(248);
      END_STATE();
    case 250:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(129);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(251);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'l')
        ADVANCE(78);
      if (lookahead == 'w')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(250);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 251:
      if (lookahead == '\n')
        SKIP(250);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 252:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(89);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(253);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(252);
      END_STATE();
    case 253:
      if (lookahead == '\n')
        SKIP(252);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 53, .external_lex_state = 2},
  [2] = {.lex_state = 53},
  [3] = {.lex_state = 88},
  [4] = {.lex_state = 109},
  [5] = {.lex_state = 53, .external_lex_state = 2},
  [6] = {.lex_state = 53, .external_lex_state = 2},
  [7] = {.lex_state = 109},
  [8] = {.lex_state = 109},
  [9] = {.lex_state = 53, .external_lex_state = 2},
  [10] = {.lex_state = 109},
  [11] = {.lex_state = 109},
  [12] = {.lex_state = 111},
  [13] = {.lex_state = 109},
  [14] = {.lex_state = 113},
  [15] = {.lex_state = 118, .external_lex_state = 3},
  [16] = {.lex_state = 123},
  [17] = {.lex_state = 123},
  [18] = {.lex_state = 53, .external_lex_state = 2},
  [19] = {.lex_state = 53, .external_lex_state = 2},
  [20] = {.lex_state = 53, .external_lex_state = 2},
  [21] = {.lex_state = 126, .external_lex_state = 3},
  [22] = {.lex_state = 53},
  [23] = {.lex_state = 128, .external_lex_state = 2},
  [24] = {.lex_state = 131, .external_lex_state = 4},
  [25] = {.lex_state = 118, .external_lex_state = 5},
  [26] = {.lex_state = 134, .external_lex_state = 6},
  [27] = {.lex_state = 88},
  [28] = {.lex_state = 109, .external_lex_state = 2},
  [29] = {.lex_state = 136, .external_lex_state = 5},
  [30] = {.lex_state = 53, .external_lex_state = 2},
  [31] = {.lex_state = 109, .external_lex_state = 2},
  [32] = {.lex_state = 109},
  [33] = {.lex_state = 109},
  [34] = {.lex_state = 138, .external_lex_state = 7},
  [35] = {.lex_state = 142, .external_lex_state = 6},
  [36] = {.lex_state = 88},
  [37] = {.lex_state = 88},
  [38] = {.lex_state = 131, .external_lex_state = 4},
  [39] = {.lex_state = 134, .external_lex_state = 6},
  [40] = {.lex_state = 88},
  [41] = {.lex_state = 113},
  [42] = {.lex_state = 144, .external_lex_state = 8},
  [43] = {.lex_state = 123},
  [44] = {.lex_state = 123},
  [45] = {.lex_state = 53, .external_lex_state = 2},
  [46] = {.lex_state = 53, .external_lex_state = 2},
  [47] = {.lex_state = 53, .external_lex_state = 2},
  [48] = {.lex_state = 144, .external_lex_state = 4},
  [49] = {.lex_state = 88},
  [50] = {.lex_state = 88},
  [51] = {.lex_state = 109},
  [52] = {.lex_state = 111},
  [53] = {.lex_state = 136, .external_lex_state = 3},
  [54] = {.lex_state = 147, .external_lex_state = 3},
  [55] = {.lex_state = 131, .external_lex_state = 4},
  [56] = {.lex_state = 136, .external_lex_state = 5},
  [57] = {.lex_state = 142, .external_lex_state = 6},
  [58] = {.lex_state = 88},
  [59] = {.lex_state = 53, .external_lex_state = 2},
  [60] = {.lex_state = 109, .external_lex_state = 2},
  [61] = {.lex_state = 113},
  [62] = {.lex_state = 149, .external_lex_state = 9},
  [63] = {.lex_state = 123},
  [64] = {.lex_state = 123},
  [65] = {.lex_state = 53, .external_lex_state = 2},
  [66] = {.lex_state = 53, .external_lex_state = 2},
  [67] = {.lex_state = 53, .external_lex_state = 2},
  [68] = {.lex_state = 149},
  [69] = {.lex_state = 149},
  [70] = {.lex_state = 113},
  [71] = {.lex_state = 152, .external_lex_state = 9},
  [72] = {.lex_state = 123},
  [73] = {.lex_state = 123},
  [74] = {.lex_state = 53, .external_lex_state = 2},
  [75] = {.lex_state = 53, .external_lex_state = 2},
  [76] = {.lex_state = 53, .external_lex_state = 2},
  [77] = {.lex_state = 152},
  [78] = {.lex_state = 152},
  [79] = {.lex_state = 131, .external_lex_state = 4},
  [80] = {.lex_state = 113},
  [81] = {.lex_state = 109, .external_lex_state = 10},
  [82] = {.lex_state = 123},
  [83] = {.lex_state = 123},
  [84] = {.lex_state = 53, .external_lex_state = 2},
  [85] = {.lex_state = 53, .external_lex_state = 2},
  [86] = {.lex_state = 53, .external_lex_state = 2},
  [87] = {.lex_state = 109, .external_lex_state = 2},
  [88] = {.lex_state = 136, .external_lex_state = 3},
  [89] = {.lex_state = 113},
  [90] = {.lex_state = 123},
  [91] = {.lex_state = 123},
  [92] = {.lex_state = 53, .external_lex_state = 2},
  [93] = {.lex_state = 53, .external_lex_state = 2},
  [94] = {.lex_state = 113},
  [95] = {.lex_state = 109},
  [96] = {.lex_state = 118, .external_lex_state = 3},
  [97] = {.lex_state = 136, .external_lex_state = 3},
  [98] = {.lex_state = 136, .external_lex_state = 3},
  [99] = {.lex_state = 136, .external_lex_state = 3},
  [100] = {.lex_state = 88},
  [101] = {.lex_state = 123},
  [102] = {.lex_state = 88},
  [103] = {.lex_state = 88},
  [104] = {.lex_state = 88},
  [105] = {.lex_state = 109},
  [106] = {.lex_state = 53, .external_lex_state = 2},
  [107] = {.lex_state = 53, .external_lex_state = 2},
  [108] = {.lex_state = 109},
  [109] = {.lex_state = 109},
  [110] = {.lex_state = 53, .external_lex_state = 2},
  [111] = {.lex_state = 109},
  [112] = {.lex_state = 109},
  [113] = {.lex_state = 111},
  [114] = {.lex_state = 113},
  [115] = {.lex_state = 156, .external_lex_state = 11},
  [116] = {.lex_state = 123},
  [117] = {.lex_state = 123},
  [118] = {.lex_state = 53, .external_lex_state = 2},
  [119] = {.lex_state = 53, .external_lex_state = 2},
  [120] = {.lex_state = 53, .external_lex_state = 2},
  [121] = {.lex_state = 159, .external_lex_state = 11},
  [122] = {.lex_state = 88},
  [123] = {.lex_state = 156, .external_lex_state = 12},
  [124] = {.lex_state = 161, .external_lex_state = 2},
  [125] = {.lex_state = 88},
  [126] = {.lex_state = 156, .external_lex_state = 12},
  [127] = {.lex_state = 109, .external_lex_state = 2},
  [128] = {.lex_state = 88},
  [129] = {.lex_state = 109},
  [130] = {.lex_state = 111},
  [131] = {.lex_state = 163, .external_lex_state = 11},
  [132] = {.lex_state = 165, .external_lex_state = 11},
  [133] = {.lex_state = 88},
  [134] = {.lex_state = 163, .external_lex_state = 12},
  [135] = {.lex_state = 167, .external_lex_state = 2},
  [136] = {.lex_state = 88},
  [137] = {.lex_state = 109, .external_lex_state = 2},
  [138] = {.lex_state = 88},
  [139] = {.lex_state = 161, .external_lex_state = 2},
  [140] = {.lex_state = 88},
  [141] = {.lex_state = 169, .external_lex_state = 2},
  [142] = {.lex_state = 171, .external_lex_state = 5},
  [143] = {.lex_state = 53, .external_lex_state = 2},
  [144] = {.lex_state = 128, .external_lex_state = 2},
  [145] = {.lex_state = 53, .external_lex_state = 2},
  [146] = {.lex_state = 53},
  [147] = {.lex_state = 109},
  [148] = {.lex_state = 175, .external_lex_state = 13},
  [149] = {.lex_state = 118, .external_lex_state = 3},
  [150] = {.lex_state = 177, .external_lex_state = 5},
  [151] = {.lex_state = 136, .external_lex_state = 5},
  [152] = {.lex_state = 118, .external_lex_state = 5},
  [153] = {.lex_state = 180, .external_lex_state = 5},
  [154] = {.lex_state = 53, .external_lex_state = 2},
  [155] = {.lex_state = 88},
  [156] = {.lex_state = 118, .external_lex_state = 5},
  [157] = {.lex_state = 88},
  [158] = {.lex_state = 109, .external_lex_state = 2},
  [159] = {.lex_state = 109, .external_lex_state = 10},
  [160] = {.lex_state = 109, .external_lex_state = 2},
  [161] = {.lex_state = 113},
  [162] = {.lex_state = 182, .external_lex_state = 9},
  [163] = {.lex_state = 123},
  [164] = {.lex_state = 123},
  [165] = {.lex_state = 53, .external_lex_state = 2},
  [166] = {.lex_state = 53, .external_lex_state = 2},
  [167] = {.lex_state = 53, .external_lex_state = 2},
  [168] = {.lex_state = 88},
  [169] = {.lex_state = 142, .external_lex_state = 6},
  [170] = {.lex_state = 184},
  [171] = {.lex_state = 113},
  [172] = {.lex_state = 134, .external_lex_state = 14},
  [173] = {.lex_state = 123},
  [174] = {.lex_state = 123},
  [175] = {.lex_state = 53, .external_lex_state = 2},
  [176] = {.lex_state = 53, .external_lex_state = 2},
  [177] = {.lex_state = 53, .external_lex_state = 2},
  [178] = {.lex_state = 109},
  [179] = {.lex_state = 186, .external_lex_state = 2},
  [180] = {.lex_state = 131, .external_lex_state = 4},
  [181] = {.lex_state = 88},
  [182] = {.lex_state = 192, .external_lex_state = 2},
  [183] = {.lex_state = 144, .external_lex_state = 8},
  [184] = {.lex_state = 113},
  [185] = {.lex_state = 109},
  [186] = {.lex_state = 144, .external_lex_state = 4},
  [187] = {.lex_state = 88},
  [188] = {.lex_state = 144, .external_lex_state = 8},
  [189] = {.lex_state = 144, .external_lex_state = 8},
  [190] = {.lex_state = 144, .external_lex_state = 8},
  [191] = {.lex_state = 144, .external_lex_state = 8},
  [192] = {.lex_state = 123},
  [193] = {.lex_state = 88},
  [194] = {.lex_state = 88},
  [195] = {.lex_state = 88},
  [196] = {.lex_state = 161, .external_lex_state = 2},
  [197] = {.lex_state = 88},
  [198] = {.lex_state = 167, .external_lex_state = 2},
  [199] = {.lex_state = 88},
  [200] = {.lex_state = 161, .external_lex_state = 2},
  [201] = {.lex_state = 88},
  [202] = {.lex_state = 171, .external_lex_state = 5},
  [203] = {.lex_state = 138, .external_lex_state = 7},
  [204] = {.lex_state = 88},
  [205] = {.lex_state = 131, .external_lex_state = 4},
  [206] = {.lex_state = 136, .external_lex_state = 3},
  [207] = {.lex_state = 88},
  [208] = {.lex_state = 202, .external_lex_state = 5},
  [209] = {.lex_state = 53, .external_lex_state = 2},
  [210] = {.lex_state = 131, .external_lex_state = 4},
  [211] = {.lex_state = 204, .external_lex_state = 2},
  [212] = {.lex_state = 53, .external_lex_state = 2},
  [213] = {.lex_state = 53},
  [214] = {.lex_state = 109},
  [215] = {.lex_state = 136, .external_lex_state = 3},
  [216] = {.lex_state = 136, .external_lex_state = 5},
  [217] = {.lex_state = 177, .external_lex_state = 5},
  [218] = {.lex_state = 131, .external_lex_state = 4},
  [219] = {.lex_state = 142, .external_lex_state = 6},
  [220] = {.lex_state = 53, .external_lex_state = 2},
  [221] = {.lex_state = 136, .external_lex_state = 5},
  [222] = {.lex_state = 206, .external_lex_state = 9},
  [223] = {.lex_state = 113},
  [224] = {.lex_state = 109},
  [225] = {.lex_state = 149, .external_lex_state = 9},
  [226] = {.lex_state = 206, .external_lex_state = 9},
  [227] = {.lex_state = 206, .external_lex_state = 9},
  [228] = {.lex_state = 206, .external_lex_state = 9},
  [229] = {.lex_state = 123},
  [230] = {.lex_state = 88},
  [231] = {.lex_state = 88},
  [232] = {.lex_state = 88},
  [233] = {.lex_state = 161, .external_lex_state = 2},
  [234] = {.lex_state = 88},
  [235] = {.lex_state = 167, .external_lex_state = 2},
  [236] = {.lex_state = 88},
  [237] = {.lex_state = 161, .external_lex_state = 2},
  [238] = {.lex_state = 131, .external_lex_state = 4},
  [239] = {.lex_state = 149},
  [240] = {.lex_state = 152, .external_lex_state = 9},
  [241] = {.lex_state = 113},
  [242] = {.lex_state = 109},
  [243] = {.lex_state = 152, .external_lex_state = 9},
  [244] = {.lex_state = 152, .external_lex_state = 9},
  [245] = {.lex_state = 152, .external_lex_state = 9},
  [246] = {.lex_state = 152, .external_lex_state = 9},
  [247] = {.lex_state = 123},
  [248] = {.lex_state = 88},
  [249] = {.lex_state = 88},
  [250] = {.lex_state = 88},
  [251] = {.lex_state = 161, .external_lex_state = 2},
  [252] = {.lex_state = 88},
  [253] = {.lex_state = 167, .external_lex_state = 2},
  [254] = {.lex_state = 88},
  [255] = {.lex_state = 161, .external_lex_state = 2},
  [256] = {.lex_state = 152},
  [257] = {.lex_state = 138, .external_lex_state = 7},
  [258] = {.lex_state = 131, .external_lex_state = 4},
  [259] = {.lex_state = 109, .external_lex_state = 10},
  [260] = {.lex_state = 113},
  [261] = {.lex_state = 109},
  [262] = {.lex_state = 109, .external_lex_state = 10},
  [263] = {.lex_state = 109, .external_lex_state = 10},
  [264] = {.lex_state = 109, .external_lex_state = 10},
  [265] = {.lex_state = 109, .external_lex_state = 10},
  [266] = {.lex_state = 123},
  [267] = {.lex_state = 88},
  [268] = {.lex_state = 88},
  [269] = {.lex_state = 88},
  [270] = {.lex_state = 161, .external_lex_state = 2},
  [271] = {.lex_state = 88},
  [272] = {.lex_state = 167, .external_lex_state = 2},
  [273] = {.lex_state = 88},
  [274] = {.lex_state = 161, .external_lex_state = 2},
  [275] = {.lex_state = 113},
  [276] = {.lex_state = 113},
  [277] = {.lex_state = 113},
  [278] = {.lex_state = 123},
  [279] = {.lex_state = 88},
  [280] = {.lex_state = 88},
  [281] = {.lex_state = 88},
  [282] = {.lex_state = 161, .external_lex_state = 2},
  [283] = {.lex_state = 88},
  [284] = {.lex_state = 167, .external_lex_state = 2},
  [285] = {.lex_state = 136, .external_lex_state = 3},
  [286] = {.lex_state = 113},
  [287] = {.lex_state = 136, .external_lex_state = 3},
  [288] = {.lex_state = 118, .external_lex_state = 3},
  [289] = {.lex_state = 88},
  [290] = {.lex_state = 88},
  [291] = {.lex_state = 136, .external_lex_state = 3},
  [292] = {.lex_state = 88},
  [293] = {.lex_state = 184},
  [294] = {.lex_state = 136, .external_lex_state = 3},
  [295] = {.lex_state = 88},
  [296] = {.lex_state = 184},
  [297] = {.lex_state = 138, .external_lex_state = 7},
  [298] = {.lex_state = 161, .external_lex_state = 2},
  [299] = {.lex_state = 88},
  [300] = {.lex_state = 88},
  [301] = {.lex_state = 88},
  [302] = {.lex_state = 144, .external_lex_state = 8},
  [303] = {.lex_state = 144, .external_lex_state = 4},
  [304] = {.lex_state = 88},
  [305] = {.lex_state = 131, .external_lex_state = 4},
  [306] = {.lex_state = 142, .external_lex_state = 6},
  [307] = {.lex_state = 53, .external_lex_state = 2},
  [308] = {.lex_state = 149},
  [309] = {.lex_state = 152},
  [310] = {.lex_state = 88},
  [311] = {.lex_state = 156, .external_lex_state = 11},
  [312] = {.lex_state = 113},
  [313] = {.lex_state = 109},
  [314] = {.lex_state = 156, .external_lex_state = 11},
  [315] = {.lex_state = 156, .external_lex_state = 11},
  [316] = {.lex_state = 156, .external_lex_state = 11},
  [317] = {.lex_state = 156, .external_lex_state = 11},
  [318] = {.lex_state = 123},
  [319] = {.lex_state = 88},
  [320] = {.lex_state = 88},
  [321] = {.lex_state = 88},
  [322] = {.lex_state = 161, .external_lex_state = 2},
  [323] = {.lex_state = 88},
  [324] = {.lex_state = 167, .external_lex_state = 2},
  [325] = {.lex_state = 88},
  [326] = {.lex_state = 161, .external_lex_state = 2},
  [327] = {.lex_state = 88},
  [328] = {.lex_state = 169, .external_lex_state = 2},
  [329] = {.lex_state = 208, .external_lex_state = 12},
  [330] = {.lex_state = 53, .external_lex_state = 2},
  [331] = {.lex_state = 136, .external_lex_state = 3},
  [332] = {.lex_state = 53, .external_lex_state = 2},
  [333] = {.lex_state = 53},
  [334] = {.lex_state = 109},
  [335] = {.lex_state = 175, .external_lex_state = 13},
  [336] = {.lex_state = 156, .external_lex_state = 11},
  [337] = {.lex_state = 210, .external_lex_state = 12},
  [338] = {.lex_state = 156, .external_lex_state = 12},
  [339] = {.lex_state = 156, .external_lex_state = 12},
  [340] = {.lex_state = 212, .external_lex_state = 12},
  [341] = {.lex_state = 156, .external_lex_state = 12},
  [342] = {.lex_state = 138, .external_lex_state = 7},
  [343] = {.lex_state = 88},
  [344] = {.lex_state = 88},
  [345] = {.lex_state = 163, .external_lex_state = 11},
  [346] = {.lex_state = 88},
  [347] = {.lex_state = 214, .external_lex_state = 12},
  [348] = {.lex_state = 53, .external_lex_state = 2},
  [349] = {.lex_state = 53, .external_lex_state = 2},
  [350] = {.lex_state = 53},
  [351] = {.lex_state = 109},
  [352] = {.lex_state = 163, .external_lex_state = 11},
  [353] = {.lex_state = 163, .external_lex_state = 12},
  [354] = {.lex_state = 216, .external_lex_state = 12},
  [355] = {.lex_state = 163, .external_lex_state = 12},
  [356] = {.lex_state = 136, .external_lex_state = 3},
  [357] = {.lex_state = 88},
  [358] = {.lex_state = 202, .external_lex_state = 5},
  [359] = {.lex_state = 169, .external_lex_state = 2},
  [360] = {.lex_state = 53},
  [361] = {.lex_state = 109},
  [362] = {.lex_state = 131, .external_lex_state = 4},
  [363] = {.lex_state = 131, .external_lex_state = 4},
  [364] = {.lex_state = 142, .external_lex_state = 6},
  [365] = {.lex_state = 131, .external_lex_state = 4},
  [366] = {.lex_state = 134, .external_lex_state = 6},
  [367] = {.lex_state = 109},
  [368] = {.lex_state = 113},
  [369] = {.lex_state = 180, .external_lex_state = 3},
  [370] = {.lex_state = 123},
  [371] = {.lex_state = 123},
  [372] = {.lex_state = 53, .external_lex_state = 2},
  [373] = {.lex_state = 53, .external_lex_state = 2},
  [374] = {.lex_state = 53, .external_lex_state = 2},
  [375] = {.lex_state = 177, .external_lex_state = 5},
  [376] = {.lex_state = 177, .external_lex_state = 5},
  [377] = {.lex_state = 218, .external_lex_state = 15},
  [378] = {.lex_state = 177, .external_lex_state = 5},
  [379] = {.lex_state = 118, .external_lex_state = 5},
  [380] = {.lex_state = 180, .external_lex_state = 5},
  [381] = {.lex_state = 180, .external_lex_state = 5},
  [382] = {.lex_state = 138, .external_lex_state = 7},
  [383] = {.lex_state = 109, .external_lex_state = 2},
  [384] = {.lex_state = 118, .external_lex_state = 5},
  [385] = {.lex_state = 221, .external_lex_state = 9},
  [386] = {.lex_state = 113},
  [387] = {.lex_state = 109},
  [388] = {.lex_state = 88},
  [389] = {.lex_state = 182, .external_lex_state = 9},
  [390] = {.lex_state = 221, .external_lex_state = 9},
  [391] = {.lex_state = 221, .external_lex_state = 9},
  [392] = {.lex_state = 221, .external_lex_state = 9},
  [393] = {.lex_state = 123},
  [394] = {.lex_state = 88},
  [395] = {.lex_state = 88},
  [396] = {.lex_state = 88},
  [397] = {.lex_state = 161, .external_lex_state = 2},
  [398] = {.lex_state = 88},
  [399] = {.lex_state = 167, .external_lex_state = 2},
  [400] = {.lex_state = 88},
  [401] = {.lex_state = 161, .external_lex_state = 2},
  [402] = {.lex_state = 142, .external_lex_state = 6},
  [403] = {.lex_state = 113},
  [404] = {.lex_state = 224, .external_lex_state = 9},
  [405] = {.lex_state = 123},
  [406] = {.lex_state = 123},
  [407] = {.lex_state = 53, .external_lex_state = 2},
  [408] = {.lex_state = 53, .external_lex_state = 2},
  [409] = {.lex_state = 53, .external_lex_state = 2},
  [410] = {.lex_state = 184},
  [411] = {.lex_state = 184},
  [412] = {.lex_state = 142, .external_lex_state = 14},
  [413] = {.lex_state = 113},
  [414] = {.lex_state = 109},
  [415] = {.lex_state = 134, .external_lex_state = 14},
  [416] = {.lex_state = 142, .external_lex_state = 14},
  [417] = {.lex_state = 142, .external_lex_state = 14},
  [418] = {.lex_state = 142, .external_lex_state = 14},
  [419] = {.lex_state = 123},
  [420] = {.lex_state = 88},
  [421] = {.lex_state = 88},
  [422] = {.lex_state = 88},
  [423] = {.lex_state = 161, .external_lex_state = 2},
  [424] = {.lex_state = 88},
  [425] = {.lex_state = 167, .external_lex_state = 2},
  [426] = {.lex_state = 88},
  [427] = {.lex_state = 161, .external_lex_state = 2},
  [428] = {.lex_state = 113},
  [429] = {.lex_state = 226, .external_lex_state = 8},
  [430] = {.lex_state = 123},
  [431] = {.lex_state = 123},
  [432] = {.lex_state = 53, .external_lex_state = 2},
  [433] = {.lex_state = 53, .external_lex_state = 2},
  [434] = {.lex_state = 53, .external_lex_state = 2},
  [435] = {.lex_state = 226, .external_lex_state = 4},
  [436] = {.lex_state = 226, .external_lex_state = 4},
  [437] = {.lex_state = 131, .external_lex_state = 4},
  [438] = {.lex_state = 186, .external_lex_state = 2},
  [439] = {.lex_state = 131, .external_lex_state = 4},
  [440] = {.lex_state = 134, .external_lex_state = 6},
  [441] = {.lex_state = 186, .external_lex_state = 2},
  [442] = {.lex_state = 131, .external_lex_state = 4},
  [443] = {.lex_state = 53, .external_lex_state = 2},
  [444] = {.lex_state = 228, .external_lex_state = 2},
  [445] = {.lex_state = 192, .external_lex_state = 2},
  [446] = {.lex_state = 131, .external_lex_state = 4},
  [447] = {.lex_state = 88},
  [448] = {.lex_state = 88},
  [449] = {.lex_state = 134, .external_lex_state = 6},
  [450] = {.lex_state = 192, .external_lex_state = 2},
  [451] = {.lex_state = 88},
  [452] = {.lex_state = 144, .external_lex_state = 8},
  [453] = {.lex_state = 144, .external_lex_state = 8},
  [454] = {.lex_state = 230},
  [455] = {.lex_state = 144, .external_lex_state = 4},
  [456] = {.lex_state = 144, .external_lex_state = 8},
  [457] = {.lex_state = 88},
  [458] = {.lex_state = 88},
  [459] = {.lex_state = 144, .external_lex_state = 8},
  [460] = {.lex_state = 88},
  [461] = {.lex_state = 184},
  [462] = {.lex_state = 144, .external_lex_state = 8},
  [463] = {.lex_state = 88},
  [464] = {.lex_state = 184},
  [465] = {.lex_state = 144, .external_lex_state = 8},
  [466] = {.lex_state = 144, .external_lex_state = 8},
  [467] = {.lex_state = 88},
  [468] = {.lex_state = 131, .external_lex_state = 4},
  [469] = {.lex_state = 142, .external_lex_state = 14},
  [470] = {.lex_state = 88},
  [471] = {.lex_state = 202, .external_lex_state = 5},
  [472] = {.lex_state = 138, .external_lex_state = 7},
  [473] = {.lex_state = 136, .external_lex_state = 3},
  [474] = {.lex_state = 88},
  [475] = {.lex_state = 53},
  [476] = {.lex_state = 109},
  [477] = {.lex_state = 131, .external_lex_state = 4},
  [478] = {.lex_state = 131, .external_lex_state = 4},
  [479] = {.lex_state = 142, .external_lex_state = 6},
  [480] = {.lex_state = 109},
  [481] = {.lex_state = 177, .external_lex_state = 3},
  [482] = {.lex_state = 136, .external_lex_state = 5},
  [483] = {.lex_state = 177, .external_lex_state = 5},
  [484] = {.lex_state = 177, .external_lex_state = 5},
  [485] = {.lex_state = 204, .external_lex_state = 2},
  [486] = {.lex_state = 136, .external_lex_state = 5},
  [487] = {.lex_state = 206, .external_lex_state = 9},
  [488] = {.lex_state = 206, .external_lex_state = 9},
  [489] = {.lex_state = 149, .external_lex_state = 9},
  [490] = {.lex_state = 88},
  [491] = {.lex_state = 88},
  [492] = {.lex_state = 206, .external_lex_state = 9},
  [493] = {.lex_state = 88},
  [494] = {.lex_state = 184},
  [495] = {.lex_state = 206, .external_lex_state = 9},
  [496] = {.lex_state = 88},
  [497] = {.lex_state = 184},
  [498] = {.lex_state = 206, .external_lex_state = 9},
  [499] = {.lex_state = 206, .external_lex_state = 9},
  [500] = {.lex_state = 152, .external_lex_state = 9},
  [501] = {.lex_state = 152, .external_lex_state = 9},
  [502] = {.lex_state = 152, .external_lex_state = 9},
  [503] = {.lex_state = 88},
  [504] = {.lex_state = 88},
  [505] = {.lex_state = 152, .external_lex_state = 9},
  [506] = {.lex_state = 88},
  [507] = {.lex_state = 184},
  [508] = {.lex_state = 152, .external_lex_state = 9},
  [509] = {.lex_state = 88},
  [510] = {.lex_state = 184},
  [511] = {.lex_state = 152, .external_lex_state = 9},
  [512] = {.lex_state = 152, .external_lex_state = 9},
  [513] = {.lex_state = 131, .external_lex_state = 4},
  [514] = {.lex_state = 184},
  [515] = {.lex_state = 113},
  [516] = {.lex_state = 236, .external_lex_state = 8},
  [517] = {.lex_state = 123},
  [518] = {.lex_state = 123},
  [519] = {.lex_state = 53, .external_lex_state = 2},
  [520] = {.lex_state = 53, .external_lex_state = 2},
  [521] = {.lex_state = 53, .external_lex_state = 2},
  [522] = {.lex_state = 109, .external_lex_state = 10},
  [523] = {.lex_state = 109, .external_lex_state = 10},
  [524] = {.lex_state = 109, .external_lex_state = 10},
  [525] = {.lex_state = 88},
  [526] = {.lex_state = 88},
  [527] = {.lex_state = 109, .external_lex_state = 10},
  [528] = {.lex_state = 88},
  [529] = {.lex_state = 184},
  [530] = {.lex_state = 109, .external_lex_state = 10},
  [531] = {.lex_state = 88},
  [532] = {.lex_state = 184},
  [533] = {.lex_state = 109, .external_lex_state = 10},
  [534] = {.lex_state = 109, .external_lex_state = 10},
  [535] = {.lex_state = 88},
  [536] = {.lex_state = 88},
  [537] = {.lex_state = 113},
  [538] = {.lex_state = 88},
  [539] = {.lex_state = 184},
  [540] = {.lex_state = 113},
  [541] = {.lex_state = 88},
  [542] = {.lex_state = 184},
  [543] = {.lex_state = 113},
  [544] = {.lex_state = 136, .external_lex_state = 3},
  [545] = {.lex_state = 88},
  [546] = {.lex_state = 136, .external_lex_state = 3},
  [547] = {.lex_state = 88},
  [548] = {.lex_state = 88},
  [549] = {.lex_state = 136, .external_lex_state = 3},
  [550] = {.lex_state = 238, .external_lex_state = 9},
  [551] = {.lex_state = 88},
  [552] = {.lex_state = 88},
  [553] = {.lex_state = 238, .external_lex_state = 9},
  [554] = {.lex_state = 88},
  [555] = {.lex_state = 161, .external_lex_state = 2},
  [556] = {.lex_state = 184},
  [557] = {.lex_state = 113},
  [558] = {.lex_state = 161, .external_lex_state = 10},
  [559] = {.lex_state = 123},
  [560] = {.lex_state = 123},
  [561] = {.lex_state = 53, .external_lex_state = 2},
  [562] = {.lex_state = 53, .external_lex_state = 2},
  [563] = {.lex_state = 53, .external_lex_state = 2},
  [564] = {.lex_state = 109},
  [565] = {.lex_state = 186, .external_lex_state = 2},
  [566] = {.lex_state = 88},
  [567] = {.lex_state = 192, .external_lex_state = 2},
  [568] = {.lex_state = 144, .external_lex_state = 4},
  [569] = {.lex_state = 88},
  [570] = {.lex_state = 88},
  [571] = {.lex_state = 208, .external_lex_state = 12},
  [572] = {.lex_state = 88},
  [573] = {.lex_state = 204, .external_lex_state = 2},
  [574] = {.lex_state = 131, .external_lex_state = 4},
  [575] = {.lex_state = 142, .external_lex_state = 6},
  [576] = {.lex_state = 88},
  [577] = {.lex_state = 138, .external_lex_state = 7},
  [578] = {.lex_state = 88},
  [579] = {.lex_state = 156, .external_lex_state = 11},
  [580] = {.lex_state = 156, .external_lex_state = 11},
  [581] = {.lex_state = 156, .external_lex_state = 11},
  [582] = {.lex_state = 88},
  [583] = {.lex_state = 88},
  [584] = {.lex_state = 156, .external_lex_state = 11},
  [585] = {.lex_state = 88},
  [586] = {.lex_state = 184},
  [587] = {.lex_state = 156, .external_lex_state = 11},
  [588] = {.lex_state = 88},
  [589] = {.lex_state = 184},
  [590] = {.lex_state = 156, .external_lex_state = 11},
  [591] = {.lex_state = 156, .external_lex_state = 11},
  [592] = {.lex_state = 88},
  [593] = {.lex_state = 240, .external_lex_state = 12},
  [594] = {.lex_state = 169, .external_lex_state = 2},
  [595] = {.lex_state = 53},
  [596] = {.lex_state = 109},
  [597] = {.lex_state = 88},
  [598] = {.lex_state = 88},
  [599] = {.lex_state = 161, .external_lex_state = 2},
  [600] = {.lex_state = 88},
  [601] = {.lex_state = 161, .external_lex_state = 2},
  [602] = {.lex_state = 109},
  [603] = {.lex_state = 113},
  [604] = {.lex_state = 212, .external_lex_state = 11},
  [605] = {.lex_state = 123},
  [606] = {.lex_state = 123},
  [607] = {.lex_state = 53, .external_lex_state = 2},
  [608] = {.lex_state = 53, .external_lex_state = 2},
  [609] = {.lex_state = 53, .external_lex_state = 2},
  [610] = {.lex_state = 210, .external_lex_state = 12},
  [611] = {.lex_state = 210, .external_lex_state = 12},
  [612] = {.lex_state = 218, .external_lex_state = 15},
  [613] = {.lex_state = 210, .external_lex_state = 12},
  [614] = {.lex_state = 156, .external_lex_state = 12},
  [615] = {.lex_state = 212, .external_lex_state = 12},
  [616] = {.lex_state = 212, .external_lex_state = 12},
  [617] = {.lex_state = 156, .external_lex_state = 12},
  [618] = {.lex_state = 167, .external_lex_state = 10},
  [619] = {.lex_state = 88},
  [620] = {.lex_state = 214, .external_lex_state = 12},
  [621] = {.lex_state = 138, .external_lex_state = 7},
  [622] = {.lex_state = 163, .external_lex_state = 11},
  [623] = {.lex_state = 88},
  [624] = {.lex_state = 53},
  [625] = {.lex_state = 109},
  [626] = {.lex_state = 167, .external_lex_state = 2},
  [627] = {.lex_state = 88},
  [628] = {.lex_state = 167, .external_lex_state = 2},
  [629] = {.lex_state = 109},
  [630] = {.lex_state = 216, .external_lex_state = 11},
  [631] = {.lex_state = 163, .external_lex_state = 12},
  [632] = {.lex_state = 216, .external_lex_state = 12},
  [633] = {.lex_state = 216, .external_lex_state = 12},
  [634] = {.lex_state = 163, .external_lex_state = 12},
  [635] = {.lex_state = 171, .external_lex_state = 5},
  [636] = {.lex_state = 202, .external_lex_state = 5},
  [637] = {.lex_state = 169, .external_lex_state = 2},
  [638] = {.lex_state = 109},
  [639] = {.lex_state = 236, .external_lex_state = 8},
  [640] = {.lex_state = 131, .external_lex_state = 4},
  [641] = {.lex_state = 180, .external_lex_state = 3},
  [642] = {.lex_state = 177, .external_lex_state = 5},
  [643] = {.lex_state = 177, .external_lex_state = 3},
  [644] = {.lex_state = 113},
  [645] = {.lex_state = 109},
  [646] = {.lex_state = 180, .external_lex_state = 3},
  [647] = {.lex_state = 177, .external_lex_state = 3},
  [648] = {.lex_state = 177, .external_lex_state = 3},
  [649] = {.lex_state = 177, .external_lex_state = 3},
  [650] = {.lex_state = 123},
  [651] = {.lex_state = 88},
  [652] = {.lex_state = 88},
  [653] = {.lex_state = 88},
  [654] = {.lex_state = 161, .external_lex_state = 2},
  [655] = {.lex_state = 88},
  [656] = {.lex_state = 167, .external_lex_state = 2},
  [657] = {.lex_state = 88},
  [658] = {.lex_state = 161, .external_lex_state = 2},
  [659] = {.lex_state = 218, .external_lex_state = 15},
  [660] = {.lex_state = 177, .external_lex_state = 5},
  [661] = {.lex_state = 123},
  [662] = {.lex_state = 123},
  [663] = {.lex_state = 218, .external_lex_state = 15},
  [664] = {.lex_state = 109, .external_lex_state = 2},
  [665] = {.lex_state = 184},
  [666] = {.lex_state = 109, .external_lex_state = 10},
  [667] = {.lex_state = 180, .external_lex_state = 5},
  [668] = {.lex_state = 221, .external_lex_state = 9},
  [669] = {.lex_state = 221, .external_lex_state = 9},
  [670] = {.lex_state = 182, .external_lex_state = 9},
  [671] = {.lex_state = 88},
  [672] = {.lex_state = 88},
  [673] = {.lex_state = 221, .external_lex_state = 9},
  [674] = {.lex_state = 88},
  [675] = {.lex_state = 184},
  [676] = {.lex_state = 221, .external_lex_state = 9},
  [677] = {.lex_state = 88},
  [678] = {.lex_state = 184},
  [679] = {.lex_state = 221, .external_lex_state = 9},
  [680] = {.lex_state = 221, .external_lex_state = 9},
  [681] = {.lex_state = 224, .external_lex_state = 9},
  [682] = {.lex_state = 113},
  [683] = {.lex_state = 109},
  [684] = {.lex_state = 224, .external_lex_state = 9},
  [685] = {.lex_state = 224, .external_lex_state = 9},
  [686] = {.lex_state = 224, .external_lex_state = 9},
  [687] = {.lex_state = 224, .external_lex_state = 9},
  [688] = {.lex_state = 123},
  [689] = {.lex_state = 88},
  [690] = {.lex_state = 88},
  [691] = {.lex_state = 88},
  [692] = {.lex_state = 161, .external_lex_state = 2},
  [693] = {.lex_state = 88},
  [694] = {.lex_state = 167, .external_lex_state = 2},
  [695] = {.lex_state = 88},
  [696] = {.lex_state = 161, .external_lex_state = 2},
  [697] = {.lex_state = 142, .external_lex_state = 6},
  [698] = {.lex_state = 184},
  [699] = {.lex_state = 142, .external_lex_state = 14},
  [700] = {.lex_state = 142, .external_lex_state = 14},
  [701] = {.lex_state = 134, .external_lex_state = 14},
  [702] = {.lex_state = 88},
  [703] = {.lex_state = 88},
  [704] = {.lex_state = 142, .external_lex_state = 14},
  [705] = {.lex_state = 88},
  [706] = {.lex_state = 184},
  [707] = {.lex_state = 142, .external_lex_state = 14},
  [708] = {.lex_state = 88},
  [709] = {.lex_state = 184},
  [710] = {.lex_state = 142, .external_lex_state = 14},
  [711] = {.lex_state = 142, .external_lex_state = 14},
  [712] = {.lex_state = 226, .external_lex_state = 8},
  [713] = {.lex_state = 113},
  [714] = {.lex_state = 109},
  [715] = {.lex_state = 226, .external_lex_state = 8},
  [716] = {.lex_state = 226, .external_lex_state = 8},
  [717] = {.lex_state = 226, .external_lex_state = 8},
  [718] = {.lex_state = 226, .external_lex_state = 8},
  [719] = {.lex_state = 123},
  [720] = {.lex_state = 88},
  [721] = {.lex_state = 88},
  [722] = {.lex_state = 88},
  [723] = {.lex_state = 161, .external_lex_state = 2},
  [724] = {.lex_state = 88},
  [725] = {.lex_state = 167, .external_lex_state = 2},
  [726] = {.lex_state = 88},
  [727] = {.lex_state = 161, .external_lex_state = 2},
  [728] = {.lex_state = 88},
  [729] = {.lex_state = 226, .external_lex_state = 4},
  [730] = {.lex_state = 186, .external_lex_state = 2},
  [731] = {.lex_state = 131, .external_lex_state = 4},
  [732] = {.lex_state = 186, .external_lex_state = 2},
  [733] = {.lex_state = 88},
  [734] = {.lex_state = 228, .external_lex_state = 2},
  [735] = {.lex_state = 131, .external_lex_state = 4},
  [736] = {.lex_state = 134, .external_lex_state = 6},
  [737] = {.lex_state = 228, .external_lex_state = 2},
  [738] = {.lex_state = 192, .external_lex_state = 2},
  [739] = {.lex_state = 131, .external_lex_state = 4},
  [740] = {.lex_state = 88},
  [741] = {.lex_state = 192, .external_lex_state = 2},
  [742] = {.lex_state = 88},
  [743] = {.lex_state = 88},
  [744] = {.lex_state = 131, .external_lex_state = 4},
  [745] = {.lex_state = 242, .external_lex_state = 9},
  [746] = {.lex_state = 230},
  [747] = {.lex_state = 221},
  [748] = {.lex_state = 230},
  [749] = {.lex_state = 230},
  [750] = {.lex_state = 144, .external_lex_state = 8},
  [751] = {.lex_state = 88},
  [752] = {.lex_state = 144, .external_lex_state = 8},
  [753] = {.lex_state = 88},
  [754] = {.lex_state = 88},
  [755] = {.lex_state = 144, .external_lex_state = 8},
  [756] = {.lex_state = 238, .external_lex_state = 9},
  [757] = {.lex_state = 88},
  [758] = {.lex_state = 88},
  [759] = {.lex_state = 238, .external_lex_state = 9},
  [760] = {.lex_state = 88},
  [761] = {.lex_state = 171, .external_lex_state = 5},
  [762] = {.lex_state = 142, .external_lex_state = 14},
  [763] = {.lex_state = 88},
  [764] = {.lex_state = 244, .external_lex_state = 8},
  [765] = {.lex_state = 202, .external_lex_state = 5},
  [766] = {.lex_state = 109},
  [767] = {.lex_state = 244, .external_lex_state = 8},
  [768] = {.lex_state = 177, .external_lex_state = 3},
  [769] = {.lex_state = 177, .external_lex_state = 3},
  [770] = {.lex_state = 131, .external_lex_state = 4},
  [771] = {.lex_state = 177, .external_lex_state = 5},
  [772] = {.lex_state = 206, .external_lex_state = 9},
  [773] = {.lex_state = 88},
  [774] = {.lex_state = 206, .external_lex_state = 9},
  [775] = {.lex_state = 88},
  [776] = {.lex_state = 88},
  [777] = {.lex_state = 206, .external_lex_state = 9},
  [778] = {.lex_state = 238, .external_lex_state = 9},
  [779] = {.lex_state = 88},
  [780] = {.lex_state = 88},
  [781] = {.lex_state = 238, .external_lex_state = 9},
  [782] = {.lex_state = 88},
  [783] = {.lex_state = 152, .external_lex_state = 9},
  [784] = {.lex_state = 88},
  [785] = {.lex_state = 152, .external_lex_state = 9},
  [786] = {.lex_state = 88},
  [787] = {.lex_state = 88},
  [788] = {.lex_state = 152, .external_lex_state = 9},
  [789] = {.lex_state = 238, .external_lex_state = 9},
  [790] = {.lex_state = 88},
  [791] = {.lex_state = 88},
  [792] = {.lex_state = 238, .external_lex_state = 9},
  [793] = {.lex_state = 88},
  [794] = {.lex_state = 131, .external_lex_state = 4},
  [795] = {.lex_state = 184},
  [796] = {.lex_state = 244, .external_lex_state = 8},
  [797] = {.lex_state = 113},
  [798] = {.lex_state = 109},
  [799] = {.lex_state = 236, .external_lex_state = 8},
  [800] = {.lex_state = 244, .external_lex_state = 8},
  [801] = {.lex_state = 244, .external_lex_state = 8},
  [802] = {.lex_state = 244, .external_lex_state = 8},
  [803] = {.lex_state = 123},
  [804] = {.lex_state = 88},
  [805] = {.lex_state = 88},
  [806] = {.lex_state = 88},
  [807] = {.lex_state = 161, .external_lex_state = 2},
  [808] = {.lex_state = 88},
  [809] = {.lex_state = 167, .external_lex_state = 2},
  [810] = {.lex_state = 88},
  [811] = {.lex_state = 161, .external_lex_state = 2},
  [812] = {.lex_state = 109, .external_lex_state = 10},
  [813] = {.lex_state = 88},
  [814] = {.lex_state = 109, .external_lex_state = 10},
  [815] = {.lex_state = 88},
  [816] = {.lex_state = 88},
  [817] = {.lex_state = 109, .external_lex_state = 10},
  [818] = {.lex_state = 238, .external_lex_state = 9},
  [819] = {.lex_state = 88},
  [820] = {.lex_state = 88},
  [821] = {.lex_state = 238, .external_lex_state = 9},
  [822] = {.lex_state = 88},
  [823] = {.lex_state = 113},
  [824] = {.lex_state = 88},
  [825] = {.lex_state = 113},
  [826] = {.lex_state = 88},
  [827] = {.lex_state = 88},
  [828] = {.lex_state = 113},
  [829] = {.lex_state = 238, .external_lex_state = 9},
  [830] = {.lex_state = 88},
  [831] = {.lex_state = 88},
  [832] = {.lex_state = 238, .external_lex_state = 9},
  [833] = {.lex_state = 88},
  [834] = {.lex_state = 88},
  [835] = {.lex_state = 88},
  [836] = {.lex_state = 88},
  [837] = {.lex_state = 136, .external_lex_state = 3},
  [838] = {.lex_state = 238, .external_lex_state = 9},
  [839] = {.lex_state = 88},
  [840] = {.lex_state = 136, .external_lex_state = 3},
  [841] = {.lex_state = 161, .external_lex_state = 2},
  [842] = {.lex_state = 184},
  [843] = {.lex_state = 161, .external_lex_state = 10},
  [844] = {.lex_state = 113},
  [845] = {.lex_state = 109},
  [846] = {.lex_state = 161, .external_lex_state = 10},
  [847] = {.lex_state = 161, .external_lex_state = 10},
  [848] = {.lex_state = 161, .external_lex_state = 10},
  [849] = {.lex_state = 161, .external_lex_state = 10},
  [850] = {.lex_state = 123},
  [851] = {.lex_state = 88},
  [852] = {.lex_state = 88},
  [853] = {.lex_state = 88},
  [854] = {.lex_state = 161, .external_lex_state = 2},
  [855] = {.lex_state = 88},
  [856] = {.lex_state = 167, .external_lex_state = 2},
  [857] = {.lex_state = 88},
  [858] = {.lex_state = 161, .external_lex_state = 2},
  [859] = {.lex_state = 226, .external_lex_state = 4},
  [860] = {.lex_state = 88},
  [861] = {.lex_state = 186, .external_lex_state = 2},
  [862] = {.lex_state = 88},
  [863] = {.lex_state = 88},
  [864] = {.lex_state = 192, .external_lex_state = 2},
  [865] = {.lex_state = 88},
  [866] = {.lex_state = 230},
  [867] = {.lex_state = 144, .external_lex_state = 4},
  [868] = {.lex_state = 88},
  [869] = {.lex_state = 88},
  [870] = {.lex_state = 88},
  [871] = {.lex_state = 204, .external_lex_state = 2},
  [872] = {.lex_state = 88},
  [873] = {.lex_state = 184},
  [874] = {.lex_state = 113},
  [875] = {.lex_state = 246, .external_lex_state = 9},
  [876] = {.lex_state = 123},
  [877] = {.lex_state = 123},
  [878] = {.lex_state = 53, .external_lex_state = 2},
  [879] = {.lex_state = 53, .external_lex_state = 2},
  [880] = {.lex_state = 53, .external_lex_state = 2},
  [881] = {.lex_state = 156, .external_lex_state = 11},
  [882] = {.lex_state = 88},
  [883] = {.lex_state = 156, .external_lex_state = 11},
  [884] = {.lex_state = 88},
  [885] = {.lex_state = 88},
  [886] = {.lex_state = 156, .external_lex_state = 11},
  [887] = {.lex_state = 238, .external_lex_state = 9},
  [888] = {.lex_state = 88},
  [889] = {.lex_state = 88},
  [890] = {.lex_state = 238, .external_lex_state = 9},
  [891] = {.lex_state = 88},
  [892] = {.lex_state = 208, .external_lex_state = 12},
  [893] = {.lex_state = 240, .external_lex_state = 12},
  [894] = {.lex_state = 109},
  [895] = {.lex_state = 246, .external_lex_state = 9},
  [896] = {.lex_state = 88},
  [897] = {.lex_state = 212, .external_lex_state = 11},
  [898] = {.lex_state = 210, .external_lex_state = 12},
  [899] = {.lex_state = 210, .external_lex_state = 11},
  [900] = {.lex_state = 113},
  [901] = {.lex_state = 109},
  [902] = {.lex_state = 212, .external_lex_state = 11},
  [903] = {.lex_state = 210, .external_lex_state = 11},
  [904] = {.lex_state = 210, .external_lex_state = 11},
  [905] = {.lex_state = 210, .external_lex_state = 11},
  [906] = {.lex_state = 123},
  [907] = {.lex_state = 88},
  [908] = {.lex_state = 88},
  [909] = {.lex_state = 88},
  [910] = {.lex_state = 161, .external_lex_state = 2},
  [911] = {.lex_state = 88},
  [912] = {.lex_state = 167, .external_lex_state = 2},
  [913] = {.lex_state = 88},
  [914] = {.lex_state = 161, .external_lex_state = 2},
  [915] = {.lex_state = 210, .external_lex_state = 12},
  [916] = {.lex_state = 218, .external_lex_state = 15},
  [917] = {.lex_state = 212, .external_lex_state = 12},
  [918] = {.lex_state = 167, .external_lex_state = 10},
  [919] = {.lex_state = 88},
  [920] = {.lex_state = 248, .external_lex_state = 9},
  [921] = {.lex_state = 214, .external_lex_state = 12},
  [922] = {.lex_state = 109},
  [923] = {.lex_state = 248, .external_lex_state = 9},
  [924] = {.lex_state = 216, .external_lex_state = 11},
  [925] = {.lex_state = 216, .external_lex_state = 11},
  [926] = {.lex_state = 216, .external_lex_state = 12},
  [927] = {.lex_state = 131, .external_lex_state = 4},
  [928] = {.lex_state = 236, .external_lex_state = 8},
  [929] = {.lex_state = 131, .external_lex_state = 4},
  [930] = {.lex_state = 177, .external_lex_state = 3},
  [931] = {.lex_state = 177, .external_lex_state = 3},
  [932] = {.lex_state = 180, .external_lex_state = 3},
  [933] = {.lex_state = 88},
  [934] = {.lex_state = 88},
  [935] = {.lex_state = 177, .external_lex_state = 3},
  [936] = {.lex_state = 88},
  [937] = {.lex_state = 184},
  [938] = {.lex_state = 177, .external_lex_state = 3},
  [939] = {.lex_state = 88},
  [940] = {.lex_state = 184},
  [941] = {.lex_state = 177, .external_lex_state = 3},
  [942] = {.lex_state = 177, .external_lex_state = 3},
  [943] = {.lex_state = 218, .external_lex_state = 15},
  [944] = {.lex_state = 218, .external_lex_state = 15},
  [945] = {.lex_state = 218, .external_lex_state = 15},
  [946] = {.lex_state = 123},
  [947] = {.lex_state = 88},
  [948] = {.lex_state = 88},
  [949] = {.lex_state = 177, .external_lex_state = 5},
  [950] = {.lex_state = 218, .external_lex_state = 15},
  [951] = {.lex_state = 109, .external_lex_state = 2},
  [952] = {.lex_state = 184},
  [953] = {.lex_state = 221, .external_lex_state = 9},
  [954] = {.lex_state = 88},
  [955] = {.lex_state = 221, .external_lex_state = 9},
  [956] = {.lex_state = 88},
  [957] = {.lex_state = 88},
  [958] = {.lex_state = 221, .external_lex_state = 9},
  [959] = {.lex_state = 238, .external_lex_state = 9},
  [960] = {.lex_state = 88},
  [961] = {.lex_state = 88},
  [962] = {.lex_state = 238, .external_lex_state = 9},
  [963] = {.lex_state = 88},
  [964] = {.lex_state = 224, .external_lex_state = 9},
  [965] = {.lex_state = 224, .external_lex_state = 9},
  [966] = {.lex_state = 224, .external_lex_state = 9},
  [967] = {.lex_state = 88},
  [968] = {.lex_state = 88},
  [969] = {.lex_state = 224, .external_lex_state = 9},
  [970] = {.lex_state = 88},
  [971] = {.lex_state = 184},
  [972] = {.lex_state = 224, .external_lex_state = 9},
  [973] = {.lex_state = 88},
  [974] = {.lex_state = 184},
  [975] = {.lex_state = 224, .external_lex_state = 9},
  [976] = {.lex_state = 224, .external_lex_state = 9},
  [977] = {.lex_state = 142, .external_lex_state = 14},
  [978] = {.lex_state = 88},
  [979] = {.lex_state = 142, .external_lex_state = 14},
  [980] = {.lex_state = 88},
  [981] = {.lex_state = 88},
  [982] = {.lex_state = 142, .external_lex_state = 14},
  [983] = {.lex_state = 238, .external_lex_state = 9},
  [984] = {.lex_state = 88},
  [985] = {.lex_state = 88},
  [986] = {.lex_state = 238, .external_lex_state = 9},
  [987] = {.lex_state = 88},
  [988] = {.lex_state = 226, .external_lex_state = 8},
  [989] = {.lex_state = 226, .external_lex_state = 8},
  [990] = {.lex_state = 226, .external_lex_state = 8},
  [991] = {.lex_state = 88},
  [992] = {.lex_state = 88},
  [993] = {.lex_state = 226, .external_lex_state = 8},
  [994] = {.lex_state = 88},
  [995] = {.lex_state = 184},
  [996] = {.lex_state = 226, .external_lex_state = 8},
  [997] = {.lex_state = 88},
  [998] = {.lex_state = 184},
  [999] = {.lex_state = 226, .external_lex_state = 8},
  [1000] = {.lex_state = 226, .external_lex_state = 8},
  [1001] = {.lex_state = 131, .external_lex_state = 4},
  [1002] = {.lex_state = 192, .external_lex_state = 2},
  [1003] = {.lex_state = 228, .external_lex_state = 2},
  [1004] = {.lex_state = 228, .external_lex_state = 2},
  [1005] = {.lex_state = 131, .external_lex_state = 4},
  [1006] = {.lex_state = 88},
  [1007] = {.lex_state = 109},
  [1008] = {.lex_state = 250, .external_lex_state = 2},
  [1009] = {.lex_state = 221},
  [1010] = {.lex_state = 242, .external_lex_state = 9},
  [1011] = {.lex_state = 131, .external_lex_state = 4},
  [1012] = {.lex_state = 230},
  [1013] = {.lex_state = 230},
  [1014] = {.lex_state = 88},
  [1015] = {.lex_state = 88},
  [1016] = {.lex_state = 88},
  [1017] = {.lex_state = 144, .external_lex_state = 8},
  [1018] = {.lex_state = 88},
  [1019] = {.lex_state = 144, .external_lex_state = 8},
  [1020] = {.lex_state = 131, .external_lex_state = 4},
  [1021] = {.lex_state = 142, .external_lex_state = 14},
  [1022] = {.lex_state = 202, .external_lex_state = 5},
  [1023] = {.lex_state = 244, .external_lex_state = 8},
  [1024] = {.lex_state = 244, .external_lex_state = 8},
  [1025] = {.lex_state = 177, .external_lex_state = 3},
  [1026] = {.lex_state = 88},
  [1027] = {.lex_state = 88},
  [1028] = {.lex_state = 88},
  [1029] = {.lex_state = 206, .external_lex_state = 9},
  [1030] = {.lex_state = 88},
  [1031] = {.lex_state = 206, .external_lex_state = 9},
  [1032] = {.lex_state = 88},
  [1033] = {.lex_state = 88},
  [1034] = {.lex_state = 88},
  [1035] = {.lex_state = 152, .external_lex_state = 9},
  [1036] = {.lex_state = 88},
  [1037] = {.lex_state = 152, .external_lex_state = 9},
  [1038] = {.lex_state = 131, .external_lex_state = 4},
  [1039] = {.lex_state = 244, .external_lex_state = 8},
  [1040] = {.lex_state = 244, .external_lex_state = 8},
  [1041] = {.lex_state = 236, .external_lex_state = 8},
  [1042] = {.lex_state = 88},
  [1043] = {.lex_state = 88},
  [1044] = {.lex_state = 244, .external_lex_state = 8},
  [1045] = {.lex_state = 88},
  [1046] = {.lex_state = 184},
  [1047] = {.lex_state = 244, .external_lex_state = 8},
  [1048] = {.lex_state = 88},
  [1049] = {.lex_state = 184},
  [1050] = {.lex_state = 244, .external_lex_state = 8},
  [1051] = {.lex_state = 244, .external_lex_state = 8},
  [1052] = {.lex_state = 88},
  [1053] = {.lex_state = 88},
  [1054] = {.lex_state = 88},
  [1055] = {.lex_state = 109, .external_lex_state = 10},
  [1056] = {.lex_state = 88},
  [1057] = {.lex_state = 109, .external_lex_state = 10},
  [1058] = {.lex_state = 88},
  [1059] = {.lex_state = 88},
  [1060] = {.lex_state = 88},
  [1061] = {.lex_state = 113},
  [1062] = {.lex_state = 88},
  [1063] = {.lex_state = 113},
  [1064] = {.lex_state = 88},
  [1065] = {.lex_state = 88},
  [1066] = {.lex_state = 136, .external_lex_state = 3},
  [1067] = {.lex_state = 238, .external_lex_state = 9},
  [1068] = {.lex_state = 136, .external_lex_state = 3},
  [1069] = {.lex_state = 161, .external_lex_state = 2},
  [1070] = {.lex_state = 161, .external_lex_state = 10},
  [1071] = {.lex_state = 161, .external_lex_state = 10},
  [1072] = {.lex_state = 161, .external_lex_state = 10},
  [1073] = {.lex_state = 88},
  [1074] = {.lex_state = 88},
  [1075] = {.lex_state = 161, .external_lex_state = 10},
  [1076] = {.lex_state = 88},
  [1077] = {.lex_state = 184},
  [1078] = {.lex_state = 161, .external_lex_state = 10},
  [1079] = {.lex_state = 88},
  [1080] = {.lex_state = 184},
  [1081] = {.lex_state = 161, .external_lex_state = 10},
  [1082] = {.lex_state = 161, .external_lex_state = 10},
  [1083] = {.lex_state = 88},
  [1084] = {.lex_state = 88},
  [1085] = {.lex_state = 88},
  [1086] = {.lex_state = 88},
  [1087] = {.lex_state = 88},
  [1088] = {.lex_state = 88},
  [1089] = {.lex_state = 230},
  [1090] = {.lex_state = 230},
  [1091] = {.lex_state = 208, .external_lex_state = 12},
  [1092] = {.lex_state = 88},
  [1093] = {.lex_state = 88},
  [1094] = {.lex_state = 184},
  [1095] = {.lex_state = 252, .external_lex_state = 9},
  [1096] = {.lex_state = 113},
  [1097] = {.lex_state = 109},
  [1098] = {.lex_state = 246, .external_lex_state = 9},
  [1099] = {.lex_state = 252, .external_lex_state = 9},
  [1100] = {.lex_state = 252, .external_lex_state = 9},
  [1101] = {.lex_state = 252, .external_lex_state = 9},
  [1102] = {.lex_state = 123},
  [1103] = {.lex_state = 88},
  [1104] = {.lex_state = 88},
  [1105] = {.lex_state = 88},
  [1106] = {.lex_state = 161, .external_lex_state = 2},
  [1107] = {.lex_state = 88},
  [1108] = {.lex_state = 167, .external_lex_state = 2},
  [1109] = {.lex_state = 88},
  [1110] = {.lex_state = 161, .external_lex_state = 2},
  [1111] = {.lex_state = 88},
  [1112] = {.lex_state = 88},
  [1113] = {.lex_state = 88},
  [1114] = {.lex_state = 156, .external_lex_state = 11},
  [1115] = {.lex_state = 88},
  [1116] = {.lex_state = 156, .external_lex_state = 11},
  [1117] = {.lex_state = 88},
  [1118] = {.lex_state = 246, .external_lex_state = 9},
  [1119] = {.lex_state = 88},
  [1120] = {.lex_state = 210, .external_lex_state = 11},
  [1121] = {.lex_state = 210, .external_lex_state = 11},
  [1122] = {.lex_state = 212, .external_lex_state = 11},
  [1123] = {.lex_state = 88},
  [1124] = {.lex_state = 88},
  [1125] = {.lex_state = 210, .external_lex_state = 11},
  [1126] = {.lex_state = 88},
  [1127] = {.lex_state = 184},
  [1128] = {.lex_state = 210, .external_lex_state = 11},
  [1129] = {.lex_state = 88},
  [1130] = {.lex_state = 184},
  [1131] = {.lex_state = 210, .external_lex_state = 11},
  [1132] = {.lex_state = 210, .external_lex_state = 11},
  [1133] = {.lex_state = 210, .external_lex_state = 12},
  [1134] = {.lex_state = 167, .external_lex_state = 10},
  [1135] = {.lex_state = 214, .external_lex_state = 12},
  [1136] = {.lex_state = 248, .external_lex_state = 9},
  [1137] = {.lex_state = 248, .external_lex_state = 9},
  [1138] = {.lex_state = 216, .external_lex_state = 11},
  [1139] = {.lex_state = 177, .external_lex_state = 3},
  [1140] = {.lex_state = 88},
  [1141] = {.lex_state = 177, .external_lex_state = 3},
  [1142] = {.lex_state = 88},
  [1143] = {.lex_state = 88},
  [1144] = {.lex_state = 177, .external_lex_state = 3},
  [1145] = {.lex_state = 238, .external_lex_state = 9},
  [1146] = {.lex_state = 88},
  [1147] = {.lex_state = 88},
  [1148] = {.lex_state = 238, .external_lex_state = 9},
  [1149] = {.lex_state = 88},
  [1150] = {.lex_state = 88},
  [1151] = {.lex_state = 88},
  [1152] = {.lex_state = 218, .external_lex_state = 15},
  [1153] = {.lex_state = 88},
  [1154] = {.lex_state = 184},
  [1155] = {.lex_state = 218, .external_lex_state = 15},
  [1156] = {.lex_state = 88},
  [1157] = {.lex_state = 184},
  [1158] = {.lex_state = 109, .external_lex_state = 2},
  [1159] = {.lex_state = 88},
  [1160] = {.lex_state = 88},
  [1161] = {.lex_state = 88},
  [1162] = {.lex_state = 221, .external_lex_state = 9},
  [1163] = {.lex_state = 88},
  [1164] = {.lex_state = 221, .external_lex_state = 9},
  [1165] = {.lex_state = 224, .external_lex_state = 9},
  [1166] = {.lex_state = 88},
  [1167] = {.lex_state = 224, .external_lex_state = 9},
  [1168] = {.lex_state = 88},
  [1169] = {.lex_state = 88},
  [1170] = {.lex_state = 224, .external_lex_state = 9},
  [1171] = {.lex_state = 238, .external_lex_state = 9},
  [1172] = {.lex_state = 88},
  [1173] = {.lex_state = 88},
  [1174] = {.lex_state = 238, .external_lex_state = 9},
  [1175] = {.lex_state = 88},
  [1176] = {.lex_state = 88},
  [1177] = {.lex_state = 88},
  [1178] = {.lex_state = 88},
  [1179] = {.lex_state = 142, .external_lex_state = 14},
  [1180] = {.lex_state = 88},
  [1181] = {.lex_state = 142, .external_lex_state = 14},
  [1182] = {.lex_state = 226, .external_lex_state = 8},
  [1183] = {.lex_state = 88},
  [1184] = {.lex_state = 226, .external_lex_state = 8},
  [1185] = {.lex_state = 88},
  [1186] = {.lex_state = 88},
  [1187] = {.lex_state = 226, .external_lex_state = 8},
  [1188] = {.lex_state = 238, .external_lex_state = 9},
  [1189] = {.lex_state = 88},
  [1190] = {.lex_state = 88},
  [1191] = {.lex_state = 238, .external_lex_state = 9},
  [1192] = {.lex_state = 88},
  [1193] = {.lex_state = 192, .external_lex_state = 2},
  [1194] = {.lex_state = 131, .external_lex_state = 4},
  [1195] = {.lex_state = 242, .external_lex_state = 9},
  [1196] = {.lex_state = 221},
  [1197] = {.lex_state = 230},
  [1198] = {.lex_state = 250, .external_lex_state = 2},
  [1199] = {.lex_state = 250, .external_lex_state = 2},
  [1200] = {.lex_state = 221},
  [1201] = {.lex_state = 242, .external_lex_state = 9},
  [1202] = {.lex_state = 131, .external_lex_state = 4},
  [1203] = {.lex_state = 88},
  [1204] = {.lex_state = 88},
  [1205] = {.lex_state = 144, .external_lex_state = 8},
  [1206] = {.lex_state = 144, .external_lex_state = 8},
  [1207] = {.lex_state = 244, .external_lex_state = 8},
  [1208] = {.lex_state = 88},
  [1209] = {.lex_state = 88},
  [1210] = {.lex_state = 206, .external_lex_state = 9},
  [1211] = {.lex_state = 206, .external_lex_state = 9},
  [1212] = {.lex_state = 88},
  [1213] = {.lex_state = 88},
  [1214] = {.lex_state = 152, .external_lex_state = 9},
  [1215] = {.lex_state = 152, .external_lex_state = 9},
  [1216] = {.lex_state = 244, .external_lex_state = 8},
  [1217] = {.lex_state = 88},
  [1218] = {.lex_state = 244, .external_lex_state = 8},
  [1219] = {.lex_state = 88},
  [1220] = {.lex_state = 88},
  [1221] = {.lex_state = 244, .external_lex_state = 8},
  [1222] = {.lex_state = 238, .external_lex_state = 9},
  [1223] = {.lex_state = 88},
  [1224] = {.lex_state = 88},
  [1225] = {.lex_state = 238, .external_lex_state = 9},
  [1226] = {.lex_state = 88},
  [1227] = {.lex_state = 88},
  [1228] = {.lex_state = 88},
  [1229] = {.lex_state = 109, .external_lex_state = 10},
  [1230] = {.lex_state = 109, .external_lex_state = 10},
  [1231] = {.lex_state = 88},
  [1232] = {.lex_state = 88},
  [1233] = {.lex_state = 113},
  [1234] = {.lex_state = 113},
  [1235] = {.lex_state = 136, .external_lex_state = 3},
  [1236] = {.lex_state = 136, .external_lex_state = 3},
  [1237] = {.lex_state = 161, .external_lex_state = 10},
  [1238] = {.lex_state = 88},
  [1239] = {.lex_state = 161, .external_lex_state = 10},
  [1240] = {.lex_state = 88},
  [1241] = {.lex_state = 88},
  [1242] = {.lex_state = 161, .external_lex_state = 10},
  [1243] = {.lex_state = 238, .external_lex_state = 9},
  [1244] = {.lex_state = 88},
  [1245] = {.lex_state = 88},
  [1246] = {.lex_state = 238, .external_lex_state = 9},
  [1247] = {.lex_state = 88},
  [1248] = {.lex_state = 88},
  [1249] = {.lex_state = 88},
  [1250] = {.lex_state = 88},
  [1251] = {.lex_state = 88},
  [1252] = {.lex_state = 230},
  [1253] = {.lex_state = 88},
  [1254] = {.lex_state = 88},
  [1255] = {.lex_state = 252, .external_lex_state = 9},
  [1256] = {.lex_state = 252, .external_lex_state = 9},
  [1257] = {.lex_state = 246, .external_lex_state = 9},
  [1258] = {.lex_state = 88},
  [1259] = {.lex_state = 88},
  [1260] = {.lex_state = 252, .external_lex_state = 9},
  [1261] = {.lex_state = 88},
  [1262] = {.lex_state = 184},
  [1263] = {.lex_state = 252, .external_lex_state = 9},
  [1264] = {.lex_state = 88},
  [1265] = {.lex_state = 184},
  [1266] = {.lex_state = 252, .external_lex_state = 9},
  [1267] = {.lex_state = 252, .external_lex_state = 9},
  [1268] = {.lex_state = 88},
  [1269] = {.lex_state = 88},
  [1270] = {.lex_state = 156, .external_lex_state = 11},
  [1271] = {.lex_state = 156, .external_lex_state = 11},
  [1272] = {.lex_state = 210, .external_lex_state = 11},
  [1273] = {.lex_state = 88},
  [1274] = {.lex_state = 210, .external_lex_state = 11},
  [1275] = {.lex_state = 88},
  [1276] = {.lex_state = 88},
  [1277] = {.lex_state = 210, .external_lex_state = 11},
  [1278] = {.lex_state = 238, .external_lex_state = 9},
  [1279] = {.lex_state = 88},
  [1280] = {.lex_state = 88},
  [1281] = {.lex_state = 238, .external_lex_state = 9},
  [1282] = {.lex_state = 88},
  [1283] = {.lex_state = 248, .external_lex_state = 9},
  [1284] = {.lex_state = 88},
  [1285] = {.lex_state = 88},
  [1286] = {.lex_state = 88},
  [1287] = {.lex_state = 177, .external_lex_state = 3},
  [1288] = {.lex_state = 88},
  [1289] = {.lex_state = 177, .external_lex_state = 3},
  [1290] = {.lex_state = 218, .external_lex_state = 15},
  [1291] = {.lex_state = 88},
  [1292] = {.lex_state = 218, .external_lex_state = 15},
  [1293] = {.lex_state = 88},
  [1294] = {.lex_state = 88},
  [1295] = {.lex_state = 218, .external_lex_state = 15},
  [1296] = {.lex_state = 238, .external_lex_state = 9},
  [1297] = {.lex_state = 88},
  [1298] = {.lex_state = 88},
  [1299] = {.lex_state = 238, .external_lex_state = 9},
  [1300] = {.lex_state = 88},
  [1301] = {.lex_state = 88},
  [1302] = {.lex_state = 88},
  [1303] = {.lex_state = 221, .external_lex_state = 9},
  [1304] = {.lex_state = 221, .external_lex_state = 9},
  [1305] = {.lex_state = 88},
  [1306] = {.lex_state = 88},
  [1307] = {.lex_state = 88},
  [1308] = {.lex_state = 224, .external_lex_state = 9},
  [1309] = {.lex_state = 88},
  [1310] = {.lex_state = 224, .external_lex_state = 9},
  [1311] = {.lex_state = 88},
  [1312] = {.lex_state = 88},
  [1313] = {.lex_state = 142, .external_lex_state = 14},
  [1314] = {.lex_state = 142, .external_lex_state = 14},
  [1315] = {.lex_state = 88},
  [1316] = {.lex_state = 88},
  [1317] = {.lex_state = 88},
  [1318] = {.lex_state = 226, .external_lex_state = 8},
  [1319] = {.lex_state = 88},
  [1320] = {.lex_state = 226, .external_lex_state = 8},
  [1321] = {.lex_state = 230},
  [1322] = {.lex_state = 250, .external_lex_state = 2},
  [1323] = {.lex_state = 250, .external_lex_state = 2},
  [1324] = {.lex_state = 144, .external_lex_state = 8},
  [1325] = {.lex_state = 144, .external_lex_state = 8},
  [1326] = {.lex_state = 206, .external_lex_state = 9},
  [1327] = {.lex_state = 206, .external_lex_state = 9},
  [1328] = {.lex_state = 152, .external_lex_state = 9},
  [1329] = {.lex_state = 152, .external_lex_state = 9},
  [1330] = {.lex_state = 88},
  [1331] = {.lex_state = 88},
  [1332] = {.lex_state = 88},
  [1333] = {.lex_state = 244, .external_lex_state = 8},
  [1334] = {.lex_state = 88},
  [1335] = {.lex_state = 244, .external_lex_state = 8},
  [1336] = {.lex_state = 109, .external_lex_state = 10},
  [1337] = {.lex_state = 109, .external_lex_state = 10},
  [1338] = {.lex_state = 113},
  [1339] = {.lex_state = 113},
  [1340] = {.lex_state = 88},
  [1341] = {.lex_state = 88},
  [1342] = {.lex_state = 88},
  [1343] = {.lex_state = 161, .external_lex_state = 10},
  [1344] = {.lex_state = 88},
  [1345] = {.lex_state = 161, .external_lex_state = 10},
  [1346] = {.lex_state = 88},
  [1347] = {.lex_state = 88},
  [1348] = {.lex_state = 252, .external_lex_state = 9},
  [1349] = {.lex_state = 88},
  [1350] = {.lex_state = 252, .external_lex_state = 9},
  [1351] = {.lex_state = 88},
  [1352] = {.lex_state = 88},
  [1353] = {.lex_state = 252, .external_lex_state = 9},
  [1354] = {.lex_state = 238, .external_lex_state = 9},
  [1355] = {.lex_state = 88},
  [1356] = {.lex_state = 88},
  [1357] = {.lex_state = 238, .external_lex_state = 9},
  [1358] = {.lex_state = 88},
  [1359] = {.lex_state = 156, .external_lex_state = 11},
  [1360] = {.lex_state = 156, .external_lex_state = 11},
  [1361] = {.lex_state = 88},
  [1362] = {.lex_state = 88},
  [1363] = {.lex_state = 88},
  [1364] = {.lex_state = 210, .external_lex_state = 11},
  [1365] = {.lex_state = 88},
  [1366] = {.lex_state = 210, .external_lex_state = 11},
  [1367] = {.lex_state = 88},
  [1368] = {.lex_state = 88},
  [1369] = {.lex_state = 177, .external_lex_state = 3},
  [1370] = {.lex_state = 177, .external_lex_state = 3},
  [1371] = {.lex_state = 88},
  [1372] = {.lex_state = 88},
  [1373] = {.lex_state = 88},
  [1374] = {.lex_state = 218, .external_lex_state = 15},
  [1375] = {.lex_state = 88},
  [1376] = {.lex_state = 218, .external_lex_state = 15},
  [1377] = {.lex_state = 221, .external_lex_state = 9},
  [1378] = {.lex_state = 221, .external_lex_state = 9},
  [1379] = {.lex_state = 88},
  [1380] = {.lex_state = 88},
  [1381] = {.lex_state = 224, .external_lex_state = 9},
  [1382] = {.lex_state = 224, .external_lex_state = 9},
  [1383] = {.lex_state = 142, .external_lex_state = 14},
  [1384] = {.lex_state = 142, .external_lex_state = 14},
  [1385] = {.lex_state = 88},
  [1386] = {.lex_state = 88},
  [1387] = {.lex_state = 226, .external_lex_state = 8},
  [1388] = {.lex_state = 226, .external_lex_state = 8},
  [1389] = {.lex_state = 230},
  [1390] = {.lex_state = 88},
  [1391] = {.lex_state = 88},
  [1392] = {.lex_state = 244, .external_lex_state = 8},
  [1393] = {.lex_state = 244, .external_lex_state = 8},
  [1394] = {.lex_state = 88},
  [1395] = {.lex_state = 88},
  [1396] = {.lex_state = 161, .external_lex_state = 10},
  [1397] = {.lex_state = 161, .external_lex_state = 10},
  [1398] = {.lex_state = 88},
  [1399] = {.lex_state = 88},
  [1400] = {.lex_state = 88},
  [1401] = {.lex_state = 252, .external_lex_state = 9},
  [1402] = {.lex_state = 88},
  [1403] = {.lex_state = 252, .external_lex_state = 9},
  [1404] = {.lex_state = 88},
  [1405] = {.lex_state = 88},
  [1406] = {.lex_state = 210, .external_lex_state = 11},
  [1407] = {.lex_state = 210, .external_lex_state = 11},
  [1408] = {.lex_state = 177, .external_lex_state = 3},
  [1409] = {.lex_state = 177, .external_lex_state = 3},
  [1410] = {.lex_state = 88},
  [1411] = {.lex_state = 88},
  [1412] = {.lex_state = 218, .external_lex_state = 15},
  [1413] = {.lex_state = 218, .external_lex_state = 15},
  [1414] = {.lex_state = 224, .external_lex_state = 9},
  [1415] = {.lex_state = 224, .external_lex_state = 9},
  [1416] = {.lex_state = 226, .external_lex_state = 8},
  [1417] = {.lex_state = 226, .external_lex_state = 8},
  [1418] = {.lex_state = 244, .external_lex_state = 8},
  [1419] = {.lex_state = 244, .external_lex_state = 8},
  [1420] = {.lex_state = 161, .external_lex_state = 10},
  [1421] = {.lex_state = 161, .external_lex_state = 10},
  [1422] = {.lex_state = 88},
  [1423] = {.lex_state = 88},
  [1424] = {.lex_state = 252, .external_lex_state = 9},
  [1425] = {.lex_state = 252, .external_lex_state = 9},
  [1426] = {.lex_state = 210, .external_lex_state = 11},
  [1427] = {.lex_state = 210, .external_lex_state = 11},
  [1428] = {.lex_state = 218, .external_lex_state = 15},
  [1429] = {.lex_state = 218, .external_lex_state = 15},
  [1430] = {.lex_state = 252, .external_lex_state = 9},
  [1431] = {.lex_state = 252, .external_lex_state = 9},
};

enum {
  ts_external_token__simple_heredoc,
  ts_external_token__heredoc_beginning,
  ts_external_token__heredoc_middle,
  ts_external_token__heredoc_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__simple_heredoc] = sym__simple_heredoc,
  [ts_external_token__heredoc_beginning] = sym__heredoc_beginning,
  [ts_external_token__heredoc_middle] = sym__heredoc_middle,
  [ts_external_token__heredoc_end] = sym__heredoc_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[16][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token__empty_value] = true,
  },
  [8] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__concat] = true,
  },
  [10] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [11] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [12] = {
    [ts_external_token_file_descriptor] = true,
  },
  [13] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
  },
  [14] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__simple_heredoc] = ACTIONS(1),
    [sym__heredoc_beginning] = ACTIONS(1),
    [sym__heredoc_middle] = ACTIONS(1),
    [sym__heredoc_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(5),
    [sym_simple_variable_name] = ACTIONS(8),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(3),
    [anon_sym__] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(22),
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [ts_builtin_sym_end] = ACTIONS(14),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(56),
    [anon_sym_GT_GT] = ACTIONS(58),
    [anon_sym_AMP_GT] = ACTIONS(56),
    [anon_sym_AMP_GT_GT] = ACTIONS(58),
    [anon_sym_LT_AMP] = ACTIONS(58),
    [anon_sym_GT_AMP] = ACTIONS(58),
    [sym_comment] = ACTIONS(54),
  },
  [3] = {
    [sym__assignment] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(62),
    [sym_comment] = ACTIONS(54),
  },
  [4] = {
    [sym_word] = ACTIONS(64),
    [sym_comment] = ACTIONS(54),
  },
  [5] = {
    [sym__terminated_statement] = STATE(37),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_bracket_command] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(39),
    [sym_local_variable_declaration] = STATE(38),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [6] = {
    [sym__terminated_statement] = STATE(40),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_bracket_command] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(39),
    [sym_local_variable_declaration] = STATE(38),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [7] = {
    [sym_concatenation] = STATE(48),
    [sym_string] = STATE(42),
    [sym_simple_expansion] = STATE(42),
    [sym_expansion] = STATE(42),
    [sym_command_substitution] = STATE(42),
    [sym_process_substitution] = STATE(42),
    [anon_sym_DQUOTE] = ACTIONS(66),
    [sym_raw_string] = ACTIONS(68),
    [anon_sym_DOLLAR] = ACTIONS(70),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(72),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(74),
    [anon_sym_BQUOTE] = ACTIONS(76),
    [anon_sym_LT_LPAREN] = ACTIONS(78),
    [anon_sym_GT_LPAREN] = ACTIONS(78),
    [sym_word] = ACTIONS(80),
    [sym_comment] = ACTIONS(54),
  },
  [8] = {
    [sym_word] = ACTIONS(82),
    [sym_comment] = ACTIONS(54),
  },
  [9] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_case_statement] = STATE(55),
    [sym_function_definition] = STATE(55),
    [sym_subshell] = STATE(55),
    [sym_pipeline] = STATE(55),
    [sym_list] = STATE(55),
    [sym_bracket_command] = STATE(55),
    [sym_command] = STATE(55),
    [sym_command_name] = STATE(56),
    [sym_environment_variable_assignment] = STATE(57),
    [sym_local_variable_declaration] = STATE(55),
    [sym_subscript] = STATE(58),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(53),
    [sym_simple_expansion] = STATE(53),
    [sym_expansion] = STATE(53),
    [sym_command_substitution] = STATE(53),
    [sym_process_substitution] = STATE(53),
    [aux_sym_program_repeat1] = STATE(59),
    [aux_sym_command_repeat1] = STATE(60),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(84),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(90),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(92),
    [sym_comment] = ACTIONS(54),
  },
  [10] = {
    [sym_concatenation] = STATE(68),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_for_statement_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(96),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(108),
    [sym_comment] = ACTIONS(54),
  },
  [11] = {
    [sym_concatenation] = STATE(77),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_for_statement_repeat1] = STATE(78),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [sym_raw_string] = ACTIONS(112),
    [anon_sym_DOLLAR] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_word] = ACTIONS(124),
    [sym_comment] = ACTIONS(54),
  },
  [12] = {
    [sym_comment] = ACTIONS(54),
    [sym_simple_variable_name] = ACTIONS(126),
  },
  [13] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(81),
    [sym_simple_expansion] = STATE(81),
    [sym_expansion] = STATE(81),
    [sym_command_substitution] = STATE(81),
    [sym_process_substitution] = STATE(81),
    [anon_sym_DQUOTE] = ACTIONS(128),
    [sym_raw_string] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(134),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(136),
    [anon_sym_BQUOTE] = ACTIONS(138),
    [anon_sym_LT_LPAREN] = ACTIONS(140),
    [anon_sym_GT_LPAREN] = ACTIONS(140),
    [sym_word] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
  },
  [14] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(94),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [15] = {
    [aux_sym_concatenation_repeat1] = STATE(96),
    [sym_file_descriptor] = ACTIONS(158),
    [sym__concat] = ACTIONS(160),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_SEMI_SEMI] = ACTIONS(162),
    [anon_sym_PIPE_AMP] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(162),
    [anon_sym_PIPE_PIPE] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(162),
    [anon_sym_GT] = ACTIONS(162),
    [anon_sym_GT_GT] = ACTIONS(162),
    [anon_sym_AMP_GT] = ACTIONS(162),
    [anon_sym_AMP_GT_GT] = ACTIONS(162),
    [anon_sym_LT_AMP] = ACTIONS(162),
    [anon_sym_GT_AMP] = ACTIONS(162),
    [anon_sym_LT_LT] = ACTIONS(162),
    [anon_sym_LT_LT_DASH] = ACTIONS(162),
    [anon_sym_DQUOTE] = ACTIONS(162),
    [sym_raw_string] = ACTIONS(162),
    [anon_sym_DOLLAR] = ACTIONS(162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(162),
    [anon_sym_BQUOTE] = ACTIONS(162),
    [anon_sym_LT_LPAREN] = ACTIONS(162),
    [anon_sym_GT_LPAREN] = ACTIONS(162),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(162),
    [anon_sym_LF] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(162),
  },
  [16] = {
    [sym_special_variable_name] = STATE(99),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(166),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(168),
    [anon_sym__] = ACTIONS(168),
  },
  [17] = {
    [sym_special_variable_name] = STATE(103),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(172),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(174),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [18] = {
    [sym_for_statement] = STATE(122),
    [sym_while_statement] = STATE(122),
    [sym_if_statement] = STATE(122),
    [sym_case_statement] = STATE(122),
    [sym_function_definition] = STATE(122),
    [sym_subshell] = STATE(122),
    [sym_pipeline] = STATE(122),
    [sym_list] = STATE(122),
    [sym_bracket_command] = STATE(122),
    [sym_command] = STATE(122),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(124),
    [sym_local_variable_declaration] = STATE(122),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [19] = {
    [sym_for_statement] = STATE(133),
    [sym_while_statement] = STATE(133),
    [sym_if_statement] = STATE(133),
    [sym_case_statement] = STATE(133),
    [sym_function_definition] = STATE(133),
    [sym_subshell] = STATE(133),
    [sym_pipeline] = STATE(133),
    [sym_list] = STATE(133),
    [sym_bracket_command] = STATE(133),
    [sym_command] = STATE(133),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(135),
    [sym_local_variable_declaration] = STATE(133),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [20] = {
    [sym_for_statement] = STATE(138),
    [sym_while_statement] = STATE(138),
    [sym_if_statement] = STATE(138),
    [sym_case_statement] = STATE(138),
    [sym_function_definition] = STATE(138),
    [sym_subshell] = STATE(138),
    [sym_pipeline] = STATE(138),
    [sym_list] = STATE(138),
    [sym_bracket_command] = STATE(138),
    [sym_command] = STATE(138),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(139),
    [sym_local_variable_declaration] = STATE(138),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [21] = {
    [sym_compound_statement] = STATE(142),
    [aux_sym_concatenation_repeat1] = STATE(96),
    [sym_file_descriptor] = ACTIONS(158),
    [sym__concat] = ACTIONS(160),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_SEMI_SEMI] = ACTIONS(162),
    [anon_sym_LPAREN] = ACTIONS(224),
    [anon_sym_LBRACE] = ACTIONS(226),
    [anon_sym_PIPE_AMP] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(162),
    [anon_sym_PIPE_PIPE] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(162),
    [anon_sym_GT] = ACTIONS(162),
    [anon_sym_GT_GT] = ACTIONS(162),
    [anon_sym_AMP_GT] = ACTIONS(162),
    [anon_sym_AMP_GT_GT] = ACTIONS(162),
    [anon_sym_LT_AMP] = ACTIONS(162),
    [anon_sym_GT_AMP] = ACTIONS(162),
    [anon_sym_LT_LT] = ACTIONS(162),
    [anon_sym_LT_LT_DASH] = ACTIONS(162),
    [anon_sym_DQUOTE] = ACTIONS(162),
    [sym_raw_string] = ACTIONS(162),
    [anon_sym_DOLLAR] = ACTIONS(162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(162),
    [anon_sym_BQUOTE] = ACTIONS(162),
    [anon_sym_LT_LPAREN] = ACTIONS(162),
    [anon_sym_GT_LPAREN] = ACTIONS(162),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(162),
    [anon_sym_LF] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(162),
  },
  [22] = {
    [ts_builtin_sym_end] = ACTIONS(228),
    [sym_comment] = ACTIONS(54),
  },
  [23] = {
    [sym_file_descriptor] = ACTIONS(230),
    [sym_variable_name] = ACTIONS(230),
    [ts_builtin_sym_end] = ACTIONS(230),
    [anon_sym_for] = ACTIONS(232),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(232),
    [anon_sym_SEMI_SEMI] = ACTIONS(230),
    [anon_sym_function] = ACTIONS(232),
    [anon_sym_LPAREN] = ACTIONS(230),
    [anon_sym_RBRACE] = ACTIONS(230),
    [anon_sym_LBRACK] = ACTIONS(232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(232),
    [anon_sym_local] = ACTIONS(232),
    [anon_sym_LT] = ACTIONS(232),
    [anon_sym_GT] = ACTIONS(232),
    [anon_sym_GT_GT] = ACTIONS(230),
    [anon_sym_AMP_GT] = ACTIONS(232),
    [anon_sym_AMP_GT_GT] = ACTIONS(230),
    [anon_sym_LT_AMP] = ACTIONS(230),
    [anon_sym_GT_AMP] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(230),
    [sym_raw_string] = ACTIONS(230),
    [anon_sym_DOLLAR] = ACTIONS(232),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(230),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(230),
    [anon_sym_BQUOTE] = ACTIONS(230),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_word] = ACTIONS(234),
    [sym_comment] = ACTIONS(54),
  },
  [24] = {
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [25] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(149),
    [sym_simple_expansion] = STATE(149),
    [sym_expansion] = STATE(149),
    [sym_command_substitution] = STATE(149),
    [sym_process_substitution] = STATE(149),
    [aux_sym_for_statement_repeat1] = STATE(152),
    [aux_sym_command_repeat2] = STATE(153),
    [sym_file_descriptor] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(244),
    [anon_sym_SEMI_SEMI] = ACTIONS(244),
    [anon_sym_PIPE_AMP] = ACTIONS(244),
    [anon_sym_AMP_AMP] = ACTIONS(244),
    [anon_sym_PIPE_PIPE] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [anon_sym_GT_GT] = ACTIONS(246),
    [anon_sym_AMP_GT] = ACTIONS(246),
    [anon_sym_AMP_GT_GT] = ACTIONS(246),
    [anon_sym_LT_AMP] = ACTIONS(246),
    [anon_sym_GT_AMP] = ACTIONS(246),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_word] = ACTIONS(252),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(244),
    [anon_sym_LF] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(244),
  },
  [26] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [27] = {
    [sym__assignment] = STATE(35),
    [anon_sym_EQ] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(62),
    [sym_comment] = ACTIONS(54),
  },
  [28] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(268),
    [sym_comment] = ACTIONS(54),
  },
  [29] = {
    [sym_file_descriptor] = ACTIONS(158),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_RPAREN] = ACTIONS(162),
    [anon_sym_SEMI_SEMI] = ACTIONS(162),
    [anon_sym_PIPE_AMP] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(162),
    [anon_sym_PIPE_PIPE] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(162),
    [anon_sym_GT] = ACTIONS(162),
    [anon_sym_GT_GT] = ACTIONS(162),
    [anon_sym_AMP_GT] = ACTIONS(162),
    [anon_sym_AMP_GT_GT] = ACTIONS(162),
    [anon_sym_LT_AMP] = ACTIONS(162),
    [anon_sym_GT_AMP] = ACTIONS(162),
    [anon_sym_LT_LT] = ACTIONS(162),
    [anon_sym_LT_LT_DASH] = ACTIONS(162),
    [anon_sym_DQUOTE] = ACTIONS(162),
    [sym_raw_string] = ACTIONS(162),
    [anon_sym_DOLLAR] = ACTIONS(162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(162),
    [anon_sym_BQUOTE] = ACTIONS(162),
    [anon_sym_LT_LPAREN] = ACTIONS(162),
    [anon_sym_GT_LPAREN] = ACTIONS(162),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(162),
    [anon_sym_LF] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(162),
  },
  [30] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(154),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [ts_builtin_sym_end] = ACTIONS(270),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [31] = {
    [sym_command_name] = STATE(156),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(157),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(274),
    [sym_comment] = ACTIONS(54),
  },
  [32] = {
    [sym_concatenation] = STATE(160),
    [sym_string] = STATE(159),
    [sym_simple_expansion] = STATE(159),
    [sym_expansion] = STATE(159),
    [sym_command_substitution] = STATE(159),
    [sym_process_substitution] = STATE(159),
    [anon_sym_DQUOTE] = ACTIONS(128),
    [sym_raw_string] = ACTIONS(276),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(134),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(136),
    [anon_sym_BQUOTE] = ACTIONS(138),
    [anon_sym_LT_LPAREN] = ACTIONS(140),
    [anon_sym_GT_LPAREN] = ACTIONS(140),
    [sym_word] = ACTIONS(278),
    [sym_comment] = ACTIONS(54),
  },
  [33] = {
    [sym_concatenation] = STATE(168),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(282),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(294),
    [sym_comment] = ACTIONS(54),
  },
  [34] = {
    [sym_concatenation] = STATE(169),
    [sym_string] = STATE(172),
    [sym_array] = STATE(169),
    [sym_simple_expansion] = STATE(172),
    [sym_expansion] = STATE(172),
    [sym_command_substitution] = STATE(172),
    [sym_process_substitution] = STATE(172),
    [sym__empty_value] = ACTIONS(296),
    [anon_sym_LPAREN] = ACTIONS(298),
    [anon_sym_DQUOTE] = ACTIONS(300),
    [sym_raw_string] = ACTIONS(302),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(308),
    [anon_sym_BQUOTE] = ACTIONS(310),
    [anon_sym_LT_LPAREN] = ACTIONS(312),
    [anon_sym_GT_LPAREN] = ACTIONS(312),
    [sym_word] = ACTIONS(314),
    [sym_comment] = ACTIONS(54),
  },
  [35] = {
    [sym_file_descriptor] = ACTIONS(316),
    [sym_variable_name] = ACTIONS(316),
    [anon_sym_PIPE] = ACTIONS(318),
    [anon_sym_RPAREN] = ACTIONS(318),
    [anon_sym_SEMI_SEMI] = ACTIONS(318),
    [anon_sym_PIPE_AMP] = ACTIONS(318),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(318),
    [anon_sym_GT] = ACTIONS(318),
    [anon_sym_GT_GT] = ACTIONS(318),
    [anon_sym_AMP_GT] = ACTIONS(318),
    [anon_sym_AMP_GT_GT] = ACTIONS(318),
    [anon_sym_LT_AMP] = ACTIONS(318),
    [anon_sym_GT_AMP] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(318),
    [sym_raw_string] = ACTIONS(318),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(318),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(318),
    [anon_sym_BQUOTE] = ACTIONS(318),
    [anon_sym_LT_LPAREN] = ACTIONS(318),
    [anon_sym_GT_LPAREN] = ACTIONS(318),
    [sym_word] = ACTIONS(318),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(318),
    [anon_sym_LF] = ACTIONS(318),
    [anon_sym_AMP] = ACTIONS(318),
  },
  [36] = {
    [anon_sym_in] = ACTIONS(320),
    [sym_comment] = ACTIONS(54),
  },
  [37] = {
    [sym_do_group] = STATE(180),
    [anon_sym_do] = ACTIONS(322),
    [sym_comment] = ACTIONS(54),
  },
  [38] = {
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(324),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(324),
    [anon_sym_LF] = ACTIONS(324),
    [anon_sym_AMP] = ACTIONS(324),
  },
  [39] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(324),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(324),
    [anon_sym_LF] = ACTIONS(324),
    [anon_sym_AMP] = ACTIONS(324),
  },
  [40] = {
    [anon_sym_then] = ACTIONS(326),
    [sym_comment] = ACTIONS(54),
  },
  [41] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(184),
    [anon_sym_DQUOTE] = ACTIONS(328),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [42] = {
    [aux_sym_concatenation_repeat1] = STATE(188),
    [sym__concat] = ACTIONS(330),
    [anon_sym_in] = ACTIONS(332),
    [anon_sym_SEMI_SEMI] = ACTIONS(334),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(334),
    [anon_sym_LF] = ACTIONS(334),
    [anon_sym_AMP] = ACTIONS(334),
  },
  [43] = {
    [sym_special_variable_name] = STATE(191),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_POUND] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(336),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(336),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_DASH] = ACTIONS(336),
    [anon_sym_BANG] = ACTIONS(336),
    [anon_sym_0] = ACTIONS(340),
    [anon_sym__] = ACTIONS(340),
  },
  [44] = {
    [sym_special_variable_name] = STATE(194),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(344),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [45] = {
    [sym_for_statement] = STATE(195),
    [sym_while_statement] = STATE(195),
    [sym_if_statement] = STATE(195),
    [sym_case_statement] = STATE(195),
    [sym_function_definition] = STATE(195),
    [sym_subshell] = STATE(195),
    [sym_pipeline] = STATE(195),
    [sym_list] = STATE(195),
    [sym_bracket_command] = STATE(195),
    [sym_command] = STATE(195),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(196),
    [sym_local_variable_declaration] = STATE(195),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [46] = {
    [sym_for_statement] = STATE(197),
    [sym_while_statement] = STATE(197),
    [sym_if_statement] = STATE(197),
    [sym_case_statement] = STATE(197),
    [sym_function_definition] = STATE(197),
    [sym_subshell] = STATE(197),
    [sym_pipeline] = STATE(197),
    [sym_list] = STATE(197),
    [sym_bracket_command] = STATE(197),
    [sym_command] = STATE(197),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(198),
    [sym_local_variable_declaration] = STATE(197),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [47] = {
    [sym_for_statement] = STATE(199),
    [sym_while_statement] = STATE(199),
    [sym_if_statement] = STATE(199),
    [sym_case_statement] = STATE(199),
    [sym_function_definition] = STATE(199),
    [sym_subshell] = STATE(199),
    [sym_pipeline] = STATE(199),
    [sym_list] = STATE(199),
    [sym_bracket_command] = STATE(199),
    [sym_command] = STATE(199),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(200),
    [sym_local_variable_declaration] = STATE(199),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [48] = {
    [anon_sym_in] = ACTIONS(332),
    [anon_sym_SEMI_SEMI] = ACTIONS(334),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(334),
    [anon_sym_LF] = ACTIONS(334),
    [anon_sym_AMP] = ACTIONS(334),
  },
  [49] = {
    [sym_compound_statement] = STATE(202),
    [anon_sym_LPAREN] = ACTIONS(346),
    [anon_sym_LBRACE] = ACTIONS(348),
    [sym_comment] = ACTIONS(54),
  },
  [50] = {
    [sym__assignment] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(350),
    [anon_sym_PLUS_EQ] = ACTIONS(350),
    [sym_comment] = ACTIONS(54),
  },
  [51] = {
    [sym_word] = ACTIONS(352),
    [sym_comment] = ACTIONS(54),
  },
  [52] = {
    [sym_comment] = ACTIONS(54),
    [sym_simple_variable_name] = ACTIONS(354),
  },
  [53] = {
    [aux_sym_concatenation_repeat1] = STATE(206),
    [sym_file_descriptor] = ACTIONS(158),
    [sym__concat] = ACTIONS(160),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_RPAREN] = ACTIONS(162),
    [anon_sym_SEMI_SEMI] = ACTIONS(162),
    [anon_sym_PIPE_AMP] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(162),
    [anon_sym_PIPE_PIPE] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(162),
    [anon_sym_GT] = ACTIONS(162),
    [anon_sym_GT_GT] = ACTIONS(162),
    [anon_sym_AMP_GT] = ACTIONS(162),
    [anon_sym_AMP_GT_GT] = ACTIONS(162),
    [anon_sym_LT_AMP] = ACTIONS(162),
    [anon_sym_GT_AMP] = ACTIONS(162),
    [anon_sym_LT_LT] = ACTIONS(162),
    [anon_sym_LT_LT_DASH] = ACTIONS(162),
    [anon_sym_DQUOTE] = ACTIONS(162),
    [sym_raw_string] = ACTIONS(162),
    [anon_sym_DOLLAR] = ACTIONS(162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(162),
    [anon_sym_BQUOTE] = ACTIONS(162),
    [anon_sym_LT_LPAREN] = ACTIONS(162),
    [anon_sym_GT_LPAREN] = ACTIONS(162),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(162),
    [anon_sym_LF] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(162),
  },
  [54] = {
    [sym_compound_statement] = STATE(208),
    [aux_sym_concatenation_repeat1] = STATE(206),
    [sym_file_descriptor] = ACTIONS(158),
    [sym__concat] = ACTIONS(160),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_RPAREN] = ACTIONS(162),
    [anon_sym_SEMI_SEMI] = ACTIONS(162),
    [anon_sym_LPAREN] = ACTIONS(356),
    [anon_sym_LBRACE] = ACTIONS(226),
    [anon_sym_PIPE_AMP] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(162),
    [anon_sym_PIPE_PIPE] = ACTIONS(162),
    [anon_sym_LT] = ACTIONS(162),
    [anon_sym_GT] = ACTIONS(162),
    [anon_sym_GT_GT] = ACTIONS(162),
    [anon_sym_AMP_GT] = ACTIONS(162),
    [anon_sym_AMP_GT_GT] = ACTIONS(162),
    [anon_sym_LT_AMP] = ACTIONS(162),
    [anon_sym_GT_AMP] = ACTIONS(162),
    [anon_sym_LT_LT] = ACTIONS(162),
    [anon_sym_LT_LT_DASH] = ACTIONS(162),
    [anon_sym_DQUOTE] = ACTIONS(162),
    [sym_raw_string] = ACTIONS(162),
    [anon_sym_DOLLAR] = ACTIONS(162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(162),
    [anon_sym_BQUOTE] = ACTIONS(162),
    [anon_sym_LT_LPAREN] = ACTIONS(162),
    [anon_sym_GT_LPAREN] = ACTIONS(162),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(162),
    [anon_sym_LF] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(162),
  },
  [55] = {
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(360),
    [anon_sym_SEMI_SEMI] = ACTIONS(362),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(364),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(362),
    [anon_sym_LF] = ACTIONS(362),
    [anon_sym_AMP] = ACTIONS(362),
  },
  [56] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [aux_sym_for_statement_repeat1] = STATE(216),
    [aux_sym_command_repeat2] = STATE(217),
    [sym_file_descriptor] = ACTIONS(366),
    [anon_sym_PIPE] = ACTIONS(244),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_SEMI_SEMI] = ACTIONS(244),
    [anon_sym_PIPE_AMP] = ACTIONS(244),
    [anon_sym_AMP_AMP] = ACTIONS(244),
    [anon_sym_PIPE_PIPE] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(368),
    [anon_sym_GT_GT] = ACTIONS(368),
    [anon_sym_AMP_GT] = ACTIONS(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(368),
    [anon_sym_LT_AMP] = ACTIONS(368),
    [anon_sym_GT_AMP] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(370),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_word] = ACTIONS(370),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(244),
    [anon_sym_LF] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(244),
  },
  [57] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(360),
    [anon_sym_SEMI_SEMI] = ACTIONS(362),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(364),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(362),
    [anon_sym_LF] = ACTIONS(362),
    [anon_sym_AMP] = ACTIONS(362),
  },
  [58] = {
    [sym__assignment] = STATE(35),
    [anon_sym_EQ] = ACTIONS(350),
    [anon_sym_PLUS_EQ] = ACTIONS(350),
    [sym_comment] = ACTIONS(54),
  },
  [59] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(218),
    [sym_while_statement] = STATE(218),
    [sym_if_statement] = STATE(218),
    [sym_case_statement] = STATE(218),
    [sym_function_definition] = STATE(218),
    [sym_subshell] = STATE(218),
    [sym_pipeline] = STATE(218),
    [sym_list] = STATE(218),
    [sym_bracket_command] = STATE(218),
    [sym_command] = STATE(218),
    [sym_command_name] = STATE(56),
    [sym_environment_variable_assignment] = STATE(219),
    [sym_local_variable_declaration] = STATE(218),
    [sym_subscript] = STATE(58),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(53),
    [sym_simple_expansion] = STATE(53),
    [sym_expansion] = STATE(53),
    [sym_command_substitution] = STATE(53),
    [sym_process_substitution] = STATE(53),
    [aux_sym_program_repeat1] = STATE(220),
    [aux_sym_command_repeat1] = STATE(60),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(84),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(90),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(92),
    [sym_comment] = ACTIONS(54),
  },
  [60] = {
    [sym_command_name] = STATE(221),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(157),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(53),
    [sym_simple_expansion] = STATE(53),
    [sym_expansion] = STATE(53),
    [sym_command_substitution] = STATE(53),
    [sym_process_substitution] = STATE(53),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(90),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(372),
    [sym_comment] = ACTIONS(54),
  },
  [61] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(223),
    [anon_sym_DQUOTE] = ACTIONS(374),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [62] = {
    [aux_sym_concatenation_repeat1] = STATE(225),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACK] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(380),
    [anon_sym_BQUOTE] = ACTIONS(380),
    [anon_sym_LT_LPAREN] = ACTIONS(380),
    [anon_sym_GT_LPAREN] = ACTIONS(380),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(54),
  },
  [63] = {
    [sym_special_variable_name] = STATE(228),
    [anon_sym_DOLLAR] = ACTIONS(384),
    [anon_sym_POUND] = ACTIONS(384),
    [anon_sym_AT] = ACTIONS(384),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(386),
    [anon_sym_STAR] = ACTIONS(384),
    [anon_sym_QMARK] = ACTIONS(384),
    [anon_sym_DASH] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(384),
    [anon_sym_0] = ACTIONS(388),
    [anon_sym__] = ACTIONS(388),
  },
  [64] = {
    [sym_special_variable_name] = STATE(231),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(390),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [65] = {
    [sym_for_statement] = STATE(232),
    [sym_while_statement] = STATE(232),
    [sym_if_statement] = STATE(232),
    [sym_case_statement] = STATE(232),
    [sym_function_definition] = STATE(232),
    [sym_subshell] = STATE(232),
    [sym_pipeline] = STATE(232),
    [sym_list] = STATE(232),
    [sym_bracket_command] = STATE(232),
    [sym_command] = STATE(232),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(233),
    [sym_local_variable_declaration] = STATE(232),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [66] = {
    [sym_for_statement] = STATE(234),
    [sym_while_statement] = STATE(234),
    [sym_if_statement] = STATE(234),
    [sym_case_statement] = STATE(234),
    [sym_function_definition] = STATE(234),
    [sym_subshell] = STATE(234),
    [sym_pipeline] = STATE(234),
    [sym_list] = STATE(234),
    [sym_bracket_command] = STATE(234),
    [sym_command] = STATE(234),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(235),
    [sym_local_variable_declaration] = STATE(234),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [67] = {
    [sym_for_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_function_definition] = STATE(236),
    [sym_subshell] = STATE(236),
    [sym_pipeline] = STATE(236),
    [sym_list] = STATE(236),
    [sym_bracket_command] = STATE(236),
    [sym_command] = STATE(236),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(237),
    [sym_local_variable_declaration] = STATE(236),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [68] = {
    [anon_sym_RBRACK] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(380),
    [anon_sym_BQUOTE] = ACTIONS(380),
    [anon_sym_LT_LPAREN] = ACTIONS(380),
    [anon_sym_GT_LPAREN] = ACTIONS(380),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(54),
  },
  [69] = {
    [sym_concatenation] = STATE(68),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_for_statement_repeat1] = STATE(239),
    [anon_sym_RBRACK] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(96),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(396),
    [sym_comment] = ACTIONS(54),
  },
  [70] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(241),
    [anon_sym_DQUOTE] = ACTIONS(398),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [71] = {
    [aux_sym_concatenation_repeat1] = STATE(243),
    [sym__concat] = ACTIONS(400),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(380),
    [anon_sym_BQUOTE] = ACTIONS(380),
    [anon_sym_LT_LPAREN] = ACTIONS(380),
    [anon_sym_GT_LPAREN] = ACTIONS(380),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(54),
  },
  [72] = {
    [sym_special_variable_name] = STATE(246),
    [anon_sym_DOLLAR] = ACTIONS(402),
    [anon_sym_POUND] = ACTIONS(402),
    [anon_sym_AT] = ACTIONS(402),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(402),
    [anon_sym_QMARK] = ACTIONS(402),
    [anon_sym_DASH] = ACTIONS(402),
    [anon_sym_BANG] = ACTIONS(402),
    [anon_sym_0] = ACTIONS(406),
    [anon_sym__] = ACTIONS(406),
  },
  [73] = {
    [sym_special_variable_name] = STATE(249),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(408),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [74] = {
    [sym_for_statement] = STATE(250),
    [sym_while_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_case_statement] = STATE(250),
    [sym_function_definition] = STATE(250),
    [sym_subshell] = STATE(250),
    [sym_pipeline] = STATE(250),
    [sym_list] = STATE(250),
    [sym_bracket_command] = STATE(250),
    [sym_command] = STATE(250),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(251),
    [sym_local_variable_declaration] = STATE(250),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [75] = {
    [sym_for_statement] = STATE(252),
    [sym_while_statement] = STATE(252),
    [sym_if_statement] = STATE(252),
    [sym_case_statement] = STATE(252),
    [sym_function_definition] = STATE(252),
    [sym_subshell] = STATE(252),
    [sym_pipeline] = STATE(252),
    [sym_list] = STATE(252),
    [sym_bracket_command] = STATE(252),
    [sym_command] = STATE(252),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(253),
    [sym_local_variable_declaration] = STATE(252),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [76] = {
    [sym_for_statement] = STATE(254),
    [sym_while_statement] = STATE(254),
    [sym_if_statement] = STATE(254),
    [sym_case_statement] = STATE(254),
    [sym_function_definition] = STATE(254),
    [sym_subshell] = STATE(254),
    [sym_pipeline] = STATE(254),
    [sym_list] = STATE(254),
    [sym_bracket_command] = STATE(254),
    [sym_command] = STATE(254),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(255),
    [sym_local_variable_declaration] = STATE(254),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [77] = {
    [anon_sym_RBRACK_RBRACK] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(380),
    [anon_sym_BQUOTE] = ACTIONS(380),
    [anon_sym_LT_LPAREN] = ACTIONS(380),
    [anon_sym_GT_LPAREN] = ACTIONS(380),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(54),
  },
  [78] = {
    [sym_concatenation] = STATE(77),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_for_statement_repeat1] = STATE(256),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [sym_raw_string] = ACTIONS(112),
    [anon_sym_DOLLAR] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_word] = ACTIONS(412),
    [sym_comment] = ACTIONS(54),
  },
  [79] = {
    [sym__assignment] = STATE(258),
    [anon_sym_PIPE] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [anon_sym_PIPE_AMP] = ACTIONS(414),
    [anon_sym_AMP_AMP] = ACTIONS(414),
    [anon_sym_PIPE_PIPE] = ACTIONS(414),
    [anon_sym_EQ] = ACTIONS(416),
    [anon_sym_PLUS_EQ] = ACTIONS(416),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [80] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(260),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [81] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym_file_descriptor] = ACTIONS(420),
    [sym__concat] = ACTIONS(422),
    [sym_variable_name] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(420),
    [anon_sym_AMP_GT] = ACTIONS(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(420),
    [anon_sym_LT_AMP] = ACTIONS(420),
    [anon_sym_GT_AMP] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(420),
    [sym_raw_string] = ACTIONS(420),
    [anon_sym_DOLLAR] = ACTIONS(424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [anon_sym_LT_LPAREN] = ACTIONS(420),
    [anon_sym_GT_LPAREN] = ACTIONS(420),
    [sym_word] = ACTIONS(424),
    [sym_comment] = ACTIONS(54),
  },
  [82] = {
    [sym_special_variable_name] = STATE(265),
    [anon_sym_DOLLAR] = ACTIONS(426),
    [anon_sym_POUND] = ACTIONS(426),
    [anon_sym_AT] = ACTIONS(426),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(428),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_QMARK] = ACTIONS(426),
    [anon_sym_DASH] = ACTIONS(426),
    [anon_sym_BANG] = ACTIONS(426),
    [anon_sym_0] = ACTIONS(430),
    [anon_sym__] = ACTIONS(430),
  },
  [83] = {
    [sym_special_variable_name] = STATE(268),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(432),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(434),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [84] = {
    [sym_for_statement] = STATE(269),
    [sym_while_statement] = STATE(269),
    [sym_if_statement] = STATE(269),
    [sym_case_statement] = STATE(269),
    [sym_function_definition] = STATE(269),
    [sym_subshell] = STATE(269),
    [sym_pipeline] = STATE(269),
    [sym_list] = STATE(269),
    [sym_bracket_command] = STATE(269),
    [sym_command] = STATE(269),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(270),
    [sym_local_variable_declaration] = STATE(269),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [85] = {
    [sym_for_statement] = STATE(271),
    [sym_while_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_case_statement] = STATE(271),
    [sym_function_definition] = STATE(271),
    [sym_subshell] = STATE(271),
    [sym_pipeline] = STATE(271),
    [sym_list] = STATE(271),
    [sym_bracket_command] = STATE(271),
    [sym_command] = STATE(271),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(272),
    [sym_local_variable_declaration] = STATE(271),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [86] = {
    [sym_for_statement] = STATE(273),
    [sym_while_statement] = STATE(273),
    [sym_if_statement] = STATE(273),
    [sym_case_statement] = STATE(273),
    [sym_function_definition] = STATE(273),
    [sym_subshell] = STATE(273),
    [sym_pipeline] = STATE(273),
    [sym_list] = STATE(273),
    [sym_bracket_command] = STATE(273),
    [sym_command] = STATE(273),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(274),
    [sym_local_variable_declaration] = STATE(273),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [87] = {
    [sym_file_descriptor] = ACTIONS(420),
    [sym_variable_name] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(420),
    [anon_sym_AMP_GT] = ACTIONS(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(420),
    [anon_sym_LT_AMP] = ACTIONS(420),
    [anon_sym_GT_AMP] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(420),
    [sym_raw_string] = ACTIONS(420),
    [anon_sym_DOLLAR] = ACTIONS(424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [anon_sym_LT_LPAREN] = ACTIONS(420),
    [anon_sym_GT_LPAREN] = ACTIONS(420),
    [sym_word] = ACTIONS(424),
    [sym_comment] = ACTIONS(54),
  },
  [88] = {
    [sym_file_descriptor] = ACTIONS(436),
    [sym__concat] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI_SEMI] = ACTIONS(438),
    [anon_sym_PIPE_AMP] = ACTIONS(438),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_PIPE_PIPE] = ACTIONS(438),
    [anon_sym_LT] = ACTIONS(438),
    [anon_sym_GT] = ACTIONS(438),
    [anon_sym_GT_GT] = ACTIONS(438),
    [anon_sym_AMP_GT] = ACTIONS(438),
    [anon_sym_AMP_GT_GT] = ACTIONS(438),
    [anon_sym_LT_AMP] = ACTIONS(438),
    [anon_sym_GT_AMP] = ACTIONS(438),
    [anon_sym_LT_LT] = ACTIONS(438),
    [anon_sym_LT_LT_DASH] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [sym_raw_string] = ACTIONS(438),
    [anon_sym_DOLLAR] = ACTIONS(438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(438),
    [anon_sym_BQUOTE] = ACTIONS(438),
    [anon_sym_LT_LPAREN] = ACTIONS(438),
    [anon_sym_GT_LPAREN] = ACTIONS(438),
    [sym_word] = ACTIONS(438),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LF] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(438),
  },
  [89] = {
    [anon_sym_DQUOTE] = ACTIONS(440),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(442),
    [anon_sym_DOLLAR] = ACTIONS(440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [sym_comment] = ACTIONS(156),
  },
  [90] = {
    [sym_special_variable_name] = STATE(277),
    [anon_sym_DOLLAR] = ACTIONS(444),
    [anon_sym_POUND] = ACTIONS(444),
    [anon_sym_AT] = ACTIONS(444),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(446),
    [anon_sym_STAR] = ACTIONS(444),
    [anon_sym_QMARK] = ACTIONS(444),
    [anon_sym_DASH] = ACTIONS(444),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_0] = ACTIONS(448),
    [anon_sym__] = ACTIONS(448),
  },
  [91] = {
    [sym_special_variable_name] = STATE(280),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(450),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(452),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [92] = {
    [sym_for_statement] = STATE(281),
    [sym_while_statement] = STATE(281),
    [sym_if_statement] = STATE(281),
    [sym_case_statement] = STATE(281),
    [sym_function_definition] = STATE(281),
    [sym_subshell] = STATE(281),
    [sym_pipeline] = STATE(281),
    [sym_list] = STATE(281),
    [sym_bracket_command] = STATE(281),
    [sym_command] = STATE(281),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(282),
    [sym_local_variable_declaration] = STATE(281),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [93] = {
    [sym_for_statement] = STATE(283),
    [sym_while_statement] = STATE(283),
    [sym_if_statement] = STATE(283),
    [sym_case_statement] = STATE(283),
    [sym_function_definition] = STATE(283),
    [sym_subshell] = STATE(283),
    [sym_pipeline] = STATE(283),
    [sym_list] = STATE(283),
    [sym_bracket_command] = STATE(283),
    [sym_command] = STATE(283),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(284),
    [sym_local_variable_declaration] = STATE(283),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [94] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(454),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [95] = {
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(456),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(458),
    [sym_comment] = ACTIONS(54),
  },
  [96] = {
    [aux_sym_concatenation_repeat1] = STATE(288),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(160),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(462),
    [anon_sym_AMP_AMP] = ACTIONS(462),
    [anon_sym_PIPE_PIPE] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(462),
    [anon_sym_AMP_GT] = ACTIONS(462),
    [anon_sym_AMP_GT_GT] = ACTIONS(462),
    [anon_sym_LT_AMP] = ACTIONS(462),
    [anon_sym_GT_AMP] = ACTIONS(462),
    [anon_sym_LT_LT] = ACTIONS(462),
    [anon_sym_LT_LT_DASH] = ACTIONS(462),
    [anon_sym_DQUOTE] = ACTIONS(462),
    [sym_raw_string] = ACTIONS(462),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(462),
    [anon_sym_BQUOTE] = ACTIONS(462),
    [anon_sym_LT_LPAREN] = ACTIONS(462),
    [anon_sym_GT_LPAREN] = ACTIONS(462),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [97] = {
    [sym_file_descriptor] = ACTIONS(464),
    [sym__concat] = ACTIONS(464),
    [anon_sym_PIPE] = ACTIONS(466),
    [anon_sym_RPAREN] = ACTIONS(466),
    [anon_sym_SEMI_SEMI] = ACTIONS(466),
    [anon_sym_PIPE_AMP] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_GT] = ACTIONS(466),
    [anon_sym_GT_GT] = ACTIONS(466),
    [anon_sym_AMP_GT] = ACTIONS(466),
    [anon_sym_AMP_GT_GT] = ACTIONS(466),
    [anon_sym_LT_AMP] = ACTIONS(466),
    [anon_sym_GT_AMP] = ACTIONS(466),
    [anon_sym_LT_LT] = ACTIONS(466),
    [anon_sym_LT_LT_DASH] = ACTIONS(466),
    [anon_sym_DQUOTE] = ACTIONS(466),
    [sym_raw_string] = ACTIONS(466),
    [anon_sym_DOLLAR] = ACTIONS(466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(466),
    [anon_sym_BQUOTE] = ACTIONS(466),
    [anon_sym_LT_LPAREN] = ACTIONS(466),
    [anon_sym_GT_LPAREN] = ACTIONS(466),
    [sym_word] = ACTIONS(466),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(466),
  },
  [98] = {
    [sym_file_descriptor] = ACTIONS(468),
    [sym__concat] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_RPAREN] = ACTIONS(470),
    [anon_sym_SEMI_SEMI] = ACTIONS(470),
    [anon_sym_PIPE_AMP] = ACTIONS(470),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_GT] = ACTIONS(470),
    [anon_sym_GT_GT] = ACTIONS(470),
    [anon_sym_AMP_GT] = ACTIONS(470),
    [anon_sym_AMP_GT_GT] = ACTIONS(470),
    [anon_sym_LT_AMP] = ACTIONS(470),
    [anon_sym_GT_AMP] = ACTIONS(470),
    [anon_sym_LT_LT] = ACTIONS(470),
    [anon_sym_LT_LT_DASH] = ACTIONS(470),
    [anon_sym_DQUOTE] = ACTIONS(470),
    [sym_raw_string] = ACTIONS(470),
    [anon_sym_DOLLAR] = ACTIONS(470),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(470),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(470),
    [anon_sym_BQUOTE] = ACTIONS(470),
    [anon_sym_LT_LPAREN] = ACTIONS(470),
    [anon_sym_GT_LPAREN] = ACTIONS(470),
    [sym_word] = ACTIONS(470),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_LF] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(470),
  },
  [99] = {
    [sym_file_descriptor] = ACTIONS(472),
    [sym__concat] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(474),
    [anon_sym_RPAREN] = ACTIONS(474),
    [anon_sym_SEMI_SEMI] = ACTIONS(474),
    [anon_sym_PIPE_AMP] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(474),
    [anon_sym_GT] = ACTIONS(474),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_AMP_GT] = ACTIONS(474),
    [anon_sym_AMP_GT_GT] = ACTIONS(474),
    [anon_sym_LT_AMP] = ACTIONS(474),
    [anon_sym_GT_AMP] = ACTIONS(474),
    [anon_sym_LT_LT] = ACTIONS(474),
    [anon_sym_LT_LT_DASH] = ACTIONS(474),
    [anon_sym_DQUOTE] = ACTIONS(474),
    [sym_raw_string] = ACTIONS(474),
    [anon_sym_DOLLAR] = ACTIONS(474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(474),
    [anon_sym_BQUOTE] = ACTIONS(474),
    [anon_sym_LT_LPAREN] = ACTIONS(474),
    [anon_sym_GT_LPAREN] = ACTIONS(474),
    [sym_word] = ACTIONS(474),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_LF] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(474),
  },
  [100] = {
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(54),
  },
  [101] = {
    [sym_special_variable_name] = STATE(290),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(478),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [102] = {
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_LBRACK] = ACTIONS(482),
    [anon_sym_EQ] = ACTIONS(484),
    [anon_sym_COLON] = ACTIONS(486),
    [anon_sym_COLON_QMARK] = ACTIONS(484),
    [anon_sym_COLON_DASH] = ACTIONS(484),
    [anon_sym_PERCENT] = ACTIONS(484),
    [anon_sym_SLASH] = ACTIONS(484),
    [sym_comment] = ACTIONS(54),
  },
  [103] = {
    [anon_sym_RBRACE] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(490),
    [anon_sym_EQ] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_COLON_QMARK] = ACTIONS(492),
    [anon_sym_COLON_DASH] = ACTIONS(492),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH] = ACTIONS(492),
    [sym_comment] = ACTIONS(54),
  },
  [104] = {
    [sym__assignment] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_PLUS_EQ] = ACTIONS(496),
    [sym_comment] = ACTIONS(54),
  },
  [105] = {
    [sym_word] = ACTIONS(498),
    [sym_comment] = ACTIONS(54),
  },
  [106] = {
    [sym__terminated_statement] = STATE(300),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_bracket_command] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(39),
    [sym_local_variable_declaration] = STATE(38),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [107] = {
    [sym__terminated_statement] = STATE(301),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_bracket_command] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(39),
    [sym_local_variable_declaration] = STATE(38),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [108] = {
    [sym_concatenation] = STATE(303),
    [sym_string] = STATE(302),
    [sym_simple_expansion] = STATE(302),
    [sym_expansion] = STATE(302),
    [sym_command_substitution] = STATE(302),
    [sym_process_substitution] = STATE(302),
    [anon_sym_DQUOTE] = ACTIONS(66),
    [sym_raw_string] = ACTIONS(500),
    [anon_sym_DOLLAR] = ACTIONS(70),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(72),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(74),
    [anon_sym_BQUOTE] = ACTIONS(76),
    [anon_sym_LT_LPAREN] = ACTIONS(78),
    [anon_sym_GT_LPAREN] = ACTIONS(78),
    [sym_word] = ACTIONS(502),
    [sym_comment] = ACTIONS(54),
  },
  [109] = {
    [sym_word] = ACTIONS(504),
    [sym_comment] = ACTIONS(54),
  },
  [110] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_function_definition] = STATE(305),
    [sym_subshell] = STATE(305),
    [sym_pipeline] = STATE(305),
    [sym_list] = STATE(305),
    [sym_bracket_command] = STATE(305),
    [sym_command] = STATE(305),
    [sym_command_name] = STATE(56),
    [sym_environment_variable_assignment] = STATE(306),
    [sym_local_variable_declaration] = STATE(305),
    [sym_subscript] = STATE(58),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(53),
    [sym_simple_expansion] = STATE(53),
    [sym_expansion] = STATE(53),
    [sym_command_substitution] = STATE(53),
    [sym_process_substitution] = STATE(53),
    [aux_sym_program_repeat1] = STATE(307),
    [aux_sym_command_repeat1] = STATE(60),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(84),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(90),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(92),
    [sym_comment] = ACTIONS(54),
  },
  [111] = {
    [sym_concatenation] = STATE(68),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_for_statement_repeat1] = STATE(308),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(96),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(108),
    [sym_comment] = ACTIONS(54),
  },
  [112] = {
    [sym_concatenation] = STATE(77),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_for_statement_repeat1] = STATE(309),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [sym_raw_string] = ACTIONS(112),
    [anon_sym_DOLLAR] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_word] = ACTIONS(124),
    [sym_comment] = ACTIONS(54),
  },
  [113] = {
    [sym_comment] = ACTIONS(54),
    [sym_simple_variable_name] = ACTIONS(506),
  },
  [114] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(312),
    [anon_sym_DQUOTE] = ACTIONS(508),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [115] = {
    [aux_sym_concatenation_repeat1] = STATE(314),
    [sym_file_descriptor] = ACTIONS(158),
    [sym__concat] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(512),
    [anon_sym_RPAREN] = ACTIONS(158),
    [anon_sym_PIPE_AMP] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(158),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_GT] = ACTIONS(512),
    [anon_sym_GT_GT] = ACTIONS(158),
    [anon_sym_AMP_GT] = ACTIONS(512),
    [anon_sym_AMP_GT_GT] = ACTIONS(158),
    [anon_sym_LT_AMP] = ACTIONS(158),
    [anon_sym_GT_AMP] = ACTIONS(158),
    [anon_sym_LT_LT] = ACTIONS(512),
    [anon_sym_LT_LT_DASH] = ACTIONS(158),
    [anon_sym_DQUOTE] = ACTIONS(158),
    [sym_raw_string] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(158),
    [anon_sym_BQUOTE] = ACTIONS(158),
    [anon_sym_LT_LPAREN] = ACTIONS(158),
    [anon_sym_GT_LPAREN] = ACTIONS(158),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(54),
  },
  [116] = {
    [sym_special_variable_name] = STATE(317),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_POUND] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(514),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(516),
    [anon_sym_STAR] = ACTIONS(514),
    [anon_sym_QMARK] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(514),
    [anon_sym_BANG] = ACTIONS(514),
    [anon_sym_0] = ACTIONS(518),
    [anon_sym__] = ACTIONS(518),
  },
  [117] = {
    [sym_special_variable_name] = STATE(320),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(520),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [118] = {
    [sym_for_statement] = STATE(321),
    [sym_while_statement] = STATE(321),
    [sym_if_statement] = STATE(321),
    [sym_case_statement] = STATE(321),
    [sym_function_definition] = STATE(321),
    [sym_subshell] = STATE(321),
    [sym_pipeline] = STATE(321),
    [sym_list] = STATE(321),
    [sym_bracket_command] = STATE(321),
    [sym_command] = STATE(321),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(322),
    [sym_local_variable_declaration] = STATE(321),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [119] = {
    [sym_for_statement] = STATE(323),
    [sym_while_statement] = STATE(323),
    [sym_if_statement] = STATE(323),
    [sym_case_statement] = STATE(323),
    [sym_function_definition] = STATE(323),
    [sym_subshell] = STATE(323),
    [sym_pipeline] = STATE(323),
    [sym_list] = STATE(323),
    [sym_bracket_command] = STATE(323),
    [sym_command] = STATE(323),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(324),
    [sym_local_variable_declaration] = STATE(323),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [120] = {
    [sym_for_statement] = STATE(325),
    [sym_while_statement] = STATE(325),
    [sym_if_statement] = STATE(325),
    [sym_case_statement] = STATE(325),
    [sym_function_definition] = STATE(325),
    [sym_subshell] = STATE(325),
    [sym_pipeline] = STATE(325),
    [sym_list] = STATE(325),
    [sym_bracket_command] = STATE(325),
    [sym_command] = STATE(325),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(326),
    [sym_local_variable_declaration] = STATE(325),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [121] = {
    [sym_compound_statement] = STATE(329),
    [aux_sym_concatenation_repeat1] = STATE(314),
    [sym_file_descriptor] = ACTIONS(158),
    [sym__concat] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(512),
    [anon_sym_RPAREN] = ACTIONS(158),
    [anon_sym_LPAREN] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(526),
    [anon_sym_PIPE_AMP] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(158),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_GT] = ACTIONS(512),
    [anon_sym_GT_GT] = ACTIONS(158),
    [anon_sym_AMP_GT] = ACTIONS(512),
    [anon_sym_AMP_GT_GT] = ACTIONS(158),
    [anon_sym_LT_AMP] = ACTIONS(158),
    [anon_sym_GT_AMP] = ACTIONS(158),
    [anon_sym_LT_LT] = ACTIONS(512),
    [anon_sym_LT_LT_DASH] = ACTIONS(158),
    [anon_sym_DQUOTE] = ACTIONS(158),
    [sym_raw_string] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(158),
    [anon_sym_BQUOTE] = ACTIONS(158),
    [anon_sym_LT_LPAREN] = ACTIONS(158),
    [anon_sym_GT_LPAREN] = ACTIONS(158),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(54),
  },
  [122] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(530),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [123] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(336),
    [sym_simple_expansion] = STATE(336),
    [sym_expansion] = STATE(336),
    [sym_command_substitution] = STATE(336),
    [sym_process_substitution] = STATE(336),
    [aux_sym_for_statement_repeat1] = STATE(339),
    [aux_sym_command_repeat2] = STATE(340),
    [sym_file_descriptor] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_RPAREN] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(542),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(550),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(552),
    [sym_comment] = ACTIONS(54),
  },
  [124] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(530),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [125] = {
    [sym__assignment] = STATE(298),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_PLUS_EQ] = ACTIONS(496),
    [sym_comment] = ACTIONS(54),
  },
  [126] = {
    [sym_file_descriptor] = ACTIONS(158),
    [anon_sym_PIPE] = ACTIONS(512),
    [anon_sym_RPAREN] = ACTIONS(158),
    [anon_sym_PIPE_AMP] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(158),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_GT] = ACTIONS(512),
    [anon_sym_GT_GT] = ACTIONS(158),
    [anon_sym_AMP_GT] = ACTIONS(512),
    [anon_sym_AMP_GT_GT] = ACTIONS(158),
    [anon_sym_LT_AMP] = ACTIONS(158),
    [anon_sym_GT_AMP] = ACTIONS(158),
    [anon_sym_LT_LT] = ACTIONS(512),
    [anon_sym_LT_LT_DASH] = ACTIONS(158),
    [anon_sym_DQUOTE] = ACTIONS(158),
    [sym_raw_string] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(158),
    [anon_sym_BQUOTE] = ACTIONS(158),
    [anon_sym_LT_LPAREN] = ACTIONS(158),
    [anon_sym_GT_LPAREN] = ACTIONS(158),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(54),
  },
  [127] = {
    [sym_command_name] = STATE(341),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(157),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(556),
    [sym_comment] = ACTIONS(54),
  },
  [128] = {
    [sym__assignment] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [sym_comment] = ACTIONS(54),
  },
  [129] = {
    [sym_word] = ACTIONS(560),
    [sym_comment] = ACTIONS(54),
  },
  [130] = {
    [sym_comment] = ACTIONS(54),
    [sym_simple_variable_name] = ACTIONS(562),
  },
  [131] = {
    [aux_sym_concatenation_repeat1] = STATE(345),
    [sym_file_descriptor] = ACTIONS(158),
    [sym__concat] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(512),
    [anon_sym_PIPE_AMP] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(158),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_GT] = ACTIONS(512),
    [anon_sym_GT_GT] = ACTIONS(158),
    [anon_sym_AMP_GT] = ACTIONS(512),
    [anon_sym_AMP_GT_GT] = ACTIONS(158),
    [anon_sym_LT_AMP] = ACTIONS(158),
    [anon_sym_GT_AMP] = ACTIONS(158),
    [anon_sym_LT_LT] = ACTIONS(512),
    [anon_sym_LT_LT_DASH] = ACTIONS(158),
    [anon_sym_DQUOTE] = ACTIONS(158),
    [sym_raw_string] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(158),
    [anon_sym_BQUOTE] = ACTIONS(158),
    [anon_sym_LT_LPAREN] = ACTIONS(158),
    [anon_sym_GT_LPAREN] = ACTIONS(158),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(54),
  },
  [132] = {
    [sym_compound_statement] = STATE(347),
    [aux_sym_concatenation_repeat1] = STATE(345),
    [sym_file_descriptor] = ACTIONS(158),
    [sym__concat] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(512),
    [anon_sym_LPAREN] = ACTIONS(564),
    [anon_sym_LBRACE] = ACTIONS(526),
    [anon_sym_PIPE_AMP] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(158),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_GT] = ACTIONS(512),
    [anon_sym_GT_GT] = ACTIONS(158),
    [anon_sym_AMP_GT] = ACTIONS(512),
    [anon_sym_AMP_GT_GT] = ACTIONS(158),
    [anon_sym_LT_AMP] = ACTIONS(158),
    [anon_sym_GT_AMP] = ACTIONS(158),
    [anon_sym_LT_LT] = ACTIONS(512),
    [anon_sym_LT_LT_DASH] = ACTIONS(158),
    [anon_sym_DQUOTE] = ACTIONS(158),
    [sym_raw_string] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(158),
    [anon_sym_BQUOTE] = ACTIONS(158),
    [anon_sym_LT_LPAREN] = ACTIONS(158),
    [anon_sym_GT_LPAREN] = ACTIONS(158),
    [sym_word] = ACTIONS(162),
    [sym_comment] = ACTIONS(54),
  },
  [133] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [sym_comment] = ACTIONS(54),
  },
  [134] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(352),
    [sym_simple_expansion] = STATE(352),
    [sym_expansion] = STATE(352),
    [sym_command_substitution] = STATE(352),
    [sym_process_substitution] = STATE(352),
    [aux_sym_for_statement_repeat1] = STATE(353),
    [aux_sym_command_repeat2] = STATE(354),
    [sym_file_descriptor] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(540),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(580),
    [sym_comment] = ACTIONS(54),
  },
  [135] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(530),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [136] = {
    [sym__assignment] = STATE(298),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [sym_comment] = ACTIONS(54),
  },
  [137] = {
    [sym_command_name] = STATE(355),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(157),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(584),
    [sym_comment] = ACTIONS(54),
  },
  [138] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(586),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [139] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(586),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [140] = {
    [anon_sym_RPAREN] = ACTIONS(588),
    [sym_comment] = ACTIONS(54),
  },
  [141] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(359),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(590),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [142] = {
    [sym_file_redirect] = STATE(362),
    [sym_file_descriptor] = ACTIONS(592),
    [anon_sym_PIPE] = ACTIONS(594),
    [anon_sym_SEMI_SEMI] = ACTIONS(594),
    [anon_sym_PIPE_AMP] = ACTIONS(594),
    [anon_sym_AMP_AMP] = ACTIONS(594),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_GT] = ACTIONS(596),
    [anon_sym_GT_GT] = ACTIONS(596),
    [anon_sym_AMP_GT] = ACTIONS(596),
    [anon_sym_AMP_GT_GT] = ACTIONS(596),
    [anon_sym_LT_AMP] = ACTIONS(596),
    [anon_sym_GT_AMP] = ACTIONS(596),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(594),
    [anon_sym_LF] = ACTIONS(594),
    [anon_sym_AMP] = ACTIONS(594),
  },
  [143] = {
    [sym_for_statement] = STATE(363),
    [sym_while_statement] = STATE(363),
    [sym_if_statement] = STATE(363),
    [sym_case_statement] = STATE(363),
    [sym_function_definition] = STATE(363),
    [sym_subshell] = STATE(363),
    [sym_pipeline] = STATE(363),
    [sym_list] = STATE(363),
    [sym_bracket_command] = STATE(363),
    [sym_command] = STATE(363),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(364),
    [sym_local_variable_declaration] = STATE(363),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [144] = {
    [sym_file_descriptor] = ACTIONS(598),
    [sym_variable_name] = ACTIONS(598),
    [ts_builtin_sym_end] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_SEMI_SEMI] = ACTIONS(598),
    [anon_sym_function] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_RBRACE] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(600),
    [anon_sym_local] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_AMP_GT] = ACTIONS(600),
    [anon_sym_AMP_GT_GT] = ACTIONS(598),
    [anon_sym_LT_AMP] = ACTIONS(598),
    [anon_sym_GT_AMP] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_word] = ACTIONS(602),
    [sym_comment] = ACTIONS(54),
  },
  [145] = {
    [sym_for_statement] = STATE(365),
    [sym_while_statement] = STATE(365),
    [sym_if_statement] = STATE(365),
    [sym_case_statement] = STATE(365),
    [sym_function_definition] = STATE(365),
    [sym_subshell] = STATE(365),
    [sym_pipeline] = STATE(365),
    [sym_list] = STATE(365),
    [sym_bracket_command] = STATE(365),
    [sym_command] = STATE(365),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(366),
    [sym_local_variable_declaration] = STATE(365),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [146] = {
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_GT] = ACTIONS(604),
    [anon_sym_GT_GT] = ACTIONS(606),
    [anon_sym_AMP_GT] = ACTIONS(604),
    [anon_sym_AMP_GT_GT] = ACTIONS(606),
    [anon_sym_LT_AMP] = ACTIONS(606),
    [anon_sym_GT_AMP] = ACTIONS(606),
    [sym_comment] = ACTIONS(54),
  },
  [147] = {
    [sym_concatenation] = STATE(375),
    [sym_string] = STATE(369),
    [sym_simple_expansion] = STATE(369),
    [sym_expansion] = STATE(369),
    [sym_command_substitution] = STATE(369),
    [sym_process_substitution] = STATE(369),
    [anon_sym_DQUOTE] = ACTIONS(608),
    [sym_raw_string] = ACTIONS(610),
    [anon_sym_DOLLAR] = ACTIONS(612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(616),
    [anon_sym_BQUOTE] = ACTIONS(618),
    [anon_sym_LT_LPAREN] = ACTIONS(620),
    [anon_sym_GT_LPAREN] = ACTIONS(620),
    [sym_word] = ACTIONS(622),
    [sym_comment] = ACTIONS(54),
  },
  [148] = {
    [sym_heredoc] = STATE(378),
    [sym__simple_heredoc] = ACTIONS(624),
    [sym__heredoc_beginning] = ACTIONS(626),
    [sym_comment] = ACTIONS(54),
  },
  [149] = {
    [aux_sym_concatenation_repeat1] = STATE(96),
    [sym_file_descriptor] = ACTIONS(380),
    [sym__concat] = ACTIONS(160),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_SEMI_SEMI] = ACTIONS(382),
    [anon_sym_PIPE_AMP] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(382),
    [anon_sym_PIPE_PIPE] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_AMP_GT] = ACTIONS(382),
    [anon_sym_AMP_GT_GT] = ACTIONS(382),
    [anon_sym_LT_AMP] = ACTIONS(382),
    [anon_sym_GT_AMP] = ACTIONS(382),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_LT_LT_DASH] = ACTIONS(382),
    [anon_sym_DQUOTE] = ACTIONS(382),
    [sym_raw_string] = ACTIONS(382),
    [anon_sym_DOLLAR] = ACTIONS(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(382),
    [anon_sym_BQUOTE] = ACTIONS(382),
    [anon_sym_LT_LPAREN] = ACTIONS(382),
    [anon_sym_GT_LPAREN] = ACTIONS(382),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(382),
    [anon_sym_LF] = ACTIONS(382),
    [anon_sym_AMP] = ACTIONS(382),
  },
  [150] = {
    [sym_file_descriptor] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_SEMI_SEMI] = ACTIONS(630),
    [anon_sym_PIPE_AMP] = ACTIONS(630),
    [anon_sym_AMP_AMP] = ACTIONS(630),
    [anon_sym_PIPE_PIPE] = ACTIONS(630),
    [anon_sym_LT] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(630),
    [anon_sym_GT_GT] = ACTIONS(630),
    [anon_sym_AMP_GT] = ACTIONS(630),
    [anon_sym_AMP_GT_GT] = ACTIONS(630),
    [anon_sym_LT_AMP] = ACTIONS(630),
    [anon_sym_GT_AMP] = ACTIONS(630),
    [anon_sym_LT_LT] = ACTIONS(630),
    [anon_sym_LT_LT_DASH] = ACTIONS(630),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(630),
    [anon_sym_LF] = ACTIONS(630),
    [anon_sym_AMP] = ACTIONS(630),
  },
  [151] = {
    [sym_file_descriptor] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_RPAREN] = ACTIONS(382),
    [anon_sym_SEMI_SEMI] = ACTIONS(382),
    [anon_sym_PIPE_AMP] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(382),
    [anon_sym_PIPE_PIPE] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_AMP_GT] = ACTIONS(382),
    [anon_sym_AMP_GT_GT] = ACTIONS(382),
    [anon_sym_LT_AMP] = ACTIONS(382),
    [anon_sym_GT_AMP] = ACTIONS(382),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_LT_LT_DASH] = ACTIONS(382),
    [anon_sym_DQUOTE] = ACTIONS(382),
    [sym_raw_string] = ACTIONS(382),
    [anon_sym_DOLLAR] = ACTIONS(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(382),
    [anon_sym_BQUOTE] = ACTIONS(382),
    [anon_sym_LT_LPAREN] = ACTIONS(382),
    [anon_sym_GT_LPAREN] = ACTIONS(382),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(382),
    [anon_sym_LF] = ACTIONS(382),
    [anon_sym_AMP] = ACTIONS(382),
  },
  [152] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(149),
    [sym_simple_expansion] = STATE(149),
    [sym_expansion] = STATE(149),
    [sym_command_substitution] = STATE(149),
    [sym_process_substitution] = STATE(149),
    [aux_sym_for_statement_repeat1] = STATE(379),
    [aux_sym_command_repeat2] = STATE(380),
    [sym_file_descriptor] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(632),
    [anon_sym_SEMI_SEMI] = ACTIONS(632),
    [anon_sym_PIPE_AMP] = ACTIONS(632),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [anon_sym_GT_GT] = ACTIONS(246),
    [anon_sym_AMP_GT] = ACTIONS(246),
    [anon_sym_AMP_GT_GT] = ACTIONS(246),
    [anon_sym_LT_AMP] = ACTIONS(246),
    [anon_sym_GT_AMP] = ACTIONS(246),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_word] = ACTIONS(252),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_LF] = ACTIONS(632),
    [anon_sym_AMP] = ACTIONS(632),
  },
  [153] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [aux_sym_command_repeat2] = STATE(381),
    [sym_file_descriptor] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(632),
    [anon_sym_SEMI_SEMI] = ACTIONS(632),
    [anon_sym_PIPE_AMP] = ACTIONS(632),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [anon_sym_GT_GT] = ACTIONS(246),
    [anon_sym_AMP_GT] = ACTIONS(246),
    [anon_sym_AMP_GT_GT] = ACTIONS(246),
    [anon_sym_LT_AMP] = ACTIONS(246),
    [anon_sym_GT_AMP] = ACTIONS(246),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_LF] = ACTIONS(632),
    [anon_sym_AMP] = ACTIONS(632),
  },
  [154] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(154),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(634),
    [sym_variable_name] = ACTIONS(637),
    [ts_builtin_sym_end] = ACTIONS(640),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(663),
    [anon_sym_local] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(672),
    [anon_sym_LT_AMP] = ACTIONS(672),
    [anon_sym_GT_AMP] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(678),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_word] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
  },
  [155] = {
    [sym__assignment] = STATE(383),
    [anon_sym_LBRACK] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_PLUS_EQ] = ACTIONS(699),
    [sym_comment] = ACTIONS(54),
  },
  [156] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(149),
    [sym_simple_expansion] = STATE(149),
    [sym_expansion] = STATE(149),
    [sym_command_substitution] = STATE(149),
    [sym_process_substitution] = STATE(149),
    [aux_sym_for_statement_repeat1] = STATE(384),
    [aux_sym_command_repeat2] = STATE(380),
    [sym_file_descriptor] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(632),
    [anon_sym_SEMI_SEMI] = ACTIONS(632),
    [anon_sym_PIPE_AMP] = ACTIONS(632),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [anon_sym_GT_GT] = ACTIONS(246),
    [anon_sym_AMP_GT] = ACTIONS(246),
    [anon_sym_AMP_GT_GT] = ACTIONS(246),
    [anon_sym_LT_AMP] = ACTIONS(246),
    [anon_sym_GT_AMP] = ACTIONS(246),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_word] = ACTIONS(252),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_LF] = ACTIONS(632),
    [anon_sym_AMP] = ACTIONS(632),
  },
  [157] = {
    [sym__assignment] = STATE(383),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_PLUS_EQ] = ACTIONS(699),
    [sym_comment] = ACTIONS(54),
  },
  [158] = {
    [sym_environment_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(157),
    [sym_file_redirect] = STATE(28),
    [aux_sym_command_repeat1] = STATE(158),
    [sym_file_descriptor] = ACTIONS(701),
    [sym_variable_name] = ACTIONS(704),
    [anon_sym_LT] = ACTIONS(707),
    [anon_sym_GT] = ACTIONS(707),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_AMP_GT] = ACTIONS(707),
    [anon_sym_AMP_GT_GT] = ACTIONS(710),
    [anon_sym_LT_AMP] = ACTIONS(710),
    [anon_sym_GT_AMP] = ACTIONS(710),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [sym_raw_string] = ACTIONS(713),
    [anon_sym_DOLLAR] = ACTIONS(715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(713),
    [anon_sym_BQUOTE] = ACTIONS(713),
    [anon_sym_LT_LPAREN] = ACTIONS(713),
    [anon_sym_GT_LPAREN] = ACTIONS(713),
    [sym_word] = ACTIONS(715),
    [sym_comment] = ACTIONS(54),
  },
  [159] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym_file_descriptor] = ACTIONS(717),
    [sym__concat] = ACTIONS(422),
    [sym_variable_name] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_AMP_GT] = ACTIONS(719),
    [anon_sym_AMP_GT_GT] = ACTIONS(717),
    [anon_sym_LT_AMP] = ACTIONS(717),
    [anon_sym_GT_AMP] = ACTIONS(717),
    [anon_sym_DQUOTE] = ACTIONS(717),
    [sym_raw_string] = ACTIONS(717),
    [anon_sym_DOLLAR] = ACTIONS(719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(717),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(717),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [anon_sym_LT_LPAREN] = ACTIONS(717),
    [anon_sym_GT_LPAREN] = ACTIONS(717),
    [sym_word] = ACTIONS(719),
    [sym_comment] = ACTIONS(54),
  },
  [160] = {
    [sym_file_descriptor] = ACTIONS(717),
    [sym_variable_name] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_AMP_GT] = ACTIONS(719),
    [anon_sym_AMP_GT_GT] = ACTIONS(717),
    [anon_sym_LT_AMP] = ACTIONS(717),
    [anon_sym_GT_AMP] = ACTIONS(717),
    [anon_sym_DQUOTE] = ACTIONS(717),
    [sym_raw_string] = ACTIONS(717),
    [anon_sym_DOLLAR] = ACTIONS(719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(717),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(717),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [anon_sym_LT_LPAREN] = ACTIONS(717),
    [anon_sym_GT_LPAREN] = ACTIONS(717),
    [sym_word] = ACTIONS(719),
    [sym_comment] = ACTIONS(54),
  },
  [161] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(386),
    [anon_sym_DQUOTE] = ACTIONS(721),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [162] = {
    [aux_sym_concatenation_repeat1] = STATE(389),
    [sym__concat] = ACTIONS(723),
    [anon_sym_RBRACK] = ACTIONS(725),
    [sym_comment] = ACTIONS(54),
  },
  [163] = {
    [sym_special_variable_name] = STATE(392),
    [anon_sym_DOLLAR] = ACTIONS(727),
    [anon_sym_POUND] = ACTIONS(727),
    [anon_sym_AT] = ACTIONS(727),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(727),
    [anon_sym_QMARK] = ACTIONS(727),
    [anon_sym_DASH] = ACTIONS(727),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_0] = ACTIONS(731),
    [anon_sym__] = ACTIONS(731),
  },
  [164] = {
    [sym_special_variable_name] = STATE(395),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(735),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [165] = {
    [sym_for_statement] = STATE(396),
    [sym_while_statement] = STATE(396),
    [sym_if_statement] = STATE(396),
    [sym_case_statement] = STATE(396),
    [sym_function_definition] = STATE(396),
    [sym_subshell] = STATE(396),
    [sym_pipeline] = STATE(396),
    [sym_list] = STATE(396),
    [sym_bracket_command] = STATE(396),
    [sym_command] = STATE(396),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(397),
    [sym_local_variable_declaration] = STATE(396),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [166] = {
    [sym_for_statement] = STATE(398),
    [sym_while_statement] = STATE(398),
    [sym_if_statement] = STATE(398),
    [sym_case_statement] = STATE(398),
    [sym_function_definition] = STATE(398),
    [sym_subshell] = STATE(398),
    [sym_pipeline] = STATE(398),
    [sym_list] = STATE(398),
    [sym_bracket_command] = STATE(398),
    [sym_command] = STATE(398),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(399),
    [sym_local_variable_declaration] = STATE(398),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [167] = {
    [sym_for_statement] = STATE(400),
    [sym_while_statement] = STATE(400),
    [sym_if_statement] = STATE(400),
    [sym_case_statement] = STATE(400),
    [sym_function_definition] = STATE(400),
    [sym_subshell] = STATE(400),
    [sym_pipeline] = STATE(400),
    [sym_list] = STATE(400),
    [sym_bracket_command] = STATE(400),
    [sym_command] = STATE(400),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(401),
    [sym_local_variable_declaration] = STATE(400),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [168] = {
    [anon_sym_RBRACK] = ACTIONS(725),
    [sym_comment] = ACTIONS(54),
  },
  [169] = {
    [sym_file_descriptor] = ACTIONS(737),
    [sym_variable_name] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(739),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(739),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_word] = ACTIONS(739),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(739),
  },
  [170] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(411),
    [anon_sym_RPAREN] = ACTIONS(741),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [171] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(413),
    [anon_sym_DQUOTE] = ACTIONS(759),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [172] = {
    [aux_sym_concatenation_repeat1] = STATE(415),
    [sym_file_descriptor] = ACTIONS(737),
    [sym__concat] = ACTIONS(761),
    [sym_variable_name] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(739),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_word] = ACTIONS(739),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(739),
  },
  [173] = {
    [sym_special_variable_name] = STATE(418),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [anon_sym_POUND] = ACTIONS(763),
    [anon_sym_AT] = ACTIONS(763),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(763),
    [anon_sym_QMARK] = ACTIONS(763),
    [anon_sym_DASH] = ACTIONS(763),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_0] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
  },
  [174] = {
    [sym_special_variable_name] = STATE(421),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [175] = {
    [sym_for_statement] = STATE(422),
    [sym_while_statement] = STATE(422),
    [sym_if_statement] = STATE(422),
    [sym_case_statement] = STATE(422),
    [sym_function_definition] = STATE(422),
    [sym_subshell] = STATE(422),
    [sym_pipeline] = STATE(422),
    [sym_list] = STATE(422),
    [sym_bracket_command] = STATE(422),
    [sym_command] = STATE(422),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(423),
    [sym_local_variable_declaration] = STATE(422),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [176] = {
    [sym_for_statement] = STATE(424),
    [sym_while_statement] = STATE(424),
    [sym_if_statement] = STATE(424),
    [sym_case_statement] = STATE(424),
    [sym_function_definition] = STATE(424),
    [sym_subshell] = STATE(424),
    [sym_pipeline] = STATE(424),
    [sym_list] = STATE(424),
    [sym_bracket_command] = STATE(424),
    [sym_command] = STATE(424),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(425),
    [sym_local_variable_declaration] = STATE(424),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [177] = {
    [sym_for_statement] = STATE(426),
    [sym_while_statement] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_case_statement] = STATE(426),
    [sym_function_definition] = STATE(426),
    [sym_subshell] = STATE(426),
    [sym_pipeline] = STATE(426),
    [sym_list] = STATE(426),
    [sym_bracket_command] = STATE(426),
    [sym_command] = STATE(426),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(427),
    [sym_local_variable_declaration] = STATE(426),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [178] = {
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_for_statement_repeat1] = STATE(436),
    [anon_sym_DQUOTE] = ACTIONS(773),
    [sym_raw_string] = ACTIONS(775),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(785),
    [anon_sym_GT_LPAREN] = ACTIONS(785),
    [sym_word] = ACTIONS(787),
    [sym_comment] = ACTIONS(54),
  },
  [179] = {
    [sym__terminated_statement] = STATE(438),
    [sym_for_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_function_definition] = STATE(439),
    [sym_subshell] = STATE(439),
    [sym_pipeline] = STATE(439),
    [sym_list] = STATE(439),
    [sym_bracket_command] = STATE(439),
    [sym_command] = STATE(439),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(440),
    [sym_local_variable_declaration] = STATE(439),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(441),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [180] = {
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(791),
    [anon_sym_SEMI_SEMI] = ACTIONS(791),
    [anon_sym_PIPE_AMP] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(791),
    [anon_sym_LF] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
  },
  [181] = {
    [anon_sym_do] = ACTIONS(598),
    [anon_sym_then] = ACTIONS(598),
    [sym_comment] = ACTIONS(54),
  },
  [182] = {
    [sym__terminated_statement] = STATE(445),
    [sym_for_statement] = STATE(446),
    [sym_while_statement] = STATE(446),
    [sym_if_statement] = STATE(446),
    [sym_elif_clause] = STATE(447),
    [sym_else_clause] = STATE(448),
    [sym_case_statement] = STATE(446),
    [sym_function_definition] = STATE(446),
    [sym_subshell] = STATE(446),
    [sym_pipeline] = STATE(446),
    [sym_list] = STATE(446),
    [sym_bracket_command] = STATE(446),
    [sym_command] = STATE(446),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(449),
    [sym_local_variable_declaration] = STATE(446),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(450),
    [aux_sym_if_statement_repeat1] = STATE(451),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(793),
    [anon_sym_elif] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [183] = {
    [sym__concat] = ACTIONS(436),
    [anon_sym_in] = ACTIONS(438),
    [anon_sym_SEMI_SEMI] = ACTIONS(438),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LF] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(438),
  },
  [184] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(799),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [185] = {
    [sym_string] = STATE(453),
    [sym_simple_expansion] = STATE(453),
    [sym_expansion] = STATE(453),
    [sym_command_substitution] = STATE(453),
    [sym_process_substitution] = STATE(453),
    [anon_sym_DQUOTE] = ACTIONS(66),
    [sym_raw_string] = ACTIONS(801),
    [anon_sym_DOLLAR] = ACTIONS(70),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(72),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(74),
    [anon_sym_BQUOTE] = ACTIONS(76),
    [anon_sym_LT_LPAREN] = ACTIONS(78),
    [anon_sym_GT_LPAREN] = ACTIONS(78),
    [sym_word] = ACTIONS(803),
    [sym_comment] = ACTIONS(54),
  },
  [186] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(805),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(805),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [187] = {
    [anon_sym_in] = ACTIONS(807),
    [sym_comment] = ACTIONS(54),
  },
  [188] = {
    [aux_sym_concatenation_repeat1] = STATE(456),
    [sym__concat] = ACTIONS(330),
    [anon_sym_in] = ACTIONS(462),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [189] = {
    [sym__concat] = ACTIONS(464),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_SEMI_SEMI] = ACTIONS(466),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(466),
  },
  [190] = {
    [sym__concat] = ACTIONS(468),
    [anon_sym_in] = ACTIONS(470),
    [anon_sym_SEMI_SEMI] = ACTIONS(470),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_LF] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(470),
  },
  [191] = {
    [sym__concat] = ACTIONS(472),
    [anon_sym_in] = ACTIONS(474),
    [anon_sym_SEMI_SEMI] = ACTIONS(474),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_LF] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(474),
  },
  [192] = {
    [sym_special_variable_name] = STATE(458),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [193] = {
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_COLON_QMARK] = ACTIONS(815),
    [anon_sym_COLON_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(815),
    [sym_comment] = ACTIONS(54),
  },
  [194] = {
    [anon_sym_RBRACE] = ACTIONS(819),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(823),
    [anon_sym_COLON] = ACTIONS(825),
    [anon_sym_COLON_QMARK] = ACTIONS(823),
    [anon_sym_COLON_DASH] = ACTIONS(823),
    [anon_sym_PERCENT] = ACTIONS(823),
    [anon_sym_SLASH] = ACTIONS(823),
    [sym_comment] = ACTIONS(54),
  },
  [195] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(827),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [196] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(827),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [197] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(827),
    [sym_comment] = ACTIONS(54),
  },
  [198] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(827),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [199] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [200] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [201] = {
    [anon_sym_RPAREN] = ACTIONS(831),
    [sym_comment] = ACTIONS(54),
  },
  [202] = {
    [sym_file_redirect] = STATE(468),
    [sym_file_descriptor] = ACTIONS(592),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_PIPE_AMP] = ACTIONS(833),
    [anon_sym_AMP_AMP] = ACTIONS(833),
    [anon_sym_PIPE_PIPE] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_GT] = ACTIONS(596),
    [anon_sym_GT_GT] = ACTIONS(596),
    [anon_sym_AMP_GT] = ACTIONS(596),
    [anon_sym_AMP_GT_GT] = ACTIONS(596),
    [anon_sym_LT_AMP] = ACTIONS(596),
    [anon_sym_GT_AMP] = ACTIONS(596),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(833),
    [anon_sym_LF] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
  },
  [203] = {
    [sym_concatenation] = STATE(169),
    [sym_string] = STATE(469),
    [sym_array] = STATE(169),
    [sym_simple_expansion] = STATE(469),
    [sym_expansion] = STATE(469),
    [sym_command_substitution] = STATE(469),
    [sym_process_substitution] = STATE(469),
    [sym__empty_value] = ACTIONS(296),
    [anon_sym_LPAREN] = ACTIONS(298),
    [anon_sym_DQUOTE] = ACTIONS(300),
    [sym_raw_string] = ACTIONS(835),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(308),
    [anon_sym_BQUOTE] = ACTIONS(310),
    [anon_sym_LT_LPAREN] = ACTIONS(312),
    [anon_sym_GT_LPAREN] = ACTIONS(312),
    [sym_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(54),
  },
  [204] = {
    [sym_compound_statement] = STATE(471),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(348),
    [sym_comment] = ACTIONS(54),
  },
  [205] = {
    [sym__assignment] = STATE(258),
    [anon_sym_PIPE] = ACTIONS(414),
    [anon_sym_RPAREN] = ACTIONS(414),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [anon_sym_PIPE_AMP] = ACTIONS(414),
    [anon_sym_AMP_AMP] = ACTIONS(414),
    [anon_sym_PIPE_PIPE] = ACTIONS(414),
    [anon_sym_EQ] = ACTIONS(841),
    [anon_sym_PLUS_EQ] = ACTIONS(841),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [206] = {
    [aux_sym_concatenation_repeat1] = STATE(473),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(160),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_RPAREN] = ACTIONS(462),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(462),
    [anon_sym_AMP_AMP] = ACTIONS(462),
    [anon_sym_PIPE_PIPE] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(462),
    [anon_sym_AMP_GT] = ACTIONS(462),
    [anon_sym_AMP_GT_GT] = ACTIONS(462),
    [anon_sym_LT_AMP] = ACTIONS(462),
    [anon_sym_GT_AMP] = ACTIONS(462),
    [anon_sym_LT_LT] = ACTIONS(462),
    [anon_sym_LT_LT_DASH] = ACTIONS(462),
    [anon_sym_DQUOTE] = ACTIONS(462),
    [sym_raw_string] = ACTIONS(462),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(462),
    [anon_sym_BQUOTE] = ACTIONS(462),
    [anon_sym_LT_LPAREN] = ACTIONS(462),
    [anon_sym_GT_LPAREN] = ACTIONS(462),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [207] = {
    [anon_sym_RPAREN] = ACTIONS(843),
    [sym_comment] = ACTIONS(54),
  },
  [208] = {
    [sym_file_redirect] = STATE(362),
    [sym_file_descriptor] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(594),
    [anon_sym_RPAREN] = ACTIONS(594),
    [anon_sym_SEMI_SEMI] = ACTIONS(594),
    [anon_sym_PIPE_AMP] = ACTIONS(594),
    [anon_sym_AMP_AMP] = ACTIONS(594),
    [anon_sym_PIPE_PIPE] = ACTIONS(594),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(594),
    [anon_sym_LF] = ACTIONS(594),
    [anon_sym_AMP] = ACTIONS(594),
  },
  [209] = {
    [sym_for_statement] = STATE(363),
    [sym_while_statement] = STATE(363),
    [sym_if_statement] = STATE(363),
    [sym_case_statement] = STATE(363),
    [sym_function_definition] = STATE(363),
    [sym_subshell] = STATE(363),
    [sym_pipeline] = STATE(363),
    [sym_list] = STATE(363),
    [sym_bracket_command] = STATE(363),
    [sym_command] = STATE(363),
    [sym_command_name] = STATE(56),
    [sym_environment_variable_assignment] = STATE(364),
    [sym_local_variable_declaration] = STATE(363),
    [sym_subscript] = STATE(58),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(53),
    [sym_simple_expansion] = STATE(53),
    [sym_expansion] = STATE(53),
    [sym_command_substitution] = STATE(53),
    [sym_process_substitution] = STATE(53),
    [aux_sym_command_repeat1] = STATE(60),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(84),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(90),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(92),
    [sym_comment] = ACTIONS(54),
  },
  [210] = {
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_RPAREN] = ACTIONS(849),
    [anon_sym_SEMI_SEMI] = ACTIONS(849),
    [anon_sym_PIPE_AMP] = ACTIONS(849),
    [anon_sym_AMP_AMP] = ACTIONS(849),
    [anon_sym_PIPE_PIPE] = ACTIONS(849),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(849),
    [anon_sym_LF] = ACTIONS(849),
    [anon_sym_AMP] = ACTIONS(849),
  },
  [211] = {
    [sym_file_descriptor] = ACTIONS(598),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_function] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(600),
    [anon_sym_local] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_AMP_GT] = ACTIONS(600),
    [anon_sym_AMP_GT_GT] = ACTIONS(598),
    [anon_sym_LT_AMP] = ACTIONS(598),
    [anon_sym_GT_AMP] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_word] = ACTIONS(602),
    [sym_comment] = ACTIONS(54),
  },
  [212] = {
    [sym_for_statement] = STATE(478),
    [sym_while_statement] = STATE(478),
    [sym_if_statement] = STATE(478),
    [sym_case_statement] = STATE(478),
    [sym_function_definition] = STATE(478),
    [sym_subshell] = STATE(478),
    [sym_pipeline] = STATE(478),
    [sym_list] = STATE(478),
    [sym_bracket_command] = STATE(478),
    [sym_command] = STATE(478),
    [sym_command_name] = STATE(56),
    [sym_environment_variable_assignment] = STATE(479),
    [sym_local_variable_declaration] = STATE(478),
    [sym_subscript] = STATE(58),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(53),
    [sym_simple_expansion] = STATE(53),
    [sym_expansion] = STATE(53),
    [sym_command_substitution] = STATE(53),
    [sym_process_substitution] = STATE(53),
    [aux_sym_command_repeat1] = STATE(60),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(84),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(90),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(92),
    [sym_comment] = ACTIONS(54),
  },
  [213] = {
    [anon_sym_LT] = ACTIONS(853),
    [anon_sym_GT] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_GT] = ACTIONS(853),
    [anon_sym_AMP_GT_GT] = ACTIONS(855),
    [anon_sym_LT_AMP] = ACTIONS(855),
    [anon_sym_GT_AMP] = ACTIONS(855),
    [sym_comment] = ACTIONS(54),
  },
  [214] = {
    [sym_concatenation] = STATE(375),
    [sym_string] = STATE(481),
    [sym_simple_expansion] = STATE(481),
    [sym_expansion] = STATE(481),
    [sym_command_substitution] = STATE(481),
    [sym_process_substitution] = STATE(481),
    [anon_sym_DQUOTE] = ACTIONS(608),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(616),
    [anon_sym_BQUOTE] = ACTIONS(618),
    [anon_sym_LT_LPAREN] = ACTIONS(620),
    [anon_sym_GT_LPAREN] = ACTIONS(620),
    [sym_word] = ACTIONS(859),
    [sym_comment] = ACTIONS(54),
  },
  [215] = {
    [aux_sym_concatenation_repeat1] = STATE(206),
    [sym_file_descriptor] = ACTIONS(380),
    [sym__concat] = ACTIONS(160),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_RPAREN] = ACTIONS(382),
    [anon_sym_SEMI_SEMI] = ACTIONS(382),
    [anon_sym_PIPE_AMP] = ACTIONS(382),
    [anon_sym_AMP_AMP] = ACTIONS(382),
    [anon_sym_PIPE_PIPE] = ACTIONS(382),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_AMP_GT] = ACTIONS(382),
    [anon_sym_AMP_GT_GT] = ACTIONS(382),
    [anon_sym_LT_AMP] = ACTIONS(382),
    [anon_sym_GT_AMP] = ACTIONS(382),
    [anon_sym_LT_LT] = ACTIONS(382),
    [anon_sym_LT_LT_DASH] = ACTIONS(382),
    [anon_sym_DQUOTE] = ACTIONS(382),
    [sym_raw_string] = ACTIONS(382),
    [anon_sym_DOLLAR] = ACTIONS(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(382),
    [anon_sym_BQUOTE] = ACTIONS(382),
    [anon_sym_LT_LPAREN] = ACTIONS(382),
    [anon_sym_GT_LPAREN] = ACTIONS(382),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(382),
    [anon_sym_LF] = ACTIONS(382),
    [anon_sym_AMP] = ACTIONS(382),
  },
  [216] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [aux_sym_for_statement_repeat1] = STATE(482),
    [aux_sym_command_repeat2] = STATE(483),
    [sym_file_descriptor] = ACTIONS(366),
    [anon_sym_PIPE] = ACTIONS(632),
    [anon_sym_RPAREN] = ACTIONS(632),
    [anon_sym_SEMI_SEMI] = ACTIONS(632),
    [anon_sym_PIPE_AMP] = ACTIONS(632),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(368),
    [anon_sym_GT_GT] = ACTIONS(368),
    [anon_sym_AMP_GT] = ACTIONS(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(368),
    [anon_sym_LT_AMP] = ACTIONS(368),
    [anon_sym_GT_AMP] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(370),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_word] = ACTIONS(370),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_LF] = ACTIONS(632),
    [anon_sym_AMP] = ACTIONS(632),
  },
  [217] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [aux_sym_command_repeat2] = STATE(484),
    [sym_file_descriptor] = ACTIONS(366),
    [anon_sym_PIPE] = ACTIONS(632),
    [anon_sym_RPAREN] = ACTIONS(632),
    [anon_sym_SEMI_SEMI] = ACTIONS(632),
    [anon_sym_PIPE_AMP] = ACTIONS(632),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(368),
    [anon_sym_GT_GT] = ACTIONS(368),
    [anon_sym_AMP_GT] = ACTIONS(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(368),
    [anon_sym_LT_AMP] = ACTIONS(368),
    [anon_sym_GT_AMP] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_LF] = ACTIONS(632),
    [anon_sym_AMP] = ACTIONS(632),
  },
  [218] = {
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(863),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(364),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_AMP] = ACTIONS(863),
  },
  [219] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(863),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(364),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_AMP] = ACTIONS(863),
  },
  [220] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(220),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(634),
    [sym_variable_name] = ACTIONS(637),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(663),
    [anon_sym_local] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(672),
    [anon_sym_LT_AMP] = ACTIONS(672),
    [anon_sym_GT_AMP] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(678),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_word] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
  },
  [221] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [aux_sym_for_statement_repeat1] = STATE(486),
    [aux_sym_command_repeat2] = STATE(483),
    [sym_file_descriptor] = ACTIONS(366),
    [anon_sym_PIPE] = ACTIONS(632),
    [anon_sym_RPAREN] = ACTIONS(632),
    [anon_sym_SEMI_SEMI] = ACTIONS(632),
    [anon_sym_PIPE_AMP] = ACTIONS(632),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(368),
    [anon_sym_GT_GT] = ACTIONS(368),
    [anon_sym_AMP_GT] = ACTIONS(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(368),
    [anon_sym_LT_AMP] = ACTIONS(368),
    [anon_sym_GT_AMP] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(370),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_word] = ACTIONS(370),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_LF] = ACTIONS(632),
    [anon_sym_AMP] = ACTIONS(632),
  },
  [222] = {
    [sym__concat] = ACTIONS(436),
    [anon_sym_RBRACE] = ACTIONS(436),
    [anon_sym_RBRACK] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(436),
    [sym_raw_string] = ACTIONS(436),
    [anon_sym_DOLLAR] = ACTIONS(865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(436),
    [anon_sym_BQUOTE] = ACTIONS(436),
    [anon_sym_LT_LPAREN] = ACTIONS(436),
    [anon_sym_GT_LPAREN] = ACTIONS(436),
    [sym_word] = ACTIONS(438),
    [sym_comment] = ACTIONS(54),
  },
  [223] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [224] = {
    [sym_string] = STATE(488),
    [sym_simple_expansion] = STATE(488),
    [sym_expansion] = STATE(488),
    [sym_command_substitution] = STATE(488),
    [sym_process_substitution] = STATE(488),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(869),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(871),
    [sym_comment] = ACTIONS(54),
  },
  [225] = {
    [aux_sym_concatenation_repeat1] = STATE(489),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACK] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(460),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [anon_sym_LT_LPAREN] = ACTIONS(460),
    [anon_sym_GT_LPAREN] = ACTIONS(460),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(54),
  },
  [226] = {
    [sym__concat] = ACTIONS(464),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_RBRACK] = ACTIONS(476),
    [anon_sym_DQUOTE] = ACTIONS(464),
    [sym_raw_string] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(464),
    [anon_sym_BQUOTE] = ACTIONS(464),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_word] = ACTIONS(466),
    [sym_comment] = ACTIONS(54),
  },
  [227] = {
    [sym__concat] = ACTIONS(468),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_RBRACK] = ACTIONS(875),
    [anon_sym_DQUOTE] = ACTIONS(468),
    [sym_raw_string] = ACTIONS(468),
    [anon_sym_DOLLAR] = ACTIONS(875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(468),
    [anon_sym_BQUOTE] = ACTIONS(468),
    [anon_sym_LT_LPAREN] = ACTIONS(468),
    [anon_sym_GT_LPAREN] = ACTIONS(468),
    [sym_word] = ACTIONS(470),
    [sym_comment] = ACTIONS(54),
  },
  [228] = {
    [sym__concat] = ACTIONS(472),
    [anon_sym_RBRACE] = ACTIONS(472),
    [anon_sym_RBRACK] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(472),
    [sym_raw_string] = ACTIONS(472),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_LT_LPAREN] = ACTIONS(472),
    [anon_sym_GT_LPAREN] = ACTIONS(472),
    [sym_word] = ACTIONS(474),
    [sym_comment] = ACTIONS(54),
  },
  [229] = {
    [sym_special_variable_name] = STATE(491),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(879),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [230] = {
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(885),
    [anon_sym_COLON] = ACTIONS(887),
    [anon_sym_COLON_QMARK] = ACTIONS(885),
    [anon_sym_COLON_DASH] = ACTIONS(885),
    [anon_sym_PERCENT] = ACTIONS(885),
    [anon_sym_SLASH] = ACTIONS(885),
    [sym_comment] = ACTIONS(54),
  },
  [231] = {
    [anon_sym_RBRACE] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(895),
    [anon_sym_COLON_QMARK] = ACTIONS(893),
    [anon_sym_COLON_DASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(54),
  },
  [232] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [233] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [234] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(897),
    [sym_comment] = ACTIONS(54),
  },
  [235] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(897),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [236] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [237] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [238] = {
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_PIPE_AMP] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(901),
    [anon_sym_LF] = ACTIONS(901),
    [anon_sym_AMP] = ACTIONS(901),
  },
  [239] = {
    [sym_concatenation] = STATE(68),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_for_statement_repeat1] = STATE(239),
    [anon_sym_RBRACK] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_DOLLAR] = ACTIONS(911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(917),
    [anon_sym_BQUOTE] = ACTIONS(920),
    [anon_sym_LT_LPAREN] = ACTIONS(923),
    [anon_sym_GT_LPAREN] = ACTIONS(923),
    [sym_word] = ACTIONS(926),
    [sym_comment] = ACTIONS(54),
  },
  [240] = {
    [sym__concat] = ACTIONS(436),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(436),
    [sym_raw_string] = ACTIONS(436),
    [anon_sym_DOLLAR] = ACTIONS(865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(436),
    [anon_sym_BQUOTE] = ACTIONS(436),
    [anon_sym_LT_LPAREN] = ACTIONS(436),
    [anon_sym_GT_LPAREN] = ACTIONS(436),
    [sym_word] = ACTIONS(438),
    [sym_comment] = ACTIONS(54),
  },
  [241] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [242] = {
    [sym_string] = STATE(501),
    [sym_simple_expansion] = STATE(501),
    [sym_expansion] = STATE(501),
    [sym_command_substitution] = STATE(501),
    [sym_process_substitution] = STATE(501),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [sym_raw_string] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_word] = ACTIONS(933),
    [sym_comment] = ACTIONS(54),
  },
  [243] = {
    [aux_sym_concatenation_repeat1] = STATE(502),
    [sym__concat] = ACTIONS(400),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(460),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [anon_sym_LT_LPAREN] = ACTIONS(460),
    [anon_sym_GT_LPAREN] = ACTIONS(460),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(54),
  },
  [244] = {
    [sym__concat] = ACTIONS(464),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(476),
    [anon_sym_DQUOTE] = ACTIONS(464),
    [sym_raw_string] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(464),
    [anon_sym_BQUOTE] = ACTIONS(464),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_word] = ACTIONS(466),
    [sym_comment] = ACTIONS(54),
  },
  [245] = {
    [sym__concat] = ACTIONS(468),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(875),
    [anon_sym_DQUOTE] = ACTIONS(468),
    [sym_raw_string] = ACTIONS(468),
    [anon_sym_DOLLAR] = ACTIONS(875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(468),
    [anon_sym_BQUOTE] = ACTIONS(468),
    [anon_sym_LT_LPAREN] = ACTIONS(468),
    [anon_sym_GT_LPAREN] = ACTIONS(468),
    [sym_word] = ACTIONS(470),
    [sym_comment] = ACTIONS(54),
  },
  [246] = {
    [sym__concat] = ACTIONS(472),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(472),
    [sym_raw_string] = ACTIONS(472),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_LT_LPAREN] = ACTIONS(472),
    [anon_sym_GT_LPAREN] = ACTIONS(472),
    [sym_word] = ACTIONS(474),
    [sym_comment] = ACTIONS(54),
  },
  [247] = {
    [sym_special_variable_name] = STATE(504),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(935),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [248] = {
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_COLON_QMARK] = ACTIONS(941),
    [anon_sym_COLON_DASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [sym_comment] = ACTIONS(54),
  },
  [249] = {
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_EQ] = ACTIONS(949),
    [anon_sym_COLON] = ACTIONS(951),
    [anon_sym_COLON_QMARK] = ACTIONS(949),
    [anon_sym_COLON_DASH] = ACTIONS(949),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(949),
    [sym_comment] = ACTIONS(54),
  },
  [250] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(953),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [251] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(953),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [252] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(953),
    [sym_comment] = ACTIONS(54),
  },
  [253] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(953),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [254] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [255] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [256] = {
    [sym_concatenation] = STATE(77),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_for_statement_repeat1] = STATE(256),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(960),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(966),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(969),
    [anon_sym_BQUOTE] = ACTIONS(972),
    [anon_sym_LT_LPAREN] = ACTIONS(975),
    [anon_sym_GT_LPAREN] = ACTIONS(975),
    [sym_word] = ACTIONS(978),
    [sym_comment] = ACTIONS(54),
  },
  [257] = {
    [sym_concatenation] = STATE(513),
    [sym_string] = STATE(516),
    [sym_array] = STATE(513),
    [sym_simple_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [sym__empty_value] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [sym_raw_string] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_word] = ACTIONS(999),
    [sym_comment] = ACTIONS(54),
  },
  [258] = {
    [anon_sym_PIPE] = ACTIONS(1001),
    [anon_sym_RPAREN] = ACTIONS(1001),
    [anon_sym_SEMI_SEMI] = ACTIONS(1001),
    [anon_sym_PIPE_AMP] = ACTIONS(1001),
    [anon_sym_AMP_AMP] = ACTIONS(1001),
    [anon_sym_PIPE_PIPE] = ACTIONS(1001),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LF] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(1001),
  },
  [259] = {
    [sym_file_descriptor] = ACTIONS(436),
    [sym__concat] = ACTIONS(436),
    [sym_variable_name] = ACTIONS(436),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(436),
    [anon_sym_AMP_GT] = ACTIONS(865),
    [anon_sym_AMP_GT_GT] = ACTIONS(436),
    [anon_sym_LT_AMP] = ACTIONS(436),
    [anon_sym_GT_AMP] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(436),
    [sym_raw_string] = ACTIONS(436),
    [anon_sym_DOLLAR] = ACTIONS(865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(436),
    [anon_sym_BQUOTE] = ACTIONS(436),
    [anon_sym_LT_LPAREN] = ACTIONS(436),
    [anon_sym_GT_LPAREN] = ACTIONS(436),
    [sym_word] = ACTIONS(865),
    [sym_comment] = ACTIONS(54),
  },
  [260] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [261] = {
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [anon_sym_DQUOTE] = ACTIONS(128),
    [sym_raw_string] = ACTIONS(1005),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(134),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(136),
    [anon_sym_BQUOTE] = ACTIONS(138),
    [anon_sym_LT_LPAREN] = ACTIONS(140),
    [anon_sym_GT_LPAREN] = ACTIONS(140),
    [sym_word] = ACTIONS(1007),
    [sym_comment] = ACTIONS(54),
  },
  [262] = {
    [aux_sym_concatenation_repeat1] = STATE(524),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(422),
    [sym_variable_name] = ACTIONS(460),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(460),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(460),
    [anon_sym_LT_AMP] = ACTIONS(460),
    [anon_sym_GT_AMP] = ACTIONS(460),
    [anon_sym_DQUOTE] = ACTIONS(460),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [anon_sym_LT_LPAREN] = ACTIONS(460),
    [anon_sym_GT_LPAREN] = ACTIONS(460),
    [sym_word] = ACTIONS(873),
    [sym_comment] = ACTIONS(54),
  },
  [263] = {
    [sym_file_descriptor] = ACTIONS(464),
    [sym__concat] = ACTIONS(464),
    [sym_variable_name] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_AMP_GT] = ACTIONS(476),
    [anon_sym_AMP_GT_GT] = ACTIONS(464),
    [anon_sym_LT_AMP] = ACTIONS(464),
    [anon_sym_GT_AMP] = ACTIONS(464),
    [anon_sym_DQUOTE] = ACTIONS(464),
    [sym_raw_string] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(464),
    [anon_sym_BQUOTE] = ACTIONS(464),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_word] = ACTIONS(476),
    [sym_comment] = ACTIONS(54),
  },
  [264] = {
    [sym_file_descriptor] = ACTIONS(468),
    [sym__concat] = ACTIONS(468),
    [sym_variable_name] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(468),
    [anon_sym_AMP_GT] = ACTIONS(875),
    [anon_sym_AMP_GT_GT] = ACTIONS(468),
    [anon_sym_LT_AMP] = ACTIONS(468),
    [anon_sym_GT_AMP] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(468),
    [sym_raw_string] = ACTIONS(468),
    [anon_sym_DOLLAR] = ACTIONS(875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(468),
    [anon_sym_BQUOTE] = ACTIONS(468),
    [anon_sym_LT_LPAREN] = ACTIONS(468),
    [anon_sym_GT_LPAREN] = ACTIONS(468),
    [sym_word] = ACTIONS(875),
    [sym_comment] = ACTIONS(54),
  },
  [265] = {
    [sym_file_descriptor] = ACTIONS(472),
    [sym__concat] = ACTIONS(472),
    [sym_variable_name] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(472),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(472),
    [anon_sym_LT_AMP] = ACTIONS(472),
    [anon_sym_GT_AMP] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(472),
    [sym_raw_string] = ACTIONS(472),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_LT_LPAREN] = ACTIONS(472),
    [anon_sym_GT_LPAREN] = ACTIONS(472),
    [sym_word] = ACTIONS(877),
    [sym_comment] = ACTIONS(54),
  },
  [266] = {
    [sym_special_variable_name] = STATE(526),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [267] = {
    [anon_sym_RBRACE] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_EQ] = ACTIONS(1015),
    [anon_sym_COLON] = ACTIONS(1017),
    [anon_sym_COLON_QMARK] = ACTIONS(1015),
    [anon_sym_COLON_DASH] = ACTIONS(1015),
    [anon_sym_PERCENT] = ACTIONS(1015),
    [anon_sym_SLASH] = ACTIONS(1015),
    [sym_comment] = ACTIONS(54),
  },
  [268] = {
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_COLON] = ACTIONS(1025),
    [anon_sym_COLON_QMARK] = ACTIONS(1023),
    [anon_sym_COLON_DASH] = ACTIONS(1023),
    [anon_sym_PERCENT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1023),
    [sym_comment] = ACTIONS(54),
  },
  [269] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [270] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [271] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [sym_comment] = ACTIONS(54),
  },
  [272] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [273] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [274] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [275] = {
    [anon_sym_DQUOTE] = ACTIONS(466),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(476),
    [anon_sym_DOLLAR] = ACTIONS(466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(466),
    [anon_sym_BQUOTE] = ACTIONS(466),
    [sym_comment] = ACTIONS(156),
  },
  [276] = {
    [anon_sym_DQUOTE] = ACTIONS(470),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(875),
    [anon_sym_DOLLAR] = ACTIONS(470),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(470),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(470),
    [anon_sym_BQUOTE] = ACTIONS(470),
    [sym_comment] = ACTIONS(156),
  },
  [277] = {
    [anon_sym_DQUOTE] = ACTIONS(474),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(877),
    [anon_sym_DOLLAR] = ACTIONS(474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(474),
    [anon_sym_BQUOTE] = ACTIONS(474),
    [sym_comment] = ACTIONS(156),
  },
  [278] = {
    [sym_special_variable_name] = STATE(536),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [279] = {
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(1035),
    [anon_sym_EQ] = ACTIONS(1037),
    [anon_sym_COLON] = ACTIONS(1039),
    [anon_sym_COLON_QMARK] = ACTIONS(1037),
    [anon_sym_COLON_DASH] = ACTIONS(1037),
    [anon_sym_PERCENT] = ACTIONS(1037),
    [anon_sym_SLASH] = ACTIONS(1037),
    [sym_comment] = ACTIONS(54),
  },
  [280] = {
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_COLON] = ACTIONS(1047),
    [anon_sym_COLON_QMARK] = ACTIONS(1045),
    [anon_sym_COLON_DASH] = ACTIONS(1045),
    [anon_sym_PERCENT] = ACTIONS(1045),
    [anon_sym_SLASH] = ACTIONS(1045),
    [sym_comment] = ACTIONS(54),
  },
  [281] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [282] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [283] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(54),
  },
  [284] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [285] = {
    [sym_file_descriptor] = ACTIONS(1051),
    [sym__concat] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [286] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(1055),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [sym_comment] = ACTIONS(156),
  },
  [287] = {
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(1074),
    [anon_sym_LT_AMP] = ACTIONS(1074),
    [anon_sym_GT_AMP] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_LT_LT_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_raw_string] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LPAREN] = ACTIONS(1074),
    [anon_sym_GT_LPAREN] = ACTIONS(1074),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [288] = {
    [aux_sym_concatenation_repeat1] = STATE(288),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1076),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(1074),
    [anon_sym_LT_AMP] = ACTIONS(1074),
    [anon_sym_GT_AMP] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_LT_LT_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_raw_string] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LPAREN] = ACTIONS(1074),
    [anon_sym_GT_LPAREN] = ACTIONS(1074),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [289] = {
    [anon_sym_RBRACE] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [sym_comment] = ACTIONS(54),
  },
  [290] = {
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1085),
    [sym_comment] = ACTIONS(54),
  },
  [291] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [292] = {
    [anon_sym_AT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(54),
  },
  [293] = {
    [sym_concatenation] = STATE(551),
    [sym_string] = STATE(550),
    [sym_simple_expansion] = STATE(550),
    [sym_expansion] = STATE(550),
    [sym_command_substitution] = STATE(550),
    [sym_process_substitution] = STATE(550),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1095),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1097),
    [sym_comment] = ACTIONS(54),
  },
  [294] = {
    [sym_file_descriptor] = ACTIONS(1099),
    [sym__concat] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
  },
  [295] = {
    [anon_sym_AT] = ACTIONS(1103),
    [sym_comment] = ACTIONS(54),
  },
  [296] = {
    [sym_concatenation] = STATE(554),
    [sym_string] = STATE(553),
    [sym_simple_expansion] = STATE(553),
    [sym_expansion] = STATE(553),
    [sym_command_substitution] = STATE(553),
    [sym_process_substitution] = STATE(553),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1107),
    [sym_comment] = ACTIONS(54),
  },
  [297] = {
    [sym_concatenation] = STATE(555),
    [sym_string] = STATE(558),
    [sym_array] = STATE(555),
    [sym_simple_expansion] = STATE(558),
    [sym_expansion] = STATE(558),
    [sym_command_substitution] = STATE(558),
    [sym_process_substitution] = STATE(558),
    [sym__empty_value] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [sym_raw_string] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1121),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LT_LPAREN] = ACTIONS(1125),
    [anon_sym_GT_LPAREN] = ACTIONS(1125),
    [sym_word] = ACTIONS(1127),
    [sym_comment] = ACTIONS(54),
  },
  [298] = {
    [sym_file_descriptor] = ACTIONS(316),
    [sym_variable_name] = ACTIONS(316),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_RPAREN] = ACTIONS(316),
    [anon_sym_PIPE_AMP] = ACTIONS(316),
    [anon_sym_AMP_AMP] = ACTIONS(316),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(316),
    [anon_sym_AMP_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT_GT] = ACTIONS(316),
    [anon_sym_LT_AMP] = ACTIONS(316),
    [anon_sym_GT_AMP] = ACTIONS(316),
    [anon_sym_DQUOTE] = ACTIONS(316),
    [sym_raw_string] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(316),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(316),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_LT_LPAREN] = ACTIONS(316),
    [anon_sym_GT_LPAREN] = ACTIONS(316),
    [sym_word] = ACTIONS(318),
    [sym_comment] = ACTIONS(54),
  },
  [299] = {
    [anon_sym_in] = ACTIONS(1131),
    [sym_comment] = ACTIONS(54),
  },
  [300] = {
    [sym_do_group] = STATE(566),
    [anon_sym_do] = ACTIONS(1133),
    [sym_comment] = ACTIONS(54),
  },
  [301] = {
    [anon_sym_then] = ACTIONS(1135),
    [sym_comment] = ACTIONS(54),
  },
  [302] = {
    [aux_sym_concatenation_repeat1] = STATE(188),
    [sym__concat] = ACTIONS(330),
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_SEMI_SEMI] = ACTIONS(1139),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym_LF] = ACTIONS(1139),
    [anon_sym_AMP] = ACTIONS(1139),
  },
  [303] = {
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_SEMI_SEMI] = ACTIONS(1139),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym_LF] = ACTIONS(1139),
    [anon_sym_AMP] = ACTIONS(1139),
  },
  [304] = {
    [sym_compound_statement] = STATE(571),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(526),
    [sym_comment] = ACTIONS(54),
  },
  [305] = {
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(1143),
    [anon_sym_SEMI_SEMI] = ACTIONS(1145),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(364),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_LF] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1145),
  },
  [306] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(1143),
    [anon_sym_SEMI_SEMI] = ACTIONS(1145),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(364),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_LF] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1145),
  },
  [307] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(574),
    [sym_while_statement] = STATE(574),
    [sym_if_statement] = STATE(574),
    [sym_case_statement] = STATE(574),
    [sym_function_definition] = STATE(574),
    [sym_subshell] = STATE(574),
    [sym_pipeline] = STATE(574),
    [sym_list] = STATE(574),
    [sym_bracket_command] = STATE(574),
    [sym_command] = STATE(574),
    [sym_command_name] = STATE(56),
    [sym_environment_variable_assignment] = STATE(575),
    [sym_local_variable_declaration] = STATE(574),
    [sym_subscript] = STATE(58),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(53),
    [sym_simple_expansion] = STATE(53),
    [sym_expansion] = STATE(53),
    [sym_command_substitution] = STATE(53),
    [sym_process_substitution] = STATE(53),
    [aux_sym_program_repeat1] = STATE(220),
    [aux_sym_command_repeat1] = STATE(60),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(84),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(90),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(92),
    [sym_comment] = ACTIONS(54),
  },
  [308] = {
    [sym_concatenation] = STATE(68),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [aux_sym_for_statement_repeat1] = STATE(239),
    [anon_sym_RBRACK] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(96),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(396),
    [sym_comment] = ACTIONS(54),
  },
  [309] = {
    [sym_concatenation] = STATE(77),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_for_statement_repeat1] = STATE(256),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [sym_raw_string] = ACTIONS(112),
    [anon_sym_DOLLAR] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_word] = ACTIONS(412),
    [sym_comment] = ACTIONS(54),
  },
  [310] = {
    [sym__assignment] = STATE(578),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_RPAREN] = ACTIONS(1151),
    [anon_sym_PIPE_AMP] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_EQ] = ACTIONS(1153),
    [anon_sym_PLUS_EQ] = ACTIONS(1153),
    [sym_comment] = ACTIONS(54),
  },
  [311] = {
    [sym_file_descriptor] = ACTIONS(436),
    [sym__concat] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_RPAREN] = ACTIONS(436),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(436),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(436),
    [anon_sym_AMP_GT] = ACTIONS(865),
    [anon_sym_AMP_GT_GT] = ACTIONS(436),
    [anon_sym_LT_AMP] = ACTIONS(436),
    [anon_sym_GT_AMP] = ACTIONS(436),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_LT_LT_DASH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(436),
    [sym_raw_string] = ACTIONS(436),
    [anon_sym_DOLLAR] = ACTIONS(865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(436),
    [anon_sym_BQUOTE] = ACTIONS(436),
    [anon_sym_LT_LPAREN] = ACTIONS(436),
    [anon_sym_GT_LPAREN] = ACTIONS(436),
    [sym_word] = ACTIONS(438),
    [sym_comment] = ACTIONS(54),
  },
  [312] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [313] = {
    [sym_string] = STATE(580),
    [sym_simple_expansion] = STATE(580),
    [sym_expansion] = STATE(580),
    [sym_command_substitution] = STATE(580),
    [sym_process_substitution] = STATE(580),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(1157),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(1159),
    [sym_comment] = ACTIONS(54),
  },
  [314] = {
    [aux_sym_concatenation_repeat1] = STATE(581),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(460),
    [anon_sym_PIPE_AMP] = ACTIONS(460),
    [anon_sym_AMP_AMP] = ACTIONS(460),
    [anon_sym_PIPE_PIPE] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(460),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(460),
    [anon_sym_LT_AMP] = ACTIONS(460),
    [anon_sym_GT_AMP] = ACTIONS(460),
    [anon_sym_LT_LT] = ACTIONS(873),
    [anon_sym_LT_LT_DASH] = ACTIONS(460),
    [anon_sym_DQUOTE] = ACTIONS(460),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [anon_sym_LT_LPAREN] = ACTIONS(460),
    [anon_sym_GT_LPAREN] = ACTIONS(460),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(54),
  },
  [315] = {
    [sym_file_descriptor] = ACTIONS(464),
    [sym__concat] = ACTIONS(464),
    [anon_sym_PIPE] = ACTIONS(476),
    [anon_sym_RPAREN] = ACTIONS(464),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(464),
    [anon_sym_PIPE_PIPE] = ACTIONS(476),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_AMP_GT] = ACTIONS(476),
    [anon_sym_AMP_GT_GT] = ACTIONS(464),
    [anon_sym_LT_AMP] = ACTIONS(464),
    [anon_sym_GT_AMP] = ACTIONS(464),
    [anon_sym_LT_LT] = ACTIONS(476),
    [anon_sym_LT_LT_DASH] = ACTIONS(464),
    [anon_sym_DQUOTE] = ACTIONS(464),
    [sym_raw_string] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(464),
    [anon_sym_BQUOTE] = ACTIONS(464),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_word] = ACTIONS(466),
    [sym_comment] = ACTIONS(54),
  },
  [316] = {
    [sym_file_descriptor] = ACTIONS(468),
    [sym__concat] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_PIPE_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(468),
    [anon_sym_AMP_GT] = ACTIONS(875),
    [anon_sym_AMP_GT_GT] = ACTIONS(468),
    [anon_sym_LT_AMP] = ACTIONS(468),
    [anon_sym_GT_AMP] = ACTIONS(468),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_LT_LT_DASH] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(468),
    [sym_raw_string] = ACTIONS(468),
    [anon_sym_DOLLAR] = ACTIONS(875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(468),
    [anon_sym_BQUOTE] = ACTIONS(468),
    [anon_sym_LT_LPAREN] = ACTIONS(468),
    [anon_sym_GT_LPAREN] = ACTIONS(468),
    [sym_word] = ACTIONS(470),
    [sym_comment] = ACTIONS(54),
  },
  [317] = {
    [sym_file_descriptor] = ACTIONS(472),
    [sym__concat] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_PIPE_AMP] = ACTIONS(472),
    [anon_sym_AMP_AMP] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(472),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(472),
    [anon_sym_LT_AMP] = ACTIONS(472),
    [anon_sym_GT_AMP] = ACTIONS(472),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(472),
    [sym_raw_string] = ACTIONS(472),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_LT_LPAREN] = ACTIONS(472),
    [anon_sym_GT_LPAREN] = ACTIONS(472),
    [sym_word] = ACTIONS(474),
    [sym_comment] = ACTIONS(54),
  },
  [318] = {
    [sym_special_variable_name] = STATE(583),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [319] = {
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(1169),
    [anon_sym_COLON_QMARK] = ACTIONS(1167),
    [anon_sym_COLON_DASH] = ACTIONS(1167),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_SLASH] = ACTIONS(1167),
    [sym_comment] = ACTIONS(54),
  },
  [320] = {
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_COLON_QMARK] = ACTIONS(1175),
    [anon_sym_COLON_DASH] = ACTIONS(1175),
    [anon_sym_PERCENT] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1175),
    [sym_comment] = ACTIONS(54),
  },
  [321] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1179),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [322] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1179),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [323] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [sym_comment] = ACTIONS(54),
  },
  [324] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [325] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1181),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [326] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1181),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [327] = {
    [anon_sym_RPAREN] = ACTIONS(1183),
    [sym_comment] = ACTIONS(54),
  },
  [328] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(594),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [329] = {
    [sym_file_redirect] = STATE(597),
    [sym_file_descriptor] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_RPAREN] = ACTIONS(1191),
    [anon_sym_PIPE_AMP] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_GT_GT] = ACTIONS(1195),
    [anon_sym_AMP_GT] = ACTIONS(1193),
    [anon_sym_AMP_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_AMP] = ACTIONS(1195),
    [anon_sym_GT_AMP] = ACTIONS(1195),
    [sym_comment] = ACTIONS(54),
  },
  [330] = {
    [sym_for_statement] = STATE(598),
    [sym_while_statement] = STATE(598),
    [sym_if_statement] = STATE(598),
    [sym_case_statement] = STATE(598),
    [sym_function_definition] = STATE(598),
    [sym_subshell] = STATE(598),
    [sym_pipeline] = STATE(598),
    [sym_list] = STATE(598),
    [sym_bracket_command] = STATE(598),
    [sym_command] = STATE(598),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(599),
    [sym_local_variable_declaration] = STATE(598),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [331] = {
    [sym_file_descriptor] = ACTIONS(1197),
    [sym__concat] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [anon_sym_PIPE_AMP] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_AMP] = ACTIONS(1199),
    [anon_sym_GT_AMP] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_LT_LT_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [sym_raw_string] = ACTIONS(1199),
    [anon_sym_DOLLAR] = ACTIONS(1199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1199),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [anon_sym_LT_LPAREN] = ACTIONS(1199),
    [anon_sym_GT_LPAREN] = ACTIONS(1199),
    [sym_word] = ACTIONS(1199),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [332] = {
    [sym_for_statement] = STATE(600),
    [sym_while_statement] = STATE(600),
    [sym_if_statement] = STATE(600),
    [sym_case_statement] = STATE(600),
    [sym_function_definition] = STATE(600),
    [sym_subshell] = STATE(600),
    [sym_pipeline] = STATE(600),
    [sym_list] = STATE(600),
    [sym_bracket_command] = STATE(600),
    [sym_command] = STATE(600),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(601),
    [sym_local_variable_declaration] = STATE(600),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [333] = {
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_AMP_GT] = ACTIONS(1201),
    [anon_sym_AMP_GT_GT] = ACTIONS(1203),
    [anon_sym_LT_AMP] = ACTIONS(1203),
    [anon_sym_GT_AMP] = ACTIONS(1203),
    [sym_comment] = ACTIONS(54),
  },
  [334] = {
    [sym_concatenation] = STATE(610),
    [sym_string] = STATE(604),
    [sym_simple_expansion] = STATE(604),
    [sym_expansion] = STATE(604),
    [sym_command_substitution] = STATE(604),
    [sym_process_substitution] = STATE(604),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [sym_raw_string] = ACTIONS(1207),
    [anon_sym_DOLLAR] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1213),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [anon_sym_LT_LPAREN] = ACTIONS(1217),
    [anon_sym_GT_LPAREN] = ACTIONS(1217),
    [sym_word] = ACTIONS(1219),
    [sym_comment] = ACTIONS(54),
  },
  [335] = {
    [sym_heredoc] = STATE(613),
    [sym__simple_heredoc] = ACTIONS(1221),
    [sym__heredoc_beginning] = ACTIONS(1223),
    [sym_comment] = ACTIONS(54),
  },
  [336] = {
    [aux_sym_concatenation_repeat1] = STATE(314),
    [sym_file_descriptor] = ACTIONS(380),
    [sym__concat] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_RPAREN] = ACTIONS(380),
    [anon_sym_PIPE_AMP] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(378),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_AMP_GT] = ACTIONS(378),
    [anon_sym_AMP_GT_GT] = ACTIONS(380),
    [anon_sym_LT_AMP] = ACTIONS(380),
    [anon_sym_GT_AMP] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(378),
    [anon_sym_LT_LT_DASH] = ACTIONS(380),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(380),
    [anon_sym_BQUOTE] = ACTIONS(380),
    [anon_sym_LT_LPAREN] = ACTIONS(380),
    [anon_sym_GT_LPAREN] = ACTIONS(380),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(54),
  },
  [337] = {
    [sym_file_descriptor] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_RPAREN] = ACTIONS(628),
    [anon_sym_PIPE_AMP] = ACTIONS(628),
    [anon_sym_AMP_AMP] = ACTIONS(628),
    [anon_sym_PIPE_PIPE] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(628),
    [anon_sym_AMP_GT] = ACTIONS(1225),
    [anon_sym_AMP_GT_GT] = ACTIONS(628),
    [anon_sym_LT_AMP] = ACTIONS(628),
    [anon_sym_GT_AMP] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_LT_LT_DASH] = ACTIONS(628),
    [anon_sym_BQUOTE] = ACTIONS(628),
    [sym_comment] = ACTIONS(54),
  },
  [338] = {
    [sym_file_descriptor] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_RPAREN] = ACTIONS(380),
    [anon_sym_PIPE_AMP] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(378),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_AMP_GT] = ACTIONS(378),
    [anon_sym_AMP_GT_GT] = ACTIONS(380),
    [anon_sym_LT_AMP] = ACTIONS(380),
    [anon_sym_GT_AMP] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(378),
    [anon_sym_LT_LT_DASH] = ACTIONS(380),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(380),
    [anon_sym_BQUOTE] = ACTIONS(380),
    [anon_sym_LT_LPAREN] = ACTIONS(380),
    [anon_sym_GT_LPAREN] = ACTIONS(380),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(54),
  },
  [339] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(336),
    [sym_simple_expansion] = STATE(336),
    [sym_expansion] = STATE(336),
    [sym_command_substitution] = STATE(336),
    [sym_process_substitution] = STATE(336),
    [aux_sym_for_statement_repeat1] = STATE(614),
    [aux_sym_command_repeat2] = STATE(615),
    [sym_file_descriptor] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_PIPE_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(542),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(550),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(552),
    [sym_comment] = ACTIONS(54),
  },
  [340] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [aux_sym_command_repeat2] = STATE(616),
    [sym_file_descriptor] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_PIPE_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(542),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [sym_comment] = ACTIONS(54),
  },
  [341] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(336),
    [sym_simple_expansion] = STATE(336),
    [sym_expansion] = STATE(336),
    [sym_command_substitution] = STATE(336),
    [sym_process_substitution] = STATE(336),
    [aux_sym_for_statement_repeat1] = STATE(617),
    [aux_sym_command_repeat2] = STATE(615),
    [sym_file_descriptor] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_PIPE_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(542),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(550),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(552),
    [sym_comment] = ACTIONS(54),
  },
  [342] = {
    [sym_concatenation] = STATE(555),
    [sym_string] = STATE(618),
    [sym_array] = STATE(555),
    [sym_simple_expansion] = STATE(618),
    [sym_expansion] = STATE(618),
    [sym_command_substitution] = STATE(618),
    [sym_process_substitution] = STATE(618),
    [sym__empty_value] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [sym_raw_string] = ACTIONS(1231),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1121),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LT_LPAREN] = ACTIONS(1125),
    [anon_sym_GT_LPAREN] = ACTIONS(1125),
    [sym_word] = ACTIONS(1233),
    [sym_comment] = ACTIONS(54),
  },
  [343] = {
    [sym_compound_statement] = STATE(620),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(526),
    [sym_comment] = ACTIONS(54),
  },
  [344] = {
    [sym__assignment] = STATE(578),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_PIPE_AMP] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_PLUS_EQ] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym_comment] = ACTIONS(54),
  },
  [345] = {
    [aux_sym_concatenation_repeat1] = STATE(622),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_PIPE_AMP] = ACTIONS(460),
    [anon_sym_AMP_AMP] = ACTIONS(460),
    [anon_sym_PIPE_PIPE] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(460),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(460),
    [anon_sym_LT_AMP] = ACTIONS(460),
    [anon_sym_GT_AMP] = ACTIONS(460),
    [anon_sym_LT_LT] = ACTIONS(873),
    [anon_sym_LT_LT_DASH] = ACTIONS(460),
    [anon_sym_DQUOTE] = ACTIONS(460),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [anon_sym_LT_LPAREN] = ACTIONS(460),
    [anon_sym_GT_LPAREN] = ACTIONS(460),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(54),
  },
  [346] = {
    [anon_sym_RPAREN] = ACTIONS(1239),
    [sym_comment] = ACTIONS(54),
  },
  [347] = {
    [sym_file_redirect] = STATE(597),
    [sym_file_descriptor] = ACTIONS(1241),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PIPE_AMP] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_AMP_GT] = ACTIONS(1243),
    [anon_sym_AMP_GT_GT] = ACTIONS(1245),
    [anon_sym_LT_AMP] = ACTIONS(1245),
    [anon_sym_GT_AMP] = ACTIONS(1245),
    [anon_sym_BQUOTE] = ACTIONS(1191),
    [sym_comment] = ACTIONS(54),
  },
  [348] = {
    [sym_for_statement] = STATE(598),
    [sym_while_statement] = STATE(598),
    [sym_if_statement] = STATE(598),
    [sym_case_statement] = STATE(598),
    [sym_function_definition] = STATE(598),
    [sym_subshell] = STATE(598),
    [sym_pipeline] = STATE(598),
    [sym_list] = STATE(598),
    [sym_bracket_command] = STATE(598),
    [sym_command] = STATE(598),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(626),
    [sym_local_variable_declaration] = STATE(598),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [349] = {
    [sym_for_statement] = STATE(627),
    [sym_while_statement] = STATE(627),
    [sym_if_statement] = STATE(627),
    [sym_case_statement] = STATE(627),
    [sym_function_definition] = STATE(627),
    [sym_subshell] = STATE(627),
    [sym_pipeline] = STATE(627),
    [sym_list] = STATE(627),
    [sym_bracket_command] = STATE(627),
    [sym_command] = STATE(627),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(628),
    [sym_local_variable_declaration] = STATE(627),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [350] = {
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1249),
    [anon_sym_AMP_GT] = ACTIONS(1247),
    [anon_sym_AMP_GT_GT] = ACTIONS(1249),
    [anon_sym_LT_AMP] = ACTIONS(1249),
    [anon_sym_GT_AMP] = ACTIONS(1249),
    [sym_comment] = ACTIONS(54),
  },
  [351] = {
    [sym_concatenation] = STATE(610),
    [sym_string] = STATE(630),
    [sym_simple_expansion] = STATE(630),
    [sym_expansion] = STATE(630),
    [sym_command_substitution] = STATE(630),
    [sym_process_substitution] = STATE(630),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [sym_raw_string] = ACTIONS(1251),
    [anon_sym_DOLLAR] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1213),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [anon_sym_LT_LPAREN] = ACTIONS(1217),
    [anon_sym_GT_LPAREN] = ACTIONS(1217),
    [sym_word] = ACTIONS(1253),
    [sym_comment] = ACTIONS(54),
  },
  [352] = {
    [aux_sym_concatenation_repeat1] = STATE(345),
    [sym_file_descriptor] = ACTIONS(380),
    [sym__concat] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_PIPE_AMP] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(378),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_AMP_GT] = ACTIONS(378),
    [anon_sym_AMP_GT_GT] = ACTIONS(380),
    [anon_sym_LT_AMP] = ACTIONS(380),
    [anon_sym_GT_AMP] = ACTIONS(380),
    [anon_sym_LT_LT] = ACTIONS(378),
    [anon_sym_LT_LT_DASH] = ACTIONS(380),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(380),
    [anon_sym_BQUOTE] = ACTIONS(380),
    [anon_sym_LT_LPAREN] = ACTIONS(380),
    [anon_sym_GT_LPAREN] = ACTIONS(380),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(54),
  },
  [353] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(352),
    [sym_simple_expansion] = STATE(352),
    [sym_expansion] = STATE(352),
    [sym_command_substitution] = STATE(352),
    [sym_process_substitution] = STATE(352),
    [aux_sym_for_statement_repeat1] = STATE(631),
    [aux_sym_command_repeat2] = STATE(632),
    [sym_file_descriptor] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PIPE_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(580),
    [sym_comment] = ACTIONS(54),
  },
  [354] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [aux_sym_command_repeat2] = STATE(633),
    [sym_file_descriptor] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PIPE_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(54),
  },
  [355] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(352),
    [sym_simple_expansion] = STATE(352),
    [sym_expansion] = STATE(352),
    [sym_command_substitution] = STATE(352),
    [sym_process_substitution] = STATE(352),
    [aux_sym_for_statement_repeat1] = STATE(634),
    [aux_sym_command_repeat2] = STATE(632),
    [sym_file_descriptor] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PIPE_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(580),
    [sym_comment] = ACTIONS(54),
  },
  [356] = {
    [sym_file_descriptor] = ACTIONS(1255),
    [sym__concat] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_word] = ACTIONS(1257),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [357] = {
    [sym_compound_statement] = STATE(635),
    [anon_sym_LBRACE] = ACTIONS(348),
    [sym_comment] = ACTIONS(54),
  },
  [358] = {
    [sym_file_descriptor] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
  },
  [359] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(637),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [360] = {
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [sym_comment] = ACTIONS(54),
  },
  [361] = {
    [sym_concatenation] = STATE(640),
    [sym_string] = STATE(639),
    [sym_simple_expansion] = STATE(639),
    [sym_expansion] = STATE(639),
    [sym_command_substitution] = STATE(639),
    [sym_process_substitution] = STATE(639),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_word] = ACTIONS(1271),
    [sym_comment] = ACTIONS(54),
  },
  [362] = {
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(833),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_PIPE_AMP] = ACTIONS(833),
    [anon_sym_AMP_AMP] = ACTIONS(833),
    [anon_sym_PIPE_PIPE] = ACTIONS(833),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(833),
    [anon_sym_LF] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
  },
  [363] = {
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE_AMP] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [364] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE_AMP] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [365] = {
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [366] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [367] = {
    [sym_concatenation] = STATE(642),
    [sym_string] = STATE(641),
    [sym_simple_expansion] = STATE(641),
    [sym_expansion] = STATE(641),
    [sym_command_substitution] = STATE(641),
    [sym_process_substitution] = STATE(641),
    [anon_sym_DQUOTE] = ACTIONS(608),
    [sym_raw_string] = ACTIONS(1277),
    [anon_sym_DOLLAR] = ACTIONS(612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(616),
    [anon_sym_BQUOTE] = ACTIONS(618),
    [anon_sym_LT_LPAREN] = ACTIONS(620),
    [anon_sym_GT_LPAREN] = ACTIONS(620),
    [sym_word] = ACTIONS(1279),
    [sym_comment] = ACTIONS(54),
  },
  [368] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(644),
    [anon_sym_DQUOTE] = ACTIONS(1281),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [369] = {
    [aux_sym_concatenation_repeat1] = STATE(646),
    [sym_file_descriptor] = ACTIONS(420),
    [sym__concat] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [370] = {
    [sym_special_variable_name] = STATE(649),
    [anon_sym_DOLLAR] = ACTIONS(1287),
    [anon_sym_POUND] = ACTIONS(1287),
    [anon_sym_AT] = ACTIONS(1287),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_QMARK] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_0] = ACTIONS(1291),
    [anon_sym__] = ACTIONS(1291),
  },
  [371] = {
    [sym_special_variable_name] = STATE(652),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(1293),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1295),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [372] = {
    [sym_for_statement] = STATE(653),
    [sym_while_statement] = STATE(653),
    [sym_if_statement] = STATE(653),
    [sym_case_statement] = STATE(653),
    [sym_function_definition] = STATE(653),
    [sym_subshell] = STATE(653),
    [sym_pipeline] = STATE(653),
    [sym_list] = STATE(653),
    [sym_bracket_command] = STATE(653),
    [sym_command] = STATE(653),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(654),
    [sym_local_variable_declaration] = STATE(653),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [373] = {
    [sym_for_statement] = STATE(655),
    [sym_while_statement] = STATE(655),
    [sym_if_statement] = STATE(655),
    [sym_case_statement] = STATE(655),
    [sym_function_definition] = STATE(655),
    [sym_subshell] = STATE(655),
    [sym_pipeline] = STATE(655),
    [sym_list] = STATE(655),
    [sym_bracket_command] = STATE(655),
    [sym_command] = STATE(655),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(656),
    [sym_local_variable_declaration] = STATE(655),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [374] = {
    [sym_for_statement] = STATE(657),
    [sym_while_statement] = STATE(657),
    [sym_if_statement] = STATE(657),
    [sym_case_statement] = STATE(657),
    [sym_function_definition] = STATE(657),
    [sym_subshell] = STATE(657),
    [sym_pipeline] = STATE(657),
    [sym_list] = STATE(657),
    [sym_bracket_command] = STATE(657),
    [sym_command] = STATE(657),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(658),
    [sym_local_variable_declaration] = STATE(657),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [375] = {
    [sym_file_descriptor] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [376] = {
    [sym_file_descriptor] = ACTIONS(1297),
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_RPAREN] = ACTIONS(1299),
    [anon_sym_SEMI_SEMI] = ACTIONS(1299),
    [anon_sym_PIPE_AMP] = ACTIONS(1299),
    [anon_sym_AMP_AMP] = ACTIONS(1299),
    [anon_sym_PIPE_PIPE] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1299),
    [anon_sym_GT] = ACTIONS(1299),
    [anon_sym_GT_GT] = ACTIONS(1299),
    [anon_sym_AMP_GT] = ACTIONS(1299),
    [anon_sym_AMP_GT_GT] = ACTIONS(1299),
    [anon_sym_LT_AMP] = ACTIONS(1299),
    [anon_sym_GT_AMP] = ACTIONS(1299),
    [anon_sym_LT_LT] = ACTIONS(1299),
    [anon_sym_LT_LT_DASH] = ACTIONS(1299),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_LF] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
  },
  [377] = {
    [sym_simple_expansion] = STATE(659),
    [sym_expansion] = STATE(659),
    [aux_sym_heredoc_repeat1] = STATE(663),
    [sym__heredoc_middle] = ACTIONS(1301),
    [sym__heredoc_end] = ACTIONS(1303),
    [anon_sym_DOLLAR] = ACTIONS(1305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1307),
    [sym_comment] = ACTIONS(54),
  },
  [378] = {
    [sym_file_descriptor] = ACTIONS(1309),
    [anon_sym_PIPE] = ACTIONS(1311),
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_SEMI_SEMI] = ACTIONS(1311),
    [anon_sym_PIPE_AMP] = ACTIONS(1311),
    [anon_sym_AMP_AMP] = ACTIONS(1311),
    [anon_sym_PIPE_PIPE] = ACTIONS(1311),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1311),
    [anon_sym_GT_GT] = ACTIONS(1311),
    [anon_sym_AMP_GT] = ACTIONS(1311),
    [anon_sym_AMP_GT_GT] = ACTIONS(1311),
    [anon_sym_LT_AMP] = ACTIONS(1311),
    [anon_sym_GT_AMP] = ACTIONS(1311),
    [anon_sym_LT_LT] = ACTIONS(1311),
    [anon_sym_LT_LT_DASH] = ACTIONS(1311),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_LF] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
  },
  [379] = {
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(149),
    [sym_simple_expansion] = STATE(149),
    [sym_expansion] = STATE(149),
    [sym_command_substitution] = STATE(149),
    [sym_process_substitution] = STATE(149),
    [aux_sym_for_statement_repeat1] = STATE(379),
    [sym_file_descriptor] = ACTIONS(1313),
    [anon_sym_PIPE] = ACTIONS(1315),
    [anon_sym_SEMI_SEMI] = ACTIONS(1315),
    [anon_sym_PIPE_AMP] = ACTIONS(1315),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1315),
    [anon_sym_GT_GT] = ACTIONS(1315),
    [anon_sym_AMP_GT] = ACTIONS(1315),
    [anon_sym_AMP_GT_GT] = ACTIONS(1315),
    [anon_sym_LT_AMP] = ACTIONS(1315),
    [anon_sym_GT_AMP] = ACTIONS(1315),
    [anon_sym_LT_LT] = ACTIONS(1315),
    [anon_sym_LT_LT_DASH] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1317),
    [sym_raw_string] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(1323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(1332),
    [anon_sym_LT_LPAREN] = ACTIONS(1335),
    [anon_sym_GT_LPAREN] = ACTIONS(1335),
    [sym_word] = ACTIONS(1320),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_LF] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
  },
  [380] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [aux_sym_command_repeat2] = STATE(381),
    [sym_file_descriptor] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(1338),
    [anon_sym_SEMI_SEMI] = ACTIONS(1338),
    [anon_sym_PIPE_AMP] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1338),
    [anon_sym_PIPE_PIPE] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [anon_sym_GT_GT] = ACTIONS(246),
    [anon_sym_AMP_GT] = ACTIONS(246),
    [anon_sym_AMP_GT_GT] = ACTIONS(246),
    [anon_sym_LT_AMP] = ACTIONS(246),
    [anon_sym_GT_AMP] = ACTIONS(246),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1338),
    [anon_sym_LF] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
  },
  [381] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [aux_sym_command_repeat2] = STATE(381),
    [sym_file_descriptor] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1343),
    [anon_sym_SEMI_SEMI] = ACTIONS(1343),
    [anon_sym_PIPE_AMP] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1343),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [anon_sym_AMP_GT] = ACTIONS(1345),
    [anon_sym_AMP_GT_GT] = ACTIONS(1345),
    [anon_sym_LT_AMP] = ACTIONS(1345),
    [anon_sym_GT_AMP] = ACTIONS(1345),
    [anon_sym_LT_LT] = ACTIONS(1348),
    [anon_sym_LT_LT_DASH] = ACTIONS(1348),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_LF] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
  },
  [382] = {
    [sym_concatenation] = STATE(664),
    [sym_string] = STATE(666),
    [sym_array] = STATE(664),
    [sym_simple_expansion] = STATE(666),
    [sym_expansion] = STATE(666),
    [sym_command_substitution] = STATE(666),
    [sym_process_substitution] = STATE(666),
    [sym__empty_value] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(128),
    [sym_raw_string] = ACTIONS(1355),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(134),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(136),
    [anon_sym_BQUOTE] = ACTIONS(138),
    [anon_sym_LT_LPAREN] = ACTIONS(140),
    [anon_sym_GT_LPAREN] = ACTIONS(140),
    [sym_word] = ACTIONS(1357),
    [sym_comment] = ACTIONS(54),
  },
  [383] = {
    [sym_file_descriptor] = ACTIONS(316),
    [sym_variable_name] = ACTIONS(316),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(316),
    [anon_sym_AMP_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT_GT] = ACTIONS(316),
    [anon_sym_LT_AMP] = ACTIONS(316),
    [anon_sym_GT_AMP] = ACTIONS(316),
    [anon_sym_DQUOTE] = ACTIONS(316),
    [sym_raw_string] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(316),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(316),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_LT_LPAREN] = ACTIONS(316),
    [anon_sym_GT_LPAREN] = ACTIONS(316),
    [sym_word] = ACTIONS(1129),
    [sym_comment] = ACTIONS(54),
  },
  [384] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(149),
    [sym_simple_expansion] = STATE(149),
    [sym_expansion] = STATE(149),
    [sym_command_substitution] = STATE(149),
    [sym_process_substitution] = STATE(149),
    [aux_sym_for_statement_repeat1] = STATE(379),
    [aux_sym_command_repeat2] = STATE(667),
    [sym_file_descriptor] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(1338),
    [anon_sym_SEMI_SEMI] = ACTIONS(1338),
    [anon_sym_PIPE_AMP] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1338),
    [anon_sym_PIPE_PIPE] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [anon_sym_GT_GT] = ACTIONS(246),
    [anon_sym_AMP_GT] = ACTIONS(246),
    [anon_sym_AMP_GT_GT] = ACTIONS(246),
    [anon_sym_LT_AMP] = ACTIONS(246),
    [anon_sym_GT_AMP] = ACTIONS(246),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_word] = ACTIONS(252),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1338),
    [anon_sym_LF] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
  },
  [385] = {
    [sym__concat] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(436),
    [anon_sym_RBRACK] = ACTIONS(436),
    [sym_comment] = ACTIONS(54),
  },
  [386] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [387] = {
    [sym_string] = STATE(669),
    [sym_simple_expansion] = STATE(669),
    [sym_expansion] = STATE(669),
    [sym_command_substitution] = STATE(669),
    [sym_process_substitution] = STATE(669),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(1363),
    [sym_comment] = ACTIONS(54),
  },
  [388] = {
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_PLUS_EQ] = ACTIONS(1365),
    [sym_comment] = ACTIONS(54),
  },
  [389] = {
    [aux_sym_concatenation_repeat1] = STATE(670),
    [sym__concat] = ACTIONS(723),
    [anon_sym_RBRACK] = ACTIONS(460),
    [sym_comment] = ACTIONS(54),
  },
  [390] = {
    [sym__concat] = ACTIONS(464),
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(464),
    [anon_sym_RBRACK] = ACTIONS(464),
    [sym_comment] = ACTIONS(54),
  },
  [391] = {
    [sym__concat] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_RBRACK] = ACTIONS(468),
    [sym_comment] = ACTIONS(54),
  },
  [392] = {
    [sym__concat] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(472),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_RBRACK] = ACTIONS(472),
    [sym_comment] = ACTIONS(54),
  },
  [393] = {
    [sym_special_variable_name] = STATE(672),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1367),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [394] = {
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(1373),
    [anon_sym_COLON] = ACTIONS(1375),
    [anon_sym_COLON_QMARK] = ACTIONS(1373),
    [anon_sym_COLON_DASH] = ACTIONS(1373),
    [anon_sym_PERCENT] = ACTIONS(1373),
    [anon_sym_SLASH] = ACTIONS(1373),
    [sym_comment] = ACTIONS(54),
  },
  [395] = {
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_EQ] = ACTIONS(1381),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_COLON_QMARK] = ACTIONS(1381),
    [anon_sym_COLON_DASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [sym_comment] = ACTIONS(54),
  },
  [396] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [397] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [398] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [sym_comment] = ACTIONS(54),
  },
  [399] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [400] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1387),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [401] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1387),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [402] = {
    [sym_file_descriptor] = ACTIONS(1389),
    [sym_variable_name] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(1391),
    [anon_sym_RPAREN] = ACTIONS(1391),
    [anon_sym_SEMI_SEMI] = ACTIONS(1391),
    [anon_sym_PIPE_AMP] = ACTIONS(1391),
    [anon_sym_AMP_AMP] = ACTIONS(1391),
    [anon_sym_PIPE_PIPE] = ACTIONS(1391),
    [anon_sym_LT] = ACTIONS(1391),
    [anon_sym_GT] = ACTIONS(1391),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [anon_sym_AMP_GT] = ACTIONS(1391),
    [anon_sym_AMP_GT_GT] = ACTIONS(1391),
    [anon_sym_LT_AMP] = ACTIONS(1391),
    [anon_sym_GT_AMP] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1391),
    [sym_raw_string] = ACTIONS(1391),
    [anon_sym_DOLLAR] = ACTIONS(1391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1391),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1391),
    [anon_sym_BQUOTE] = ACTIONS(1391),
    [anon_sym_LT_LPAREN] = ACTIONS(1391),
    [anon_sym_GT_LPAREN] = ACTIONS(1391),
    [sym_word] = ACTIONS(1391),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_LF] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1391),
  },
  [403] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(682),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [404] = {
    [aux_sym_concatenation_repeat1] = STATE(684),
    [sym__concat] = ACTIONS(1395),
    [anon_sym_RPAREN] = ACTIONS(380),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(380),
    [anon_sym_BQUOTE] = ACTIONS(380),
    [anon_sym_LT_LPAREN] = ACTIONS(380),
    [anon_sym_GT_LPAREN] = ACTIONS(380),
    [sym_word] = ACTIONS(378),
    [sym_comment] = ACTIONS(54),
  },
  [405] = {
    [sym_special_variable_name] = STATE(687),
    [anon_sym_DOLLAR] = ACTIONS(1397),
    [anon_sym_POUND] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(1397),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1399),
    [anon_sym_STAR] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1397),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_BANG] = ACTIONS(1397),
    [anon_sym_0] = ACTIONS(1401),
    [anon_sym__] = ACTIONS(1401),
  },
  [406] = {
    [sym_special_variable_name] = STATE(690),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1405),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [407] = {
    [sym_for_statement] = STATE(691),
    [sym_while_statement] = STATE(691),
    [sym_if_statement] = STATE(691),
    [sym_case_statement] = STATE(691),
    [sym_function_definition] = STATE(691),
    [sym_subshell] = STATE(691),
    [sym_pipeline] = STATE(691),
    [sym_list] = STATE(691),
    [sym_bracket_command] = STATE(691),
    [sym_command] = STATE(691),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(692),
    [sym_local_variable_declaration] = STATE(691),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [408] = {
    [sym_for_statement] = STATE(693),
    [sym_while_statement] = STATE(693),
    [sym_if_statement] = STATE(693),
    [sym_case_statement] = STATE(693),
    [sym_function_definition] = STATE(693),
    [sym_subshell] = STATE(693),
    [sym_pipeline] = STATE(693),
    [sym_list] = STATE(693),
    [sym_bracket_command] = STATE(693),
    [sym_command] = STATE(693),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(694),
    [sym_local_variable_declaration] = STATE(693),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [409] = {
    [sym_for_statement] = STATE(695),
    [sym_while_statement] = STATE(695),
    [sym_if_statement] = STATE(695),
    [sym_case_statement] = STATE(695),
    [sym_function_definition] = STATE(695),
    [sym_subshell] = STATE(695),
    [sym_pipeline] = STATE(695),
    [sym_list] = STATE(695),
    [sym_bracket_command] = STATE(695),
    [sym_command] = STATE(695),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(696),
    [sym_local_variable_declaration] = STATE(695),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [410] = {
    [anon_sym_RPAREN] = ACTIONS(380),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(380),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(380),
    [anon_sym_BQUOTE] = ACTIONS(380),
    [anon_sym_LT_LPAREN] = ACTIONS(380),
    [anon_sym_GT_LPAREN] = ACTIONS(380),
    [sym_word] = ACTIONS(378),
    [sym_comment] = ACTIONS(54),
  },
  [411] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(698),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [412] = {
    [sym_file_descriptor] = ACTIONS(436),
    [sym__concat] = ACTIONS(436),
    [sym_variable_name] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI_SEMI] = ACTIONS(438),
    [anon_sym_PIPE_AMP] = ACTIONS(438),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_PIPE_PIPE] = ACTIONS(438),
    [anon_sym_LT] = ACTIONS(438),
    [anon_sym_GT] = ACTIONS(438),
    [anon_sym_GT_GT] = ACTIONS(438),
    [anon_sym_AMP_GT] = ACTIONS(438),
    [anon_sym_AMP_GT_GT] = ACTIONS(438),
    [anon_sym_LT_AMP] = ACTIONS(438),
    [anon_sym_GT_AMP] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [sym_raw_string] = ACTIONS(438),
    [anon_sym_DOLLAR] = ACTIONS(438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(438),
    [anon_sym_BQUOTE] = ACTIONS(438),
    [anon_sym_LT_LPAREN] = ACTIONS(438),
    [anon_sym_GT_LPAREN] = ACTIONS(438),
    [sym_word] = ACTIONS(438),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LF] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(438),
  },
  [413] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [414] = {
    [sym_string] = STATE(700),
    [sym_simple_expansion] = STATE(700),
    [sym_expansion] = STATE(700),
    [sym_command_substitution] = STATE(700),
    [sym_process_substitution] = STATE(700),
    [anon_sym_DQUOTE] = ACTIONS(300),
    [sym_raw_string] = ACTIONS(1411),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(308),
    [anon_sym_BQUOTE] = ACTIONS(310),
    [anon_sym_LT_LPAREN] = ACTIONS(312),
    [anon_sym_GT_LPAREN] = ACTIONS(312),
    [sym_word] = ACTIONS(1413),
    [sym_comment] = ACTIONS(54),
  },
  [415] = {
    [aux_sym_concatenation_repeat1] = STATE(701),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(761),
    [sym_variable_name] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(462),
    [anon_sym_AMP_AMP] = ACTIONS(462),
    [anon_sym_PIPE_PIPE] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(462),
    [anon_sym_AMP_GT] = ACTIONS(462),
    [anon_sym_AMP_GT_GT] = ACTIONS(462),
    [anon_sym_LT_AMP] = ACTIONS(462),
    [anon_sym_GT_AMP] = ACTIONS(462),
    [anon_sym_DQUOTE] = ACTIONS(462),
    [sym_raw_string] = ACTIONS(462),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(462),
    [anon_sym_BQUOTE] = ACTIONS(462),
    [anon_sym_LT_LPAREN] = ACTIONS(462),
    [anon_sym_GT_LPAREN] = ACTIONS(462),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [416] = {
    [sym_file_descriptor] = ACTIONS(464),
    [sym__concat] = ACTIONS(464),
    [sym_variable_name] = ACTIONS(464),
    [anon_sym_PIPE] = ACTIONS(466),
    [anon_sym_RPAREN] = ACTIONS(466),
    [anon_sym_SEMI_SEMI] = ACTIONS(466),
    [anon_sym_PIPE_AMP] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_GT] = ACTIONS(466),
    [anon_sym_GT_GT] = ACTIONS(466),
    [anon_sym_AMP_GT] = ACTIONS(466),
    [anon_sym_AMP_GT_GT] = ACTIONS(466),
    [anon_sym_LT_AMP] = ACTIONS(466),
    [anon_sym_GT_AMP] = ACTIONS(466),
    [anon_sym_DQUOTE] = ACTIONS(466),
    [sym_raw_string] = ACTIONS(466),
    [anon_sym_DOLLAR] = ACTIONS(466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(466),
    [anon_sym_BQUOTE] = ACTIONS(466),
    [anon_sym_LT_LPAREN] = ACTIONS(466),
    [anon_sym_GT_LPAREN] = ACTIONS(466),
    [sym_word] = ACTIONS(466),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(466),
  },
  [417] = {
    [sym_file_descriptor] = ACTIONS(468),
    [sym__concat] = ACTIONS(468),
    [sym_variable_name] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_RPAREN] = ACTIONS(470),
    [anon_sym_SEMI_SEMI] = ACTIONS(470),
    [anon_sym_PIPE_AMP] = ACTIONS(470),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_GT] = ACTIONS(470),
    [anon_sym_GT_GT] = ACTIONS(470),
    [anon_sym_AMP_GT] = ACTIONS(470),
    [anon_sym_AMP_GT_GT] = ACTIONS(470),
    [anon_sym_LT_AMP] = ACTIONS(470),
    [anon_sym_GT_AMP] = ACTIONS(470),
    [anon_sym_DQUOTE] = ACTIONS(470),
    [sym_raw_string] = ACTIONS(470),
    [anon_sym_DOLLAR] = ACTIONS(470),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(470),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(470),
    [anon_sym_BQUOTE] = ACTIONS(470),
    [anon_sym_LT_LPAREN] = ACTIONS(470),
    [anon_sym_GT_LPAREN] = ACTIONS(470),
    [sym_word] = ACTIONS(470),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_LF] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(470),
  },
  [418] = {
    [sym_file_descriptor] = ACTIONS(472),
    [sym__concat] = ACTIONS(472),
    [sym_variable_name] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(474),
    [anon_sym_RPAREN] = ACTIONS(474),
    [anon_sym_SEMI_SEMI] = ACTIONS(474),
    [anon_sym_PIPE_AMP] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(474),
    [anon_sym_GT] = ACTIONS(474),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_AMP_GT] = ACTIONS(474),
    [anon_sym_AMP_GT_GT] = ACTIONS(474),
    [anon_sym_LT_AMP] = ACTIONS(474),
    [anon_sym_GT_AMP] = ACTIONS(474),
    [anon_sym_DQUOTE] = ACTIONS(474),
    [sym_raw_string] = ACTIONS(474),
    [anon_sym_DOLLAR] = ACTIONS(474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(474),
    [anon_sym_BQUOTE] = ACTIONS(474),
    [anon_sym_LT_LPAREN] = ACTIONS(474),
    [anon_sym_GT_LPAREN] = ACTIONS(474),
    [sym_word] = ACTIONS(474),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_LF] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(474),
  },
  [419] = {
    [sym_special_variable_name] = STATE(703),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1415),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [420] = {
    [anon_sym_RBRACE] = ACTIONS(1417),
    [anon_sym_LBRACK] = ACTIONS(1419),
    [anon_sym_EQ] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1423),
    [anon_sym_COLON_QMARK] = ACTIONS(1421),
    [anon_sym_COLON_DASH] = ACTIONS(1421),
    [anon_sym_PERCENT] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(1421),
    [sym_comment] = ACTIONS(54),
  },
  [421] = {
    [anon_sym_RBRACE] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_COLON] = ACTIONS(1431),
    [anon_sym_COLON_QMARK] = ACTIONS(1429),
    [anon_sym_COLON_DASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [sym_comment] = ACTIONS(54),
  },
  [422] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [423] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [424] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(54),
  },
  [425] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(1433),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [426] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [427] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [428] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(713),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [429] = {
    [aux_sym_concatenation_repeat1] = STATE(715),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_SEMI_SEMI] = ACTIONS(382),
    [anon_sym_DQUOTE] = ACTIONS(382),
    [sym_raw_string] = ACTIONS(382),
    [anon_sym_DOLLAR] = ACTIONS(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(382),
    [anon_sym_BQUOTE] = ACTIONS(382),
    [anon_sym_LT_LPAREN] = ACTIONS(382),
    [anon_sym_GT_LPAREN] = ACTIONS(382),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(382),
    [anon_sym_LF] = ACTIONS(382),
    [anon_sym_AMP] = ACTIONS(382),
  },
  [430] = {
    [sym_special_variable_name] = STATE(718),
    [anon_sym_DOLLAR] = ACTIONS(1441),
    [anon_sym_POUND] = ACTIONS(1441),
    [anon_sym_AT] = ACTIONS(1441),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1443),
    [anon_sym_STAR] = ACTIONS(1441),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1441),
    [anon_sym_0] = ACTIONS(1445),
    [anon_sym__] = ACTIONS(1445),
  },
  [431] = {
    [sym_special_variable_name] = STATE(721),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1449),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [432] = {
    [sym_for_statement] = STATE(722),
    [sym_while_statement] = STATE(722),
    [sym_if_statement] = STATE(722),
    [sym_case_statement] = STATE(722),
    [sym_function_definition] = STATE(722),
    [sym_subshell] = STATE(722),
    [sym_pipeline] = STATE(722),
    [sym_list] = STATE(722),
    [sym_bracket_command] = STATE(722),
    [sym_command] = STATE(722),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(723),
    [sym_local_variable_declaration] = STATE(722),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [433] = {
    [sym_for_statement] = STATE(724),
    [sym_while_statement] = STATE(724),
    [sym_if_statement] = STATE(724),
    [sym_case_statement] = STATE(724),
    [sym_function_definition] = STATE(724),
    [sym_subshell] = STATE(724),
    [sym_pipeline] = STATE(724),
    [sym_list] = STATE(724),
    [sym_bracket_command] = STATE(724),
    [sym_command] = STATE(724),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(725),
    [sym_local_variable_declaration] = STATE(724),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [434] = {
    [sym_for_statement] = STATE(726),
    [sym_while_statement] = STATE(726),
    [sym_if_statement] = STATE(726),
    [sym_case_statement] = STATE(726),
    [sym_function_definition] = STATE(726),
    [sym_subshell] = STATE(726),
    [sym_pipeline] = STATE(726),
    [sym_list] = STATE(726),
    [sym_bracket_command] = STATE(726),
    [sym_command] = STATE(726),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(727),
    [sym_local_variable_declaration] = STATE(726),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [435] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(382),
    [anon_sym_DQUOTE] = ACTIONS(382),
    [sym_raw_string] = ACTIONS(382),
    [anon_sym_DOLLAR] = ACTIONS(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(382),
    [anon_sym_BQUOTE] = ACTIONS(382),
    [anon_sym_LT_LPAREN] = ACTIONS(382),
    [anon_sym_GT_LPAREN] = ACTIONS(382),
    [sym_word] = ACTIONS(382),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(382),
    [anon_sym_LF] = ACTIONS(382),
    [anon_sym_AMP] = ACTIONS(382),
  },
  [436] = {
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_for_statement_repeat1] = STATE(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1453),
    [sym_raw_string] = ACTIONS(1455),
    [anon_sym_DOLLAR] = ACTIONS(1457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1461),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1465),
    [anon_sym_GT_LPAREN] = ACTIONS(1465),
    [sym_word] = ACTIONS(1455),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1451),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
  },
  [437] = {
    [anon_sym_PIPE] = ACTIONS(1467),
    [anon_sym_RPAREN] = ACTIONS(1467),
    [anon_sym_SEMI_SEMI] = ACTIONS(1467),
    [anon_sym_PIPE_AMP] = ACTIONS(1467),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
  },
  [438] = {
    [sym_file_descriptor] = ACTIONS(230),
    [sym_variable_name] = ACTIONS(230),
    [anon_sym_for] = ACTIONS(232),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_done] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(232),
    [anon_sym_function] = ACTIONS(232),
    [anon_sym_LPAREN] = ACTIONS(230),
    [anon_sym_LBRACK] = ACTIONS(232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(232),
    [anon_sym_local] = ACTIONS(232),
    [anon_sym_LT] = ACTIONS(232),
    [anon_sym_GT] = ACTIONS(232),
    [anon_sym_GT_GT] = ACTIONS(230),
    [anon_sym_AMP_GT] = ACTIONS(232),
    [anon_sym_AMP_GT_GT] = ACTIONS(230),
    [anon_sym_LT_AMP] = ACTIONS(230),
    [anon_sym_GT_AMP] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(230),
    [sym_raw_string] = ACTIONS(230),
    [anon_sym_DOLLAR] = ACTIONS(232),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(230),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(230),
    [anon_sym_BQUOTE] = ACTIONS(230),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_word] = ACTIONS(234),
    [sym_comment] = ACTIONS(54),
  },
  [439] = {
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(1469),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_LF] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1469),
  },
  [440] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(1469),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_LF] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1469),
  },
  [441] = {
    [sym__terminated_statement] = STATE(438),
    [sym_for_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_function_definition] = STATE(439),
    [sym_subshell] = STATE(439),
    [sym_pipeline] = STATE(439),
    [sym_list] = STATE(439),
    [sym_bracket_command] = STATE(439),
    [sym_command] = STATE(439),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(440),
    [sym_local_variable_declaration] = STATE(439),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(732),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(1471),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [442] = {
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(1473),
    [anon_sym_SEMI_SEMI] = ACTIONS(1473),
    [anon_sym_PIPE_AMP] = ACTIONS(1473),
    [anon_sym_AMP_AMP] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE] = ACTIONS(1473),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_LF] = ACTIONS(1473),
    [anon_sym_AMP] = ACTIONS(1473),
  },
  [443] = {
    [sym__terminated_statement] = STATE(733),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_bracket_command] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(39),
    [sym_local_variable_declaration] = STATE(38),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [444] = {
    [sym__terminated_statement] = STATE(734),
    [sym_for_statement] = STATE(735),
    [sym_while_statement] = STATE(735),
    [sym_if_statement] = STATE(735),
    [sym_case_statement] = STATE(735),
    [sym_function_definition] = STATE(735),
    [sym_subshell] = STATE(735),
    [sym_pipeline] = STATE(735),
    [sym_list] = STATE(735),
    [sym_bracket_command] = STATE(735),
    [sym_command] = STATE(735),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(736),
    [sym_local_variable_declaration] = STATE(735),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(737),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [445] = {
    [sym_file_descriptor] = ACTIONS(230),
    [sym_variable_name] = ACTIONS(230),
    [anon_sym_for] = ACTIONS(232),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(232),
    [anon_sym_fi] = ACTIONS(232),
    [anon_sym_elif] = ACTIONS(232),
    [anon_sym_else] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(232),
    [anon_sym_function] = ACTIONS(232),
    [anon_sym_LPAREN] = ACTIONS(230),
    [anon_sym_LBRACK] = ACTIONS(232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(232),
    [anon_sym_local] = ACTIONS(232),
    [anon_sym_LT] = ACTIONS(232),
    [anon_sym_GT] = ACTIONS(232),
    [anon_sym_GT_GT] = ACTIONS(230),
    [anon_sym_AMP_GT] = ACTIONS(232),
    [anon_sym_AMP_GT_GT] = ACTIONS(230),
    [anon_sym_LT_AMP] = ACTIONS(230),
    [anon_sym_GT_AMP] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(230),
    [sym_raw_string] = ACTIONS(230),
    [anon_sym_DOLLAR] = ACTIONS(232),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(230),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(230),
    [anon_sym_BQUOTE] = ACTIONS(230),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_word] = ACTIONS(234),
    [sym_comment] = ACTIONS(54),
  },
  [446] = {
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(1477),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LF] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1477),
  },
  [447] = {
    [anon_sym_fi] = ACTIONS(1479),
    [anon_sym_elif] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1479),
    [sym_comment] = ACTIONS(54),
  },
  [448] = {
    [anon_sym_fi] = ACTIONS(1481),
    [sym_comment] = ACTIONS(54),
  },
  [449] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(1477),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_LF] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1477),
  },
  [450] = {
    [sym__terminated_statement] = STATE(445),
    [sym_for_statement] = STATE(446),
    [sym_while_statement] = STATE(446),
    [sym_if_statement] = STATE(446),
    [sym_elif_clause] = STATE(447),
    [sym_else_clause] = STATE(740),
    [sym_case_statement] = STATE(446),
    [sym_function_definition] = STATE(446),
    [sym_subshell] = STATE(446),
    [sym_pipeline] = STATE(446),
    [sym_list] = STATE(446),
    [sym_bracket_command] = STATE(446),
    [sym_command] = STATE(446),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(449),
    [sym_local_variable_declaration] = STATE(446),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(741),
    [aux_sym_if_statement_repeat1] = STATE(742),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(1483),
    [anon_sym_elif] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [451] = {
    [sym_elif_clause] = STATE(447),
    [sym_else_clause] = STATE(740),
    [aux_sym_if_statement_repeat1] = STATE(743),
    [anon_sym_fi] = ACTIONS(1481),
    [anon_sym_elif] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1487),
    [sym_comment] = ACTIONS(54),
  },
  [452] = {
    [sym__concat] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [453] = {
    [sym__concat] = ACTIONS(1072),
    [anon_sym_in] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [454] = {
    [sym_case_item] = STATE(746),
    [sym_concatenation] = STATE(747),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [aux_sym_case_statement_repeat1] = STATE(748),
    [anon_sym_esac] = ACTIONS(1489),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(1493),
    [sym_comment] = ACTIONS(54),
  },
  [455] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1495),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_LF] = ACTIONS(1495),
    [anon_sym_AMP] = ACTIONS(1495),
  },
  [456] = {
    [aux_sym_concatenation_repeat1] = STATE(456),
    [sym__concat] = ACTIONS(1497),
    [anon_sym_in] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [457] = {
    [anon_sym_RBRACE] = ACTIONS(1500),
    [anon_sym_LBRACK] = ACTIONS(1502),
    [sym_comment] = ACTIONS(54),
  },
  [458] = {
    [anon_sym_RBRACE] = ACTIONS(1504),
    [anon_sym_LBRACK] = ACTIONS(1506),
    [sym_comment] = ACTIONS(54),
  },
  [459] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_in] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [460] = {
    [anon_sym_AT] = ACTIONS(1508),
    [sym_comment] = ACTIONS(54),
  },
  [461] = {
    [sym_concatenation] = STATE(757),
    [sym_string] = STATE(756),
    [sym_simple_expansion] = STATE(756),
    [sym_expansion] = STATE(756),
    [sym_command_substitution] = STATE(756),
    [sym_process_substitution] = STATE(756),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1514),
    [sym_comment] = ACTIONS(54),
  },
  [462] = {
    [sym__concat] = ACTIONS(1099),
    [anon_sym_in] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
  },
  [463] = {
    [anon_sym_AT] = ACTIONS(1516),
    [sym_comment] = ACTIONS(54),
  },
  [464] = {
    [sym_concatenation] = STATE(760),
    [sym_string] = STATE(759),
    [sym_simple_expansion] = STATE(759),
    [sym_expansion] = STATE(759),
    [sym_command_substitution] = STATE(759),
    [sym_process_substitution] = STATE(759),
    [anon_sym_RBRACE] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1518),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1520),
    [sym_comment] = ACTIONS(54),
  },
  [465] = {
    [sym__concat] = ACTIONS(1197),
    [anon_sym_in] = ACTIONS(1199),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [466] = {
    [sym__concat] = ACTIONS(1255),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [467] = {
    [sym_compound_statement] = STATE(761),
    [anon_sym_LBRACE] = ACTIONS(348),
    [sym_comment] = ACTIONS(54),
  },
  [468] = {
    [anon_sym_PIPE] = ACTIONS(1522),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_SEMI_SEMI] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1522),
    [anon_sym_LF] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1522),
  },
  [469] = {
    [aux_sym_concatenation_repeat1] = STATE(762),
    [sym_file_descriptor] = ACTIONS(737),
    [sym__concat] = ACTIONS(761),
    [sym_variable_name] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(739),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_GT_GT] = ACTIONS(739),
    [anon_sym_AMP_GT] = ACTIONS(739),
    [anon_sym_AMP_GT_GT] = ACTIONS(739),
    [anon_sym_LT_AMP] = ACTIONS(739),
    [anon_sym_GT_AMP] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [sym_raw_string] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_LT_LPAREN] = ACTIONS(739),
    [anon_sym_GT_LPAREN] = ACTIONS(739),
    [sym_word] = ACTIONS(739),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(739),
  },
  [470] = {
    [anon_sym_RPAREN] = ACTIONS(1524),
    [sym_comment] = ACTIONS(54),
  },
  [471] = {
    [sym_file_redirect] = STATE(468),
    [sym_file_descriptor] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(833),
    [anon_sym_SEMI_SEMI] = ACTIONS(833),
    [anon_sym_PIPE_AMP] = ACTIONS(833),
    [anon_sym_AMP_AMP] = ACTIONS(833),
    [anon_sym_PIPE_PIPE] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(833),
    [anon_sym_LF] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(833),
  },
  [472] = {
    [sym_concatenation] = STATE(513),
    [sym_string] = STATE(764),
    [sym_array] = STATE(513),
    [sym_simple_expansion] = STATE(764),
    [sym_expansion] = STATE(764),
    [sym_command_substitution] = STATE(764),
    [sym_process_substitution] = STATE(764),
    [sym__empty_value] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [sym_raw_string] = ACTIONS(1526),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_word] = ACTIONS(1528),
    [sym_comment] = ACTIONS(54),
  },
  [473] = {
    [aux_sym_concatenation_repeat1] = STATE(473),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1076),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(1074),
    [anon_sym_LT_AMP] = ACTIONS(1074),
    [anon_sym_GT_AMP] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_LT_LT_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_raw_string] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LPAREN] = ACTIONS(1074),
    [anon_sym_GT_LPAREN] = ACTIONS(1074),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [474] = {
    [sym_compound_statement] = STATE(765),
    [anon_sym_LBRACE] = ACTIONS(348),
    [sym_comment] = ACTIONS(54),
  },
  [475] = {
    [anon_sym_LT] = ACTIONS(1530),
    [anon_sym_GT] = ACTIONS(1530),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1530),
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [sym_comment] = ACTIONS(54),
  },
  [476] = {
    [sym_concatenation] = STATE(640),
    [sym_string] = STATE(767),
    [sym_simple_expansion] = STATE(767),
    [sym_expansion] = STATE(767),
    [sym_command_substitution] = STATE(767),
    [sym_process_substitution] = STATE(767),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [sym_raw_string] = ACTIONS(1534),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_word] = ACTIONS(1536),
    [sym_comment] = ACTIONS(54),
  },
  [477] = {
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_SEMI_SEMI] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1538),
    [anon_sym_LF] = ACTIONS(1538),
    [anon_sym_AMP] = ACTIONS(1538),
  },
  [478] = {
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(1275),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [479] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(1275),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [480] = {
    [sym_concatenation] = STATE(642),
    [sym_string] = STATE(768),
    [sym_simple_expansion] = STATE(768),
    [sym_expansion] = STATE(768),
    [sym_command_substitution] = STATE(768),
    [sym_process_substitution] = STATE(768),
    [anon_sym_DQUOTE] = ACTIONS(608),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(616),
    [anon_sym_BQUOTE] = ACTIONS(618),
    [anon_sym_LT_LPAREN] = ACTIONS(620),
    [anon_sym_GT_LPAREN] = ACTIONS(620),
    [sym_word] = ACTIONS(1542),
    [sym_comment] = ACTIONS(54),
  },
  [481] = {
    [aux_sym_concatenation_repeat1] = STATE(769),
    [sym_file_descriptor] = ACTIONS(420),
    [sym__concat] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [482] = {
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [aux_sym_for_statement_repeat1] = STATE(482),
    [sym_file_descriptor] = ACTIONS(1313),
    [anon_sym_PIPE] = ACTIONS(1315),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_SEMI_SEMI] = ACTIONS(1315),
    [anon_sym_PIPE_AMP] = ACTIONS(1315),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1315),
    [anon_sym_GT_GT] = ACTIONS(1315),
    [anon_sym_AMP_GT] = ACTIONS(1315),
    [anon_sym_AMP_GT_GT] = ACTIONS(1315),
    [anon_sym_LT_AMP] = ACTIONS(1315),
    [anon_sym_GT_AMP] = ACTIONS(1315),
    [anon_sym_LT_LT] = ACTIONS(1315),
    [anon_sym_LT_LT_DASH] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1317),
    [sym_raw_string] = ACTIONS(1544),
    [anon_sym_DOLLAR] = ACTIONS(1323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(1332),
    [anon_sym_LT_LPAREN] = ACTIONS(1335),
    [anon_sym_GT_LPAREN] = ACTIONS(1335),
    [sym_word] = ACTIONS(1544),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_LF] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
  },
  [483] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [aux_sym_command_repeat2] = STATE(484),
    [sym_file_descriptor] = ACTIONS(366),
    [anon_sym_PIPE] = ACTIONS(1338),
    [anon_sym_RPAREN] = ACTIONS(1338),
    [anon_sym_SEMI_SEMI] = ACTIONS(1338),
    [anon_sym_PIPE_AMP] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1338),
    [anon_sym_PIPE_PIPE] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(368),
    [anon_sym_GT_GT] = ACTIONS(368),
    [anon_sym_AMP_GT] = ACTIONS(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(368),
    [anon_sym_LT_AMP] = ACTIONS(368),
    [anon_sym_GT_AMP] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1338),
    [anon_sym_LF] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
  },
  [484] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [aux_sym_command_repeat2] = STATE(484),
    [sym_file_descriptor] = ACTIONS(1547),
    [anon_sym_PIPE] = ACTIONS(1343),
    [anon_sym_RPAREN] = ACTIONS(1343),
    [anon_sym_SEMI_SEMI] = ACTIONS(1343),
    [anon_sym_PIPE_AMP] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1343),
    [anon_sym_LT] = ACTIONS(1550),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_GT_GT] = ACTIONS(1550),
    [anon_sym_AMP_GT] = ACTIONS(1550),
    [anon_sym_AMP_GT_GT] = ACTIONS(1550),
    [anon_sym_LT_AMP] = ACTIONS(1550),
    [anon_sym_GT_AMP] = ACTIONS(1550),
    [anon_sym_LT_LT] = ACTIONS(1348),
    [anon_sym_LT_LT_DASH] = ACTIONS(1348),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_LF] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
  },
  [485] = {
    [sym_file_descriptor] = ACTIONS(598),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(600),
    [anon_sym_local] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_AMP_GT] = ACTIONS(600),
    [anon_sym_AMP_GT_GT] = ACTIONS(598),
    [anon_sym_LT_AMP] = ACTIONS(598),
    [anon_sym_GT_AMP] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_word] = ACTIONS(602),
    [sym_comment] = ACTIONS(54),
  },
  [486] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [sym_concatenation] = STATE(151),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [aux_sym_for_statement_repeat1] = STATE(482),
    [aux_sym_command_repeat2] = STATE(771),
    [sym_file_descriptor] = ACTIONS(366),
    [anon_sym_PIPE] = ACTIONS(1338),
    [anon_sym_RPAREN] = ACTIONS(1338),
    [anon_sym_SEMI_SEMI] = ACTIONS(1338),
    [anon_sym_PIPE_AMP] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1338),
    [anon_sym_PIPE_PIPE] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(368),
    [anon_sym_GT_GT] = ACTIONS(368),
    [anon_sym_AMP_GT] = ACTIONS(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(368),
    [anon_sym_LT_AMP] = ACTIONS(368),
    [anon_sym_GT_AMP] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [sym_raw_string] = ACTIONS(370),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(258),
    [anon_sym_BQUOTE] = ACTIONS(260),
    [anon_sym_LT_LPAREN] = ACTIONS(262),
    [anon_sym_GT_LPAREN] = ACTIONS(262),
    [sym_word] = ACTIONS(370),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1338),
    [anon_sym_LF] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
  },
  [487] = {
    [sym__concat] = ACTIONS(1051),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_RBRACK] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(54),
  },
  [488] = {
    [sym__concat] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_RBRACK] = ACTIONS(1557),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [489] = {
    [aux_sym_concatenation_repeat1] = STATE(489),
    [sym__concat] = ACTIONS(1559),
    [anon_sym_RBRACK] = ACTIONS(1557),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [490] = {
    [anon_sym_RBRACE] = ACTIONS(1562),
    [anon_sym_LBRACK] = ACTIONS(1564),
    [sym_comment] = ACTIONS(54),
  },
  [491] = {
    [anon_sym_RBRACE] = ACTIONS(1566),
    [anon_sym_LBRACK] = ACTIONS(1568),
    [sym_comment] = ACTIONS(54),
  },
  [492] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_RBRACK] = ACTIONS(1570),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_word] = ACTIONS(1089),
    [sym_comment] = ACTIONS(54),
  },
  [493] = {
    [anon_sym_AT] = ACTIONS(1572),
    [sym_comment] = ACTIONS(54),
  },
  [494] = {
    [sym_concatenation] = STATE(779),
    [sym_string] = STATE(778),
    [sym_simple_expansion] = STATE(778),
    [sym_expansion] = STATE(778),
    [sym_command_substitution] = STATE(778),
    [sym_process_substitution] = STATE(778),
    [anon_sym_RBRACE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1576),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1578),
    [sym_comment] = ACTIONS(54),
  },
  [495] = {
    [sym__concat] = ACTIONS(1099),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_RBRACK] = ACTIONS(1580),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_word] = ACTIONS(1101),
    [sym_comment] = ACTIONS(54),
  },
  [496] = {
    [anon_sym_AT] = ACTIONS(1582),
    [sym_comment] = ACTIONS(54),
  },
  [497] = {
    [sym_concatenation] = STATE(782),
    [sym_string] = STATE(781),
    [sym_simple_expansion] = STATE(781),
    [sym_expansion] = STATE(781),
    [sym_command_substitution] = STATE(781),
    [sym_process_substitution] = STATE(781),
    [anon_sym_RBRACE] = ACTIONS(1566),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1584),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1586),
    [sym_comment] = ACTIONS(54),
  },
  [498] = {
    [sym__concat] = ACTIONS(1197),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_RBRACK] = ACTIONS(1588),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR] = ACTIONS(1588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1197),
    [anon_sym_BQUOTE] = ACTIONS(1197),
    [anon_sym_LT_LPAREN] = ACTIONS(1197),
    [anon_sym_GT_LPAREN] = ACTIONS(1197),
    [sym_word] = ACTIONS(1199),
    [sym_comment] = ACTIONS(54),
  },
  [499] = {
    [sym__concat] = ACTIONS(1255),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_RBRACK] = ACTIONS(1590),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1255),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [anon_sym_LT_LPAREN] = ACTIONS(1255),
    [anon_sym_GT_LPAREN] = ACTIONS(1255),
    [sym_word] = ACTIONS(1257),
    [sym_comment] = ACTIONS(54),
  },
  [500] = {
    [sym__concat] = ACTIONS(1051),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(54),
  },
  [501] = {
    [sym__concat] = ACTIONS(1072),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1557),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [502] = {
    [aux_sym_concatenation_repeat1] = STATE(502),
    [sym__concat] = ACTIONS(1592),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1557),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [503] = {
    [anon_sym_RBRACE] = ACTIONS(1595),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [sym_comment] = ACTIONS(54),
  },
  [504] = {
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1601),
    [sym_comment] = ACTIONS(54),
  },
  [505] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1570),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_word] = ACTIONS(1089),
    [sym_comment] = ACTIONS(54),
  },
  [506] = {
    [anon_sym_AT] = ACTIONS(1603),
    [sym_comment] = ACTIONS(54),
  },
  [507] = {
    [sym_concatenation] = STATE(790),
    [sym_string] = STATE(789),
    [sym_simple_expansion] = STATE(789),
    [sym_expansion] = STATE(789),
    [sym_command_substitution] = STATE(789),
    [sym_process_substitution] = STATE(789),
    [anon_sym_RBRACE] = ACTIONS(1605),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1607),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1609),
    [sym_comment] = ACTIONS(54),
  },
  [508] = {
    [sym__concat] = ACTIONS(1099),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1580),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_word] = ACTIONS(1101),
    [sym_comment] = ACTIONS(54),
  },
  [509] = {
    [anon_sym_AT] = ACTIONS(1611),
    [sym_comment] = ACTIONS(54),
  },
  [510] = {
    [sym_concatenation] = STATE(793),
    [sym_string] = STATE(792),
    [sym_simple_expansion] = STATE(792),
    [sym_expansion] = STATE(792),
    [sym_command_substitution] = STATE(792),
    [sym_process_substitution] = STATE(792),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1613),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1615),
    [sym_comment] = ACTIONS(54),
  },
  [511] = {
    [sym__concat] = ACTIONS(1197),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1588),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR] = ACTIONS(1588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1197),
    [anon_sym_BQUOTE] = ACTIONS(1197),
    [anon_sym_LT_LPAREN] = ACTIONS(1197),
    [anon_sym_GT_LPAREN] = ACTIONS(1197),
    [sym_word] = ACTIONS(1199),
    [sym_comment] = ACTIONS(54),
  },
  [512] = {
    [sym__concat] = ACTIONS(1255),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1590),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1255),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [anon_sym_LT_LPAREN] = ACTIONS(1255),
    [anon_sym_GT_LPAREN] = ACTIONS(1255),
    [sym_word] = ACTIONS(1257),
    [sym_comment] = ACTIONS(54),
  },
  [513] = {
    [anon_sym_PIPE] = ACTIONS(739),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(739),
  },
  [514] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(795),
    [anon_sym_RPAREN] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [515] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(797),
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [516] = {
    [aux_sym_concatenation_repeat1] = STATE(799),
    [sym__concat] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(739),
  },
  [517] = {
    [sym_special_variable_name] = STATE(802),
    [anon_sym_DOLLAR] = ACTIONS(1623),
    [anon_sym_POUND] = ACTIONS(1623),
    [anon_sym_AT] = ACTIONS(1623),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1625),
    [anon_sym_STAR] = ACTIONS(1623),
    [anon_sym_QMARK] = ACTIONS(1623),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_0] = ACTIONS(1627),
    [anon_sym__] = ACTIONS(1627),
  },
  [518] = {
    [sym_special_variable_name] = STATE(805),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(1629),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1631),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [519] = {
    [sym_for_statement] = STATE(806),
    [sym_while_statement] = STATE(806),
    [sym_if_statement] = STATE(806),
    [sym_case_statement] = STATE(806),
    [sym_function_definition] = STATE(806),
    [sym_subshell] = STATE(806),
    [sym_pipeline] = STATE(806),
    [sym_list] = STATE(806),
    [sym_bracket_command] = STATE(806),
    [sym_command] = STATE(806),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(807),
    [sym_local_variable_declaration] = STATE(806),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [520] = {
    [sym_for_statement] = STATE(808),
    [sym_while_statement] = STATE(808),
    [sym_if_statement] = STATE(808),
    [sym_case_statement] = STATE(808),
    [sym_function_definition] = STATE(808),
    [sym_subshell] = STATE(808),
    [sym_pipeline] = STATE(808),
    [sym_list] = STATE(808),
    [sym_bracket_command] = STATE(808),
    [sym_command] = STATE(808),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(809),
    [sym_local_variable_declaration] = STATE(808),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [521] = {
    [sym_for_statement] = STATE(810),
    [sym_while_statement] = STATE(810),
    [sym_if_statement] = STATE(810),
    [sym_case_statement] = STATE(810),
    [sym_function_definition] = STATE(810),
    [sym_subshell] = STATE(810),
    [sym_pipeline] = STATE(810),
    [sym_list] = STATE(810),
    [sym_bracket_command] = STATE(810),
    [sym_command] = STATE(810),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(811),
    [sym_local_variable_declaration] = STATE(810),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [522] = {
    [sym_file_descriptor] = ACTIONS(1051),
    [sym__concat] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_word] = ACTIONS(1555),
    [sym_comment] = ACTIONS(54),
  },
  [523] = {
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1072),
    [sym_variable_name] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1557),
    [sym_comment] = ACTIONS(54),
  },
  [524] = {
    [aux_sym_concatenation_repeat1] = STATE(524),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1633),
    [sym_variable_name] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1557),
    [sym_comment] = ACTIONS(54),
  },
  [525] = {
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(1638),
    [sym_comment] = ACTIONS(54),
  },
  [526] = {
    [anon_sym_RBRACE] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1642),
    [sym_comment] = ACTIONS(54),
  },
  [527] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1570),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1570),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_word] = ACTIONS(1570),
    [sym_comment] = ACTIONS(54),
  },
  [528] = {
    [anon_sym_AT] = ACTIONS(1644),
    [sym_comment] = ACTIONS(54),
  },
  [529] = {
    [sym_concatenation] = STATE(819),
    [sym_string] = STATE(818),
    [sym_simple_expansion] = STATE(818),
    [sym_expansion] = STATE(818),
    [sym_command_substitution] = STATE(818),
    [sym_process_substitution] = STATE(818),
    [anon_sym_RBRACE] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1650),
    [sym_comment] = ACTIONS(54),
  },
  [530] = {
    [sym_file_descriptor] = ACTIONS(1099),
    [sym__concat] = ACTIONS(1099),
    [sym_variable_name] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1580),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_word] = ACTIONS(1580),
    [sym_comment] = ACTIONS(54),
  },
  [531] = {
    [anon_sym_AT] = ACTIONS(1652),
    [sym_comment] = ACTIONS(54),
  },
  [532] = {
    [sym_concatenation] = STATE(822),
    [sym_string] = STATE(821),
    [sym_simple_expansion] = STATE(821),
    [sym_expansion] = STATE(821),
    [sym_command_substitution] = STATE(821),
    [sym_process_substitution] = STATE(821),
    [anon_sym_RBRACE] = ACTIONS(1640),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1656),
    [sym_comment] = ACTIONS(54),
  },
  [533] = {
    [sym_file_descriptor] = ACTIONS(1197),
    [sym__concat] = ACTIONS(1197),
    [sym_variable_name] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT] = ACTIONS(1588),
    [anon_sym_AMP_GT_GT] = ACTIONS(1197),
    [anon_sym_LT_AMP] = ACTIONS(1197),
    [anon_sym_GT_AMP] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR] = ACTIONS(1588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1197),
    [anon_sym_BQUOTE] = ACTIONS(1197),
    [anon_sym_LT_LPAREN] = ACTIONS(1197),
    [anon_sym_GT_LPAREN] = ACTIONS(1197),
    [sym_word] = ACTIONS(1588),
    [sym_comment] = ACTIONS(54),
  },
  [534] = {
    [sym_file_descriptor] = ACTIONS(1255),
    [sym__concat] = ACTIONS(1255),
    [sym_variable_name] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_AMP_GT] = ACTIONS(1590),
    [anon_sym_AMP_GT_GT] = ACTIONS(1255),
    [anon_sym_LT_AMP] = ACTIONS(1255),
    [anon_sym_GT_AMP] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1255),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [anon_sym_LT_LPAREN] = ACTIONS(1255),
    [anon_sym_GT_LPAREN] = ACTIONS(1255),
    [sym_word] = ACTIONS(1590),
    [sym_comment] = ACTIONS(54),
  },
  [535] = {
    [anon_sym_RBRACE] = ACTIONS(1658),
    [anon_sym_LBRACK] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [536] = {
    [anon_sym_RBRACE] = ACTIONS(1662),
    [anon_sym_LBRACK] = ACTIONS(1664),
    [sym_comment] = ACTIONS(54),
  },
  [537] = {
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1570),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(156),
  },
  [538] = {
    [anon_sym_AT] = ACTIONS(1666),
    [sym_comment] = ACTIONS(54),
  },
  [539] = {
    [sym_concatenation] = STATE(830),
    [sym_string] = STATE(829),
    [sym_simple_expansion] = STATE(829),
    [sym_expansion] = STATE(829),
    [sym_command_substitution] = STATE(829),
    [sym_process_substitution] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(1668),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1670),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1672),
    [sym_comment] = ACTIONS(54),
  },
  [540] = {
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1580),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [sym_comment] = ACTIONS(156),
  },
  [541] = {
    [anon_sym_AT] = ACTIONS(1674),
    [sym_comment] = ACTIONS(54),
  },
  [542] = {
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(832),
    [sym_simple_expansion] = STATE(832),
    [sym_expansion] = STATE(832),
    [sym_command_substitution] = STATE(832),
    [sym_process_substitution] = STATE(832),
    [anon_sym_RBRACE] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1676),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1678),
    [sym_comment] = ACTIONS(54),
  },
  [543] = {
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1588),
    [anon_sym_DOLLAR] = ACTIONS(1199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1199),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(156),
  },
  [544] = {
    [sym_file_descriptor] = ACTIONS(1680),
    [sym__concat] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_SEMI_SEMI] = ACTIONS(1682),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_LT_LT_DASH] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(1682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_word] = ACTIONS(1682),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_LF] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
  },
  [545] = {
    [anon_sym_AT] = ACTIONS(1684),
    [sym_comment] = ACTIONS(54),
  },
  [546] = {
    [sym_file_descriptor] = ACTIONS(1686),
    [sym__concat] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(1688),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(1688),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(1688),
    [anon_sym_GT_GT] = ACTIONS(1688),
    [anon_sym_AMP_GT] = ACTIONS(1688),
    [anon_sym_AMP_GT_GT] = ACTIONS(1688),
    [anon_sym_LT_AMP] = ACTIONS(1688),
    [anon_sym_GT_AMP] = ACTIONS(1688),
    [anon_sym_LT_LT] = ACTIONS(1688),
    [anon_sym_LT_LT_DASH] = ACTIONS(1688),
    [anon_sym_DQUOTE] = ACTIONS(1688),
    [sym_raw_string] = ACTIONS(1688),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1688),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [anon_sym_LT_LPAREN] = ACTIONS(1688),
    [anon_sym_GT_LPAREN] = ACTIONS(1688),
    [sym_word] = ACTIONS(1688),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [547] = {
    [anon_sym_AT] = ACTIONS(1690),
    [sym_comment] = ACTIONS(54),
  },
  [548] = {
    [anon_sym_RBRACK] = ACTIONS(1692),
    [sym_comment] = ACTIONS(54),
  },
  [549] = {
    [sym_file_descriptor] = ACTIONS(1694),
    [sym__concat] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(1696),
    [anon_sym_RPAREN] = ACTIONS(1696),
    [anon_sym_SEMI_SEMI] = ACTIONS(1696),
    [anon_sym_PIPE_AMP] = ACTIONS(1696),
    [anon_sym_AMP_AMP] = ACTIONS(1696),
    [anon_sym_PIPE_PIPE] = ACTIONS(1696),
    [anon_sym_LT] = ACTIONS(1696),
    [anon_sym_GT] = ACTIONS(1696),
    [anon_sym_GT_GT] = ACTIONS(1696),
    [anon_sym_AMP_GT] = ACTIONS(1696),
    [anon_sym_AMP_GT_GT] = ACTIONS(1696),
    [anon_sym_LT_AMP] = ACTIONS(1696),
    [anon_sym_GT_AMP] = ACTIONS(1696),
    [anon_sym_LT_LT] = ACTIONS(1696),
    [anon_sym_LT_LT_DASH] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [sym_raw_string] = ACTIONS(1696),
    [anon_sym_DOLLAR] = ACTIONS(1696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1696),
    [anon_sym_BQUOTE] = ACTIONS(1696),
    [anon_sym_LT_LPAREN] = ACTIONS(1696),
    [anon_sym_GT_LPAREN] = ACTIONS(1696),
    [sym_word] = ACTIONS(1696),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_LF] = ACTIONS(1696),
    [anon_sym_AMP] = ACTIONS(1696),
  },
  [550] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(1698),
    [sym_comment] = ACTIONS(54),
  },
  [551] = {
    [anon_sym_RBRACE] = ACTIONS(1698),
    [sym_comment] = ACTIONS(54),
  },
  [552] = {
    [anon_sym_RBRACK] = ACTIONS(1700),
    [sym_comment] = ACTIONS(54),
  },
  [553] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(1702),
    [sym_comment] = ACTIONS(54),
  },
  [554] = {
    [anon_sym_RBRACE] = ACTIONS(1702),
    [sym_comment] = ACTIONS(54),
  },
  [555] = {
    [sym_file_descriptor] = ACTIONS(737),
    [sym_variable_name] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(1704),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(1704),
    [anon_sym_LT] = ACTIONS(1704),
    [anon_sym_GT] = ACTIONS(1704),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(1704),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_word] = ACTIONS(739),
    [sym_comment] = ACTIONS(54),
  },
  [556] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(842),
    [anon_sym_RPAREN] = ACTIONS(1706),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [557] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(844),
    [anon_sym_DQUOTE] = ACTIONS(1708),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [558] = {
    [aux_sym_concatenation_repeat1] = STATE(846),
    [sym_file_descriptor] = ACTIONS(737),
    [sym__concat] = ACTIONS(1710),
    [sym_variable_name] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(1704),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(1704),
    [anon_sym_LT] = ACTIONS(1704),
    [anon_sym_GT] = ACTIONS(1704),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(1704),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_word] = ACTIONS(739),
    [sym_comment] = ACTIONS(54),
  },
  [559] = {
    [sym_special_variable_name] = STATE(849),
    [anon_sym_DOLLAR] = ACTIONS(1712),
    [anon_sym_POUND] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(1712),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1714),
    [anon_sym_STAR] = ACTIONS(1712),
    [anon_sym_QMARK] = ACTIONS(1712),
    [anon_sym_DASH] = ACTIONS(1712),
    [anon_sym_BANG] = ACTIONS(1712),
    [anon_sym_0] = ACTIONS(1716),
    [anon_sym__] = ACTIONS(1716),
  },
  [560] = {
    [sym_special_variable_name] = STATE(852),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(1718),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1720),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [561] = {
    [sym_for_statement] = STATE(853),
    [sym_while_statement] = STATE(853),
    [sym_if_statement] = STATE(853),
    [sym_case_statement] = STATE(853),
    [sym_function_definition] = STATE(853),
    [sym_subshell] = STATE(853),
    [sym_pipeline] = STATE(853),
    [sym_list] = STATE(853),
    [sym_bracket_command] = STATE(853),
    [sym_command] = STATE(853),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(854),
    [sym_local_variable_declaration] = STATE(853),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [562] = {
    [sym_for_statement] = STATE(855),
    [sym_while_statement] = STATE(855),
    [sym_if_statement] = STATE(855),
    [sym_case_statement] = STATE(855),
    [sym_function_definition] = STATE(855),
    [sym_subshell] = STATE(855),
    [sym_pipeline] = STATE(855),
    [sym_list] = STATE(855),
    [sym_bracket_command] = STATE(855),
    [sym_command] = STATE(855),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(856),
    [sym_local_variable_declaration] = STATE(855),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [563] = {
    [sym_for_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_function_definition] = STATE(857),
    [sym_subshell] = STATE(857),
    [sym_pipeline] = STATE(857),
    [sym_list] = STATE(857),
    [sym_bracket_command] = STATE(857),
    [sym_command] = STATE(857),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(858),
    [sym_local_variable_declaration] = STATE(857),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [564] = {
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_for_statement_repeat1] = STATE(859),
    [anon_sym_DQUOTE] = ACTIONS(773),
    [sym_raw_string] = ACTIONS(775),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(785),
    [anon_sym_GT_LPAREN] = ACTIONS(785),
    [sym_word] = ACTIONS(787),
    [sym_comment] = ACTIONS(54),
  },
  [565] = {
    [sym__terminated_statement] = STATE(438),
    [sym_for_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_function_definition] = STATE(439),
    [sym_subshell] = STATE(439),
    [sym_pipeline] = STATE(439),
    [sym_list] = STATE(439),
    [sym_bracket_command] = STATE(439),
    [sym_command] = STATE(439),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(440),
    [sym_local_variable_declaration] = STATE(439),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(861),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(1722),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [566] = {
    [anon_sym_PIPE] = ACTIONS(1724),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_PIPE_AMP] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1726),
    [anon_sym_PIPE_PIPE] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [sym_comment] = ACTIONS(54),
  },
  [567] = {
    [sym__terminated_statement] = STATE(445),
    [sym_for_statement] = STATE(446),
    [sym_while_statement] = STATE(446),
    [sym_if_statement] = STATE(446),
    [sym_elif_clause] = STATE(447),
    [sym_else_clause] = STATE(863),
    [sym_case_statement] = STATE(446),
    [sym_function_definition] = STATE(446),
    [sym_subshell] = STATE(446),
    [sym_pipeline] = STATE(446),
    [sym_list] = STATE(446),
    [sym_bracket_command] = STATE(446),
    [sym_command] = STATE(446),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(449),
    [sym_local_variable_declaration] = STATE(446),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(864),
    [aux_sym_if_statement_repeat1] = STATE(865),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(1728),
    [anon_sym_elif] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [568] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1730),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1730),
    [anon_sym_LF] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1730),
  },
  [569] = {
    [anon_sym_in] = ACTIONS(1732),
    [sym_comment] = ACTIONS(54),
  },
  [570] = {
    [anon_sym_RPAREN] = ACTIONS(1734),
    [sym_comment] = ACTIONS(54),
  },
  [571] = {
    [sym_file_redirect] = STATE(869),
    [sym_file_descriptor] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1736),
    [anon_sym_RPAREN] = ACTIONS(1738),
    [anon_sym_PIPE_AMP] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_GT_GT] = ACTIONS(1195),
    [anon_sym_AMP_GT] = ACTIONS(1193),
    [anon_sym_AMP_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_AMP] = ACTIONS(1195),
    [anon_sym_GT_AMP] = ACTIONS(1195),
    [sym_comment] = ACTIONS(54),
  },
  [572] = {
    [anon_sym_PIPE] = ACTIONS(1740),
    [anon_sym_RPAREN] = ACTIONS(1742),
    [anon_sym_PIPE_AMP] = ACTIONS(1742),
    [anon_sym_AMP_AMP] = ACTIONS(1742),
    [anon_sym_PIPE_PIPE] = ACTIONS(1742),
    [anon_sym_BQUOTE] = ACTIONS(1742),
    [sym_comment] = ACTIONS(54),
  },
  [573] = {
    [sym_file_descriptor] = ACTIONS(598),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_function] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(600),
    [anon_sym_local] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_AMP_GT] = ACTIONS(600),
    [anon_sym_AMP_GT_GT] = ACTIONS(598),
    [anon_sym_LT_AMP] = ACTIONS(598),
    [anon_sym_GT_AMP] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_word] = ACTIONS(602),
    [sym_comment] = ACTIONS(54),
  },
  [574] = {
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1748),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(364),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1748),
    [anon_sym_LF] = ACTIONS(1748),
    [anon_sym_AMP] = ACTIONS(1748),
  },
  [575] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(358),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1748),
    [anon_sym_PIPE_AMP] = ACTIONS(358),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(364),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1748),
    [anon_sym_LF] = ACTIONS(1748),
    [anon_sym_AMP] = ACTIONS(1748),
  },
  [576] = {
    [anon_sym_PIPE] = ACTIONS(1750),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [sym_comment] = ACTIONS(54),
  },
  [577] = {
    [sym_concatenation] = STATE(872),
    [sym_string] = STATE(875),
    [sym_array] = STATE(872),
    [sym_simple_expansion] = STATE(875),
    [sym_expansion] = STATE(875),
    [sym_command_substitution] = STATE(875),
    [sym_process_substitution] = STATE(875),
    [sym__empty_value] = ACTIONS(1754),
    [anon_sym_LPAREN] = ACTIONS(1756),
    [anon_sym_DQUOTE] = ACTIONS(1758),
    [sym_raw_string] = ACTIONS(1760),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [anon_sym_LT_LPAREN] = ACTIONS(1770),
    [anon_sym_GT_LPAREN] = ACTIONS(1770),
    [sym_word] = ACTIONS(1772),
    [sym_comment] = ACTIONS(54),
  },
  [578] = {
    [anon_sym_PIPE] = ACTIONS(1774),
    [anon_sym_RPAREN] = ACTIONS(1776),
    [anon_sym_PIPE_AMP] = ACTIONS(1776),
    [anon_sym_AMP_AMP] = ACTIONS(1776),
    [anon_sym_PIPE_PIPE] = ACTIONS(1776),
    [anon_sym_BQUOTE] = ACTIONS(1776),
    [sym_comment] = ACTIONS(54),
  },
  [579] = {
    [sym_file_descriptor] = ACTIONS(1051),
    [sym__concat] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1555),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(54),
  },
  [580] = {
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1557),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1557),
    [anon_sym_LT_LT_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [581] = {
    [aux_sym_concatenation_repeat1] = STATE(581),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1778),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1557),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1557),
    [anon_sym_LT_LT_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [582] = {
    [anon_sym_RBRACE] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(54),
  },
  [583] = {
    [anon_sym_RBRACE] = ACTIONS(1785),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [sym_comment] = ACTIONS(54),
  },
  [584] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1570),
    [anon_sym_LT] = ACTIONS(1570),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1570),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1570),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_word] = ACTIONS(1089),
    [sym_comment] = ACTIONS(54),
  },
  [585] = {
    [anon_sym_AT] = ACTIONS(1789),
    [sym_comment] = ACTIONS(54),
  },
  [586] = {
    [sym_concatenation] = STATE(888),
    [sym_string] = STATE(887),
    [sym_simple_expansion] = STATE(887),
    [sym_expansion] = STATE(887),
    [sym_command_substitution] = STATE(887),
    [sym_process_substitution] = STATE(887),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1795),
    [sym_comment] = ACTIONS(54),
  },
  [587] = {
    [sym_file_descriptor] = ACTIONS(1099),
    [sym__concat] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1580),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_LT_LT_DASH] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_word] = ACTIONS(1101),
    [sym_comment] = ACTIONS(54),
  },
  [588] = {
    [anon_sym_AT] = ACTIONS(1797),
    [sym_comment] = ACTIONS(54),
  },
  [589] = {
    [sym_concatenation] = STATE(891),
    [sym_string] = STATE(890),
    [sym_simple_expansion] = STATE(890),
    [sym_expansion] = STATE(890),
    [sym_command_substitution] = STATE(890),
    [sym_process_substitution] = STATE(890),
    [anon_sym_RBRACE] = ACTIONS(1785),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(1799),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(1801),
    [sym_comment] = ACTIONS(54),
  },
  [590] = {
    [sym_file_descriptor] = ACTIONS(1197),
    [sym__concat] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_PIPE_AMP] = ACTIONS(1197),
    [anon_sym_AMP_AMP] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT] = ACTIONS(1588),
    [anon_sym_AMP_GT_GT] = ACTIONS(1197),
    [anon_sym_LT_AMP] = ACTIONS(1197),
    [anon_sym_GT_AMP] = ACTIONS(1197),
    [anon_sym_LT_LT] = ACTIONS(1588),
    [anon_sym_LT_LT_DASH] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR] = ACTIONS(1588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1197),
    [anon_sym_BQUOTE] = ACTIONS(1197),
    [anon_sym_LT_LPAREN] = ACTIONS(1197),
    [anon_sym_GT_LPAREN] = ACTIONS(1197),
    [sym_word] = ACTIONS(1199),
    [sym_comment] = ACTIONS(54),
  },
  [591] = {
    [sym_file_descriptor] = ACTIONS(1255),
    [sym__concat] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1590),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1590),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_AMP_GT] = ACTIONS(1590),
    [anon_sym_AMP_GT_GT] = ACTIONS(1255),
    [anon_sym_LT_AMP] = ACTIONS(1255),
    [anon_sym_GT_AMP] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1590),
    [anon_sym_LT_LT_DASH] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1255),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [anon_sym_LT_LPAREN] = ACTIONS(1255),
    [anon_sym_GT_LPAREN] = ACTIONS(1255),
    [sym_word] = ACTIONS(1257),
    [sym_comment] = ACTIONS(54),
  },
  [592] = {
    [sym_compound_statement] = STATE(892),
    [anon_sym_LBRACE] = ACTIONS(526),
    [sym_comment] = ACTIONS(54),
  },
  [593] = {
    [sym_file_descriptor] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1803),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1803),
    [anon_sym_GT] = ACTIONS(1803),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1803),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [anon_sym_BQUOTE] = ACTIONS(1259),
    [sym_comment] = ACTIONS(54),
  },
  [594] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(637),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [595] = {
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_GT_GT] = ACTIONS(1809),
    [anon_sym_AMP_GT] = ACTIONS(1807),
    [anon_sym_AMP_GT_GT] = ACTIONS(1809),
    [anon_sym_LT_AMP] = ACTIONS(1809),
    [anon_sym_GT_AMP] = ACTIONS(1809),
    [sym_comment] = ACTIONS(54),
  },
  [596] = {
    [sym_concatenation] = STATE(896),
    [sym_string] = STATE(895),
    [sym_simple_expansion] = STATE(895),
    [sym_expansion] = STATE(895),
    [sym_command_substitution] = STATE(895),
    [sym_process_substitution] = STATE(895),
    [anon_sym_DQUOTE] = ACTIONS(1758),
    [sym_raw_string] = ACTIONS(1811),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [anon_sym_LT_LPAREN] = ACTIONS(1770),
    [anon_sym_GT_LPAREN] = ACTIONS(1770),
    [sym_word] = ACTIONS(1813),
    [sym_comment] = ACTIONS(54),
  },
  [597] = {
    [anon_sym_PIPE] = ACTIONS(1736),
    [anon_sym_RPAREN] = ACTIONS(1738),
    [anon_sym_PIPE_AMP] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(54),
  },
  [598] = {
    [anon_sym_PIPE] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(1817),
    [anon_sym_PIPE_AMP] = ACTIONS(1817),
    [anon_sym_AMP_AMP] = ACTIONS(1817),
    [anon_sym_PIPE_PIPE] = ACTIONS(1817),
    [anon_sym_BQUOTE] = ACTIONS(1817),
    [sym_comment] = ACTIONS(54),
  },
  [599] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(1817),
    [anon_sym_PIPE_AMP] = ACTIONS(1817),
    [anon_sym_AMP_AMP] = ACTIONS(1817),
    [anon_sym_PIPE_PIPE] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [600] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1819),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(1819),
    [anon_sym_PIPE_PIPE] = ACTIONS(1819),
    [sym_comment] = ACTIONS(54),
  },
  [601] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1819),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(1819),
    [anon_sym_PIPE_PIPE] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [602] = {
    [sym_concatenation] = STATE(898),
    [sym_string] = STATE(897),
    [sym_simple_expansion] = STATE(897),
    [sym_expansion] = STATE(897),
    [sym_command_substitution] = STATE(897),
    [sym_process_substitution] = STATE(897),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [sym_raw_string] = ACTIONS(1823),
    [anon_sym_DOLLAR] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1213),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [anon_sym_LT_LPAREN] = ACTIONS(1217),
    [anon_sym_GT_LPAREN] = ACTIONS(1217),
    [sym_word] = ACTIONS(1825),
    [sym_comment] = ACTIONS(54),
  },
  [603] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(900),
    [anon_sym_DQUOTE] = ACTIONS(1827),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [604] = {
    [aux_sym_concatenation_repeat1] = STATE(902),
    [sym_file_descriptor] = ACTIONS(420),
    [sym__concat] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(420),
    [anon_sym_AMP_GT] = ACTIONS(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(420),
    [anon_sym_LT_AMP] = ACTIONS(420),
    [anon_sym_GT_AMP] = ACTIONS(420),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_LT_LT_DASH] = ACTIONS(420),
    [sym_comment] = ACTIONS(54),
  },
  [605] = {
    [sym_special_variable_name] = STATE(905),
    [anon_sym_DOLLAR] = ACTIONS(1831),
    [anon_sym_POUND] = ACTIONS(1831),
    [anon_sym_AT] = ACTIONS(1831),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_0] = ACTIONS(1835),
    [anon_sym__] = ACTIONS(1835),
  },
  [606] = {
    [sym_special_variable_name] = STATE(908),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(1837),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1839),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [607] = {
    [sym_for_statement] = STATE(909),
    [sym_while_statement] = STATE(909),
    [sym_if_statement] = STATE(909),
    [sym_case_statement] = STATE(909),
    [sym_function_definition] = STATE(909),
    [sym_subshell] = STATE(909),
    [sym_pipeline] = STATE(909),
    [sym_list] = STATE(909),
    [sym_bracket_command] = STATE(909),
    [sym_command] = STATE(909),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(910),
    [sym_local_variable_declaration] = STATE(909),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [608] = {
    [sym_for_statement] = STATE(911),
    [sym_while_statement] = STATE(911),
    [sym_if_statement] = STATE(911),
    [sym_case_statement] = STATE(911),
    [sym_function_definition] = STATE(911),
    [sym_subshell] = STATE(911),
    [sym_pipeline] = STATE(911),
    [sym_list] = STATE(911),
    [sym_bracket_command] = STATE(911),
    [sym_command] = STATE(911),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(912),
    [sym_local_variable_declaration] = STATE(911),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [609] = {
    [sym_for_statement] = STATE(913),
    [sym_while_statement] = STATE(913),
    [sym_if_statement] = STATE(913),
    [sym_case_statement] = STATE(913),
    [sym_function_definition] = STATE(913),
    [sym_subshell] = STATE(913),
    [sym_pipeline] = STATE(913),
    [sym_list] = STATE(913),
    [sym_bracket_command] = STATE(913),
    [sym_command] = STATE(913),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(914),
    [sym_local_variable_declaration] = STATE(913),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [610] = {
    [sym_file_descriptor] = ACTIONS(420),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(420),
    [anon_sym_AMP_GT] = ACTIONS(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(420),
    [anon_sym_LT_AMP] = ACTIONS(420),
    [anon_sym_GT_AMP] = ACTIONS(420),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_LT_LT_DASH] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [sym_comment] = ACTIONS(54),
  },
  [611] = {
    [sym_file_descriptor] = ACTIONS(1297),
    [anon_sym_PIPE] = ACTIONS(1841),
    [anon_sym_RPAREN] = ACTIONS(1297),
    [anon_sym_PIPE_AMP] = ACTIONS(1297),
    [anon_sym_AMP_AMP] = ACTIONS(1297),
    [anon_sym_PIPE_PIPE] = ACTIONS(1297),
    [anon_sym_LT] = ACTIONS(1841),
    [anon_sym_GT] = ACTIONS(1841),
    [anon_sym_GT_GT] = ACTIONS(1297),
    [anon_sym_AMP_GT] = ACTIONS(1841),
    [anon_sym_AMP_GT_GT] = ACTIONS(1297),
    [anon_sym_LT_AMP] = ACTIONS(1297),
    [anon_sym_GT_AMP] = ACTIONS(1297),
    [anon_sym_LT_LT] = ACTIONS(1841),
    [anon_sym_LT_LT_DASH] = ACTIONS(1297),
    [anon_sym_BQUOTE] = ACTIONS(1297),
    [sym_comment] = ACTIONS(54),
  },
  [612] = {
    [sym_simple_expansion] = STATE(659),
    [sym_expansion] = STATE(659),
    [aux_sym_heredoc_repeat1] = STATE(916),
    [sym__heredoc_middle] = ACTIONS(1301),
    [sym__heredoc_end] = ACTIONS(1843),
    [anon_sym_DOLLAR] = ACTIONS(1305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1307),
    [sym_comment] = ACTIONS(54),
  },
  [613] = {
    [sym_file_descriptor] = ACTIONS(1309),
    [anon_sym_PIPE] = ACTIONS(1845),
    [anon_sym_RPAREN] = ACTIONS(1309),
    [anon_sym_PIPE_AMP] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1309),
    [anon_sym_PIPE_PIPE] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1845),
    [anon_sym_GT] = ACTIONS(1845),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_AMP_GT] = ACTIONS(1845),
    [anon_sym_AMP_GT_GT] = ACTIONS(1309),
    [anon_sym_LT_AMP] = ACTIONS(1309),
    [anon_sym_GT_AMP] = ACTIONS(1309),
    [anon_sym_LT_LT] = ACTIONS(1845),
    [anon_sym_LT_LT_DASH] = ACTIONS(1309),
    [anon_sym_BQUOTE] = ACTIONS(1309),
    [sym_comment] = ACTIONS(54),
  },
  [614] = {
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(336),
    [sym_simple_expansion] = STATE(336),
    [sym_expansion] = STATE(336),
    [sym_command_substitution] = STATE(336),
    [sym_process_substitution] = STATE(336),
    [aux_sym_for_statement_repeat1] = STATE(614),
    [sym_file_descriptor] = ACTIONS(1313),
    [anon_sym_PIPE] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(1313),
    [anon_sym_PIPE_AMP] = ACTIONS(1313),
    [anon_sym_AMP_AMP] = ACTIONS(1313),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(903),
    [anon_sym_GT] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(1313),
    [anon_sym_AMP_GT] = ACTIONS(903),
    [anon_sym_AMP_GT_GT] = ACTIONS(1313),
    [anon_sym_LT_AMP] = ACTIONS(1313),
    [anon_sym_GT_AMP] = ACTIONS(1313),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(1847),
    [sym_raw_string] = ACTIONS(1850),
    [anon_sym_DOLLAR] = ACTIONS(1853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1856),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1859),
    [anon_sym_BQUOTE] = ACTIONS(1862),
    [anon_sym_LT_LPAREN] = ACTIONS(1865),
    [anon_sym_GT_LPAREN] = ACTIONS(1865),
    [sym_word] = ACTIONS(1868),
    [sym_comment] = ACTIONS(54),
  },
  [615] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [aux_sym_command_repeat2] = STATE(616),
    [sym_file_descriptor] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(1871),
    [anon_sym_RPAREN] = ACTIONS(1873),
    [anon_sym_PIPE_AMP] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(542),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [sym_comment] = ACTIONS(54),
  },
  [616] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [aux_sym_command_repeat2] = STATE(616),
    [sym_file_descriptor] = ACTIONS(1875),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1880),
    [anon_sym_PIPE_AMP] = ACTIONS(1880),
    [anon_sym_AMP_AMP] = ACTIONS(1880),
    [anon_sym_PIPE_PIPE] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_GT] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT_GT] = ACTIONS(1885),
    [anon_sym_LT_AMP] = ACTIONS(1885),
    [anon_sym_GT_AMP] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(1888),
    [anon_sym_LT_LT_DASH] = ACTIONS(1891),
    [sym_comment] = ACTIONS(54),
  },
  [617] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(336),
    [sym_simple_expansion] = STATE(336),
    [sym_expansion] = STATE(336),
    [sym_command_substitution] = STATE(336),
    [sym_process_substitution] = STATE(336),
    [aux_sym_for_statement_repeat1] = STATE(614),
    [aux_sym_command_repeat2] = STATE(917),
    [sym_file_descriptor] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(1871),
    [anon_sym_RPAREN] = ACTIONS(1873),
    [anon_sym_PIPE_AMP] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_PIPE_PIPE] = ACTIONS(1871),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(542),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(550),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(552),
    [sym_comment] = ACTIONS(54),
  },
  [618] = {
    [aux_sym_concatenation_repeat1] = STATE(918),
    [sym_file_descriptor] = ACTIONS(737),
    [sym__concat] = ACTIONS(1710),
    [sym_variable_name] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(1704),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(1704),
    [anon_sym_LT] = ACTIONS(1704),
    [anon_sym_GT] = ACTIONS(1704),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(1704),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_word] = ACTIONS(739),
    [sym_comment] = ACTIONS(54),
  },
  [619] = {
    [anon_sym_RPAREN] = ACTIONS(1894),
    [sym_comment] = ACTIONS(54),
  },
  [620] = {
    [sym_file_redirect] = STATE(869),
    [sym_file_descriptor] = ACTIONS(1241),
    [anon_sym_PIPE] = ACTIONS(1736),
    [anon_sym_PIPE_AMP] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_AMP_GT] = ACTIONS(1243),
    [anon_sym_AMP_GT_GT] = ACTIONS(1245),
    [anon_sym_LT_AMP] = ACTIONS(1245),
    [anon_sym_GT_AMP] = ACTIONS(1245),
    [anon_sym_BQUOTE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(54),
  },
  [621] = {
    [sym_concatenation] = STATE(872),
    [sym_string] = STATE(920),
    [sym_array] = STATE(872),
    [sym_simple_expansion] = STATE(920),
    [sym_expansion] = STATE(920),
    [sym_command_substitution] = STATE(920),
    [sym_process_substitution] = STATE(920),
    [sym__empty_value] = ACTIONS(1754),
    [anon_sym_LPAREN] = ACTIONS(1756),
    [anon_sym_DQUOTE] = ACTIONS(1758),
    [sym_raw_string] = ACTIONS(1896),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [anon_sym_LT_LPAREN] = ACTIONS(1770),
    [anon_sym_GT_LPAREN] = ACTIONS(1770),
    [sym_word] = ACTIONS(1898),
    [sym_comment] = ACTIONS(54),
  },
  [622] = {
    [aux_sym_concatenation_repeat1] = STATE(622),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1778),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1557),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1557),
    [anon_sym_LT_LT_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [623] = {
    [sym_compound_statement] = STATE(921),
    [anon_sym_LBRACE] = ACTIONS(526),
    [sym_comment] = ACTIONS(54),
  },
  [624] = {
    [anon_sym_LT] = ACTIONS(1900),
    [anon_sym_GT] = ACTIONS(1900),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_AMP_GT] = ACTIONS(1900),
    [anon_sym_AMP_GT_GT] = ACTIONS(1902),
    [anon_sym_LT_AMP] = ACTIONS(1902),
    [anon_sym_GT_AMP] = ACTIONS(1902),
    [sym_comment] = ACTIONS(54),
  },
  [625] = {
    [sym_concatenation] = STATE(896),
    [sym_string] = STATE(923),
    [sym_simple_expansion] = STATE(923),
    [sym_expansion] = STATE(923),
    [sym_command_substitution] = STATE(923),
    [sym_process_substitution] = STATE(923),
    [anon_sym_DQUOTE] = ACTIONS(1758),
    [sym_raw_string] = ACTIONS(1904),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [anon_sym_LT_LPAREN] = ACTIONS(1770),
    [anon_sym_GT_LPAREN] = ACTIONS(1770),
    [sym_word] = ACTIONS(1906),
    [sym_comment] = ACTIONS(54),
  },
  [626] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(1815),
    [anon_sym_PIPE_AMP] = ACTIONS(1817),
    [anon_sym_AMP_AMP] = ACTIONS(1817),
    [anon_sym_PIPE_PIPE] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(1817),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [627] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(1819),
    [anon_sym_PIPE_PIPE] = ACTIONS(1819),
    [anon_sym_BQUOTE] = ACTIONS(1819),
    [sym_comment] = ACTIONS(54),
  },
  [628] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(1819),
    [anon_sym_PIPE_PIPE] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [629] = {
    [sym_concatenation] = STATE(898),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [sym_raw_string] = ACTIONS(1908),
    [anon_sym_DOLLAR] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1213),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [anon_sym_LT_LPAREN] = ACTIONS(1217),
    [anon_sym_GT_LPAREN] = ACTIONS(1217),
    [sym_word] = ACTIONS(1910),
    [sym_comment] = ACTIONS(54),
  },
  [630] = {
    [aux_sym_concatenation_repeat1] = STATE(925),
    [sym_file_descriptor] = ACTIONS(420),
    [sym__concat] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(420),
    [anon_sym_AMP_GT] = ACTIONS(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(420),
    [anon_sym_LT_AMP] = ACTIONS(420),
    [anon_sym_GT_AMP] = ACTIONS(420),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_LT_LT_DASH] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [sym_comment] = ACTIONS(54),
  },
  [631] = {
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(352),
    [sym_simple_expansion] = STATE(352),
    [sym_expansion] = STATE(352),
    [sym_command_substitution] = STATE(352),
    [sym_process_substitution] = STATE(352),
    [aux_sym_for_statement_repeat1] = STATE(631),
    [sym_file_descriptor] = ACTIONS(1313),
    [anon_sym_PIPE] = ACTIONS(903),
    [anon_sym_PIPE_AMP] = ACTIONS(1313),
    [anon_sym_AMP_AMP] = ACTIONS(1313),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(903),
    [anon_sym_GT] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(1313),
    [anon_sym_AMP_GT] = ACTIONS(903),
    [anon_sym_AMP_GT_GT] = ACTIONS(1313),
    [anon_sym_LT_AMP] = ACTIONS(1313),
    [anon_sym_GT_AMP] = ACTIONS(1313),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_LT_LT_DASH] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(1847),
    [sym_raw_string] = ACTIONS(1912),
    [anon_sym_DOLLAR] = ACTIONS(1853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1856),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1859),
    [anon_sym_BQUOTE] = ACTIONS(1862),
    [anon_sym_LT_LPAREN] = ACTIONS(1865),
    [anon_sym_GT_LPAREN] = ACTIONS(1865),
    [sym_word] = ACTIONS(1915),
    [sym_comment] = ACTIONS(54),
  },
  [632] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [aux_sym_command_repeat2] = STATE(633),
    [sym_file_descriptor] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1871),
    [anon_sym_PIPE_AMP] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_PIPE_PIPE] = ACTIONS(1873),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(1873),
    [sym_comment] = ACTIONS(54),
  },
  [633] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [aux_sym_command_repeat2] = STATE(633),
    [sym_file_descriptor] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(1880),
    [anon_sym_AMP_AMP] = ACTIONS(1880),
    [anon_sym_PIPE_PIPE] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_GT] = ACTIONS(1921),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1921),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1888),
    [anon_sym_LT_LT_DASH] = ACTIONS(1891),
    [anon_sym_BQUOTE] = ACTIONS(1880),
    [sym_comment] = ACTIONS(54),
  },
  [634] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(352),
    [sym_simple_expansion] = STATE(352),
    [sym_expansion] = STATE(352),
    [sym_command_substitution] = STATE(352),
    [sym_process_substitution] = STATE(352),
    [aux_sym_for_statement_repeat1] = STATE(631),
    [aux_sym_command_repeat2] = STATE(926),
    [sym_file_descriptor] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1871),
    [anon_sym_PIPE_AMP] = ACTIONS(1873),
    [anon_sym_AMP_AMP] = ACTIONS(1873),
    [anon_sym_PIPE_PIPE] = ACTIONS(1871),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(1873),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(580),
    [sym_comment] = ACTIONS(54),
  },
  [635] = {
    [sym_file_redirect] = STATE(927),
    [sym_file_descriptor] = ACTIONS(592),
    [anon_sym_PIPE] = ACTIONS(1522),
    [anon_sym_SEMI_SEMI] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_GT] = ACTIONS(596),
    [anon_sym_GT_GT] = ACTIONS(596),
    [anon_sym_AMP_GT] = ACTIONS(596),
    [anon_sym_AMP_GT_GT] = ACTIONS(596),
    [anon_sym_LT_AMP] = ACTIONS(596),
    [anon_sym_GT_AMP] = ACTIONS(596),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1522),
    [anon_sym_LF] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1522),
  },
  [636] = {
    [sym_file_descriptor] = ACTIONS(1927),
    [anon_sym_PIPE] = ACTIONS(1929),
    [anon_sym_RPAREN] = ACTIONS(1929),
    [anon_sym_SEMI_SEMI] = ACTIONS(1929),
    [anon_sym_PIPE_AMP] = ACTIONS(1929),
    [anon_sym_AMP_AMP] = ACTIONS(1929),
    [anon_sym_PIPE_PIPE] = ACTIONS(1929),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [anon_sym_GT_GT] = ACTIONS(1929),
    [anon_sym_AMP_GT] = ACTIONS(1929),
    [anon_sym_AMP_GT_GT] = ACTIONS(1929),
    [anon_sym_LT_AMP] = ACTIONS(1929),
    [anon_sym_GT_AMP] = ACTIONS(1929),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1929),
    [anon_sym_LF] = ACTIONS(1929),
    [anon_sym_AMP] = ACTIONS(1929),
  },
  [637] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(637),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(634),
    [sym_variable_name] = ACTIONS(637),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_RBRACE] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(663),
    [anon_sym_local] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(672),
    [anon_sym_LT_AMP] = ACTIONS(672),
    [anon_sym_GT_AMP] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(678),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_word] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
  },
  [638] = {
    [sym_concatenation] = STATE(929),
    [sym_string] = STATE(928),
    [sym_simple_expansion] = STATE(928),
    [sym_expansion] = STATE(928),
    [sym_command_substitution] = STATE(928),
    [sym_process_substitution] = STATE(928),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [sym_raw_string] = ACTIONS(1931),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_word] = ACTIONS(1933),
    [sym_comment] = ACTIONS(54),
  },
  [639] = {
    [aux_sym_concatenation_repeat1] = STATE(799),
    [sym__concat] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [640] = {
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [641] = {
    [aux_sym_concatenation_repeat1] = STATE(646),
    [sym_file_descriptor] = ACTIONS(717),
    [sym__concat] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1935),
    [anon_sym_SEMI_SEMI] = ACTIONS(1935),
    [anon_sym_PIPE_AMP] = ACTIONS(1935),
    [anon_sym_AMP_AMP] = ACTIONS(1935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_GT] = ACTIONS(1935),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT_GT] = ACTIONS(1935),
    [anon_sym_LT_AMP] = ACTIONS(1935),
    [anon_sym_GT_AMP] = ACTIONS(1935),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_LT_LT_DASH] = ACTIONS(1935),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1935),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
  },
  [642] = {
    [sym_file_descriptor] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(1935),
    [anon_sym_RPAREN] = ACTIONS(1935),
    [anon_sym_SEMI_SEMI] = ACTIONS(1935),
    [anon_sym_PIPE_AMP] = ACTIONS(1935),
    [anon_sym_AMP_AMP] = ACTIONS(1935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_GT] = ACTIONS(1935),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT_GT] = ACTIONS(1935),
    [anon_sym_LT_AMP] = ACTIONS(1935),
    [anon_sym_GT_AMP] = ACTIONS(1935),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_LT_LT_DASH] = ACTIONS(1935),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1935),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
  },
  [643] = {
    [sym_file_descriptor] = ACTIONS(436),
    [sym__concat] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI_SEMI] = ACTIONS(438),
    [anon_sym_PIPE_AMP] = ACTIONS(438),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_PIPE_PIPE] = ACTIONS(438),
    [anon_sym_LT] = ACTIONS(438),
    [anon_sym_GT] = ACTIONS(438),
    [anon_sym_GT_GT] = ACTIONS(438),
    [anon_sym_AMP_GT] = ACTIONS(438),
    [anon_sym_AMP_GT_GT] = ACTIONS(438),
    [anon_sym_LT_AMP] = ACTIONS(438),
    [anon_sym_GT_AMP] = ACTIONS(438),
    [anon_sym_LT_LT] = ACTIONS(438),
    [anon_sym_LT_LT_DASH] = ACTIONS(438),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LF] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(438),
  },
  [644] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(1937),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [645] = {
    [sym_string] = STATE(931),
    [sym_simple_expansion] = STATE(931),
    [sym_expansion] = STATE(931),
    [sym_command_substitution] = STATE(931),
    [sym_process_substitution] = STATE(931),
    [anon_sym_DQUOTE] = ACTIONS(608),
    [sym_raw_string] = ACTIONS(1939),
    [anon_sym_DOLLAR] = ACTIONS(612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(616),
    [anon_sym_BQUOTE] = ACTIONS(618),
    [anon_sym_LT_LPAREN] = ACTIONS(620),
    [anon_sym_GT_LPAREN] = ACTIONS(620),
    [sym_word] = ACTIONS(1941),
    [sym_comment] = ACTIONS(54),
  },
  [646] = {
    [aux_sym_concatenation_repeat1] = STATE(932),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(462),
    [anon_sym_AMP_AMP] = ACTIONS(462),
    [anon_sym_PIPE_PIPE] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(462),
    [anon_sym_AMP_GT] = ACTIONS(462),
    [anon_sym_AMP_GT_GT] = ACTIONS(462),
    [anon_sym_LT_AMP] = ACTIONS(462),
    [anon_sym_GT_AMP] = ACTIONS(462),
    [anon_sym_LT_LT] = ACTIONS(462),
    [anon_sym_LT_LT_DASH] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [647] = {
    [sym_file_descriptor] = ACTIONS(464),
    [sym__concat] = ACTIONS(464),
    [anon_sym_PIPE] = ACTIONS(466),
    [anon_sym_RPAREN] = ACTIONS(466),
    [anon_sym_SEMI_SEMI] = ACTIONS(466),
    [anon_sym_PIPE_AMP] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_GT] = ACTIONS(466),
    [anon_sym_GT_GT] = ACTIONS(466),
    [anon_sym_AMP_GT] = ACTIONS(466),
    [anon_sym_AMP_GT_GT] = ACTIONS(466),
    [anon_sym_LT_AMP] = ACTIONS(466),
    [anon_sym_GT_AMP] = ACTIONS(466),
    [anon_sym_LT_LT] = ACTIONS(466),
    [anon_sym_LT_LT_DASH] = ACTIONS(466),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(466),
  },
  [648] = {
    [sym_file_descriptor] = ACTIONS(468),
    [sym__concat] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_RPAREN] = ACTIONS(470),
    [anon_sym_SEMI_SEMI] = ACTIONS(470),
    [anon_sym_PIPE_AMP] = ACTIONS(470),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_GT] = ACTIONS(470),
    [anon_sym_GT_GT] = ACTIONS(470),
    [anon_sym_AMP_GT] = ACTIONS(470),
    [anon_sym_AMP_GT_GT] = ACTIONS(470),
    [anon_sym_LT_AMP] = ACTIONS(470),
    [anon_sym_GT_AMP] = ACTIONS(470),
    [anon_sym_LT_LT] = ACTIONS(470),
    [anon_sym_LT_LT_DASH] = ACTIONS(470),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_LF] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(470),
  },
  [649] = {
    [sym_file_descriptor] = ACTIONS(472),
    [sym__concat] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(474),
    [anon_sym_RPAREN] = ACTIONS(474),
    [anon_sym_SEMI_SEMI] = ACTIONS(474),
    [anon_sym_PIPE_AMP] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(474),
    [anon_sym_GT] = ACTIONS(474),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_AMP_GT] = ACTIONS(474),
    [anon_sym_AMP_GT_GT] = ACTIONS(474),
    [anon_sym_LT_AMP] = ACTIONS(474),
    [anon_sym_GT_AMP] = ACTIONS(474),
    [anon_sym_LT_LT] = ACTIONS(474),
    [anon_sym_LT_LT_DASH] = ACTIONS(474),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_LF] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(474),
  },
  [650] = {
    [sym_special_variable_name] = STATE(934),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [651] = {
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_EQ] = ACTIONS(1949),
    [anon_sym_COLON] = ACTIONS(1951),
    [anon_sym_COLON_QMARK] = ACTIONS(1949),
    [anon_sym_COLON_DASH] = ACTIONS(1949),
    [anon_sym_PERCENT] = ACTIONS(1949),
    [anon_sym_SLASH] = ACTIONS(1949),
    [sym_comment] = ACTIONS(54),
  },
  [652] = {
    [anon_sym_RBRACE] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1955),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1959),
    [anon_sym_COLON_QMARK] = ACTIONS(1957),
    [anon_sym_COLON_DASH] = ACTIONS(1957),
    [anon_sym_PERCENT] = ACTIONS(1957),
    [anon_sym_SLASH] = ACTIONS(1957),
    [sym_comment] = ACTIONS(54),
  },
  [653] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1961),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [654] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1961),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [655] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(1961),
    [sym_comment] = ACTIONS(54),
  },
  [656] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(1961),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [657] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1963),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [658] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(1963),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [659] = {
    [sym__heredoc_middle] = ACTIONS(1965),
    [sym__heredoc_end] = ACTIONS(1965),
    [anon_sym_DOLLAR] = ACTIONS(1967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1965),
    [sym_comment] = ACTIONS(54),
  },
  [660] = {
    [sym_file_descriptor] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1971),
    [anon_sym_RPAREN] = ACTIONS(1971),
    [anon_sym_SEMI_SEMI] = ACTIONS(1971),
    [anon_sym_PIPE_AMP] = ACTIONS(1971),
    [anon_sym_AMP_AMP] = ACTIONS(1971),
    [anon_sym_PIPE_PIPE] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_GT] = ACTIONS(1971),
    [anon_sym_GT_GT] = ACTIONS(1971),
    [anon_sym_AMP_GT] = ACTIONS(1971),
    [anon_sym_AMP_GT_GT] = ACTIONS(1971),
    [anon_sym_LT_AMP] = ACTIONS(1971),
    [anon_sym_GT_AMP] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1971),
    [anon_sym_LT_LT_DASH] = ACTIONS(1971),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1971),
    [anon_sym_LF] = ACTIONS(1971),
    [anon_sym_AMP] = ACTIONS(1971),
  },
  [661] = {
    [sym_special_variable_name] = STATE(945),
    [anon_sym_DOLLAR] = ACTIONS(1973),
    [anon_sym_POUND] = ACTIONS(1973),
    [anon_sym_AT] = ACTIONS(1973),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1973),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_0] = ACTIONS(1977),
    [anon_sym__] = ACTIONS(1977),
  },
  [662] = {
    [sym_special_variable_name] = STATE(948),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [663] = {
    [sym_simple_expansion] = STATE(659),
    [sym_expansion] = STATE(659),
    [aux_sym_heredoc_repeat1] = STATE(950),
    [sym__heredoc_middle] = ACTIONS(1301),
    [sym__heredoc_end] = ACTIONS(1983),
    [anon_sym_DOLLAR] = ACTIONS(1305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1307),
    [sym_comment] = ACTIONS(54),
  },
  [664] = {
    [sym_file_descriptor] = ACTIONS(737),
    [sym_variable_name] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(1704),
    [anon_sym_GT] = ACTIONS(1704),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(1704),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_word] = ACTIONS(1704),
    [sym_comment] = ACTIONS(54),
  },
  [665] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(952),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [666] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym_file_descriptor] = ACTIONS(737),
    [sym__concat] = ACTIONS(422),
    [sym_variable_name] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(1704),
    [anon_sym_GT] = ACTIONS(1704),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(1704),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_word] = ACTIONS(1704),
    [sym_comment] = ACTIONS(54),
  },
  [667] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [aux_sym_command_repeat2] = STATE(381),
    [sym_file_descriptor] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_SEMI_SEMI] = ACTIONS(1987),
    [anon_sym_PIPE_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(246),
    [anon_sym_GT_GT] = ACTIONS(246),
    [anon_sym_AMP_GT] = ACTIONS(246),
    [anon_sym_AMP_GT_GT] = ACTIONS(246),
    [anon_sym_LT_AMP] = ACTIONS(246),
    [anon_sym_GT_AMP] = ACTIONS(246),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1987),
    [anon_sym_LF] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
  },
  [668] = {
    [sym__concat] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_RBRACK] = ACTIONS(1051),
    [sym_comment] = ACTIONS(54),
  },
  [669] = {
    [sym__concat] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_RBRACK] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [670] = {
    [aux_sym_concatenation_repeat1] = STATE(670),
    [sym__concat] = ACTIONS(1989),
    [anon_sym_RBRACK] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [671] = {
    [anon_sym_RBRACE] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [sym_comment] = ACTIONS(54),
  },
  [672] = {
    [anon_sym_RBRACE] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1998),
    [sym_comment] = ACTIONS(54),
  },
  [673] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_RBRACK] = ACTIONS(1087),
    [sym_comment] = ACTIONS(54),
  },
  [674] = {
    [anon_sym_AT] = ACTIONS(2000),
    [sym_comment] = ACTIONS(54),
  },
  [675] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(959),
    [sym_simple_expansion] = STATE(959),
    [sym_expansion] = STATE(959),
    [sym_command_substitution] = STATE(959),
    [sym_process_substitution] = STATE(959),
    [anon_sym_RBRACE] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2004),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2006),
    [sym_comment] = ACTIONS(54),
  },
  [676] = {
    [sym__concat] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_RBRACK] = ACTIONS(1099),
    [sym_comment] = ACTIONS(54),
  },
  [677] = {
    [anon_sym_AT] = ACTIONS(2008),
    [sym_comment] = ACTIONS(54),
  },
  [678] = {
    [sym_concatenation] = STATE(963),
    [sym_string] = STATE(962),
    [sym_simple_expansion] = STATE(962),
    [sym_expansion] = STATE(962),
    [sym_command_substitution] = STATE(962),
    [sym_process_substitution] = STATE(962),
    [anon_sym_RBRACE] = ACTIONS(1996),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2012),
    [sym_comment] = ACTIONS(54),
  },
  [679] = {
    [sym__concat] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_RBRACK] = ACTIONS(1197),
    [sym_comment] = ACTIONS(54),
  },
  [680] = {
    [sym__concat] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_RBRACK] = ACTIONS(1255),
    [sym_comment] = ACTIONS(54),
  },
  [681] = {
    [sym__concat] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(436),
    [sym_raw_string] = ACTIONS(436),
    [anon_sym_DOLLAR] = ACTIONS(865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(436),
    [anon_sym_BQUOTE] = ACTIONS(436),
    [anon_sym_LT_LPAREN] = ACTIONS(436),
    [anon_sym_GT_LPAREN] = ACTIONS(436),
    [sym_word] = ACTIONS(865),
    [sym_comment] = ACTIONS(54),
  },
  [682] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [683] = {
    [sym_string] = STATE(965),
    [sym_simple_expansion] = STATE(965),
    [sym_expansion] = STATE(965),
    [sym_command_substitution] = STATE(965),
    [sym_process_substitution] = STATE(965),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(2018),
    [sym_comment] = ACTIONS(54),
  },
  [684] = {
    [aux_sym_concatenation_repeat1] = STATE(966),
    [sym__concat] = ACTIONS(1395),
    [anon_sym_RPAREN] = ACTIONS(460),
    [anon_sym_DQUOTE] = ACTIONS(460),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [anon_sym_LT_LPAREN] = ACTIONS(460),
    [anon_sym_GT_LPAREN] = ACTIONS(460),
    [sym_word] = ACTIONS(873),
    [sym_comment] = ACTIONS(54),
  },
  [685] = {
    [sym__concat] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(464),
    [anon_sym_DQUOTE] = ACTIONS(464),
    [sym_raw_string] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(464),
    [anon_sym_BQUOTE] = ACTIONS(464),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_word] = ACTIONS(476),
    [sym_comment] = ACTIONS(54),
  },
  [686] = {
    [sym__concat] = ACTIONS(468),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(468),
    [sym_raw_string] = ACTIONS(468),
    [anon_sym_DOLLAR] = ACTIONS(875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(468),
    [anon_sym_BQUOTE] = ACTIONS(468),
    [anon_sym_LT_LPAREN] = ACTIONS(468),
    [anon_sym_GT_LPAREN] = ACTIONS(468),
    [sym_word] = ACTIONS(875),
    [sym_comment] = ACTIONS(54),
  },
  [687] = {
    [sym__concat] = ACTIONS(472),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(472),
    [sym_raw_string] = ACTIONS(472),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_LT_LPAREN] = ACTIONS(472),
    [anon_sym_GT_LPAREN] = ACTIONS(472),
    [sym_word] = ACTIONS(877),
    [sym_comment] = ACTIONS(54),
  },
  [688] = {
    [sym_special_variable_name] = STATE(968),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [689] = {
    [anon_sym_RBRACE] = ACTIONS(2022),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_COLON] = ACTIONS(2028),
    [anon_sym_COLON_QMARK] = ACTIONS(2026),
    [anon_sym_COLON_DASH] = ACTIONS(2026),
    [anon_sym_PERCENT] = ACTIONS(2026),
    [anon_sym_SLASH] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
  },
  [690] = {
    [anon_sym_RBRACE] = ACTIONS(2030),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_EQ] = ACTIONS(2034),
    [anon_sym_COLON] = ACTIONS(2036),
    [anon_sym_COLON_QMARK] = ACTIONS(2034),
    [anon_sym_COLON_DASH] = ACTIONS(2034),
    [anon_sym_PERCENT] = ACTIONS(2034),
    [anon_sym_SLASH] = ACTIONS(2034),
    [sym_comment] = ACTIONS(54),
  },
  [691] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2038),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [692] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2038),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [693] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(54),
  },
  [694] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(2038),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [695] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2040),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [696] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2040),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [697] = {
    [sym_file_descriptor] = ACTIONS(2042),
    [sym_variable_name] = ACTIONS(2042),
    [anon_sym_PIPE] = ACTIONS(2044),
    [anon_sym_RPAREN] = ACTIONS(2044),
    [anon_sym_SEMI_SEMI] = ACTIONS(2044),
    [anon_sym_PIPE_AMP] = ACTIONS(2044),
    [anon_sym_AMP_AMP] = ACTIONS(2044),
    [anon_sym_PIPE_PIPE] = ACTIONS(2044),
    [anon_sym_LT] = ACTIONS(2044),
    [anon_sym_GT] = ACTIONS(2044),
    [anon_sym_GT_GT] = ACTIONS(2044),
    [anon_sym_AMP_GT] = ACTIONS(2044),
    [anon_sym_AMP_GT_GT] = ACTIONS(2044),
    [anon_sym_LT_AMP] = ACTIONS(2044),
    [anon_sym_GT_AMP] = ACTIONS(2044),
    [anon_sym_DQUOTE] = ACTIONS(2044),
    [sym_raw_string] = ACTIONS(2044),
    [anon_sym_DOLLAR] = ACTIONS(2044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2044),
    [anon_sym_BQUOTE] = ACTIONS(2044),
    [anon_sym_LT_LPAREN] = ACTIONS(2044),
    [anon_sym_GT_LPAREN] = ACTIONS(2044),
    [sym_word] = ACTIONS(2044),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym_LF] = ACTIONS(2044),
    [anon_sym_AMP] = ACTIONS(2044),
  },
  [698] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(698),
    [anon_sym_RPAREN] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [sym_raw_string] = ACTIONS(2049),
    [anon_sym_DOLLAR] = ACTIONS(2052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2058),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_LT_LPAREN] = ACTIONS(2064),
    [anon_sym_GT_LPAREN] = ACTIONS(2064),
    [sym_word] = ACTIONS(2067),
    [sym_comment] = ACTIONS(54),
  },
  [699] = {
    [sym_file_descriptor] = ACTIONS(1051),
    [sym__concat] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [700] = {
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1072),
    [sym_variable_name] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(1074),
    [anon_sym_LT_AMP] = ACTIONS(1074),
    [anon_sym_GT_AMP] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_raw_string] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LPAREN] = ACTIONS(1074),
    [anon_sym_GT_LPAREN] = ACTIONS(1074),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [701] = {
    [aux_sym_concatenation_repeat1] = STATE(701),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(2070),
    [sym_variable_name] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(1074),
    [anon_sym_LT_AMP] = ACTIONS(1074),
    [anon_sym_GT_AMP] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_raw_string] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LPAREN] = ACTIONS(1074),
    [anon_sym_GT_LPAREN] = ACTIONS(1074),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [702] = {
    [anon_sym_RBRACE] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2075),
    [sym_comment] = ACTIONS(54),
  },
  [703] = {
    [anon_sym_RBRACE] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(2079),
    [sym_comment] = ACTIONS(54),
  },
  [704] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [705] = {
    [anon_sym_AT] = ACTIONS(2081),
    [sym_comment] = ACTIONS(54),
  },
  [706] = {
    [sym_concatenation] = STATE(984),
    [sym_string] = STATE(983),
    [sym_simple_expansion] = STATE(983),
    [sym_expansion] = STATE(983),
    [sym_command_substitution] = STATE(983),
    [sym_process_substitution] = STATE(983),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2085),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2087),
    [sym_comment] = ACTIONS(54),
  },
  [707] = {
    [sym_file_descriptor] = ACTIONS(1099),
    [sym__concat] = ACTIONS(1099),
    [sym_variable_name] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
  },
  [708] = {
    [anon_sym_AT] = ACTIONS(2089),
    [sym_comment] = ACTIONS(54),
  },
  [709] = {
    [sym_concatenation] = STATE(987),
    [sym_string] = STATE(986),
    [sym_simple_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [sym_process_substitution] = STATE(986),
    [anon_sym_RBRACE] = ACTIONS(2077),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2091),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2093),
    [sym_comment] = ACTIONS(54),
  },
  [710] = {
    [sym_file_descriptor] = ACTIONS(1197),
    [sym__concat] = ACTIONS(1197),
    [sym_variable_name] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [anon_sym_PIPE_AMP] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_AMP] = ACTIONS(1199),
    [anon_sym_GT_AMP] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [sym_raw_string] = ACTIONS(1199),
    [anon_sym_DOLLAR] = ACTIONS(1199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1199),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [anon_sym_LT_LPAREN] = ACTIONS(1199),
    [anon_sym_GT_LPAREN] = ACTIONS(1199),
    [sym_word] = ACTIONS(1199),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [711] = {
    [sym_file_descriptor] = ACTIONS(1255),
    [sym__concat] = ACTIONS(1255),
    [sym_variable_name] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_word] = ACTIONS(1257),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [712] = {
    [sym__concat] = ACTIONS(436),
    [anon_sym_SEMI_SEMI] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [sym_raw_string] = ACTIONS(438),
    [anon_sym_DOLLAR] = ACTIONS(438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(438),
    [anon_sym_BQUOTE] = ACTIONS(438),
    [anon_sym_LT_LPAREN] = ACTIONS(438),
    [anon_sym_GT_LPAREN] = ACTIONS(438),
    [sym_word] = ACTIONS(438),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LF] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(438),
  },
  [713] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(2095),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [714] = {
    [sym_string] = STATE(989),
    [sym_simple_expansion] = STATE(989),
    [sym_expansion] = STATE(989),
    [sym_command_substitution] = STATE(989),
    [sym_process_substitution] = STATE(989),
    [anon_sym_DQUOTE] = ACTIONS(773),
    [sym_raw_string] = ACTIONS(2097),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(781),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [anon_sym_LT_LPAREN] = ACTIONS(785),
    [anon_sym_GT_LPAREN] = ACTIONS(785),
    [sym_word] = ACTIONS(2099),
    [sym_comment] = ACTIONS(54),
  },
  [715] = {
    [aux_sym_concatenation_repeat1] = STATE(990),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [anon_sym_DQUOTE] = ACTIONS(462),
    [sym_raw_string] = ACTIONS(462),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(462),
    [anon_sym_BQUOTE] = ACTIONS(462),
    [anon_sym_LT_LPAREN] = ACTIONS(462),
    [anon_sym_GT_LPAREN] = ACTIONS(462),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [716] = {
    [sym__concat] = ACTIONS(464),
    [anon_sym_SEMI_SEMI] = ACTIONS(466),
    [anon_sym_DQUOTE] = ACTIONS(466),
    [sym_raw_string] = ACTIONS(466),
    [anon_sym_DOLLAR] = ACTIONS(466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(466),
    [anon_sym_BQUOTE] = ACTIONS(466),
    [anon_sym_LT_LPAREN] = ACTIONS(466),
    [anon_sym_GT_LPAREN] = ACTIONS(466),
    [sym_word] = ACTIONS(466),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(466),
  },
  [717] = {
    [sym__concat] = ACTIONS(468),
    [anon_sym_SEMI_SEMI] = ACTIONS(470),
    [anon_sym_DQUOTE] = ACTIONS(470),
    [sym_raw_string] = ACTIONS(470),
    [anon_sym_DOLLAR] = ACTIONS(470),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(470),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(470),
    [anon_sym_BQUOTE] = ACTIONS(470),
    [anon_sym_LT_LPAREN] = ACTIONS(470),
    [anon_sym_GT_LPAREN] = ACTIONS(470),
    [sym_word] = ACTIONS(470),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_LF] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(470),
  },
  [718] = {
    [sym__concat] = ACTIONS(472),
    [anon_sym_SEMI_SEMI] = ACTIONS(474),
    [anon_sym_DQUOTE] = ACTIONS(474),
    [sym_raw_string] = ACTIONS(474),
    [anon_sym_DOLLAR] = ACTIONS(474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(474),
    [anon_sym_BQUOTE] = ACTIONS(474),
    [anon_sym_LT_LPAREN] = ACTIONS(474),
    [anon_sym_GT_LPAREN] = ACTIONS(474),
    [sym_word] = ACTIONS(474),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_LF] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(474),
  },
  [719] = {
    [sym_special_variable_name] = STATE(992),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(2101),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [720] = {
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2105),
    [anon_sym_EQ] = ACTIONS(2107),
    [anon_sym_COLON] = ACTIONS(2109),
    [anon_sym_COLON_QMARK] = ACTIONS(2107),
    [anon_sym_COLON_DASH] = ACTIONS(2107),
    [anon_sym_PERCENT] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(2107),
    [sym_comment] = ACTIONS(54),
  },
  [721] = {
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2113),
    [anon_sym_EQ] = ACTIONS(2115),
    [anon_sym_COLON] = ACTIONS(2117),
    [anon_sym_COLON_QMARK] = ACTIONS(2115),
    [anon_sym_COLON_DASH] = ACTIONS(2115),
    [anon_sym_PERCENT] = ACTIONS(2115),
    [anon_sym_SLASH] = ACTIONS(2115),
    [sym_comment] = ACTIONS(54),
  },
  [722] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2119),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [723] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2119),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [724] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(54),
  },
  [725] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [726] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2121),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [727] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2121),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [728] = {
    [sym_do_group] = STATE(1001),
    [anon_sym_do] = ACTIONS(322),
    [sym_comment] = ACTIONS(54),
  },
  [729] = {
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_for_statement_repeat1] = STATE(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [sym_raw_string] = ACTIONS(2126),
    [anon_sym_DOLLAR] = ACTIONS(2129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2132),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2135),
    [anon_sym_BQUOTE] = ACTIONS(2138),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [sym_word] = ACTIONS(2126),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_LF] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
  },
  [730] = {
    [sym_file_descriptor] = ACTIONS(598),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_done] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_function] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(600),
    [anon_sym_local] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_AMP_GT] = ACTIONS(600),
    [anon_sym_AMP_GT_GT] = ACTIONS(598),
    [anon_sym_LT_AMP] = ACTIONS(598),
    [anon_sym_GT_AMP] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_word] = ACTIONS(602),
    [sym_comment] = ACTIONS(54),
  },
  [731] = {
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_RPAREN] = ACTIONS(2144),
    [anon_sym_SEMI_SEMI] = ACTIONS(2144),
    [anon_sym_PIPE_AMP] = ACTIONS(2144),
    [anon_sym_AMP_AMP] = ACTIONS(2144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2144),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_LF] = ACTIONS(2144),
    [anon_sym_AMP] = ACTIONS(2144),
  },
  [732] = {
    [sym__terminated_statement] = STATE(438),
    [sym_for_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_function_definition] = STATE(439),
    [sym_subshell] = STATE(439),
    [sym_pipeline] = STATE(439),
    [sym_list] = STATE(439),
    [sym_bracket_command] = STATE(439),
    [sym_command] = STATE(439),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(440),
    [sym_local_variable_declaration] = STATE(439),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(732),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(634),
    [sym_variable_name] = ACTIONS(637),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(645),
    [anon_sym_done] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(663),
    [anon_sym_local] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(672),
    [anon_sym_LT_AMP] = ACTIONS(672),
    [anon_sym_GT_AMP] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(678),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_word] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
  },
  [733] = {
    [anon_sym_then] = ACTIONS(2148),
    [sym_comment] = ACTIONS(54),
  },
  [734] = {
    [sym_file_descriptor] = ACTIONS(230),
    [sym_variable_name] = ACTIONS(230),
    [anon_sym_for] = ACTIONS(232),
    [anon_sym_while] = ACTIONS(232),
    [anon_sym_if] = ACTIONS(232),
    [anon_sym_fi] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(232),
    [anon_sym_function] = ACTIONS(232),
    [anon_sym_LPAREN] = ACTIONS(230),
    [anon_sym_LBRACK] = ACTIONS(232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(232),
    [anon_sym_local] = ACTIONS(232),
    [anon_sym_LT] = ACTIONS(232),
    [anon_sym_GT] = ACTIONS(232),
    [anon_sym_GT_GT] = ACTIONS(230),
    [anon_sym_AMP_GT] = ACTIONS(232),
    [anon_sym_AMP_GT_GT] = ACTIONS(230),
    [anon_sym_LT_AMP] = ACTIONS(230),
    [anon_sym_GT_AMP] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(230),
    [sym_raw_string] = ACTIONS(230),
    [anon_sym_DOLLAR] = ACTIONS(232),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(230),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(230),
    [anon_sym_BQUOTE] = ACTIONS(230),
    [anon_sym_LT_LPAREN] = ACTIONS(230),
    [anon_sym_GT_LPAREN] = ACTIONS(230),
    [sym_word] = ACTIONS(234),
    [sym_comment] = ACTIONS(54),
  },
  [735] = {
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(2150),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_LF] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
  },
  [736] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_SEMI_SEMI] = ACTIONS(2150),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_LT] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(266),
    [anon_sym_AMP_GT] = ACTIONS(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(266),
    [anon_sym_LT_AMP] = ACTIONS(266),
    [anon_sym_GT_AMP] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [anon_sym_LT_LPAREN] = ACTIONS(266),
    [anon_sym_GT_LPAREN] = ACTIONS(266),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_LF] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
  },
  [737] = {
    [sym__terminated_statement] = STATE(734),
    [sym_for_statement] = STATE(735),
    [sym_while_statement] = STATE(735),
    [sym_if_statement] = STATE(735),
    [sym_case_statement] = STATE(735),
    [sym_function_definition] = STATE(735),
    [sym_subshell] = STATE(735),
    [sym_pipeline] = STATE(735),
    [sym_list] = STATE(735),
    [sym_bracket_command] = STATE(735),
    [sym_command] = STATE(735),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(736),
    [sym_local_variable_declaration] = STATE(735),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(1004),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2152),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [738] = {
    [sym_file_descriptor] = ACTIONS(598),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_fi] = ACTIONS(600),
    [anon_sym_elif] = ACTIONS(600),
    [anon_sym_else] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_function] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(600),
    [anon_sym_local] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_AMP_GT] = ACTIONS(600),
    [anon_sym_AMP_GT_GT] = ACTIONS(598),
    [anon_sym_LT_AMP] = ACTIONS(598),
    [anon_sym_GT_AMP] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_word] = ACTIONS(602),
    [sym_comment] = ACTIONS(54),
  },
  [739] = {
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_RPAREN] = ACTIONS(2154),
    [anon_sym_SEMI_SEMI] = ACTIONS(2154),
    [anon_sym_PIPE_AMP] = ACTIONS(2154),
    [anon_sym_AMP_AMP] = ACTIONS(2154),
    [anon_sym_PIPE_PIPE] = ACTIONS(2154),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_LF] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
  },
  [740] = {
    [anon_sym_fi] = ACTIONS(2156),
    [sym_comment] = ACTIONS(54),
  },
  [741] = {
    [sym__terminated_statement] = STATE(445),
    [sym_for_statement] = STATE(446),
    [sym_while_statement] = STATE(446),
    [sym_if_statement] = STATE(446),
    [sym_case_statement] = STATE(446),
    [sym_function_definition] = STATE(446),
    [sym_subshell] = STATE(446),
    [sym_pipeline] = STATE(446),
    [sym_list] = STATE(446),
    [sym_bracket_command] = STATE(446),
    [sym_command] = STATE(446),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(449),
    [sym_local_variable_declaration] = STATE(446),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(741),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(634),
    [sym_variable_name] = ACTIONS(637),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_fi] = ACTIONS(2146),
    [anon_sym_elif] = ACTIONS(2146),
    [anon_sym_else] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(663),
    [anon_sym_local] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(672),
    [anon_sym_LT_AMP] = ACTIONS(672),
    [anon_sym_GT_AMP] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(678),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_word] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
  },
  [742] = {
    [sym_elif_clause] = STATE(447),
    [sym_else_clause] = STATE(1006),
    [aux_sym_if_statement_repeat1] = STATE(743),
    [anon_sym_fi] = ACTIONS(2156),
    [anon_sym_elif] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1487),
    [sym_comment] = ACTIONS(54),
  },
  [743] = {
    [sym_elif_clause] = STATE(447),
    [aux_sym_if_statement_repeat1] = STATE(743),
    [anon_sym_fi] = ACTIONS(2158),
    [anon_sym_elif] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2158),
    [sym_comment] = ACTIONS(54),
  },
  [744] = {
    [anon_sym_PIPE] = ACTIONS(2163),
    [anon_sym_RPAREN] = ACTIONS(2163),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_LF] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2163),
  },
  [745] = {
    [aux_sym_case_item_repeat1] = STATE(1009),
    [aux_sym_concatenation_repeat1] = STATE(1010),
    [sym__concat] = ACTIONS(723),
    [anon_sym_PIPE] = ACTIONS(2165),
    [anon_sym_RPAREN] = ACTIONS(2167),
    [sym_comment] = ACTIONS(54),
  },
  [746] = {
    [anon_sym_esac] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2171),
    [sym_raw_string] = ACTIONS(2171),
    [anon_sym_DOLLAR] = ACTIONS(2169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2171),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2171),
    [anon_sym_BQUOTE] = ACTIONS(2171),
    [anon_sym_LT_LPAREN] = ACTIONS(2171),
    [anon_sym_GT_LPAREN] = ACTIONS(2171),
    [sym_word] = ACTIONS(2173),
    [sym_comment] = ACTIONS(54),
  },
  [747] = {
    [aux_sym_case_item_repeat1] = STATE(1009),
    [anon_sym_PIPE] = ACTIONS(2165),
    [anon_sym_RPAREN] = ACTIONS(2167),
    [sym_comment] = ACTIONS(54),
  },
  [748] = {
    [sym_case_item] = STATE(746),
    [sym_concatenation] = STATE(747),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [aux_sym_case_statement_repeat1] = STATE(1012),
    [anon_sym_esac] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(1493),
    [sym_comment] = ACTIONS(54),
  },
  [749] = {
    [sym_case_item] = STATE(746),
    [sym_concatenation] = STATE(747),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [aux_sym_case_statement_repeat1] = STATE(1013),
    [anon_sym_esac] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(1493),
    [sym_comment] = ACTIONS(54),
  },
  [750] = {
    [sym__concat] = ACTIONS(1680),
    [anon_sym_in] = ACTIONS(1682),
    [anon_sym_SEMI_SEMI] = ACTIONS(1682),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_LF] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
  },
  [751] = {
    [anon_sym_AT] = ACTIONS(2177),
    [sym_comment] = ACTIONS(54),
  },
  [752] = {
    [sym__concat] = ACTIONS(1686),
    [anon_sym_in] = ACTIONS(1688),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [753] = {
    [anon_sym_AT] = ACTIONS(2179),
    [sym_comment] = ACTIONS(54),
  },
  [754] = {
    [anon_sym_RBRACK] = ACTIONS(2181),
    [sym_comment] = ACTIONS(54),
  },
  [755] = {
    [sym__concat] = ACTIONS(1694),
    [anon_sym_in] = ACTIONS(1696),
    [anon_sym_SEMI_SEMI] = ACTIONS(1696),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_LF] = ACTIONS(1696),
    [anon_sym_AMP] = ACTIONS(1696),
  },
  [756] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(54),
  },
  [757] = {
    [anon_sym_RBRACE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(54),
  },
  [758] = {
    [anon_sym_RBRACK] = ACTIONS(2185),
    [sym_comment] = ACTIONS(54),
  },
  [759] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [sym_comment] = ACTIONS(54),
  },
  [760] = {
    [anon_sym_RBRACE] = ACTIONS(2187),
    [sym_comment] = ACTIONS(54),
  },
  [761] = {
    [sym_file_redirect] = STATE(1020),
    [sym_file_descriptor] = ACTIONS(592),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI_SEMI] = ACTIONS(2189),
    [anon_sym_PIPE_AMP] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_PIPE_PIPE] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_GT] = ACTIONS(596),
    [anon_sym_GT_GT] = ACTIONS(596),
    [anon_sym_AMP_GT] = ACTIONS(596),
    [anon_sym_AMP_GT_GT] = ACTIONS(596),
    [anon_sym_LT_AMP] = ACTIONS(596),
    [anon_sym_GT_AMP] = ACTIONS(596),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_LF] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
  },
  [762] = {
    [aux_sym_concatenation_repeat1] = STATE(1021),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(761),
    [sym_variable_name] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_RPAREN] = ACTIONS(462),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(462),
    [anon_sym_AMP_AMP] = ACTIONS(462),
    [anon_sym_PIPE_PIPE] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(462),
    [anon_sym_AMP_GT] = ACTIONS(462),
    [anon_sym_AMP_GT_GT] = ACTIONS(462),
    [anon_sym_LT_AMP] = ACTIONS(462),
    [anon_sym_GT_AMP] = ACTIONS(462),
    [anon_sym_DQUOTE] = ACTIONS(462),
    [sym_raw_string] = ACTIONS(462),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(462),
    [anon_sym_BQUOTE] = ACTIONS(462),
    [anon_sym_LT_LPAREN] = ACTIONS(462),
    [anon_sym_GT_LPAREN] = ACTIONS(462),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [763] = {
    [sym_compound_statement] = STATE(1022),
    [anon_sym_LBRACE] = ACTIONS(348),
    [sym_comment] = ACTIONS(54),
  },
  [764] = {
    [aux_sym_concatenation_repeat1] = STATE(1023),
    [sym__concat] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(739),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(739),
    [anon_sym_PIPE_AMP] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_AMP] = ACTIONS(739),
  },
  [765] = {
    [sym_file_redirect] = STATE(927),
    [sym_file_descriptor] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1522),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_SEMI_SEMI] = ACTIONS(1522),
    [anon_sym_PIPE_AMP] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1522),
    [anon_sym_LF] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1522),
  },
  [766] = {
    [sym_concatenation] = STATE(929),
    [sym_string] = STATE(1024),
    [sym_simple_expansion] = STATE(1024),
    [sym_expansion] = STATE(1024),
    [sym_command_substitution] = STATE(1024),
    [sym_process_substitution] = STATE(1024),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [sym_raw_string] = ACTIONS(2191),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_word] = ACTIONS(2193),
    [sym_comment] = ACTIONS(54),
  },
  [767] = {
    [aux_sym_concatenation_repeat1] = STATE(1023),
    [sym__concat] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [768] = {
    [aux_sym_concatenation_repeat1] = STATE(769),
    [sym_file_descriptor] = ACTIONS(717),
    [sym__concat] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1935),
    [anon_sym_RPAREN] = ACTIONS(1935),
    [anon_sym_SEMI_SEMI] = ACTIONS(1935),
    [anon_sym_PIPE_AMP] = ACTIONS(1935),
    [anon_sym_AMP_AMP] = ACTIONS(1935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_GT] = ACTIONS(1935),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT_GT] = ACTIONS(1935),
    [anon_sym_LT_AMP] = ACTIONS(1935),
    [anon_sym_GT_AMP] = ACTIONS(1935),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_LT_LT_DASH] = ACTIONS(1935),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1935),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
  },
  [769] = {
    [aux_sym_concatenation_repeat1] = STATE(1025),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_RPAREN] = ACTIONS(462),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(462),
    [anon_sym_AMP_AMP] = ACTIONS(462),
    [anon_sym_PIPE_PIPE] = ACTIONS(462),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(462),
    [anon_sym_GT_GT] = ACTIONS(462),
    [anon_sym_AMP_GT] = ACTIONS(462),
    [anon_sym_AMP_GT_GT] = ACTIONS(462),
    [anon_sym_LT_AMP] = ACTIONS(462),
    [anon_sym_GT_AMP] = ACTIONS(462),
    [anon_sym_LT_LT] = ACTIONS(462),
    [anon_sym_LT_LT_DASH] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [770] = {
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_RPAREN] = ACTIONS(2195),
    [anon_sym_SEMI_SEMI] = ACTIONS(2195),
    [anon_sym_PIPE_AMP] = ACTIONS(2195),
    [anon_sym_AMP_AMP] = ACTIONS(2195),
    [anon_sym_PIPE_PIPE] = ACTIONS(2195),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2195),
    [anon_sym_LF] = ACTIONS(2195),
    [anon_sym_AMP] = ACTIONS(2195),
  },
  [771] = {
    [sym_file_redirect] = STATE(150),
    [sym_heredoc_redirect] = STATE(150),
    [aux_sym_command_repeat2] = STATE(484),
    [sym_file_descriptor] = ACTIONS(366),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_RPAREN] = ACTIONS(1987),
    [anon_sym_SEMI_SEMI] = ACTIONS(1987),
    [anon_sym_PIPE_AMP] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(368),
    [anon_sym_GT_GT] = ACTIONS(368),
    [anon_sym_AMP_GT] = ACTIONS(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(368),
    [anon_sym_LT_AMP] = ACTIONS(368),
    [anon_sym_GT_AMP] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(248),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1987),
    [anon_sym_LF] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
  },
  [772] = {
    [sym__concat] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_RBRACK] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [sym_raw_string] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(2197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [anon_sym_LT_LPAREN] = ACTIONS(1680),
    [anon_sym_GT_LPAREN] = ACTIONS(1680),
    [sym_word] = ACTIONS(1682),
    [sym_comment] = ACTIONS(54),
  },
  [773] = {
    [anon_sym_AT] = ACTIONS(2199),
    [sym_comment] = ACTIONS(54),
  },
  [774] = {
    [sym__concat] = ACTIONS(1686),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [anon_sym_RBRACK] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_raw_string] = ACTIONS(1686),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1686),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [anon_sym_LT_LPAREN] = ACTIONS(1686),
    [anon_sym_GT_LPAREN] = ACTIONS(1686),
    [sym_word] = ACTIONS(1688),
    [sym_comment] = ACTIONS(54),
  },
  [775] = {
    [anon_sym_AT] = ACTIONS(2203),
    [sym_comment] = ACTIONS(54),
  },
  [776] = {
    [anon_sym_RBRACK] = ACTIONS(2205),
    [sym_comment] = ACTIONS(54),
  },
  [777] = {
    [sym__concat] = ACTIONS(1694),
    [anon_sym_RBRACE] = ACTIONS(1694),
    [anon_sym_RBRACK] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_raw_string] = ACTIONS(1694),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1694),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [anon_sym_LT_LPAREN] = ACTIONS(1694),
    [anon_sym_GT_LPAREN] = ACTIONS(1694),
    [sym_word] = ACTIONS(1696),
    [sym_comment] = ACTIONS(54),
  },
  [778] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(54),
  },
  [779] = {
    [anon_sym_RBRACE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(54),
  },
  [780] = {
    [anon_sym_RBRACK] = ACTIONS(2211),
    [sym_comment] = ACTIONS(54),
  },
  [781] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [sym_comment] = ACTIONS(54),
  },
  [782] = {
    [anon_sym_RBRACE] = ACTIONS(2213),
    [sym_comment] = ACTIONS(54),
  },
  [783] = {
    [sym__concat] = ACTIONS(1680),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [sym_raw_string] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(2197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [anon_sym_LT_LPAREN] = ACTIONS(1680),
    [anon_sym_GT_LPAREN] = ACTIONS(1680),
    [sym_word] = ACTIONS(1682),
    [sym_comment] = ACTIONS(54),
  },
  [784] = {
    [anon_sym_AT] = ACTIONS(2215),
    [sym_comment] = ACTIONS(54),
  },
  [785] = {
    [sym__concat] = ACTIONS(1686),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_raw_string] = ACTIONS(1686),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1686),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [anon_sym_LT_LPAREN] = ACTIONS(1686),
    [anon_sym_GT_LPAREN] = ACTIONS(1686),
    [sym_word] = ACTIONS(1688),
    [sym_comment] = ACTIONS(54),
  },
  [786] = {
    [anon_sym_AT] = ACTIONS(2217),
    [sym_comment] = ACTIONS(54),
  },
  [787] = {
    [anon_sym_RBRACK] = ACTIONS(2219),
    [sym_comment] = ACTIONS(54),
  },
  [788] = {
    [sym__concat] = ACTIONS(1694),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_raw_string] = ACTIONS(1694),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1694),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [anon_sym_LT_LPAREN] = ACTIONS(1694),
    [anon_sym_GT_LPAREN] = ACTIONS(1694),
    [sym_word] = ACTIONS(1696),
    [sym_comment] = ACTIONS(54),
  },
  [789] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [sym_comment] = ACTIONS(54),
  },
  [790] = {
    [anon_sym_RBRACE] = ACTIONS(2221),
    [sym_comment] = ACTIONS(54),
  },
  [791] = {
    [anon_sym_RBRACK] = ACTIONS(2223),
    [sym_comment] = ACTIONS(54),
  },
  [792] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [sym_comment] = ACTIONS(54),
  },
  [793] = {
    [anon_sym_RBRACE] = ACTIONS(2225),
    [sym_comment] = ACTIONS(54),
  },
  [794] = {
    [anon_sym_PIPE] = ACTIONS(1391),
    [anon_sym_RPAREN] = ACTIONS(1391),
    [anon_sym_SEMI_SEMI] = ACTIONS(1391),
    [anon_sym_PIPE_AMP] = ACTIONS(1391),
    [anon_sym_AMP_AMP] = ACTIONS(1391),
    [anon_sym_PIPE_PIPE] = ACTIONS(1391),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_LF] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1391),
  },
  [795] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(698),
    [anon_sym_RPAREN] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [796] = {
    [sym__concat] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI_SEMI] = ACTIONS(438),
    [anon_sym_PIPE_AMP] = ACTIONS(438),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_PIPE_PIPE] = ACTIONS(438),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_LF] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(438),
  },
  [797] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [798] = {
    [sym_string] = STATE(1040),
    [sym_simple_expansion] = STATE(1040),
    [sym_expansion] = STATE(1040),
    [sym_command_substitution] = STATE(1040),
    [sym_process_substitution] = STATE(1040),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [sym_raw_string] = ACTIONS(2231),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_word] = ACTIONS(2233),
    [sym_comment] = ACTIONS(54),
  },
  [799] = {
    [aux_sym_concatenation_repeat1] = STATE(1041),
    [sym__concat] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(462),
    [anon_sym_AMP_AMP] = ACTIONS(462),
    [anon_sym_PIPE_PIPE] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [800] = {
    [sym__concat] = ACTIONS(464),
    [anon_sym_PIPE] = ACTIONS(466),
    [anon_sym_RPAREN] = ACTIONS(466),
    [anon_sym_SEMI_SEMI] = ACTIONS(466),
    [anon_sym_PIPE_AMP] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(466),
  },
  [801] = {
    [sym__concat] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_RPAREN] = ACTIONS(470),
    [anon_sym_SEMI_SEMI] = ACTIONS(470),
    [anon_sym_PIPE_AMP] = ACTIONS(470),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_LF] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(470),
  },
  [802] = {
    [sym__concat] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(474),
    [anon_sym_RPAREN] = ACTIONS(474),
    [anon_sym_SEMI_SEMI] = ACTIONS(474),
    [anon_sym_PIPE_AMP] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_LF] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(474),
  },
  [803] = {
    [sym_special_variable_name] = STATE(1043),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [804] = {
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_EQ] = ACTIONS(2241),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_COLON_QMARK] = ACTIONS(2241),
    [anon_sym_COLON_DASH] = ACTIONS(2241),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [sym_comment] = ACTIONS(54),
  },
  [805] = {
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_EQ] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [anon_sym_COLON_QMARK] = ACTIONS(2249),
    [anon_sym_COLON_DASH] = ACTIONS(2249),
    [anon_sym_PERCENT] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2249),
    [sym_comment] = ACTIONS(54),
  },
  [806] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2253),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [807] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2253),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [808] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(2253),
    [sym_comment] = ACTIONS(54),
  },
  [809] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(2253),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [810] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2255),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [811] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2255),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [812] = {
    [sym_file_descriptor] = ACTIONS(1680),
    [sym__concat] = ACTIONS(1680),
    [sym_variable_name] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(1680),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(1680),
    [anon_sym_LT_AMP] = ACTIONS(1680),
    [anon_sym_GT_AMP] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [sym_raw_string] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(2197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [anon_sym_LT_LPAREN] = ACTIONS(1680),
    [anon_sym_GT_LPAREN] = ACTIONS(1680),
    [sym_word] = ACTIONS(2197),
    [sym_comment] = ACTIONS(54),
  },
  [813] = {
    [anon_sym_AT] = ACTIONS(2257),
    [sym_comment] = ACTIONS(54),
  },
  [814] = {
    [sym_file_descriptor] = ACTIONS(1686),
    [sym__concat] = ACTIONS(1686),
    [sym_variable_name] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_GT_GT] = ACTIONS(1686),
    [anon_sym_AMP_GT] = ACTIONS(2201),
    [anon_sym_AMP_GT_GT] = ACTIONS(1686),
    [anon_sym_LT_AMP] = ACTIONS(1686),
    [anon_sym_GT_AMP] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_raw_string] = ACTIONS(1686),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1686),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [anon_sym_LT_LPAREN] = ACTIONS(1686),
    [anon_sym_GT_LPAREN] = ACTIONS(1686),
    [sym_word] = ACTIONS(2201),
    [sym_comment] = ACTIONS(54),
  },
  [815] = {
    [anon_sym_AT] = ACTIONS(2259),
    [sym_comment] = ACTIONS(54),
  },
  [816] = {
    [anon_sym_RBRACK] = ACTIONS(2261),
    [sym_comment] = ACTIONS(54),
  },
  [817] = {
    [sym_file_descriptor] = ACTIONS(1694),
    [sym__concat] = ACTIONS(1694),
    [sym_variable_name] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_AMP_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT_GT] = ACTIONS(1694),
    [anon_sym_LT_AMP] = ACTIONS(1694),
    [anon_sym_GT_AMP] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_raw_string] = ACTIONS(1694),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1694),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [anon_sym_LT_LPAREN] = ACTIONS(1694),
    [anon_sym_GT_LPAREN] = ACTIONS(1694),
    [sym_word] = ACTIONS(2207),
    [sym_comment] = ACTIONS(54),
  },
  [818] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [sym_comment] = ACTIONS(54),
  },
  [819] = {
    [anon_sym_RBRACE] = ACTIONS(2263),
    [sym_comment] = ACTIONS(54),
  },
  [820] = {
    [anon_sym_RBRACK] = ACTIONS(2265),
    [sym_comment] = ACTIONS(54),
  },
  [821] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [sym_comment] = ACTIONS(54),
  },
  [822] = {
    [anon_sym_RBRACE] = ACTIONS(2267),
    [sym_comment] = ACTIONS(54),
  },
  [823] = {
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2197),
    [anon_sym_DOLLAR] = ACTIONS(1682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(156),
  },
  [824] = {
    [anon_sym_AT] = ACTIONS(2269),
    [sym_comment] = ACTIONS(54),
  },
  [825] = {
    [anon_sym_DQUOTE] = ACTIONS(1688),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2201),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1688),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(156),
  },
  [826] = {
    [anon_sym_AT] = ACTIONS(2271),
    [sym_comment] = ACTIONS(54),
  },
  [827] = {
    [anon_sym_RBRACK] = ACTIONS(2273),
    [sym_comment] = ACTIONS(54),
  },
  [828] = {
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2207),
    [anon_sym_DOLLAR] = ACTIONS(1696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1696),
    [anon_sym_BQUOTE] = ACTIONS(1696),
    [sym_comment] = ACTIONS(156),
  },
  [829] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2275),
    [sym_comment] = ACTIONS(54),
  },
  [830] = {
    [anon_sym_RBRACE] = ACTIONS(2275),
    [sym_comment] = ACTIONS(54),
  },
  [831] = {
    [anon_sym_RBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(54),
  },
  [832] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2279),
    [sym_comment] = ACTIONS(54),
  },
  [833] = {
    [anon_sym_RBRACE] = ACTIONS(2279),
    [sym_comment] = ACTIONS(54),
  },
  [834] = {
    [anon_sym_RBRACK] = ACTIONS(2281),
    [sym_comment] = ACTIONS(54),
  },
  [835] = {
    [anon_sym_RBRACK] = ACTIONS(2283),
    [sym_comment] = ACTIONS(54),
  },
  [836] = {
    [anon_sym_RBRACE] = ACTIONS(2285),
    [sym_comment] = ACTIONS(54),
  },
  [837] = {
    [sym_file_descriptor] = ACTIONS(2287),
    [sym__concat] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2289),
    [anon_sym_RPAREN] = ACTIONS(2289),
    [anon_sym_SEMI_SEMI] = ACTIONS(2289),
    [anon_sym_PIPE_AMP] = ACTIONS(2289),
    [anon_sym_AMP_AMP] = ACTIONS(2289),
    [anon_sym_PIPE_PIPE] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(2289),
    [anon_sym_GT] = ACTIONS(2289),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_AMP_GT] = ACTIONS(2289),
    [anon_sym_AMP_GT_GT] = ACTIONS(2289),
    [anon_sym_LT_AMP] = ACTIONS(2289),
    [anon_sym_GT_AMP] = ACTIONS(2289),
    [anon_sym_LT_LT] = ACTIONS(2289),
    [anon_sym_LT_LT_DASH] = ACTIONS(2289),
    [anon_sym_DQUOTE] = ACTIONS(2289),
    [sym_raw_string] = ACTIONS(2289),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2289),
    [anon_sym_BQUOTE] = ACTIONS(2289),
    [anon_sym_LT_LPAREN] = ACTIONS(2289),
    [anon_sym_GT_LPAREN] = ACTIONS(2289),
    [sym_word] = ACTIONS(2289),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_LF] = ACTIONS(2289),
    [anon_sym_AMP] = ACTIONS(2289),
  },
  [838] = {
    [aux_sym_concatenation_repeat1] = STATE(1067),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(460),
    [sym_comment] = ACTIONS(54),
  },
  [839] = {
    [anon_sym_RBRACE] = ACTIONS(2291),
    [sym_comment] = ACTIONS(54),
  },
  [840] = {
    [sym_file_descriptor] = ACTIONS(2293),
    [sym__concat] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_RPAREN] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_AMP_GT] = ACTIONS(2295),
    [anon_sym_AMP_GT_GT] = ACTIONS(2295),
    [anon_sym_LT_AMP] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_LT_LT_DASH] = ACTIONS(2295),
    [anon_sym_DQUOTE] = ACTIONS(2295),
    [sym_raw_string] = ACTIONS(2295),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(2295),
    [anon_sym_LT_LPAREN] = ACTIONS(2295),
    [anon_sym_GT_LPAREN] = ACTIONS(2295),
    [sym_word] = ACTIONS(2295),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LF] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
  },
  [841] = {
    [sym_file_descriptor] = ACTIONS(1389),
    [sym_variable_name] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_RPAREN] = ACTIONS(1389),
    [anon_sym_PIPE_AMP] = ACTIONS(1389),
    [anon_sym_AMP_AMP] = ACTIONS(1389),
    [anon_sym_PIPE_PIPE] = ACTIONS(2297),
    [anon_sym_LT] = ACTIONS(2297),
    [anon_sym_GT] = ACTIONS(2297),
    [anon_sym_GT_GT] = ACTIONS(1389),
    [anon_sym_AMP_GT] = ACTIONS(2297),
    [anon_sym_AMP_GT_GT] = ACTIONS(1389),
    [anon_sym_LT_AMP] = ACTIONS(1389),
    [anon_sym_GT_AMP] = ACTIONS(1389),
    [anon_sym_DQUOTE] = ACTIONS(1389),
    [sym_raw_string] = ACTIONS(1389),
    [anon_sym_DOLLAR] = ACTIONS(2297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1389),
    [anon_sym_BQUOTE] = ACTIONS(1389),
    [anon_sym_LT_LPAREN] = ACTIONS(1389),
    [anon_sym_GT_LPAREN] = ACTIONS(1389),
    [sym_word] = ACTIONS(1391),
    [sym_comment] = ACTIONS(54),
  },
  [842] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(698),
    [anon_sym_RPAREN] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [843] = {
    [sym_file_descriptor] = ACTIONS(436),
    [sym__concat] = ACTIONS(436),
    [sym_variable_name] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_RPAREN] = ACTIONS(436),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(436),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(436),
    [anon_sym_AMP_GT] = ACTIONS(865),
    [anon_sym_AMP_GT_GT] = ACTIONS(436),
    [anon_sym_LT_AMP] = ACTIONS(436),
    [anon_sym_GT_AMP] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(436),
    [sym_raw_string] = ACTIONS(436),
    [anon_sym_DOLLAR] = ACTIONS(865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(436),
    [anon_sym_BQUOTE] = ACTIONS(436),
    [anon_sym_LT_LPAREN] = ACTIONS(436),
    [anon_sym_GT_LPAREN] = ACTIONS(436),
    [sym_word] = ACTIONS(438),
    [sym_comment] = ACTIONS(54),
  },
  [844] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(2301),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [845] = {
    [sym_string] = STATE(1071),
    [sym_simple_expansion] = STATE(1071),
    [sym_expansion] = STATE(1071),
    [sym_command_substitution] = STATE(1071),
    [sym_process_substitution] = STATE(1071),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [sym_raw_string] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1121),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LT_LPAREN] = ACTIONS(1125),
    [anon_sym_GT_LPAREN] = ACTIONS(1125),
    [sym_word] = ACTIONS(2305),
    [sym_comment] = ACTIONS(54),
  },
  [846] = {
    [aux_sym_concatenation_repeat1] = STATE(1072),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(1710),
    [sym_variable_name] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(460),
    [anon_sym_PIPE_AMP] = ACTIONS(460),
    [anon_sym_AMP_AMP] = ACTIONS(460),
    [anon_sym_PIPE_PIPE] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(460),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(460),
    [anon_sym_LT_AMP] = ACTIONS(460),
    [anon_sym_GT_AMP] = ACTIONS(460),
    [anon_sym_DQUOTE] = ACTIONS(460),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [anon_sym_LT_LPAREN] = ACTIONS(460),
    [anon_sym_GT_LPAREN] = ACTIONS(460),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(54),
  },
  [847] = {
    [sym_file_descriptor] = ACTIONS(464),
    [sym__concat] = ACTIONS(464),
    [sym_variable_name] = ACTIONS(464),
    [anon_sym_PIPE] = ACTIONS(476),
    [anon_sym_RPAREN] = ACTIONS(464),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(464),
    [anon_sym_PIPE_PIPE] = ACTIONS(476),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_AMP_GT] = ACTIONS(476),
    [anon_sym_AMP_GT_GT] = ACTIONS(464),
    [anon_sym_LT_AMP] = ACTIONS(464),
    [anon_sym_GT_AMP] = ACTIONS(464),
    [anon_sym_DQUOTE] = ACTIONS(464),
    [sym_raw_string] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(464),
    [anon_sym_BQUOTE] = ACTIONS(464),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_word] = ACTIONS(466),
    [sym_comment] = ACTIONS(54),
  },
  [848] = {
    [sym_file_descriptor] = ACTIONS(468),
    [sym__concat] = ACTIONS(468),
    [sym_variable_name] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_PIPE_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(468),
    [anon_sym_AMP_GT] = ACTIONS(875),
    [anon_sym_AMP_GT_GT] = ACTIONS(468),
    [anon_sym_LT_AMP] = ACTIONS(468),
    [anon_sym_GT_AMP] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(468),
    [sym_raw_string] = ACTIONS(468),
    [anon_sym_DOLLAR] = ACTIONS(875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(468),
    [anon_sym_BQUOTE] = ACTIONS(468),
    [anon_sym_LT_LPAREN] = ACTIONS(468),
    [anon_sym_GT_LPAREN] = ACTIONS(468),
    [sym_word] = ACTIONS(470),
    [sym_comment] = ACTIONS(54),
  },
  [849] = {
    [sym_file_descriptor] = ACTIONS(472),
    [sym__concat] = ACTIONS(472),
    [sym_variable_name] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_PIPE_AMP] = ACTIONS(472),
    [anon_sym_AMP_AMP] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(472),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(472),
    [anon_sym_LT_AMP] = ACTIONS(472),
    [anon_sym_GT_AMP] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(472),
    [sym_raw_string] = ACTIONS(472),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_LT_LPAREN] = ACTIONS(472),
    [anon_sym_GT_LPAREN] = ACTIONS(472),
    [sym_word] = ACTIONS(474),
    [sym_comment] = ACTIONS(54),
  },
  [850] = {
    [sym_special_variable_name] = STATE(1074),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [851] = {
    [anon_sym_RBRACE] = ACTIONS(2309),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_EQ] = ACTIONS(2313),
    [anon_sym_COLON] = ACTIONS(2315),
    [anon_sym_COLON_QMARK] = ACTIONS(2313),
    [anon_sym_COLON_DASH] = ACTIONS(2313),
    [anon_sym_PERCENT] = ACTIONS(2313),
    [anon_sym_SLASH] = ACTIONS(2313),
    [sym_comment] = ACTIONS(54),
  },
  [852] = {
    [anon_sym_RBRACE] = ACTIONS(2317),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_EQ] = ACTIONS(2321),
    [anon_sym_COLON] = ACTIONS(2323),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_DASH] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [sym_comment] = ACTIONS(54),
  },
  [853] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2325),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [854] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2325),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [855] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(2325),
    [sym_comment] = ACTIONS(54),
  },
  [856] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(2325),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [857] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2327),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [858] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2327),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [859] = {
    [sym_concatenation] = STATE(435),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_for_statement_repeat1] = STATE(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(2329),
    [anon_sym_DQUOTE] = ACTIONS(1453),
    [sym_raw_string] = ACTIONS(1455),
    [anon_sym_DOLLAR] = ACTIONS(1457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1461),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1465),
    [anon_sym_GT_LPAREN] = ACTIONS(1465),
    [sym_word] = ACTIONS(1455),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2329),
    [anon_sym_LF] = ACTIONS(2329),
    [anon_sym_AMP] = ACTIONS(2329),
  },
  [860] = {
    [anon_sym_PIPE] = ACTIONS(2331),
    [anon_sym_RPAREN] = ACTIONS(2333),
    [anon_sym_PIPE_AMP] = ACTIONS(2333),
    [anon_sym_AMP_AMP] = ACTIONS(2333),
    [anon_sym_PIPE_PIPE] = ACTIONS(2333),
    [anon_sym_BQUOTE] = ACTIONS(2333),
    [sym_comment] = ACTIONS(54),
  },
  [861] = {
    [sym__terminated_statement] = STATE(438),
    [sym_for_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_function_definition] = STATE(439),
    [sym_subshell] = STATE(439),
    [sym_pipeline] = STATE(439),
    [sym_list] = STATE(439),
    [sym_bracket_command] = STATE(439),
    [sym_command] = STATE(439),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(440),
    [sym_local_variable_declaration] = STATE(439),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(732),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(2335),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [862] = {
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_RPAREN] = ACTIONS(2339),
    [anon_sym_PIPE_AMP] = ACTIONS(2339),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(54),
  },
  [863] = {
    [anon_sym_fi] = ACTIONS(2341),
    [sym_comment] = ACTIONS(54),
  },
  [864] = {
    [sym__terminated_statement] = STATE(445),
    [sym_for_statement] = STATE(446),
    [sym_while_statement] = STATE(446),
    [sym_if_statement] = STATE(446),
    [sym_elif_clause] = STATE(447),
    [sym_else_clause] = STATE(1086),
    [sym_case_statement] = STATE(446),
    [sym_function_definition] = STATE(446),
    [sym_subshell] = STATE(446),
    [sym_pipeline] = STATE(446),
    [sym_list] = STATE(446),
    [sym_bracket_command] = STATE(446),
    [sym_command] = STATE(446),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(449),
    [sym_local_variable_declaration] = STATE(446),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(741),
    [aux_sym_if_statement_repeat1] = STATE(1087),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2343),
    [anon_sym_elif] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [865] = {
    [sym_elif_clause] = STATE(447),
    [sym_else_clause] = STATE(1086),
    [aux_sym_if_statement_repeat1] = STATE(743),
    [anon_sym_fi] = ACTIONS(2341),
    [anon_sym_elif] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1487),
    [sym_comment] = ACTIONS(54),
  },
  [866] = {
    [sym_case_item] = STATE(746),
    [sym_concatenation] = STATE(747),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [aux_sym_case_statement_repeat1] = STATE(1089),
    [anon_sym_esac] = ACTIONS(2345),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(1493),
    [sym_comment] = ACTIONS(54),
  },
  [867] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2347),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_LF] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2347),
  },
  [868] = {
    [sym_compound_statement] = STATE(1091),
    [anon_sym_LBRACE] = ACTIONS(526),
    [sym_comment] = ACTIONS(54),
  },
  [869] = {
    [anon_sym_PIPE] = ACTIONS(2349),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [sym_comment] = ACTIONS(54),
  },
  [870] = {
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_RPAREN] = ACTIONS(2355),
    [anon_sym_PIPE_AMP] = ACTIONS(2355),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_PIPE_PIPE] = ACTIONS(2355),
    [anon_sym_BQUOTE] = ACTIONS(2355),
    [sym_comment] = ACTIONS(54),
  },
  [871] = {
    [sym_file_descriptor] = ACTIONS(598),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_RPAREN] = ACTIONS(2357),
    [anon_sym_function] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(600),
    [anon_sym_local] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_AMP_GT] = ACTIONS(600),
    [anon_sym_AMP_GT_GT] = ACTIONS(598),
    [anon_sym_LT_AMP] = ACTIONS(598),
    [anon_sym_GT_AMP] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_word] = ACTIONS(602),
    [sym_comment] = ACTIONS(54),
  },
  [872] = {
    [anon_sym_PIPE] = ACTIONS(1704),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [sym_comment] = ACTIONS(54),
  },
  [873] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(1094),
    [anon_sym_RPAREN] = ACTIONS(2359),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [874] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(1096),
    [anon_sym_DQUOTE] = ACTIONS(2361),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [875] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym__concat] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(1704),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym_comment] = ACTIONS(54),
  },
  [876] = {
    [sym_special_variable_name] = STATE(1101),
    [anon_sym_DOLLAR] = ACTIONS(2365),
    [anon_sym_POUND] = ACTIONS(2365),
    [anon_sym_AT] = ACTIONS(2365),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_QMARK] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2365),
    [anon_sym_0] = ACTIONS(2369),
    [anon_sym__] = ACTIONS(2369),
  },
  [877] = {
    [sym_special_variable_name] = STATE(1104),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(2371),
    [anon_sym_AT] = ACTIONS(170),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [878] = {
    [sym_for_statement] = STATE(1105),
    [sym_while_statement] = STATE(1105),
    [sym_if_statement] = STATE(1105),
    [sym_case_statement] = STATE(1105),
    [sym_function_definition] = STATE(1105),
    [sym_subshell] = STATE(1105),
    [sym_pipeline] = STATE(1105),
    [sym_list] = STATE(1105),
    [sym_bracket_command] = STATE(1105),
    [sym_command] = STATE(1105),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(1106),
    [sym_local_variable_declaration] = STATE(1105),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [879] = {
    [sym_for_statement] = STATE(1107),
    [sym_while_statement] = STATE(1107),
    [sym_if_statement] = STATE(1107),
    [sym_case_statement] = STATE(1107),
    [sym_function_definition] = STATE(1107),
    [sym_subshell] = STATE(1107),
    [sym_pipeline] = STATE(1107),
    [sym_list] = STATE(1107),
    [sym_bracket_command] = STATE(1107),
    [sym_command] = STATE(1107),
    [sym_command_name] = STATE(134),
    [sym_environment_variable_assignment] = STATE(1108),
    [sym_local_variable_declaration] = STATE(1107),
    [sym_subscript] = STATE(136),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [aux_sym_command_repeat1] = STATE(137),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(214),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(216),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(218),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(222),
    [sym_comment] = ACTIONS(54),
  },
  [880] = {
    [sym_for_statement] = STATE(1109),
    [sym_while_statement] = STATE(1109),
    [sym_if_statement] = STATE(1109),
    [sym_case_statement] = STATE(1109),
    [sym_function_definition] = STATE(1109),
    [sym_subshell] = STATE(1109),
    [sym_pipeline] = STATE(1109),
    [sym_list] = STATE(1109),
    [sym_bracket_command] = STATE(1109),
    [sym_command] = STATE(1109),
    [sym_command_name] = STATE(123),
    [sym_environment_variable_assignment] = STATE(1110),
    [sym_local_variable_declaration] = STATE(1109),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(115),
    [sym_simple_expansion] = STATE(115),
    [sym_expansion] = STATE(115),
    [sym_command_substitution] = STATE(115),
    [sym_process_substitution] = STATE(115),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(182),
    [anon_sym_if] = ACTIONS(184),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(194),
    [anon_sym_local] = ACTIONS(196),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(206),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(54),
  },
  [881] = {
    [sym_file_descriptor] = ACTIONS(1680),
    [sym__concat] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [anon_sym_PIPE_AMP] = ACTIONS(1680),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_PIPE_PIPE] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(1680),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(1680),
    [anon_sym_LT_AMP] = ACTIONS(1680),
    [anon_sym_GT_AMP] = ACTIONS(1680),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [sym_raw_string] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(2197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [anon_sym_LT_LPAREN] = ACTIONS(1680),
    [anon_sym_GT_LPAREN] = ACTIONS(1680),
    [sym_word] = ACTIONS(1682),
    [sym_comment] = ACTIONS(54),
  },
  [882] = {
    [anon_sym_AT] = ACTIONS(2375),
    [sym_comment] = ACTIONS(54),
  },
  [883] = {
    [sym_file_descriptor] = ACTIONS(1686),
    [sym__concat] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_PIPE_AMP] = ACTIONS(1686),
    [anon_sym_AMP_AMP] = ACTIONS(1686),
    [anon_sym_PIPE_PIPE] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_GT_GT] = ACTIONS(1686),
    [anon_sym_AMP_GT] = ACTIONS(2201),
    [anon_sym_AMP_GT_GT] = ACTIONS(1686),
    [anon_sym_LT_AMP] = ACTIONS(1686),
    [anon_sym_GT_AMP] = ACTIONS(1686),
    [anon_sym_LT_LT] = ACTIONS(2201),
    [anon_sym_LT_LT_DASH] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_raw_string] = ACTIONS(1686),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1686),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [anon_sym_LT_LPAREN] = ACTIONS(1686),
    [anon_sym_GT_LPAREN] = ACTIONS(1686),
    [sym_word] = ACTIONS(1688),
    [sym_comment] = ACTIONS(54),
  },
  [884] = {
    [anon_sym_AT] = ACTIONS(2377),
    [sym_comment] = ACTIONS(54),
  },
  [885] = {
    [anon_sym_RBRACK] = ACTIONS(2379),
    [sym_comment] = ACTIONS(54),
  },
  [886] = {
    [sym_file_descriptor] = ACTIONS(1694),
    [sym__concat] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(1694),
    [anon_sym_PIPE_AMP] = ACTIONS(1694),
    [anon_sym_AMP_AMP] = ACTIONS(1694),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_AMP_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT_GT] = ACTIONS(1694),
    [anon_sym_LT_AMP] = ACTIONS(1694),
    [anon_sym_GT_AMP] = ACTIONS(1694),
    [anon_sym_LT_LT] = ACTIONS(2207),
    [anon_sym_LT_LT_DASH] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_raw_string] = ACTIONS(1694),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1694),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [anon_sym_LT_LPAREN] = ACTIONS(1694),
    [anon_sym_GT_LPAREN] = ACTIONS(1694),
    [sym_word] = ACTIONS(1696),
    [sym_comment] = ACTIONS(54),
  },
  [887] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2381),
    [sym_comment] = ACTIONS(54),
  },
  [888] = {
    [anon_sym_RBRACE] = ACTIONS(2381),
    [sym_comment] = ACTIONS(54),
  },
  [889] = {
    [anon_sym_RBRACK] = ACTIONS(2383),
    [sym_comment] = ACTIONS(54),
  },
  [890] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2385),
    [sym_comment] = ACTIONS(54),
  },
  [891] = {
    [anon_sym_RBRACE] = ACTIONS(2385),
    [sym_comment] = ACTIONS(54),
  },
  [892] = {
    [sym_file_redirect] = STATE(1117),
    [sym_file_descriptor] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(2349),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_GT_GT] = ACTIONS(1195),
    [anon_sym_AMP_GT] = ACTIONS(1193),
    [anon_sym_AMP_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_AMP] = ACTIONS(1195),
    [anon_sym_GT_AMP] = ACTIONS(1195),
    [sym_comment] = ACTIONS(54),
  },
  [893] = {
    [sym_file_descriptor] = ACTIONS(1927),
    [anon_sym_PIPE] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(1927),
    [anon_sym_PIPE_AMP] = ACTIONS(1927),
    [anon_sym_AMP_AMP] = ACTIONS(1927),
    [anon_sym_PIPE_PIPE] = ACTIONS(1927),
    [anon_sym_LT] = ACTIONS(2387),
    [anon_sym_GT] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(1927),
    [anon_sym_AMP_GT] = ACTIONS(2387),
    [anon_sym_AMP_GT_GT] = ACTIONS(1927),
    [anon_sym_LT_AMP] = ACTIONS(1927),
    [anon_sym_GT_AMP] = ACTIONS(1927),
    [anon_sym_BQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(54),
  },
  [894] = {
    [sym_concatenation] = STATE(1119),
    [sym_string] = STATE(1118),
    [sym_simple_expansion] = STATE(1118),
    [sym_expansion] = STATE(1118),
    [sym_command_substitution] = STATE(1118),
    [sym_process_substitution] = STATE(1118),
    [anon_sym_DQUOTE] = ACTIONS(1758),
    [sym_raw_string] = ACTIONS(2389),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [anon_sym_LT_LPAREN] = ACTIONS(1770),
    [anon_sym_GT_LPAREN] = ACTIONS(1770),
    [sym_word] = ACTIONS(2391),
    [sym_comment] = ACTIONS(54),
  },
  [895] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym__concat] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [sym_comment] = ACTIONS(54),
  },
  [896] = {
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [sym_comment] = ACTIONS(54),
  },
  [897] = {
    [aux_sym_concatenation_repeat1] = STATE(902),
    [sym_file_descriptor] = ACTIONS(717),
    [sym__concat] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_PIPE_AMP] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_AMP_GT] = ACTIONS(719),
    [anon_sym_AMP_GT_GT] = ACTIONS(717),
    [anon_sym_LT_AMP] = ACTIONS(717),
    [anon_sym_GT_AMP] = ACTIONS(717),
    [anon_sym_LT_LT] = ACTIONS(719),
    [anon_sym_LT_LT_DASH] = ACTIONS(717),
    [sym_comment] = ACTIONS(54),
  },
  [898] = {
    [sym_file_descriptor] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_PIPE_AMP] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_AMP_GT] = ACTIONS(719),
    [anon_sym_AMP_GT_GT] = ACTIONS(717),
    [anon_sym_LT_AMP] = ACTIONS(717),
    [anon_sym_GT_AMP] = ACTIONS(717),
    [anon_sym_LT_LT] = ACTIONS(719),
    [anon_sym_LT_LT_DASH] = ACTIONS(717),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_comment] = ACTIONS(54),
  },
  [899] = {
    [sym_file_descriptor] = ACTIONS(436),
    [sym__concat] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_RPAREN] = ACTIONS(436),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(436),
    [anon_sym_PIPE_PIPE] = ACTIONS(436),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_GT_GT] = ACTIONS(436),
    [anon_sym_AMP_GT] = ACTIONS(865),
    [anon_sym_AMP_GT_GT] = ACTIONS(436),
    [anon_sym_LT_AMP] = ACTIONS(436),
    [anon_sym_GT_AMP] = ACTIONS(436),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_LT_LT_DASH] = ACTIONS(436),
    [anon_sym_BQUOTE] = ACTIONS(436),
    [sym_comment] = ACTIONS(54),
  },
  [900] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(2393),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [901] = {
    [sym_string] = STATE(1121),
    [sym_simple_expansion] = STATE(1121),
    [sym_expansion] = STATE(1121),
    [sym_command_substitution] = STATE(1121),
    [sym_process_substitution] = STATE(1121),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [sym_raw_string] = ACTIONS(2395),
    [anon_sym_DOLLAR] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1213),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [anon_sym_LT_LPAREN] = ACTIONS(1217),
    [anon_sym_GT_LPAREN] = ACTIONS(1217),
    [sym_word] = ACTIONS(2397),
    [sym_comment] = ACTIONS(54),
  },
  [902] = {
    [aux_sym_concatenation_repeat1] = STATE(1122),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(460),
    [anon_sym_PIPE_AMP] = ACTIONS(460),
    [anon_sym_AMP_AMP] = ACTIONS(460),
    [anon_sym_PIPE_PIPE] = ACTIONS(460),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(460),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(460),
    [anon_sym_LT_AMP] = ACTIONS(460),
    [anon_sym_GT_AMP] = ACTIONS(460),
    [anon_sym_LT_LT] = ACTIONS(873),
    [anon_sym_LT_LT_DASH] = ACTIONS(460),
    [sym_comment] = ACTIONS(54),
  },
  [903] = {
    [sym_file_descriptor] = ACTIONS(464),
    [sym__concat] = ACTIONS(464),
    [anon_sym_PIPE] = ACTIONS(476),
    [anon_sym_RPAREN] = ACTIONS(464),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(464),
    [anon_sym_PIPE_PIPE] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_AMP_GT] = ACTIONS(476),
    [anon_sym_AMP_GT_GT] = ACTIONS(464),
    [anon_sym_LT_AMP] = ACTIONS(464),
    [anon_sym_GT_AMP] = ACTIONS(464),
    [anon_sym_LT_LT] = ACTIONS(476),
    [anon_sym_LT_LT_DASH] = ACTIONS(464),
    [anon_sym_BQUOTE] = ACTIONS(464),
    [sym_comment] = ACTIONS(54),
  },
  [904] = {
    [sym_file_descriptor] = ACTIONS(468),
    [sym__concat] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_PIPE_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_PIPE_PIPE] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(468),
    [anon_sym_AMP_GT] = ACTIONS(875),
    [anon_sym_AMP_GT_GT] = ACTIONS(468),
    [anon_sym_LT_AMP] = ACTIONS(468),
    [anon_sym_GT_AMP] = ACTIONS(468),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_LT_LT_DASH] = ACTIONS(468),
    [anon_sym_BQUOTE] = ACTIONS(468),
    [sym_comment] = ACTIONS(54),
  },
  [905] = {
    [sym_file_descriptor] = ACTIONS(472),
    [sym__concat] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_PIPE_AMP] = ACTIONS(472),
    [anon_sym_AMP_AMP] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(472),
    [anon_sym_AMP_GT] = ACTIONS(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(472),
    [anon_sym_LT_AMP] = ACTIONS(472),
    [anon_sym_GT_AMP] = ACTIONS(472),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [sym_comment] = ACTIONS(54),
  },
  [906] = {
    [sym_special_variable_name] = STATE(1124),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(2399),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [907] = {
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_EQ] = ACTIONS(2405),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2405),
    [anon_sym_COLON_DASH] = ACTIONS(2405),
    [anon_sym_PERCENT] = ACTIONS(2405),
    [anon_sym_SLASH] = ACTIONS(2405),
    [sym_comment] = ACTIONS(54),
  },
  [908] = {
    [anon_sym_RBRACE] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2415),
    [anon_sym_COLON_QMARK] = ACTIONS(2413),
    [anon_sym_COLON_DASH] = ACTIONS(2413),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [sym_comment] = ACTIONS(54),
  },
  [909] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2417),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [910] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2417),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [911] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(2417),
    [sym_comment] = ACTIONS(54),
  },
  [912] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(2417),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [913] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2419),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [914] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2419),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [915] = {
    [sym_file_descriptor] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(2421),
    [anon_sym_RPAREN] = ACTIONS(1969),
    [anon_sym_PIPE_AMP] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(2421),
    [anon_sym_GT] = ACTIONS(2421),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_AMP_GT] = ACTIONS(2421),
    [anon_sym_AMP_GT_GT] = ACTIONS(1969),
    [anon_sym_LT_AMP] = ACTIONS(1969),
    [anon_sym_GT_AMP] = ACTIONS(1969),
    [anon_sym_LT_LT] = ACTIONS(2421),
    [anon_sym_LT_LT_DASH] = ACTIONS(1969),
    [anon_sym_BQUOTE] = ACTIONS(1969),
    [sym_comment] = ACTIONS(54),
  },
  [916] = {
    [sym_simple_expansion] = STATE(659),
    [sym_expansion] = STATE(659),
    [aux_sym_heredoc_repeat1] = STATE(950),
    [sym__heredoc_middle] = ACTIONS(1301),
    [sym__heredoc_end] = ACTIONS(2423),
    [anon_sym_DOLLAR] = ACTIONS(1305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1307),
    [sym_comment] = ACTIONS(54),
  },
  [917] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [aux_sym_command_repeat2] = STATE(616),
    [sym_file_descriptor] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(2425),
    [anon_sym_RPAREN] = ACTIONS(2427),
    [anon_sym_PIPE_AMP] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(542),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [sym_comment] = ACTIONS(54),
  },
  [918] = {
    [aux_sym_concatenation_repeat1] = STATE(1134),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(1710),
    [sym_variable_name] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_PIPE_AMP] = ACTIONS(460),
    [anon_sym_AMP_AMP] = ACTIONS(460),
    [anon_sym_PIPE_PIPE] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(460),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(460),
    [anon_sym_LT_AMP] = ACTIONS(460),
    [anon_sym_GT_AMP] = ACTIONS(460),
    [anon_sym_DQUOTE] = ACTIONS(460),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [anon_sym_LT_LPAREN] = ACTIONS(460),
    [anon_sym_GT_LPAREN] = ACTIONS(460),
    [sym_word] = ACTIONS(462),
    [sym_comment] = ACTIONS(54),
  },
  [919] = {
    [sym_compound_statement] = STATE(1135),
    [anon_sym_LBRACE] = ACTIONS(526),
    [sym_comment] = ACTIONS(54),
  },
  [920] = {
    [aux_sym_concatenation_repeat1] = STATE(1136),
    [sym__concat] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(1704),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [sym_comment] = ACTIONS(54),
  },
  [921] = {
    [sym_file_redirect] = STATE(1117),
    [sym_file_descriptor] = ACTIONS(1241),
    [anon_sym_PIPE] = ACTIONS(2349),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_AMP_GT] = ACTIONS(1243),
    [anon_sym_AMP_GT_GT] = ACTIONS(1245),
    [anon_sym_LT_AMP] = ACTIONS(1245),
    [anon_sym_GT_AMP] = ACTIONS(1245),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [sym_comment] = ACTIONS(54),
  },
  [922] = {
    [sym_concatenation] = STATE(1119),
    [sym_string] = STATE(1137),
    [sym_simple_expansion] = STATE(1137),
    [sym_expansion] = STATE(1137),
    [sym_command_substitution] = STATE(1137),
    [sym_process_substitution] = STATE(1137),
    [anon_sym_DQUOTE] = ACTIONS(1758),
    [sym_raw_string] = ACTIONS(2429),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [anon_sym_LT_LPAREN] = ACTIONS(1770),
    [anon_sym_GT_LPAREN] = ACTIONS(1770),
    [sym_word] = ACTIONS(2431),
    [sym_comment] = ACTIONS(54),
  },
  [923] = {
    [aux_sym_concatenation_repeat1] = STATE(1136),
    [sym__concat] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(424),
    [anon_sym_PIPE_AMP] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [sym_comment] = ACTIONS(54),
  },
  [924] = {
    [aux_sym_concatenation_repeat1] = STATE(925),
    [sym_file_descriptor] = ACTIONS(717),
    [sym__concat] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(719),
    [anon_sym_PIPE_AMP] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_AMP_GT] = ACTIONS(719),
    [anon_sym_AMP_GT_GT] = ACTIONS(717),
    [anon_sym_LT_AMP] = ACTIONS(717),
    [anon_sym_GT_AMP] = ACTIONS(717),
    [anon_sym_LT_LT] = ACTIONS(719),
    [anon_sym_LT_LT_DASH] = ACTIONS(717),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_comment] = ACTIONS(54),
  },
  [925] = {
    [aux_sym_concatenation_repeat1] = STATE(1138),
    [sym_file_descriptor] = ACTIONS(460),
    [sym__concat] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_PIPE_AMP] = ACTIONS(460),
    [anon_sym_AMP_AMP] = ACTIONS(460),
    [anon_sym_PIPE_PIPE] = ACTIONS(460),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(460),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(460),
    [anon_sym_LT_AMP] = ACTIONS(460),
    [anon_sym_GT_AMP] = ACTIONS(460),
    [anon_sym_LT_LT] = ACTIONS(873),
    [anon_sym_LT_LT_DASH] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [sym_comment] = ACTIONS(54),
  },
  [926] = {
    [sym_file_redirect] = STATE(337),
    [sym_heredoc_redirect] = STATE(337),
    [aux_sym_command_repeat2] = STATE(633),
    [sym_file_descriptor] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(2425),
    [anon_sym_PIPE_AMP] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(546),
    [anon_sym_LT_LT_DASH] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(2427),
    [sym_comment] = ACTIONS(54),
  },
  [927] = {
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_RPAREN] = ACTIONS(2189),
    [anon_sym_SEMI_SEMI] = ACTIONS(2189),
    [anon_sym_PIPE_AMP] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_PIPE_PIPE] = ACTIONS(2189),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_LF] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
  },
  [928] = {
    [aux_sym_concatenation_repeat1] = STATE(799),
    [sym__concat] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1935),
    [anon_sym_SEMI_SEMI] = ACTIONS(1935),
    [anon_sym_PIPE_AMP] = ACTIONS(1935),
    [anon_sym_AMP_AMP] = ACTIONS(1935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1935),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1935),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
  },
  [929] = {
    [anon_sym_PIPE] = ACTIONS(1935),
    [anon_sym_RPAREN] = ACTIONS(1935),
    [anon_sym_SEMI_SEMI] = ACTIONS(1935),
    [anon_sym_PIPE_AMP] = ACTIONS(1935),
    [anon_sym_AMP_AMP] = ACTIONS(1935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1935),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1935),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
  },
  [930] = {
    [sym_file_descriptor] = ACTIONS(1051),
    [sym__concat] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [931] = {
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(1074),
    [anon_sym_LT_AMP] = ACTIONS(1074),
    [anon_sym_GT_AMP] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_LT_LT_DASH] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [932] = {
    [aux_sym_concatenation_repeat1] = STATE(932),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(2433),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(1074),
    [anon_sym_LT_AMP] = ACTIONS(1074),
    [anon_sym_GT_AMP] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_LT_LT_DASH] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [933] = {
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [sym_comment] = ACTIONS(54),
  },
  [934] = {
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [sym_comment] = ACTIONS(54),
  },
  [935] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [936] = {
    [anon_sym_AT] = ACTIONS(2444),
    [sym_comment] = ACTIONS(54),
  },
  [937] = {
    [sym_concatenation] = STATE(1146),
    [sym_string] = STATE(1145),
    [sym_simple_expansion] = STATE(1145),
    [sym_expansion] = STATE(1145),
    [sym_command_substitution] = STATE(1145),
    [sym_process_substitution] = STATE(1145),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2448),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2450),
    [sym_comment] = ACTIONS(54),
  },
  [938] = {
    [sym_file_descriptor] = ACTIONS(1099),
    [sym__concat] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
  },
  [939] = {
    [anon_sym_AT] = ACTIONS(2452),
    [sym_comment] = ACTIONS(54),
  },
  [940] = {
    [sym_concatenation] = STATE(1149),
    [sym_string] = STATE(1148),
    [sym_simple_expansion] = STATE(1148),
    [sym_expansion] = STATE(1148),
    [sym_command_substitution] = STATE(1148),
    [sym_process_substitution] = STATE(1148),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2456),
    [sym_comment] = ACTIONS(54),
  },
  [941] = {
    [sym_file_descriptor] = ACTIONS(1197),
    [sym__concat] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [anon_sym_PIPE_AMP] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_AMP] = ACTIONS(1199),
    [anon_sym_GT_AMP] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_LT_LT_DASH] = ACTIONS(1199),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [942] = {
    [sym_file_descriptor] = ACTIONS(1255),
    [sym__concat] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [943] = {
    [sym__heredoc_middle] = ACTIONS(464),
    [sym__heredoc_end] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(464),
    [sym_comment] = ACTIONS(54),
  },
  [944] = {
    [sym__heredoc_middle] = ACTIONS(468),
    [sym__heredoc_end] = ACTIONS(468),
    [anon_sym_DOLLAR] = ACTIONS(875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(468),
    [sym_comment] = ACTIONS(54),
  },
  [945] = {
    [sym__heredoc_middle] = ACTIONS(472),
    [sym__heredoc_end] = ACTIONS(472),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(472),
    [sym_comment] = ACTIONS(54),
  },
  [946] = {
    [sym_special_variable_name] = STATE(1151),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [947] = {
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2464),
    [anon_sym_COLON_DASH] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2464),
    [sym_comment] = ACTIONS(54),
  },
  [948] = {
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2472),
    [anon_sym_COLON_DASH] = ACTIONS(2472),
    [anon_sym_PERCENT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2472),
    [sym_comment] = ACTIONS(54),
  },
  [949] = {
    [sym_file_descriptor] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_SEMI_SEMI] = ACTIONS(2478),
    [anon_sym_PIPE_AMP] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_AMP_GT] = ACTIONS(2478),
    [anon_sym_AMP_GT_GT] = ACTIONS(2478),
    [anon_sym_LT_AMP] = ACTIONS(2478),
    [anon_sym_GT_AMP] = ACTIONS(2478),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_LT_LT_DASH] = ACTIONS(2478),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_LF] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2478),
  },
  [950] = {
    [sym_simple_expansion] = STATE(659),
    [sym_expansion] = STATE(659),
    [aux_sym_heredoc_repeat1] = STATE(950),
    [sym__heredoc_middle] = ACTIONS(2480),
    [sym__heredoc_end] = ACTIONS(2483),
    [anon_sym_DOLLAR] = ACTIONS(2485),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(54),
  },
  [951] = {
    [sym_file_descriptor] = ACTIONS(1389),
    [sym_variable_name] = ACTIONS(1389),
    [anon_sym_LT] = ACTIONS(2297),
    [anon_sym_GT] = ACTIONS(2297),
    [anon_sym_GT_GT] = ACTIONS(1389),
    [anon_sym_AMP_GT] = ACTIONS(2297),
    [anon_sym_AMP_GT_GT] = ACTIONS(1389),
    [anon_sym_LT_AMP] = ACTIONS(1389),
    [anon_sym_GT_AMP] = ACTIONS(1389),
    [anon_sym_DQUOTE] = ACTIONS(1389),
    [sym_raw_string] = ACTIONS(1389),
    [anon_sym_DOLLAR] = ACTIONS(2297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1389),
    [anon_sym_BQUOTE] = ACTIONS(1389),
    [anon_sym_LT_LPAREN] = ACTIONS(1389),
    [anon_sym_GT_LPAREN] = ACTIONS(1389),
    [sym_word] = ACTIONS(2297),
    [sym_comment] = ACTIONS(54),
  },
  [952] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(698),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [953] = {
    [sym__concat] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1680),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [anon_sym_RBRACK] = ACTIONS(1680),
    [sym_comment] = ACTIONS(54),
  },
  [954] = {
    [anon_sym_AT] = ACTIONS(2493),
    [sym_comment] = ACTIONS(54),
  },
  [955] = {
    [sym__concat] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(1686),
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_RBRACK] = ACTIONS(1686),
    [sym_comment] = ACTIONS(54),
  },
  [956] = {
    [anon_sym_AT] = ACTIONS(2495),
    [sym_comment] = ACTIONS(54),
  },
  [957] = {
    [anon_sym_RBRACK] = ACTIONS(2497),
    [sym_comment] = ACTIONS(54),
  },
  [958] = {
    [sym__concat] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_RPAREN] = ACTIONS(1694),
    [anon_sym_RBRACK] = ACTIONS(1694),
    [sym_comment] = ACTIONS(54),
  },
  [959] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2499),
    [sym_comment] = ACTIONS(54),
  },
  [960] = {
    [anon_sym_RBRACE] = ACTIONS(2499),
    [sym_comment] = ACTIONS(54),
  },
  [961] = {
    [anon_sym_RBRACK] = ACTIONS(2501),
    [sym_comment] = ACTIONS(54),
  },
  [962] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [sym_comment] = ACTIONS(54),
  },
  [963] = {
    [anon_sym_RBRACE] = ACTIONS(2503),
    [sym_comment] = ACTIONS(54),
  },
  [964] = {
    [sym__concat] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_word] = ACTIONS(1555),
    [sym_comment] = ACTIONS(54),
  },
  [965] = {
    [sym__concat] = ACTIONS(1072),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1557),
    [sym_comment] = ACTIONS(54),
  },
  [966] = {
    [aux_sym_concatenation_repeat1] = STATE(966),
    [sym__concat] = ACTIONS(2505),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1557),
    [sym_comment] = ACTIONS(54),
  },
  [967] = {
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [sym_comment] = ACTIONS(54),
  },
  [968] = {
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [sym_comment] = ACTIONS(54),
  },
  [969] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_word] = ACTIONS(1570),
    [sym_comment] = ACTIONS(54),
  },
  [970] = {
    [anon_sym_AT] = ACTIONS(2516),
    [sym_comment] = ACTIONS(54),
  },
  [971] = {
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(1171),
    [sym_simple_expansion] = STATE(1171),
    [sym_expansion] = STATE(1171),
    [sym_command_substitution] = STATE(1171),
    [sym_process_substitution] = STATE(1171),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2522),
    [sym_comment] = ACTIONS(54),
  },
  [972] = {
    [sym__concat] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_word] = ACTIONS(1580),
    [sym_comment] = ACTIONS(54),
  },
  [973] = {
    [anon_sym_AT] = ACTIONS(2524),
    [sym_comment] = ACTIONS(54),
  },
  [974] = {
    [sym_concatenation] = STATE(1175),
    [sym_string] = STATE(1174),
    [sym_simple_expansion] = STATE(1174),
    [sym_expansion] = STATE(1174),
    [sym_command_substitution] = STATE(1174),
    [sym_process_substitution] = STATE(1174),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2526),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2528),
    [sym_comment] = ACTIONS(54),
  },
  [975] = {
    [sym__concat] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR] = ACTIONS(1588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1197),
    [anon_sym_BQUOTE] = ACTIONS(1197),
    [anon_sym_LT_LPAREN] = ACTIONS(1197),
    [anon_sym_GT_LPAREN] = ACTIONS(1197),
    [sym_word] = ACTIONS(1588),
    [sym_comment] = ACTIONS(54),
  },
  [976] = {
    [sym__concat] = ACTIONS(1255),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1255),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [anon_sym_LT_LPAREN] = ACTIONS(1255),
    [anon_sym_GT_LPAREN] = ACTIONS(1255),
    [sym_word] = ACTIONS(1590),
    [sym_comment] = ACTIONS(54),
  },
  [977] = {
    [sym_file_descriptor] = ACTIONS(1680),
    [sym__concat] = ACTIONS(1680),
    [sym_variable_name] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_SEMI_SEMI] = ACTIONS(1682),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(1682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_word] = ACTIONS(1682),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_LF] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
  },
  [978] = {
    [anon_sym_AT] = ACTIONS(2530),
    [sym_comment] = ACTIONS(54),
  },
  [979] = {
    [sym_file_descriptor] = ACTIONS(1686),
    [sym__concat] = ACTIONS(1686),
    [sym_variable_name] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(1688),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(1688),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(1688),
    [anon_sym_GT_GT] = ACTIONS(1688),
    [anon_sym_AMP_GT] = ACTIONS(1688),
    [anon_sym_AMP_GT_GT] = ACTIONS(1688),
    [anon_sym_LT_AMP] = ACTIONS(1688),
    [anon_sym_GT_AMP] = ACTIONS(1688),
    [anon_sym_DQUOTE] = ACTIONS(1688),
    [sym_raw_string] = ACTIONS(1688),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1688),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [anon_sym_LT_LPAREN] = ACTIONS(1688),
    [anon_sym_GT_LPAREN] = ACTIONS(1688),
    [sym_word] = ACTIONS(1688),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [980] = {
    [anon_sym_AT] = ACTIONS(2532),
    [sym_comment] = ACTIONS(54),
  },
  [981] = {
    [anon_sym_RBRACK] = ACTIONS(2534),
    [sym_comment] = ACTIONS(54),
  },
  [982] = {
    [sym_file_descriptor] = ACTIONS(1694),
    [sym__concat] = ACTIONS(1694),
    [sym_variable_name] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(1696),
    [anon_sym_RPAREN] = ACTIONS(1696),
    [anon_sym_SEMI_SEMI] = ACTIONS(1696),
    [anon_sym_PIPE_AMP] = ACTIONS(1696),
    [anon_sym_AMP_AMP] = ACTIONS(1696),
    [anon_sym_PIPE_PIPE] = ACTIONS(1696),
    [anon_sym_LT] = ACTIONS(1696),
    [anon_sym_GT] = ACTIONS(1696),
    [anon_sym_GT_GT] = ACTIONS(1696),
    [anon_sym_AMP_GT] = ACTIONS(1696),
    [anon_sym_AMP_GT_GT] = ACTIONS(1696),
    [anon_sym_LT_AMP] = ACTIONS(1696),
    [anon_sym_GT_AMP] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [sym_raw_string] = ACTIONS(1696),
    [anon_sym_DOLLAR] = ACTIONS(1696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1696),
    [anon_sym_BQUOTE] = ACTIONS(1696),
    [anon_sym_LT_LPAREN] = ACTIONS(1696),
    [anon_sym_GT_LPAREN] = ACTIONS(1696),
    [sym_word] = ACTIONS(1696),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_LF] = ACTIONS(1696),
    [anon_sym_AMP] = ACTIONS(1696),
  },
  [983] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(54),
  },
  [984] = {
    [anon_sym_RBRACE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(54),
  },
  [985] = {
    [anon_sym_RBRACK] = ACTIONS(2538),
    [sym_comment] = ACTIONS(54),
  },
  [986] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [sym_comment] = ACTIONS(54),
  },
  [987] = {
    [anon_sym_RBRACE] = ACTIONS(2540),
    [sym_comment] = ACTIONS(54),
  },
  [988] = {
    [sym__concat] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [989] = {
    [sym__concat] = ACTIONS(1072),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_raw_string] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LPAREN] = ACTIONS(1074),
    [anon_sym_GT_LPAREN] = ACTIONS(1074),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [990] = {
    [aux_sym_concatenation_repeat1] = STATE(990),
    [sym__concat] = ACTIONS(2542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_raw_string] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LPAREN] = ACTIONS(1074),
    [anon_sym_GT_LPAREN] = ACTIONS(1074),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [991] = {
    [anon_sym_RBRACE] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [sym_comment] = ACTIONS(54),
  },
  [992] = {
    [anon_sym_RBRACE] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [sym_comment] = ACTIONS(54),
  },
  [993] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_word] = ACTIONS(1089),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [994] = {
    [anon_sym_AT] = ACTIONS(2553),
    [sym_comment] = ACTIONS(54),
  },
  [995] = {
    [sym_concatenation] = STATE(1189),
    [sym_string] = STATE(1188),
    [sym_simple_expansion] = STATE(1188),
    [sym_expansion] = STATE(1188),
    [sym_command_substitution] = STATE(1188),
    [sym_process_substitution] = STATE(1188),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2557),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2559),
    [sym_comment] = ACTIONS(54),
  },
  [996] = {
    [sym__concat] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
  },
  [997] = {
    [anon_sym_AT] = ACTIONS(2561),
    [sym_comment] = ACTIONS(54),
  },
  [998] = {
    [sym_concatenation] = STATE(1192),
    [sym_string] = STATE(1191),
    [sym_simple_expansion] = STATE(1191),
    [sym_expansion] = STATE(1191),
    [sym_command_substitution] = STATE(1191),
    [sym_process_substitution] = STATE(1191),
    [anon_sym_RBRACE] = ACTIONS(2549),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2563),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2565),
    [sym_comment] = ACTIONS(54),
  },
  [999] = {
    [sym__concat] = ACTIONS(1197),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [sym_raw_string] = ACTIONS(1199),
    [anon_sym_DOLLAR] = ACTIONS(1199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1199),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [anon_sym_LT_LPAREN] = ACTIONS(1199),
    [anon_sym_GT_LPAREN] = ACTIONS(1199),
    [sym_word] = ACTIONS(1199),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [1000] = {
    [sym__concat] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_word] = ACTIONS(1257),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [1001] = {
    [anon_sym_PIPE] = ACTIONS(2567),
    [anon_sym_RPAREN] = ACTIONS(2567),
    [anon_sym_SEMI_SEMI] = ACTIONS(2567),
    [anon_sym_PIPE_AMP] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2567),
    [anon_sym_LF] = ACTIONS(2567),
    [anon_sym_AMP] = ACTIONS(2567),
  },
  [1002] = {
    [sym__terminated_statement] = STATE(445),
    [sym_for_statement] = STATE(446),
    [sym_while_statement] = STATE(446),
    [sym_if_statement] = STATE(446),
    [sym_case_statement] = STATE(446),
    [sym_function_definition] = STATE(446),
    [sym_subshell] = STATE(446),
    [sym_pipeline] = STATE(446),
    [sym_list] = STATE(446),
    [sym_bracket_command] = STATE(446),
    [sym_command] = STATE(446),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(449),
    [sym_local_variable_declaration] = STATE(446),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(1193),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2569),
    [anon_sym_elif] = ACTIONS(2569),
    [anon_sym_else] = ACTIONS(2569),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [1003] = {
    [sym_file_descriptor] = ACTIONS(598),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_fi] = ACTIONS(600),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_function] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(600),
    [anon_sym_local] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_AMP_GT] = ACTIONS(600),
    [anon_sym_AMP_GT_GT] = ACTIONS(598),
    [anon_sym_LT_AMP] = ACTIONS(598),
    [anon_sym_GT_AMP] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_word] = ACTIONS(602),
    [sym_comment] = ACTIONS(54),
  },
  [1004] = {
    [sym__terminated_statement] = STATE(734),
    [sym_for_statement] = STATE(735),
    [sym_while_statement] = STATE(735),
    [sym_if_statement] = STATE(735),
    [sym_case_statement] = STATE(735),
    [sym_function_definition] = STATE(735),
    [sym_subshell] = STATE(735),
    [sym_pipeline] = STATE(735),
    [sym_list] = STATE(735),
    [sym_bracket_command] = STATE(735),
    [sym_command] = STATE(735),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(736),
    [sym_local_variable_declaration] = STATE(735),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(1004),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(634),
    [sym_variable_name] = ACTIONS(637),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_fi] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(663),
    [anon_sym_local] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(672),
    [anon_sym_LT_AMP] = ACTIONS(672),
    [anon_sym_GT_AMP] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(678),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_word] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
  },
  [1005] = {
    [anon_sym_PIPE] = ACTIONS(2571),
    [anon_sym_RPAREN] = ACTIONS(2571),
    [anon_sym_SEMI_SEMI] = ACTIONS(2571),
    [anon_sym_PIPE_AMP] = ACTIONS(2571),
    [anon_sym_AMP_AMP] = ACTIONS(2571),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_LF] = ACTIONS(2571),
    [anon_sym_AMP] = ACTIONS(2571),
  },
  [1006] = {
    [anon_sym_fi] = ACTIONS(2573),
    [sym_comment] = ACTIONS(54),
  },
  [1007] = {
    [sym_concatenation] = STATE(1196),
    [sym_string] = STATE(1195),
    [sym_simple_expansion] = STATE(1195),
    [sym_expansion] = STATE(1195),
    [sym_command_substitution] = STATE(1195),
    [sym_process_substitution] = STATE(1195),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(2575),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(2577),
    [sym_comment] = ACTIONS(54),
  },
  [1008] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(1198),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(2579),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [1009] = {
    [aux_sym_case_item_repeat1] = STATE(1200),
    [anon_sym_PIPE] = ACTIONS(2165),
    [anon_sym_RPAREN] = ACTIONS(2581),
    [sym_comment] = ACTIONS(54),
  },
  [1010] = {
    [aux_sym_concatenation_repeat1] = STATE(1201),
    [sym__concat] = ACTIONS(723),
    [anon_sym_PIPE] = ACTIONS(460),
    [anon_sym_RPAREN] = ACTIONS(460),
    [sym_comment] = ACTIONS(54),
  },
  [1011] = {
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
  },
  [1012] = {
    [sym_case_item] = STATE(746),
    [sym_concatenation] = STATE(747),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [aux_sym_case_statement_repeat1] = STATE(1012),
    [anon_sym_esac] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(2587),
    [sym_raw_string] = ACTIONS(2590),
    [anon_sym_DOLLAR] = ACTIONS(2593),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2596),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2599),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2605),
    [anon_sym_GT_LPAREN] = ACTIONS(2605),
    [sym_word] = ACTIONS(2608),
    [sym_comment] = ACTIONS(54),
  },
  [1013] = {
    [sym_case_item] = STATE(746),
    [sym_concatenation] = STATE(747),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [aux_sym_case_statement_repeat1] = STATE(1012),
    [anon_sym_esac] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(1493),
    [sym_comment] = ACTIONS(54),
  },
  [1014] = {
    [anon_sym_RBRACK] = ACTIONS(2613),
    [sym_comment] = ACTIONS(54),
  },
  [1015] = {
    [anon_sym_RBRACK] = ACTIONS(2615),
    [sym_comment] = ACTIONS(54),
  },
  [1016] = {
    [anon_sym_RBRACE] = ACTIONS(2617),
    [sym_comment] = ACTIONS(54),
  },
  [1017] = {
    [sym__concat] = ACTIONS(2287),
    [anon_sym_in] = ACTIONS(2289),
    [anon_sym_SEMI_SEMI] = ACTIONS(2289),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_LF] = ACTIONS(2289),
    [anon_sym_AMP] = ACTIONS(2289),
  },
  [1018] = {
    [anon_sym_RBRACE] = ACTIONS(2619),
    [sym_comment] = ACTIONS(54),
  },
  [1019] = {
    [sym__concat] = ACTIONS(2293),
    [anon_sym_in] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LF] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
  },
  [1020] = {
    [anon_sym_PIPE] = ACTIONS(2621),
    [anon_sym_RPAREN] = ACTIONS(2621),
    [anon_sym_SEMI_SEMI] = ACTIONS(2621),
    [anon_sym_PIPE_AMP] = ACTIONS(2621),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE_PIPE] = ACTIONS(2621),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym_LF] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
  },
  [1021] = {
    [aux_sym_concatenation_repeat1] = STATE(1021),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(2070),
    [sym_variable_name] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(1074),
    [anon_sym_LT_AMP] = ACTIONS(1074),
    [anon_sym_GT_AMP] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_raw_string] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1074),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LPAREN] = ACTIONS(1074),
    [anon_sym_GT_LPAREN] = ACTIONS(1074),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [1022] = {
    [sym_file_redirect] = STATE(1020),
    [sym_file_descriptor] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_RPAREN] = ACTIONS(2189),
    [anon_sym_SEMI_SEMI] = ACTIONS(2189),
    [anon_sym_PIPE_AMP] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_PIPE_PIPE] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_LF] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
  },
  [1023] = {
    [aux_sym_concatenation_repeat1] = STATE(1207),
    [sym__concat] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_RPAREN] = ACTIONS(462),
    [anon_sym_SEMI_SEMI] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(462),
    [anon_sym_AMP_AMP] = ACTIONS(462),
    [anon_sym_PIPE_PIPE] = ACTIONS(462),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_LF] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(462),
  },
  [1024] = {
    [aux_sym_concatenation_repeat1] = STATE(1023),
    [sym__concat] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1935),
    [anon_sym_RPAREN] = ACTIONS(1935),
    [anon_sym_SEMI_SEMI] = ACTIONS(1935),
    [anon_sym_PIPE_AMP] = ACTIONS(1935),
    [anon_sym_AMP_AMP] = ACTIONS(1935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1935),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1935),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
  },
  [1025] = {
    [aux_sym_concatenation_repeat1] = STATE(1025),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(2433),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT] = ACTIONS(1074),
    [anon_sym_AMP_GT_GT] = ACTIONS(1074),
    [anon_sym_LT_AMP] = ACTIONS(1074),
    [anon_sym_GT_AMP] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_LT_LT_DASH] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [1026] = {
    [anon_sym_RBRACK] = ACTIONS(2623),
    [sym_comment] = ACTIONS(54),
  },
  [1027] = {
    [anon_sym_RBRACK] = ACTIONS(2625),
    [sym_comment] = ACTIONS(54),
  },
  [1028] = {
    [anon_sym_RBRACE] = ACTIONS(2627),
    [sym_comment] = ACTIONS(54),
  },
  [1029] = {
    [sym__concat] = ACTIONS(2287),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_RBRACK] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_raw_string] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [anon_sym_LT_LPAREN] = ACTIONS(2287),
    [anon_sym_GT_LPAREN] = ACTIONS(2287),
    [sym_word] = ACTIONS(2289),
    [sym_comment] = ACTIONS(54),
  },
  [1030] = {
    [anon_sym_RBRACE] = ACTIONS(2631),
    [sym_comment] = ACTIONS(54),
  },
  [1031] = {
    [sym__concat] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2293),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [anon_sym_LT_LPAREN] = ACTIONS(2293),
    [anon_sym_GT_LPAREN] = ACTIONS(2293),
    [sym_word] = ACTIONS(2295),
    [sym_comment] = ACTIONS(54),
  },
  [1032] = {
    [anon_sym_RBRACK] = ACTIONS(2635),
    [sym_comment] = ACTIONS(54),
  },
  [1033] = {
    [anon_sym_RBRACK] = ACTIONS(2637),
    [sym_comment] = ACTIONS(54),
  },
  [1034] = {
    [anon_sym_RBRACE] = ACTIONS(2639),
    [sym_comment] = ACTIONS(54),
  },
  [1035] = {
    [sym__concat] = ACTIONS(2287),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_raw_string] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [anon_sym_LT_LPAREN] = ACTIONS(2287),
    [anon_sym_GT_LPAREN] = ACTIONS(2287),
    [sym_word] = ACTIONS(2289),
    [sym_comment] = ACTIONS(54),
  },
  [1036] = {
    [anon_sym_RBRACE] = ACTIONS(2641),
    [sym_comment] = ACTIONS(54),
  },
  [1037] = {
    [sym__concat] = ACTIONS(2293),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2293),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [anon_sym_LT_LPAREN] = ACTIONS(2293),
    [anon_sym_GT_LPAREN] = ACTIONS(2293),
    [sym_word] = ACTIONS(2295),
    [sym_comment] = ACTIONS(54),
  },
  [1038] = {
    [anon_sym_PIPE] = ACTIONS(2044),
    [anon_sym_RPAREN] = ACTIONS(2044),
    [anon_sym_SEMI_SEMI] = ACTIONS(2044),
    [anon_sym_PIPE_AMP] = ACTIONS(2044),
    [anon_sym_AMP_AMP] = ACTIONS(2044),
    [anon_sym_PIPE_PIPE] = ACTIONS(2044),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym_LF] = ACTIONS(2044),
    [anon_sym_AMP] = ACTIONS(2044),
  },
  [1039] = {
    [sym__concat] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1040] = {
    [sym__concat] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [1041] = {
    [aux_sym_concatenation_repeat1] = STATE(1041),
    [sym__concat] = ACTIONS(2643),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [1042] = {
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [sym_comment] = ACTIONS(54),
  },
  [1043] = {
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [sym_comment] = ACTIONS(54),
  },
  [1044] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [1045] = {
    [anon_sym_AT] = ACTIONS(2654),
    [sym_comment] = ACTIONS(54),
  },
  [1046] = {
    [sym_concatenation] = STATE(1223),
    [sym_string] = STATE(1222),
    [sym_simple_expansion] = STATE(1222),
    [sym_expansion] = STATE(1222),
    [sym_command_substitution] = STATE(1222),
    [sym_process_substitution] = STATE(1222),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2660),
    [sym_comment] = ACTIONS(54),
  },
  [1047] = {
    [sym__concat] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
  },
  [1048] = {
    [anon_sym_AT] = ACTIONS(2662),
    [sym_comment] = ACTIONS(54),
  },
  [1049] = {
    [sym_concatenation] = STATE(1226),
    [sym_string] = STATE(1225),
    [sym_simple_expansion] = STATE(1225),
    [sym_expansion] = STATE(1225),
    [sym_command_substitution] = STATE(1225),
    [sym_process_substitution] = STATE(1225),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2666),
    [sym_comment] = ACTIONS(54),
  },
  [1050] = {
    [sym__concat] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_SEMI_SEMI] = ACTIONS(1199),
    [anon_sym_PIPE_AMP] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LF] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
  },
  [1051] = {
    [sym__concat] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_LF] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [1052] = {
    [anon_sym_RBRACK] = ACTIONS(2668),
    [sym_comment] = ACTIONS(54),
  },
  [1053] = {
    [anon_sym_RBRACK] = ACTIONS(2670),
    [sym_comment] = ACTIONS(54),
  },
  [1054] = {
    [anon_sym_RBRACE] = ACTIONS(2672),
    [sym_comment] = ACTIONS(54),
  },
  [1055] = {
    [sym_file_descriptor] = ACTIONS(2287),
    [sym__concat] = ACTIONS(2287),
    [sym_variable_name] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_AMP_GT] = ACTIONS(2629),
    [anon_sym_AMP_GT_GT] = ACTIONS(2287),
    [anon_sym_LT_AMP] = ACTIONS(2287),
    [anon_sym_GT_AMP] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_raw_string] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [anon_sym_LT_LPAREN] = ACTIONS(2287),
    [anon_sym_GT_LPAREN] = ACTIONS(2287),
    [sym_word] = ACTIONS(2629),
    [sym_comment] = ACTIONS(54),
  },
  [1056] = {
    [anon_sym_RBRACE] = ACTIONS(2674),
    [sym_comment] = ACTIONS(54),
  },
  [1057] = {
    [sym_file_descriptor] = ACTIONS(2293),
    [sym__concat] = ACTIONS(2293),
    [sym_variable_name] = ACTIONS(2293),
    [anon_sym_LT] = ACTIONS(2633),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_AMP_GT] = ACTIONS(2633),
    [anon_sym_AMP_GT_GT] = ACTIONS(2293),
    [anon_sym_LT_AMP] = ACTIONS(2293),
    [anon_sym_GT_AMP] = ACTIONS(2293),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2293),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [anon_sym_LT_LPAREN] = ACTIONS(2293),
    [anon_sym_GT_LPAREN] = ACTIONS(2293),
    [sym_word] = ACTIONS(2633),
    [sym_comment] = ACTIONS(54),
  },
  [1058] = {
    [anon_sym_RBRACK] = ACTIONS(2676),
    [sym_comment] = ACTIONS(54),
  },
  [1059] = {
    [anon_sym_RBRACK] = ACTIONS(2678),
    [sym_comment] = ACTIONS(54),
  },
  [1060] = {
    [anon_sym_RBRACE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(54),
  },
  [1061] = {
    [anon_sym_DQUOTE] = ACTIONS(2289),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2289),
    [anon_sym_BQUOTE] = ACTIONS(2289),
    [sym_comment] = ACTIONS(156),
  },
  [1062] = {
    [anon_sym_RBRACE] = ACTIONS(2682),
    [sym_comment] = ACTIONS(54),
  },
  [1063] = {
    [anon_sym_DQUOTE] = ACTIONS(2295),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2633),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(2295),
    [sym_comment] = ACTIONS(156),
  },
  [1064] = {
    [anon_sym_RBRACE] = ACTIONS(2684),
    [sym_comment] = ACTIONS(54),
  },
  [1065] = {
    [anon_sym_RBRACE] = ACTIONS(2686),
    [sym_comment] = ACTIONS(54),
  },
  [1066] = {
    [sym_file_descriptor] = ACTIONS(2688),
    [sym__concat] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2690),
    [anon_sym_RPAREN] = ACTIONS(2690),
    [anon_sym_SEMI_SEMI] = ACTIONS(2690),
    [anon_sym_PIPE_AMP] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_GT] = ACTIONS(2690),
    [anon_sym_GT_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT_GT] = ACTIONS(2690),
    [anon_sym_LT_AMP] = ACTIONS(2690),
    [anon_sym_GT_AMP] = ACTIONS(2690),
    [anon_sym_LT_LT] = ACTIONS(2690),
    [anon_sym_LT_LT_DASH] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [sym_raw_string] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2690),
    [anon_sym_BQUOTE] = ACTIONS(2690),
    [anon_sym_LT_LPAREN] = ACTIONS(2690),
    [anon_sym_GT_LPAREN] = ACTIONS(2690),
    [sym_word] = ACTIONS(2690),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_LF] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2690),
  },
  [1067] = {
    [aux_sym_concatenation_repeat1] = STATE(1067),
    [sym__concat] = ACTIONS(1559),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [1068] = {
    [sym_file_descriptor] = ACTIONS(2692),
    [sym__concat] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_RPAREN] = ACTIONS(2694),
    [anon_sym_SEMI_SEMI] = ACTIONS(2694),
    [anon_sym_PIPE_AMP] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_PIPE_PIPE] = ACTIONS(2694),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2694),
    [anon_sym_AMP_GT] = ACTIONS(2694),
    [anon_sym_AMP_GT_GT] = ACTIONS(2694),
    [anon_sym_LT_AMP] = ACTIONS(2694),
    [anon_sym_GT_AMP] = ACTIONS(2694),
    [anon_sym_LT_LT] = ACTIONS(2694),
    [anon_sym_LT_LT_DASH] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [sym_raw_string] = ACTIONS(2694),
    [anon_sym_DOLLAR] = ACTIONS(2694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2694),
    [anon_sym_BQUOTE] = ACTIONS(2694),
    [anon_sym_LT_LPAREN] = ACTIONS(2694),
    [anon_sym_GT_LPAREN] = ACTIONS(2694),
    [sym_word] = ACTIONS(2694),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_LF] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2694),
  },
  [1069] = {
    [sym_file_descriptor] = ACTIONS(2042),
    [sym_variable_name] = ACTIONS(2042),
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_RPAREN] = ACTIONS(2042),
    [anon_sym_PIPE_AMP] = ACTIONS(2042),
    [anon_sym_AMP_AMP] = ACTIONS(2042),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_LT] = ACTIONS(2696),
    [anon_sym_GT] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2042),
    [anon_sym_AMP_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT_GT] = ACTIONS(2042),
    [anon_sym_LT_AMP] = ACTIONS(2042),
    [anon_sym_GT_AMP] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(2042),
    [sym_raw_string] = ACTIONS(2042),
    [anon_sym_DOLLAR] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2042),
    [anon_sym_BQUOTE] = ACTIONS(2042),
    [anon_sym_LT_LPAREN] = ACTIONS(2042),
    [anon_sym_GT_LPAREN] = ACTIONS(2042),
    [sym_word] = ACTIONS(2044),
    [sym_comment] = ACTIONS(54),
  },
  [1070] = {
    [sym_file_descriptor] = ACTIONS(1051),
    [sym__concat] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(54),
  },
  [1071] = {
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1072),
    [sym_variable_name] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1557),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [1072] = {
    [aux_sym_concatenation_repeat1] = STATE(1072),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(2698),
    [sym_variable_name] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1557),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [1073] = {
    [anon_sym_RBRACE] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [sym_comment] = ACTIONS(54),
  },
  [1074] = {
    [anon_sym_RBRACE] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [sym_comment] = ACTIONS(54),
  },
  [1075] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1570),
    [anon_sym_LT] = ACTIONS(1570),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1570),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [anon_sym_LT_LPAREN] = ACTIONS(1087),
    [anon_sym_GT_LPAREN] = ACTIONS(1087),
    [sym_word] = ACTIONS(1089),
    [sym_comment] = ACTIONS(54),
  },
  [1076] = {
    [anon_sym_AT] = ACTIONS(2709),
    [sym_comment] = ACTIONS(54),
  },
  [1077] = {
    [sym_concatenation] = STATE(1244),
    [sym_string] = STATE(1243),
    [sym_simple_expansion] = STATE(1243),
    [sym_expansion] = STATE(1243),
    [sym_command_substitution] = STATE(1243),
    [sym_process_substitution] = STATE(1243),
    [anon_sym_RBRACE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2713),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2715),
    [sym_comment] = ACTIONS(54),
  },
  [1078] = {
    [sym_file_descriptor] = ACTIONS(1099),
    [sym__concat] = ACTIONS(1099),
    [sym_variable_name] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1580),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_word] = ACTIONS(1101),
    [sym_comment] = ACTIONS(54),
  },
  [1079] = {
    [anon_sym_AT] = ACTIONS(2717),
    [sym_comment] = ACTIONS(54),
  },
  [1080] = {
    [sym_concatenation] = STATE(1247),
    [sym_string] = STATE(1246),
    [sym_simple_expansion] = STATE(1246),
    [sym_expansion] = STATE(1246),
    [sym_command_substitution] = STATE(1246),
    [sym_process_substitution] = STATE(1246),
    [anon_sym_RBRACE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2721),
    [sym_comment] = ACTIONS(54),
  },
  [1081] = {
    [sym_file_descriptor] = ACTIONS(1197),
    [sym__concat] = ACTIONS(1197),
    [sym_variable_name] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_PIPE_AMP] = ACTIONS(1197),
    [anon_sym_AMP_AMP] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT] = ACTIONS(1588),
    [anon_sym_AMP_GT_GT] = ACTIONS(1197),
    [anon_sym_LT_AMP] = ACTIONS(1197),
    [anon_sym_GT_AMP] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR] = ACTIONS(1588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1197),
    [anon_sym_BQUOTE] = ACTIONS(1197),
    [anon_sym_LT_LPAREN] = ACTIONS(1197),
    [anon_sym_GT_LPAREN] = ACTIONS(1197),
    [sym_word] = ACTIONS(1199),
    [sym_comment] = ACTIONS(54),
  },
  [1082] = {
    [sym_file_descriptor] = ACTIONS(1255),
    [sym__concat] = ACTIONS(1255),
    [sym_variable_name] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1590),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1590),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_AMP_GT] = ACTIONS(1590),
    [anon_sym_AMP_GT_GT] = ACTIONS(1255),
    [anon_sym_LT_AMP] = ACTIONS(1255),
    [anon_sym_GT_AMP] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_raw_string] = ACTIONS(1255),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1255),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [anon_sym_LT_LPAREN] = ACTIONS(1255),
    [anon_sym_GT_LPAREN] = ACTIONS(1255),
    [sym_word] = ACTIONS(1257),
    [sym_comment] = ACTIONS(54),
  },
  [1083] = {
    [sym_do_group] = STATE(1248),
    [anon_sym_do] = ACTIONS(1133),
    [sym_comment] = ACTIONS(54),
  },
  [1084] = {
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_PIPE_AMP] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2725),
    [anon_sym_BQUOTE] = ACTIONS(2725),
    [sym_comment] = ACTIONS(54),
  },
  [1085] = {
    [anon_sym_PIPE] = ACTIONS(2727),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_PIPE_AMP] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BQUOTE] = ACTIONS(2729),
    [sym_comment] = ACTIONS(54),
  },
  [1086] = {
    [anon_sym_fi] = ACTIONS(2731),
    [sym_comment] = ACTIONS(54),
  },
  [1087] = {
    [sym_elif_clause] = STATE(447),
    [sym_else_clause] = STATE(1250),
    [aux_sym_if_statement_repeat1] = STATE(743),
    [anon_sym_fi] = ACTIONS(2731),
    [anon_sym_elif] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1487),
    [sym_comment] = ACTIONS(54),
  },
  [1088] = {
    [anon_sym_PIPE] = ACTIONS(2733),
    [anon_sym_RPAREN] = ACTIONS(2735),
    [anon_sym_PIPE_AMP] = ACTIONS(2735),
    [anon_sym_AMP_AMP] = ACTIONS(2735),
    [anon_sym_PIPE_PIPE] = ACTIONS(2735),
    [anon_sym_BQUOTE] = ACTIONS(2735),
    [sym_comment] = ACTIONS(54),
  },
  [1089] = {
    [sym_case_item] = STATE(746),
    [sym_concatenation] = STATE(747),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [aux_sym_case_statement_repeat1] = STATE(1012),
    [anon_sym_esac] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(1493),
    [sym_comment] = ACTIONS(54),
  },
  [1090] = {
    [sym_case_item] = STATE(746),
    [sym_concatenation] = STATE(747),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [aux_sym_case_statement_repeat1] = STATE(1252),
    [anon_sym_esac] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(1493),
    [sym_comment] = ACTIONS(54),
  },
  [1091] = {
    [sym_file_redirect] = STATE(1253),
    [sym_file_descriptor] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_RPAREN] = ACTIONS(2741),
    [anon_sym_PIPE_AMP] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_GT_GT] = ACTIONS(1195),
    [anon_sym_AMP_GT] = ACTIONS(1193),
    [anon_sym_AMP_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_AMP] = ACTIONS(1195),
    [anon_sym_GT_AMP] = ACTIONS(1195),
    [sym_comment] = ACTIONS(54),
  },
  [1092] = {
    [anon_sym_PIPE] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2745),
    [anon_sym_PIPE_AMP] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_PIPE_PIPE] = ACTIONS(2745),
    [anon_sym_BQUOTE] = ACTIONS(2745),
    [sym_comment] = ACTIONS(54),
  },
  [1093] = {
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_RPAREN] = ACTIONS(1389),
    [anon_sym_PIPE_AMP] = ACTIONS(1389),
    [anon_sym_AMP_AMP] = ACTIONS(1389),
    [anon_sym_PIPE_PIPE] = ACTIONS(1389),
    [anon_sym_BQUOTE] = ACTIONS(1389),
    [sym_comment] = ACTIONS(54),
  },
  [1094] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(404),
    [sym_simple_expansion] = STATE(404),
    [sym_expansion] = STATE(404),
    [sym_command_substitution] = STATE(404),
    [sym_process_substitution] = STATE(404),
    [aux_sym_for_statement_repeat1] = STATE(698),
    [anon_sym_RPAREN] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(743),
    [sym_raw_string] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_LT_LPAREN] = ACTIONS(755),
    [anon_sym_GT_LPAREN] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_comment] = ACTIONS(54),
  },
  [1095] = {
    [sym__concat] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_RPAREN] = ACTIONS(436),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(436),
    [anon_sym_PIPE_PIPE] = ACTIONS(436),
    [anon_sym_BQUOTE] = ACTIONS(436),
    [sym_comment] = ACTIONS(54),
  },
  [1096] = {
    [sym_simple_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(146),
    [anon_sym_DOLLAR] = ACTIONS(148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [sym_comment] = ACTIONS(156),
  },
  [1097] = {
    [sym_string] = STATE(1256),
    [sym_simple_expansion] = STATE(1256),
    [sym_expansion] = STATE(1256),
    [sym_command_substitution] = STATE(1256),
    [sym_process_substitution] = STATE(1256),
    [anon_sym_DQUOTE] = ACTIONS(1758),
    [sym_raw_string] = ACTIONS(2751),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [anon_sym_LT_LPAREN] = ACTIONS(1770),
    [anon_sym_GT_LPAREN] = ACTIONS(1770),
    [sym_word] = ACTIONS(2753),
    [sym_comment] = ACTIONS(54),
  },
  [1098] = {
    [aux_sym_concatenation_repeat1] = STATE(1257),
    [sym__concat] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_RPAREN] = ACTIONS(460),
    [anon_sym_PIPE_AMP] = ACTIONS(460),
    [anon_sym_AMP_AMP] = ACTIONS(460),
    [anon_sym_PIPE_PIPE] = ACTIONS(460),
    [sym_comment] = ACTIONS(54),
  },
  [1099] = {
    [sym__concat] = ACTIONS(464),
    [anon_sym_PIPE] = ACTIONS(476),
    [anon_sym_RPAREN] = ACTIONS(464),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(464),
    [anon_sym_PIPE_PIPE] = ACTIONS(464),
    [anon_sym_BQUOTE] = ACTIONS(464),
    [sym_comment] = ACTIONS(54),
  },
  [1100] = {
    [sym__concat] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_PIPE_AMP] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_PIPE_PIPE] = ACTIONS(468),
    [anon_sym_BQUOTE] = ACTIONS(468),
    [sym_comment] = ACTIONS(54),
  },
  [1101] = {
    [sym__concat] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_PIPE_AMP] = ACTIONS(472),
    [anon_sym_AMP_AMP] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [sym_comment] = ACTIONS(54),
  },
  [1102] = {
    [sym_special_variable_name] = STATE(1259),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(170),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(156),
    [sym_simple_variable_name] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [1103] = {
    [anon_sym_RBRACE] = ACTIONS(2757),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_COLON] = ACTIONS(2763),
    [anon_sym_COLON_QMARK] = ACTIONS(2761),
    [anon_sym_COLON_DASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [sym_comment] = ACTIONS(54),
  },
  [1104] = {
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_EQ] = ACTIONS(2769),
    [anon_sym_COLON] = ACTIONS(2771),
    [anon_sym_COLON_QMARK] = ACTIONS(2769),
    [anon_sym_COLON_DASH] = ACTIONS(2769),
    [anon_sym_PERCENT] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2769),
    [sym_comment] = ACTIONS(54),
  },
  [1105] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [1106] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [1107] = {
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_BQUOTE] = ACTIONS(2773),
    [sym_comment] = ACTIONS(54),
  },
  [1108] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_AMP] = ACTIONS(568),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(2773),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [1109] = {
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [sym_comment] = ACTIONS(54),
  },
  [1110] = {
    [sym_file_descriptor] = ACTIONS(264),
    [sym_variable_name] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_PIPE_AMP] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(264),
    [anon_sym_LT_AMP] = ACTIONS(264),
    [anon_sym_GT_AMP] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(264),
    [sym_raw_string] = ACTIONS(264),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(264),
    [anon_sym_BQUOTE] = ACTIONS(264),
    [anon_sym_LT_LPAREN] = ACTIONS(264),
    [anon_sym_GT_LPAREN] = ACTIONS(264),
    [sym_word] = ACTIONS(266),
    [sym_comment] = ACTIONS(54),
  },
  [1111] = {
    [anon_sym_RBRACK] = ACTIONS(2777),
    [sym_comment] = ACTIONS(54),
  },
  [1112] = {
    [anon_sym_RBRACK] = ACTIONS(2779),
    [sym_comment] = ACTIONS(54),
  },
  [1113] = {
    [anon_sym_RBRACE] = ACTIONS(2781),
    [sym_comment] = ACTIONS(54),
  },
  [1114] = {
    [sym_file_descriptor] = ACTIONS(2287),
    [sym__concat] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2629),
    [anon_sym_RPAREN] = ACTIONS(2287),
    [anon_sym_PIPE_AMP] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2287),
    [anon_sym_PIPE_PIPE] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_AMP_GT] = ACTIONS(2629),
    [anon_sym_AMP_GT_GT] = ACTIONS(2287),
    [anon_sym_LT_AMP] = ACTIONS(2287),
    [anon_sym_GT_AMP] = ACTIONS(2287),
    [anon_sym_LT_LT] = ACTIONS(2629),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_raw_string] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [anon_sym_LT_LPAREN] = ACTIONS(2287),
    [anon_sym_GT_LPAREN] = ACTIONS(2287),
    [sym_word] = ACTIONS(2289),
    [sym_comment] = ACTIONS(54),
  },
  [1115] = {
    [anon_sym_RBRACE] = ACTIONS(2783),
    [sym_comment] = ACTIONS(54),
  },
  [1116] = {
    [sym_file_descriptor] = ACTIONS(2293),
    [sym__concat] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_PIPE_AMP] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2633),
    [anon_sym_LT] = ACTIONS(2633),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_AMP_GT] = ACTIONS(2633),
    [anon_sym_AMP_GT_GT] = ACTIONS(2293),
    [anon_sym_LT_AMP] = ACTIONS(2293),
    [anon_sym_GT_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_DASH] = ACTIONS(2293),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2293),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [anon_sym_LT_LPAREN] = ACTIONS(2293),
    [anon_sym_GT_LPAREN] = ACTIONS(2293),
    [sym_word] = ACTIONS(2295),
    [sym_comment] = ACTIONS(54),
  },
  [1117] = {
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_RPAREN] = ACTIONS(2741),
    [anon_sym_PIPE_AMP] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2741),
    [anon_sym_BQUOTE] = ACTIONS(2741),
    [sym_comment] = ACTIONS(54),
  },
  [1118] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym__concat] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_PIPE_AMP] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [sym_comment] = ACTIONS(54),
  },
  [1119] = {
    [anon_sym_PIPE] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_PIPE_AMP] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_comment] = ACTIONS(54),
  },
  [1120] = {
    [sym_file_descriptor] = ACTIONS(1051),
    [sym__concat] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1555),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [sym_comment] = ACTIONS(54),
  },
  [1121] = {
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1557),
    [anon_sym_LT_LT_DASH] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [1122] = {
    [aux_sym_concatenation_repeat1] = STATE(1122),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1557),
    [anon_sym_LT_LT_DASH] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [1123] = {
    [anon_sym_RBRACE] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [sym_comment] = ACTIONS(54),
  },
  [1124] = {
    [anon_sym_RBRACE] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [sym_comment] = ACTIONS(54),
  },
  [1125] = {
    [sym_file_descriptor] = ACTIONS(1087),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1570),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_AMP_GT] = ACTIONS(1570),
    [anon_sym_AMP_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_AMP] = ACTIONS(1087),
    [anon_sym_GT_AMP] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1570),
    [anon_sym_LT_LT_DASH] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(54),
  },
  [1126] = {
    [anon_sym_AT] = ACTIONS(2796),
    [sym_comment] = ACTIONS(54),
  },
  [1127] = {
    [sym_concatenation] = STATE(1279),
    [sym_string] = STATE(1278),
    [sym_simple_expansion] = STATE(1278),
    [sym_expansion] = STATE(1278),
    [sym_command_substitution] = STATE(1278),
    [sym_process_substitution] = STATE(1278),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2800),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2802),
    [sym_comment] = ACTIONS(54),
  },
  [1128] = {
    [sym_file_descriptor] = ACTIONS(1099),
    [sym__concat] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1580),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1580),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_LT_LT_DASH] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(54),
  },
  [1129] = {
    [anon_sym_AT] = ACTIONS(2804),
    [sym_comment] = ACTIONS(54),
  },
  [1130] = {
    [sym_concatenation] = STATE(1282),
    [sym_string] = STATE(1281),
    [sym_simple_expansion] = STATE(1281),
    [sym_expansion] = STATE(1281),
    [sym_command_substitution] = STATE(1281),
    [sym_process_substitution] = STATE(1281),
    [anon_sym_RBRACE] = ACTIONS(2792),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2808),
    [sym_comment] = ACTIONS(54),
  },
  [1131] = {
    [sym_file_descriptor] = ACTIONS(1197),
    [sym__concat] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_PIPE_AMP] = ACTIONS(1197),
    [anon_sym_AMP_AMP] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT] = ACTIONS(1588),
    [anon_sym_AMP_GT_GT] = ACTIONS(1197),
    [anon_sym_LT_AMP] = ACTIONS(1197),
    [anon_sym_GT_AMP] = ACTIONS(1197),
    [anon_sym_LT_LT] = ACTIONS(1588),
    [anon_sym_LT_LT_DASH] = ACTIONS(1197),
    [anon_sym_BQUOTE] = ACTIONS(1197),
    [sym_comment] = ACTIONS(54),
  },
  [1132] = {
    [sym_file_descriptor] = ACTIONS(1255),
    [sym__concat] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1590),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_AMP_GT] = ACTIONS(1590),
    [anon_sym_AMP_GT_GT] = ACTIONS(1255),
    [anon_sym_LT_AMP] = ACTIONS(1255),
    [anon_sym_GT_AMP] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1590),
    [anon_sym_LT_LT_DASH] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [sym_comment] = ACTIONS(54),
  },
  [1133] = {
    [sym_file_descriptor] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2810),
    [anon_sym_RPAREN] = ACTIONS(2476),
    [anon_sym_PIPE_AMP] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2810),
    [anon_sym_GT] = ACTIONS(2810),
    [anon_sym_GT_GT] = ACTIONS(2476),
    [anon_sym_AMP_GT] = ACTIONS(2810),
    [anon_sym_AMP_GT_GT] = ACTIONS(2476),
    [anon_sym_LT_AMP] = ACTIONS(2476),
    [anon_sym_GT_AMP] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2810),
    [anon_sym_LT_LT_DASH] = ACTIONS(2476),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [sym_comment] = ACTIONS(54),
  },
  [1134] = {
    [aux_sym_concatenation_repeat1] = STATE(1134),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(2698),
    [sym_variable_name] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1557),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_raw_string] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(54),
  },
  [1135] = {
    [sym_file_redirect] = STATE(1253),
    [sym_file_descriptor] = ACTIONS(1241),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_PIPE_AMP] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_AMP_GT] = ACTIONS(1243),
    [anon_sym_AMP_GT_GT] = ACTIONS(1245),
    [anon_sym_LT_AMP] = ACTIONS(1245),
    [anon_sym_GT_AMP] = ACTIONS(1245),
    [anon_sym_BQUOTE] = ACTIONS(2741),
    [sym_comment] = ACTIONS(54),
  },
  [1136] = {
    [aux_sym_concatenation_repeat1] = STATE(1283),
    [sym__concat] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_PIPE_AMP] = ACTIONS(460),
    [anon_sym_AMP_AMP] = ACTIONS(460),
    [anon_sym_PIPE_PIPE] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [sym_comment] = ACTIONS(54),
  },
  [1137] = {
    [aux_sym_concatenation_repeat1] = STATE(1136),
    [sym__concat] = ACTIONS(2363),
    [anon_sym_PIPE] = ACTIONS(719),
    [anon_sym_PIPE_AMP] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_comment] = ACTIONS(54),
  },
  [1138] = {
    [aux_sym_concatenation_repeat1] = STATE(1138),
    [sym_file_descriptor] = ACTIONS(1072),
    [sym__concat] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1557),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1557),
    [anon_sym_LT_LT_DASH] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [1139] = {
    [sym_file_descriptor] = ACTIONS(1680),
    [sym__concat] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_SEMI_SEMI] = ACTIONS(1682),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_LT_LT_DASH] = ACTIONS(1682),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_LF] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
  },
  [1140] = {
    [anon_sym_AT] = ACTIONS(2812),
    [sym_comment] = ACTIONS(54),
  },
  [1141] = {
    [sym_file_descriptor] = ACTIONS(1686),
    [sym__concat] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(1688),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(1688),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(1688),
    [anon_sym_GT_GT] = ACTIONS(1688),
    [anon_sym_AMP_GT] = ACTIONS(1688),
    [anon_sym_AMP_GT_GT] = ACTIONS(1688),
    [anon_sym_LT_AMP] = ACTIONS(1688),
    [anon_sym_GT_AMP] = ACTIONS(1688),
    [anon_sym_LT_LT] = ACTIONS(1688),
    [anon_sym_LT_LT_DASH] = ACTIONS(1688),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [1142] = {
    [anon_sym_AT] = ACTIONS(2814),
    [sym_comment] = ACTIONS(54),
  },
  [1143] = {
    [anon_sym_RBRACK] = ACTIONS(2816),
    [sym_comment] = ACTIONS(54),
  },
  [1144] = {
    [sym_file_descriptor] = ACTIONS(1694),
    [sym__concat] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(1696),
    [anon_sym_RPAREN] = ACTIONS(1696),
    [anon_sym_SEMI_SEMI] = ACTIONS(1696),
    [anon_sym_PIPE_AMP] = ACTIONS(1696),
    [anon_sym_AMP_AMP] = ACTIONS(1696),
    [anon_sym_PIPE_PIPE] = ACTIONS(1696),
    [anon_sym_LT] = ACTIONS(1696),
    [anon_sym_GT] = ACTIONS(1696),
    [anon_sym_GT_GT] = ACTIONS(1696),
    [anon_sym_AMP_GT] = ACTIONS(1696),
    [anon_sym_AMP_GT_GT] = ACTIONS(1696),
    [anon_sym_LT_AMP] = ACTIONS(1696),
    [anon_sym_GT_AMP] = ACTIONS(1696),
    [anon_sym_LT_LT] = ACTIONS(1696),
    [anon_sym_LT_LT_DASH] = ACTIONS(1696),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_LF] = ACTIONS(1696),
    [anon_sym_AMP] = ACTIONS(1696),
  },
  [1145] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(54),
  },
  [1146] = {
    [anon_sym_RBRACE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(54),
  },
  [1147] = {
    [anon_sym_RBRACK] = ACTIONS(2820),
    [sym_comment] = ACTIONS(54),
  },
  [1148] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
  },
  [1149] = {
    [anon_sym_RBRACE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
  },
  [1150] = {
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [sym_comment] = ACTIONS(54),
  },
  [1151] = {
    [anon_sym_RBRACE] = ACTIONS(2828),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [sym_comment] = ACTIONS(54),
  },
  [1152] = {
    [sym__heredoc_middle] = ACTIONS(1087),
    [sym__heredoc_end] = ACTIONS(1087),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(54),
  },
  [1153] = {
    [anon_sym_AT] = ACTIONS(2832),
    [sym_comment] = ACTIONS(54),
  },
  [1154] = {
    [sym_concatenation] = STATE(1297),
    [sym_string] = STATE(1296),
    [sym_simple_expansion] = STATE(1296),
    [sym_expansion] = STATE(1296),
    [sym_command_substitution] = STATE(1296),
    [sym_process_substitution] = STATE(1296),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2836),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2838),
    [sym_comment] = ACTIONS(54),
  },
  [1155] = {
    [sym__heredoc_middle] = ACTIONS(1099),
    [sym__heredoc_end] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(54),
  },
  [1156] = {
    [anon_sym_AT] = ACTIONS(2840),
    [sym_comment] = ACTIONS(54),
  },
  [1157] = {
    [sym_concatenation] = STATE(1300),
    [sym_string] = STATE(1299),
    [sym_simple_expansion] = STATE(1299),
    [sym_expansion] = STATE(1299),
    [sym_command_substitution] = STATE(1299),
    [sym_process_substitution] = STATE(1299),
    [anon_sym_RBRACE] = ACTIONS(2828),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2842),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2844),
    [sym_comment] = ACTIONS(54),
  },
  [1158] = {
    [sym_file_descriptor] = ACTIONS(2042),
    [sym_variable_name] = ACTIONS(2042),
    [anon_sym_LT] = ACTIONS(2696),
    [anon_sym_GT] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2042),
    [anon_sym_AMP_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT_GT] = ACTIONS(2042),
    [anon_sym_LT_AMP] = ACTIONS(2042),
    [anon_sym_GT_AMP] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(2042),
    [sym_raw_string] = ACTIONS(2042),
    [anon_sym_DOLLAR] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2042),
    [anon_sym_BQUOTE] = ACTIONS(2042),
    [anon_sym_LT_LPAREN] = ACTIONS(2042),
    [anon_sym_GT_LPAREN] = ACTIONS(2042),
    [sym_word] = ACTIONS(2696),
    [sym_comment] = ACTIONS(54),
  },
  [1159] = {
    [anon_sym_RBRACK] = ACTIONS(2846),
    [sym_comment] = ACTIONS(54),
  },
  [1160] = {
    [anon_sym_RBRACK] = ACTIONS(2848),
    [sym_comment] = ACTIONS(54),
  },
  [1161] = {
    [anon_sym_RBRACE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(54),
  },
  [1162] = {
    [sym__concat] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2287),
    [anon_sym_RPAREN] = ACTIONS(2287),
    [anon_sym_RBRACK] = ACTIONS(2287),
    [sym_comment] = ACTIONS(54),
  },
  [1163] = {
    [anon_sym_RBRACE] = ACTIONS(2852),
    [sym_comment] = ACTIONS(54),
  },
  [1164] = {
    [sym__concat] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [sym_comment] = ACTIONS(54),
  },
  [1165] = {
    [sym__concat] = ACTIONS(1680),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [sym_raw_string] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(2197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [anon_sym_LT_LPAREN] = ACTIONS(1680),
    [anon_sym_GT_LPAREN] = ACTIONS(1680),
    [sym_word] = ACTIONS(2197),
    [sym_comment] = ACTIONS(54),
  },
  [1166] = {
    [anon_sym_AT] = ACTIONS(2854),
    [sym_comment] = ACTIONS(54),
  },
  [1167] = {
    [sym__concat] = ACTIONS(1686),
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_raw_string] = ACTIONS(1686),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1686),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [anon_sym_LT_LPAREN] = ACTIONS(1686),
    [anon_sym_GT_LPAREN] = ACTIONS(1686),
    [sym_word] = ACTIONS(2201),
    [sym_comment] = ACTIONS(54),
  },
  [1168] = {
    [anon_sym_AT] = ACTIONS(2856),
    [sym_comment] = ACTIONS(54),
  },
  [1169] = {
    [anon_sym_RBRACK] = ACTIONS(2858),
    [sym_comment] = ACTIONS(54),
  },
  [1170] = {
    [sym__concat] = ACTIONS(1694),
    [anon_sym_RPAREN] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_raw_string] = ACTIONS(1694),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1694),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [anon_sym_LT_LPAREN] = ACTIONS(1694),
    [anon_sym_GT_LPAREN] = ACTIONS(1694),
    [sym_word] = ACTIONS(2207),
    [sym_comment] = ACTIONS(54),
  },
  [1171] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2860),
    [sym_comment] = ACTIONS(54),
  },
  [1172] = {
    [anon_sym_RBRACE] = ACTIONS(2860),
    [sym_comment] = ACTIONS(54),
  },
  [1173] = {
    [anon_sym_RBRACK] = ACTIONS(2862),
    [sym_comment] = ACTIONS(54),
  },
  [1174] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2864),
    [sym_comment] = ACTIONS(54),
  },
  [1175] = {
    [anon_sym_RBRACE] = ACTIONS(2864),
    [sym_comment] = ACTIONS(54),
  },
  [1176] = {
    [anon_sym_RBRACK] = ACTIONS(2866),
    [sym_comment] = ACTIONS(54),
  },
  [1177] = {
    [anon_sym_RBRACK] = ACTIONS(2868),
    [sym_comment] = ACTIONS(54),
  },
  [1178] = {
    [anon_sym_RBRACE] = ACTIONS(2870),
    [sym_comment] = ACTIONS(54),
  },
  [1179] = {
    [sym_file_descriptor] = ACTIONS(2287),
    [sym__concat] = ACTIONS(2287),
    [sym_variable_name] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2289),
    [anon_sym_RPAREN] = ACTIONS(2289),
    [anon_sym_SEMI_SEMI] = ACTIONS(2289),
    [anon_sym_PIPE_AMP] = ACTIONS(2289),
    [anon_sym_AMP_AMP] = ACTIONS(2289),
    [anon_sym_PIPE_PIPE] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(2289),
    [anon_sym_GT] = ACTIONS(2289),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_AMP_GT] = ACTIONS(2289),
    [anon_sym_AMP_GT_GT] = ACTIONS(2289),
    [anon_sym_LT_AMP] = ACTIONS(2289),
    [anon_sym_GT_AMP] = ACTIONS(2289),
    [anon_sym_DQUOTE] = ACTIONS(2289),
    [sym_raw_string] = ACTIONS(2289),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2289),
    [anon_sym_BQUOTE] = ACTIONS(2289),
    [anon_sym_LT_LPAREN] = ACTIONS(2289),
    [anon_sym_GT_LPAREN] = ACTIONS(2289),
    [sym_word] = ACTIONS(2289),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_LF] = ACTIONS(2289),
    [anon_sym_AMP] = ACTIONS(2289),
  },
  [1180] = {
    [anon_sym_RBRACE] = ACTIONS(2872),
    [sym_comment] = ACTIONS(54),
  },
  [1181] = {
    [sym_file_descriptor] = ACTIONS(2293),
    [sym__concat] = ACTIONS(2293),
    [sym_variable_name] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_RPAREN] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_AMP_GT] = ACTIONS(2295),
    [anon_sym_AMP_GT_GT] = ACTIONS(2295),
    [anon_sym_LT_AMP] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(2295),
    [anon_sym_DQUOTE] = ACTIONS(2295),
    [sym_raw_string] = ACTIONS(2295),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(2295),
    [anon_sym_LT_LPAREN] = ACTIONS(2295),
    [anon_sym_GT_LPAREN] = ACTIONS(2295),
    [sym_word] = ACTIONS(2295),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LF] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
  },
  [1182] = {
    [sym__concat] = ACTIONS(1680),
    [anon_sym_SEMI_SEMI] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(1682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_word] = ACTIONS(1682),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_LF] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
  },
  [1183] = {
    [anon_sym_AT] = ACTIONS(2874),
    [sym_comment] = ACTIONS(54),
  },
  [1184] = {
    [sym__concat] = ACTIONS(1686),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [anon_sym_DQUOTE] = ACTIONS(1688),
    [sym_raw_string] = ACTIONS(1688),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1688),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [anon_sym_LT_LPAREN] = ACTIONS(1688),
    [anon_sym_GT_LPAREN] = ACTIONS(1688),
    [sym_word] = ACTIONS(1688),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [1185] = {
    [anon_sym_AT] = ACTIONS(2876),
    [sym_comment] = ACTIONS(54),
  },
  [1186] = {
    [anon_sym_RBRACK] = ACTIONS(2878),
    [sym_comment] = ACTIONS(54),
  },
  [1187] = {
    [sym__concat] = ACTIONS(1694),
    [anon_sym_SEMI_SEMI] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [sym_raw_string] = ACTIONS(1696),
    [anon_sym_DOLLAR] = ACTIONS(1696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1696),
    [anon_sym_BQUOTE] = ACTIONS(1696),
    [anon_sym_LT_LPAREN] = ACTIONS(1696),
    [anon_sym_GT_LPAREN] = ACTIONS(1696),
    [sym_word] = ACTIONS(1696),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_LF] = ACTIONS(1696),
    [anon_sym_AMP] = ACTIONS(1696),
  },
  [1188] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [sym_comment] = ACTIONS(54),
  },
  [1189] = {
    [anon_sym_RBRACE] = ACTIONS(2880),
    [sym_comment] = ACTIONS(54),
  },
  [1190] = {
    [anon_sym_RBRACK] = ACTIONS(2882),
    [sym_comment] = ACTIONS(54),
  },
  [1191] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [sym_comment] = ACTIONS(54),
  },
  [1192] = {
    [anon_sym_RBRACE] = ACTIONS(2884),
    [sym_comment] = ACTIONS(54),
  },
  [1193] = {
    [sym__terminated_statement] = STATE(445),
    [sym_for_statement] = STATE(446),
    [sym_while_statement] = STATE(446),
    [sym_if_statement] = STATE(446),
    [sym_case_statement] = STATE(446),
    [sym_function_definition] = STATE(446),
    [sym_subshell] = STATE(446),
    [sym_pipeline] = STATE(446),
    [sym_list] = STATE(446),
    [sym_bracket_command] = STATE(446),
    [sym_command] = STATE(446),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(449),
    [sym_local_variable_declaration] = STATE(446),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(741),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2886),
    [anon_sym_elif] = ACTIONS(2886),
    [anon_sym_else] = ACTIONS(2886),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [1194] = {
    [anon_sym_PIPE] = ACTIONS(2888),
    [anon_sym_RPAREN] = ACTIONS(2888),
    [anon_sym_SEMI_SEMI] = ACTIONS(2888),
    [anon_sym_PIPE_AMP] = ACTIONS(2888),
    [anon_sym_AMP_AMP] = ACTIONS(2888),
    [anon_sym_PIPE_PIPE] = ACTIONS(2888),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2888),
    [anon_sym_LF] = ACTIONS(2888),
    [anon_sym_AMP] = ACTIONS(2888),
  },
  [1195] = {
    [aux_sym_concatenation_repeat1] = STATE(1010),
    [sym__concat] = ACTIONS(723),
    [anon_sym_PIPE] = ACTIONS(2890),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(54),
  },
  [1196] = {
    [anon_sym_PIPE] = ACTIONS(2890),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(54),
  },
  [1197] = {
    [anon_sym_esac] = ACTIONS(2892),
    [anon_sym_DQUOTE] = ACTIONS(2894),
    [sym_raw_string] = ACTIONS(2894),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2894),
    [anon_sym_BQUOTE] = ACTIONS(2894),
    [anon_sym_LT_LPAREN] = ACTIONS(2894),
    [anon_sym_GT_LPAREN] = ACTIONS(2894),
    [sym_word] = ACTIONS(2896),
    [sym_comment] = ACTIONS(54),
  },
  [1198] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(1322),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(2898),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [1199] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(1323),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(2898),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [1200] = {
    [aux_sym_case_item_repeat1] = STATE(1200),
    [anon_sym_PIPE] = ACTIONS(2900),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(54),
  },
  [1201] = {
    [aux_sym_concatenation_repeat1] = STATE(1201),
    [sym__concat] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [1202] = {
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_RPAREN] = ACTIONS(2903),
    [anon_sym_SEMI_SEMI] = ACTIONS(2903),
    [anon_sym_PIPE_AMP] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_PIPE_PIPE] = ACTIONS(2903),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_LF] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2903),
  },
  [1203] = {
    [anon_sym_RBRACE] = ACTIONS(2905),
    [sym_comment] = ACTIONS(54),
  },
  [1204] = {
    [anon_sym_RBRACE] = ACTIONS(2907),
    [sym_comment] = ACTIONS(54),
  },
  [1205] = {
    [sym__concat] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(2690),
    [anon_sym_SEMI_SEMI] = ACTIONS(2690),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_LF] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2690),
  },
  [1206] = {
    [sym__concat] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2694),
    [anon_sym_SEMI_SEMI] = ACTIONS(2694),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_LF] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2694),
  },
  [1207] = {
    [aux_sym_concatenation_repeat1] = STATE(1207),
    [sym__concat] = ACTIONS(2643),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_SEMI_SEMI] = ACTIONS(1074),
    [anon_sym_PIPE_AMP] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1074),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_LF] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
  },
  [1208] = {
    [anon_sym_RBRACE] = ACTIONS(2909),
    [sym_comment] = ACTIONS(54),
  },
  [1209] = {
    [anon_sym_RBRACE] = ACTIONS(2911),
    [sym_comment] = ACTIONS(54),
  },
  [1210] = {
    [sym__concat] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_RBRACK] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [sym_raw_string] = ACTIONS(2688),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2688),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [anon_sym_LT_LPAREN] = ACTIONS(2688),
    [anon_sym_GT_LPAREN] = ACTIONS(2688),
    [sym_word] = ACTIONS(2690),
    [sym_comment] = ACTIONS(54),
  },
  [1211] = {
    [sym__concat] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_RBRACK] = ACTIONS(2915),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [sym_raw_string] = ACTIONS(2692),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2692),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [anon_sym_LT_LPAREN] = ACTIONS(2692),
    [anon_sym_GT_LPAREN] = ACTIONS(2692),
    [sym_word] = ACTIONS(2694),
    [sym_comment] = ACTIONS(54),
  },
  [1212] = {
    [anon_sym_RBRACE] = ACTIONS(2917),
    [sym_comment] = ACTIONS(54),
  },
  [1213] = {
    [anon_sym_RBRACE] = ACTIONS(2919),
    [sym_comment] = ACTIONS(54),
  },
  [1214] = {
    [sym__concat] = ACTIONS(2688),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [sym_raw_string] = ACTIONS(2688),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2688),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [anon_sym_LT_LPAREN] = ACTIONS(2688),
    [anon_sym_GT_LPAREN] = ACTIONS(2688),
    [sym_word] = ACTIONS(2690),
    [sym_comment] = ACTIONS(54),
  },
  [1215] = {
    [sym__concat] = ACTIONS(2692),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2915),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [sym_raw_string] = ACTIONS(2692),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2692),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [anon_sym_LT_LPAREN] = ACTIONS(2692),
    [anon_sym_GT_LPAREN] = ACTIONS(2692),
    [sym_word] = ACTIONS(2694),
    [sym_comment] = ACTIONS(54),
  },
  [1216] = {
    [sym__concat] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_SEMI_SEMI] = ACTIONS(1682),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_LF] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
  },
  [1217] = {
    [anon_sym_AT] = ACTIONS(2921),
    [sym_comment] = ACTIONS(54),
  },
  [1218] = {
    [sym__concat] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(1688),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(1688),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [1219] = {
    [anon_sym_AT] = ACTIONS(2923),
    [sym_comment] = ACTIONS(54),
  },
  [1220] = {
    [anon_sym_RBRACK] = ACTIONS(2925),
    [sym_comment] = ACTIONS(54),
  },
  [1221] = {
    [sym__concat] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(1696),
    [anon_sym_RPAREN] = ACTIONS(1696),
    [anon_sym_SEMI_SEMI] = ACTIONS(1696),
    [anon_sym_PIPE_AMP] = ACTIONS(1696),
    [anon_sym_AMP_AMP] = ACTIONS(1696),
    [anon_sym_PIPE_PIPE] = ACTIONS(1696),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_LF] = ACTIONS(1696),
    [anon_sym_AMP] = ACTIONS(1696),
  },
  [1222] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [sym_comment] = ACTIONS(54),
  },
  [1223] = {
    [anon_sym_RBRACE] = ACTIONS(2927),
    [sym_comment] = ACTIONS(54),
  },
  [1224] = {
    [anon_sym_RBRACK] = ACTIONS(2929),
    [sym_comment] = ACTIONS(54),
  },
  [1225] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [sym_comment] = ACTIONS(54),
  },
  [1226] = {
    [anon_sym_RBRACE] = ACTIONS(2931),
    [sym_comment] = ACTIONS(54),
  },
  [1227] = {
    [anon_sym_RBRACE] = ACTIONS(2933),
    [sym_comment] = ACTIONS(54),
  },
  [1228] = {
    [anon_sym_RBRACE] = ACTIONS(2935),
    [sym_comment] = ACTIONS(54),
  },
  [1229] = {
    [sym_file_descriptor] = ACTIONS(2688),
    [sym__concat] = ACTIONS(2688),
    [sym_variable_name] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2688),
    [anon_sym_AMP_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT_GT] = ACTIONS(2688),
    [anon_sym_LT_AMP] = ACTIONS(2688),
    [anon_sym_GT_AMP] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [sym_raw_string] = ACTIONS(2688),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2688),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [anon_sym_LT_LPAREN] = ACTIONS(2688),
    [anon_sym_GT_LPAREN] = ACTIONS(2688),
    [sym_word] = ACTIONS(2913),
    [sym_comment] = ACTIONS(54),
  },
  [1230] = {
    [sym_file_descriptor] = ACTIONS(2692),
    [sym__concat] = ACTIONS(2692),
    [sym_variable_name] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2692),
    [anon_sym_LT_AMP] = ACTIONS(2692),
    [anon_sym_GT_AMP] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [sym_raw_string] = ACTIONS(2692),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2692),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [anon_sym_LT_LPAREN] = ACTIONS(2692),
    [anon_sym_GT_LPAREN] = ACTIONS(2692),
    [sym_word] = ACTIONS(2915),
    [sym_comment] = ACTIONS(54),
  },
  [1231] = {
    [anon_sym_RBRACE] = ACTIONS(2937),
    [sym_comment] = ACTIONS(54),
  },
  [1232] = {
    [anon_sym_RBRACE] = ACTIONS(2939),
    [sym_comment] = ACTIONS(54),
  },
  [1233] = {
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2690),
    [anon_sym_BQUOTE] = ACTIONS(2690),
    [sym_comment] = ACTIONS(156),
  },
  [1234] = {
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2915),
    [anon_sym_DOLLAR] = ACTIONS(2694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2694),
    [anon_sym_BQUOTE] = ACTIONS(2694),
    [sym_comment] = ACTIONS(156),
  },
  [1235] = {
    [sym_file_descriptor] = ACTIONS(2941),
    [sym__concat] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_SEMI_SEMI] = ACTIONS(2943),
    [anon_sym_PIPE_AMP] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(2943),
    [anon_sym_GT_GT] = ACTIONS(2943),
    [anon_sym_AMP_GT] = ACTIONS(2943),
    [anon_sym_AMP_GT_GT] = ACTIONS(2943),
    [anon_sym_LT_AMP] = ACTIONS(2943),
    [anon_sym_GT_AMP] = ACTIONS(2943),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_LT_LT_DASH] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [sym_raw_string] = ACTIONS(2943),
    [anon_sym_DOLLAR] = ACTIONS(2943),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2943),
    [anon_sym_BQUOTE] = ACTIONS(2943),
    [anon_sym_LT_LPAREN] = ACTIONS(2943),
    [anon_sym_GT_LPAREN] = ACTIONS(2943),
    [sym_word] = ACTIONS(2943),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_LF] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2943),
  },
  [1236] = {
    [sym_file_descriptor] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_SEMI_SEMI] = ACTIONS(2947),
    [anon_sym_PIPE_AMP] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_GT] = ACTIONS(2947),
    [anon_sym_AMP_GT_GT] = ACTIONS(2947),
    [anon_sym_LT_AMP] = ACTIONS(2947),
    [anon_sym_GT_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_LT_LT_DASH] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_raw_string] = ACTIONS(2947),
    [anon_sym_DOLLAR] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2947),
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2947),
    [anon_sym_GT_LPAREN] = ACTIONS(2947),
    [sym_word] = ACTIONS(2947),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
  },
  [1237] = {
    [sym_file_descriptor] = ACTIONS(1680),
    [sym__concat] = ACTIONS(1680),
    [sym_variable_name] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [anon_sym_PIPE_AMP] = ACTIONS(1680),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_PIPE_PIPE] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(1680),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(1680),
    [anon_sym_LT_AMP] = ACTIONS(1680),
    [anon_sym_GT_AMP] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [sym_raw_string] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(2197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [anon_sym_LT_LPAREN] = ACTIONS(1680),
    [anon_sym_GT_LPAREN] = ACTIONS(1680),
    [sym_word] = ACTIONS(1682),
    [sym_comment] = ACTIONS(54),
  },
  [1238] = {
    [anon_sym_AT] = ACTIONS(2949),
    [sym_comment] = ACTIONS(54),
  },
  [1239] = {
    [sym_file_descriptor] = ACTIONS(1686),
    [sym__concat] = ACTIONS(1686),
    [sym_variable_name] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_PIPE_AMP] = ACTIONS(1686),
    [anon_sym_AMP_AMP] = ACTIONS(1686),
    [anon_sym_PIPE_PIPE] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_GT_GT] = ACTIONS(1686),
    [anon_sym_AMP_GT] = ACTIONS(2201),
    [anon_sym_AMP_GT_GT] = ACTIONS(1686),
    [anon_sym_LT_AMP] = ACTIONS(1686),
    [anon_sym_GT_AMP] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [sym_raw_string] = ACTIONS(1686),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1686),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [anon_sym_LT_LPAREN] = ACTIONS(1686),
    [anon_sym_GT_LPAREN] = ACTIONS(1686),
    [sym_word] = ACTIONS(1688),
    [sym_comment] = ACTIONS(54),
  },
  [1240] = {
    [anon_sym_AT] = ACTIONS(2951),
    [sym_comment] = ACTIONS(54),
  },
  [1241] = {
    [anon_sym_RBRACK] = ACTIONS(2953),
    [sym_comment] = ACTIONS(54),
  },
  [1242] = {
    [sym_file_descriptor] = ACTIONS(1694),
    [sym__concat] = ACTIONS(1694),
    [sym_variable_name] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(1694),
    [anon_sym_PIPE_AMP] = ACTIONS(1694),
    [anon_sym_AMP_AMP] = ACTIONS(1694),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_AMP_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT_GT] = ACTIONS(1694),
    [anon_sym_LT_AMP] = ACTIONS(1694),
    [anon_sym_GT_AMP] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1694),
    [sym_raw_string] = ACTIONS(1694),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1694),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [anon_sym_LT_LPAREN] = ACTIONS(1694),
    [anon_sym_GT_LPAREN] = ACTIONS(1694),
    [sym_word] = ACTIONS(1696),
    [sym_comment] = ACTIONS(54),
  },
  [1243] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [sym_comment] = ACTIONS(54),
  },
  [1244] = {
    [anon_sym_RBRACE] = ACTIONS(2955),
    [sym_comment] = ACTIONS(54),
  },
  [1245] = {
    [anon_sym_RBRACK] = ACTIONS(2957),
    [sym_comment] = ACTIONS(54),
  },
  [1246] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [sym_comment] = ACTIONS(54),
  },
  [1247] = {
    [anon_sym_RBRACE] = ACTIONS(2959),
    [sym_comment] = ACTIONS(54),
  },
  [1248] = {
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_PIPE_AMP] = ACTIONS(2963),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2963),
    [anon_sym_BQUOTE] = ACTIONS(2963),
    [sym_comment] = ACTIONS(54),
  },
  [1249] = {
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_PIPE_AMP] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_BQUOTE] = ACTIONS(2967),
    [sym_comment] = ACTIONS(54),
  },
  [1250] = {
    [anon_sym_fi] = ACTIONS(2969),
    [sym_comment] = ACTIONS(54),
  },
  [1251] = {
    [anon_sym_PIPE] = ACTIONS(2971),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_PIPE_AMP] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_BQUOTE] = ACTIONS(2973),
    [sym_comment] = ACTIONS(54),
  },
  [1252] = {
    [sym_case_item] = STATE(746),
    [sym_concatenation] = STATE(747),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [aux_sym_case_statement_repeat1] = STATE(1012),
    [anon_sym_esac] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [sym_raw_string] = ACTIONS(1491),
    [anon_sym_DOLLAR] = ACTIONS(284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_word] = ACTIONS(1493),
    [sym_comment] = ACTIONS(54),
  },
  [1253] = {
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_PIPE_AMP] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_BQUOTE] = ACTIONS(2979),
    [sym_comment] = ACTIONS(54),
  },
  [1254] = {
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_RPAREN] = ACTIONS(2042),
    [anon_sym_PIPE_AMP] = ACTIONS(2042),
    [anon_sym_AMP_AMP] = ACTIONS(2042),
    [anon_sym_PIPE_PIPE] = ACTIONS(2042),
    [anon_sym_BQUOTE] = ACTIONS(2042),
    [sym_comment] = ACTIONS(54),
  },
  [1255] = {
    [sym__concat] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [sym_comment] = ACTIONS(54),
  },
  [1256] = {
    [sym__concat] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [1257] = {
    [aux_sym_concatenation_repeat1] = STATE(1257),
    [sym__concat] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [1258] = {
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [sym_comment] = ACTIONS(54),
  },
  [1259] = {
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [sym_comment] = ACTIONS(54),
  },
  [1260] = {
    [sym__concat] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_PIPE_AMP] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(54),
  },
  [1261] = {
    [anon_sym_AT] = ACTIONS(2992),
    [sym_comment] = ACTIONS(54),
  },
  [1262] = {
    [sym_concatenation] = STATE(1355),
    [sym_string] = STATE(1354),
    [sym_simple_expansion] = STATE(1354),
    [sym_expansion] = STATE(1354),
    [sym_command_substitution] = STATE(1354),
    [sym_process_substitution] = STATE(1354),
    [anon_sym_RBRACE] = ACTIONS(2994),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(2996),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(2998),
    [sym_comment] = ACTIONS(54),
  },
  [1263] = {
    [sym__concat] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(54),
  },
  [1264] = {
    [anon_sym_AT] = ACTIONS(3000),
    [sym_comment] = ACTIONS(54),
  },
  [1265] = {
    [sym_concatenation] = STATE(1358),
    [sym_string] = STATE(1357),
    [sym_simple_expansion] = STATE(1357),
    [sym_expansion] = STATE(1357),
    [sym_command_substitution] = STATE(1357),
    [sym_process_substitution] = STATE(1357),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(94),
    [sym_raw_string] = ACTIONS(3002),
    [anon_sym_DOLLAR] = ACTIONS(98),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(102),
    [anon_sym_BQUOTE] = ACTIONS(104),
    [anon_sym_LT_LPAREN] = ACTIONS(106),
    [anon_sym_GT_LPAREN] = ACTIONS(106),
    [sym_word] = ACTIONS(3004),
    [sym_comment] = ACTIONS(54),
  },
  [1266] = {
    [sym__concat] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_PIPE_AMP] = ACTIONS(1197),
    [anon_sym_AMP_AMP] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1197),
    [anon_sym_BQUOTE] = ACTIONS(1197),
    [sym_comment] = ACTIONS(54),
  },
  [1267] = {
    [sym__concat] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1590),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [sym_comment] = ACTIONS(54),
  },
  [1268] = {
    [anon_sym_RBRACE] = ACTIONS(3006),
    [sym_comment] = ACTIONS(54),
  },
  [1269] = {
    [anon_sym_RBRACE] = ACTIONS(3008),
    [sym_comment] = ACTIONS(54),
  },
  [1270] = {
    [sym_file_descriptor] = ACTIONS(2688),
    [sym__concat] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_PIPE_AMP] = ACTIONS(2688),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2688),
    [anon_sym_AMP_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT_GT] = ACTIONS(2688),
    [anon_sym_LT_AMP] = ACTIONS(2688),
    [anon_sym_GT_AMP] = ACTIONS(2688),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_LT_LT_DASH] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [sym_raw_string] = ACTIONS(2688),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2688),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [anon_sym_LT_LPAREN] = ACTIONS(2688),
    [anon_sym_GT_LPAREN] = ACTIONS(2688),
    [sym_word] = ACTIONS(2690),
    [sym_comment] = ACTIONS(54),
  },
  [1271] = {
    [sym_file_descriptor] = ACTIONS(2692),
    [sym__concat] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_PIPE_AMP] = ACTIONS(2692),
    [anon_sym_AMP_AMP] = ACTIONS(2692),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2692),
    [anon_sym_LT_AMP] = ACTIONS(2692),
    [anon_sym_GT_AMP] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_LT_LT_DASH] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [sym_raw_string] = ACTIONS(2692),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2692),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [anon_sym_LT_LPAREN] = ACTIONS(2692),
    [anon_sym_GT_LPAREN] = ACTIONS(2692),
    [sym_word] = ACTIONS(2694),
    [sym_comment] = ACTIONS(54),
  },
  [1272] = {
    [sym_file_descriptor] = ACTIONS(1680),
    [sym__concat] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [anon_sym_PIPE_AMP] = ACTIONS(1680),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_PIPE_PIPE] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(1680),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(1680),
    [anon_sym_LT_AMP] = ACTIONS(1680),
    [anon_sym_GT_AMP] = ACTIONS(1680),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [sym_comment] = ACTIONS(54),
  },
  [1273] = {
    [anon_sym_AT] = ACTIONS(3010),
    [sym_comment] = ACTIONS(54),
  },
  [1274] = {
    [sym_file_descriptor] = ACTIONS(1686),
    [sym__concat] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_PIPE_AMP] = ACTIONS(1686),
    [anon_sym_AMP_AMP] = ACTIONS(1686),
    [anon_sym_PIPE_PIPE] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_GT_GT] = ACTIONS(1686),
    [anon_sym_AMP_GT] = ACTIONS(2201),
    [anon_sym_AMP_GT_GT] = ACTIONS(1686),
    [anon_sym_LT_AMP] = ACTIONS(1686),
    [anon_sym_GT_AMP] = ACTIONS(1686),
    [anon_sym_LT_LT] = ACTIONS(2201),
    [anon_sym_LT_LT_DASH] = ACTIONS(1686),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(54),
  },
  [1275] = {
    [anon_sym_AT] = ACTIONS(3012),
    [sym_comment] = ACTIONS(54),
  },
  [1276] = {
    [anon_sym_RBRACK] = ACTIONS(3014),
    [sym_comment] = ACTIONS(54),
  },
  [1277] = {
    [sym_file_descriptor] = ACTIONS(1694),
    [sym__concat] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(1694),
    [anon_sym_PIPE_AMP] = ACTIONS(1694),
    [anon_sym_AMP_AMP] = ACTIONS(1694),
    [anon_sym_PIPE_PIPE] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_AMP_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT_GT] = ACTIONS(1694),
    [anon_sym_LT_AMP] = ACTIONS(1694),
    [anon_sym_GT_AMP] = ACTIONS(1694),
    [anon_sym_LT_LT] = ACTIONS(2207),
    [anon_sym_LT_LT_DASH] = ACTIONS(1694),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [sym_comment] = ACTIONS(54),
  },
  [1278] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [sym_comment] = ACTIONS(54),
  },
  [1279] = {
    [anon_sym_RBRACE] = ACTIONS(3016),
    [sym_comment] = ACTIONS(54),
  },
  [1280] = {
    [anon_sym_RBRACK] = ACTIONS(3018),
    [sym_comment] = ACTIONS(54),
  },
  [1281] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(3020),
    [sym_comment] = ACTIONS(54),
  },
  [1282] = {
    [anon_sym_RBRACE] = ACTIONS(3020),
    [sym_comment] = ACTIONS(54),
  },
  [1283] = {
    [aux_sym_concatenation_repeat1] = STATE(1283),
    [sym__concat] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_PIPE_AMP] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(54),
  },
  [1284] = {
    [anon_sym_RBRACK] = ACTIONS(3022),
    [sym_comment] = ACTIONS(54),
  },
  [1285] = {
    [anon_sym_RBRACK] = ACTIONS(3024),
    [sym_comment] = ACTIONS(54),
  },
  [1286] = {
    [anon_sym_RBRACE] = ACTIONS(3026),
    [sym_comment] = ACTIONS(54),
  },
  [1287] = {
    [sym_file_descriptor] = ACTIONS(2287),
    [sym__concat] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2289),
    [anon_sym_RPAREN] = ACTIONS(2289),
    [anon_sym_SEMI_SEMI] = ACTIONS(2289),
    [anon_sym_PIPE_AMP] = ACTIONS(2289),
    [anon_sym_AMP_AMP] = ACTIONS(2289),
    [anon_sym_PIPE_PIPE] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(2289),
    [anon_sym_GT] = ACTIONS(2289),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_AMP_GT] = ACTIONS(2289),
    [anon_sym_AMP_GT_GT] = ACTIONS(2289),
    [anon_sym_LT_AMP] = ACTIONS(2289),
    [anon_sym_GT_AMP] = ACTIONS(2289),
    [anon_sym_LT_LT] = ACTIONS(2289),
    [anon_sym_LT_LT_DASH] = ACTIONS(2289),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_LF] = ACTIONS(2289),
    [anon_sym_AMP] = ACTIONS(2289),
  },
  [1288] = {
    [anon_sym_RBRACE] = ACTIONS(3028),
    [sym_comment] = ACTIONS(54),
  },
  [1289] = {
    [sym_file_descriptor] = ACTIONS(2293),
    [sym__concat] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_RPAREN] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_AMP_GT] = ACTIONS(2295),
    [anon_sym_AMP_GT_GT] = ACTIONS(2295),
    [anon_sym_LT_AMP] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_LT_LT_DASH] = ACTIONS(2295),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LF] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
  },
  [1290] = {
    [sym__heredoc_middle] = ACTIONS(1680),
    [sym__heredoc_end] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(2197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1680),
    [sym_comment] = ACTIONS(54),
  },
  [1291] = {
    [anon_sym_AT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(54),
  },
  [1292] = {
    [sym__heredoc_middle] = ACTIONS(1686),
    [sym__heredoc_end] = ACTIONS(1686),
    [anon_sym_DOLLAR] = ACTIONS(2201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(54),
  },
  [1293] = {
    [anon_sym_AT] = ACTIONS(3032),
    [sym_comment] = ACTIONS(54),
  },
  [1294] = {
    [anon_sym_RBRACK] = ACTIONS(3034),
    [sym_comment] = ACTIONS(54),
  },
  [1295] = {
    [sym__heredoc_middle] = ACTIONS(1694),
    [sym__heredoc_end] = ACTIONS(1694),
    [anon_sym_DOLLAR] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1694),
    [sym_comment] = ACTIONS(54),
  },
  [1296] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [sym_comment] = ACTIONS(54),
  },
  [1297] = {
    [anon_sym_RBRACE] = ACTIONS(3036),
    [sym_comment] = ACTIONS(54),
  },
  [1298] = {
    [anon_sym_RBRACK] = ACTIONS(3038),
    [sym_comment] = ACTIONS(54),
  },
  [1299] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [sym_comment] = ACTIONS(54),
  },
  [1300] = {
    [anon_sym_RBRACE] = ACTIONS(3040),
    [sym_comment] = ACTIONS(54),
  },
  [1301] = {
    [anon_sym_RBRACE] = ACTIONS(3042),
    [sym_comment] = ACTIONS(54),
  },
  [1302] = {
    [anon_sym_RBRACE] = ACTIONS(3044),
    [sym_comment] = ACTIONS(54),
  },
  [1303] = {
    [sym__concat] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2688),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_RBRACK] = ACTIONS(2688),
    [sym_comment] = ACTIONS(54),
  },
  [1304] = {
    [sym__concat] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2692),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_RBRACK] = ACTIONS(2692),
    [sym_comment] = ACTIONS(54),
  },
  [1305] = {
    [anon_sym_RBRACK] = ACTIONS(3046),
    [sym_comment] = ACTIONS(54),
  },
  [1306] = {
    [anon_sym_RBRACK] = ACTIONS(3048),
    [sym_comment] = ACTIONS(54),
  },
  [1307] = {
    [anon_sym_RBRACE] = ACTIONS(3050),
    [sym_comment] = ACTIONS(54),
  },
  [1308] = {
    [sym__concat] = ACTIONS(2287),
    [anon_sym_RPAREN] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_raw_string] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [anon_sym_LT_LPAREN] = ACTIONS(2287),
    [anon_sym_GT_LPAREN] = ACTIONS(2287),
    [sym_word] = ACTIONS(2629),
    [sym_comment] = ACTIONS(54),
  },
  [1309] = {
    [anon_sym_RBRACE] = ACTIONS(3052),
    [sym_comment] = ACTIONS(54),
  },
  [1310] = {
    [sym__concat] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2293),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [anon_sym_LT_LPAREN] = ACTIONS(2293),
    [anon_sym_GT_LPAREN] = ACTIONS(2293),
    [sym_word] = ACTIONS(2633),
    [sym_comment] = ACTIONS(54),
  },
  [1311] = {
    [anon_sym_RBRACE] = ACTIONS(3054),
    [sym_comment] = ACTIONS(54),
  },
  [1312] = {
    [anon_sym_RBRACE] = ACTIONS(3056),
    [sym_comment] = ACTIONS(54),
  },
  [1313] = {
    [sym_file_descriptor] = ACTIONS(2688),
    [sym__concat] = ACTIONS(2688),
    [sym_variable_name] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2690),
    [anon_sym_RPAREN] = ACTIONS(2690),
    [anon_sym_SEMI_SEMI] = ACTIONS(2690),
    [anon_sym_PIPE_AMP] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_GT] = ACTIONS(2690),
    [anon_sym_GT_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT_GT] = ACTIONS(2690),
    [anon_sym_LT_AMP] = ACTIONS(2690),
    [anon_sym_GT_AMP] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [sym_raw_string] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2690),
    [anon_sym_BQUOTE] = ACTIONS(2690),
    [anon_sym_LT_LPAREN] = ACTIONS(2690),
    [anon_sym_GT_LPAREN] = ACTIONS(2690),
    [sym_word] = ACTIONS(2690),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_LF] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2690),
  },
  [1314] = {
    [sym_file_descriptor] = ACTIONS(2692),
    [sym__concat] = ACTIONS(2692),
    [sym_variable_name] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_RPAREN] = ACTIONS(2694),
    [anon_sym_SEMI_SEMI] = ACTIONS(2694),
    [anon_sym_PIPE_AMP] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_PIPE_PIPE] = ACTIONS(2694),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2694),
    [anon_sym_AMP_GT] = ACTIONS(2694),
    [anon_sym_AMP_GT_GT] = ACTIONS(2694),
    [anon_sym_LT_AMP] = ACTIONS(2694),
    [anon_sym_GT_AMP] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [sym_raw_string] = ACTIONS(2694),
    [anon_sym_DOLLAR] = ACTIONS(2694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2694),
    [anon_sym_BQUOTE] = ACTIONS(2694),
    [anon_sym_LT_LPAREN] = ACTIONS(2694),
    [anon_sym_GT_LPAREN] = ACTIONS(2694),
    [sym_word] = ACTIONS(2694),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_LF] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2694),
  },
  [1315] = {
    [anon_sym_RBRACK] = ACTIONS(3058),
    [sym_comment] = ACTIONS(54),
  },
  [1316] = {
    [anon_sym_RBRACK] = ACTIONS(3060),
    [sym_comment] = ACTIONS(54),
  },
  [1317] = {
    [anon_sym_RBRACE] = ACTIONS(3062),
    [sym_comment] = ACTIONS(54),
  },
  [1318] = {
    [sym__concat] = ACTIONS(2287),
    [anon_sym_SEMI_SEMI] = ACTIONS(2289),
    [anon_sym_DQUOTE] = ACTIONS(2289),
    [sym_raw_string] = ACTIONS(2289),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2289),
    [anon_sym_BQUOTE] = ACTIONS(2289),
    [anon_sym_LT_LPAREN] = ACTIONS(2289),
    [anon_sym_GT_LPAREN] = ACTIONS(2289),
    [sym_word] = ACTIONS(2289),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_LF] = ACTIONS(2289),
    [anon_sym_AMP] = ACTIONS(2289),
  },
  [1319] = {
    [anon_sym_RBRACE] = ACTIONS(3064),
    [sym_comment] = ACTIONS(54),
  },
  [1320] = {
    [sym__concat] = ACTIONS(2293),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_DQUOTE] = ACTIONS(2295),
    [sym_raw_string] = ACTIONS(2295),
    [anon_sym_DOLLAR] = ACTIONS(2295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(2295),
    [anon_sym_LT_LPAREN] = ACTIONS(2295),
    [anon_sym_GT_LPAREN] = ACTIONS(2295),
    [sym_word] = ACTIONS(2295),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LF] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
  },
  [1321] = {
    [anon_sym_esac] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3068),
    [sym_raw_string] = ACTIONS(3068),
    [anon_sym_DOLLAR] = ACTIONS(3066),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3068),
    [anon_sym_BQUOTE] = ACTIONS(3068),
    [anon_sym_LT_LPAREN] = ACTIONS(3068),
    [anon_sym_GT_LPAREN] = ACTIONS(3068),
    [sym_word] = ACTIONS(3070),
    [sym_comment] = ACTIONS(54),
  },
  [1322] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(1322),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(634),
    [sym_variable_name] = ACTIONS(637),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(651),
    [anon_sym_SEMI_SEMI] = ACTIONS(640),
    [anon_sym_function] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(663),
    [anon_sym_local] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_AMP_GT] = ACTIONS(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(672),
    [anon_sym_LT_AMP] = ACTIONS(672),
    [anon_sym_GT_AMP] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(678),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_word] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
  },
  [1323] = {
    [sym__terminated_statement] = STATE(23),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_subshell] = STATE(24),
    [sym_pipeline] = STATE(24),
    [sym_list] = STATE(24),
    [sym_bracket_command] = STATE(24),
    [sym_command] = STATE(24),
    [sym_command_name] = STATE(25),
    [sym_environment_variable_assignment] = STATE(26),
    [sym_local_variable_declaration] = STATE(24),
    [sym_subscript] = STATE(27),
    [sym_file_redirect] = STATE(28),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(15),
    [sym_simple_expansion] = STATE(15),
    [sym_expansion] = STATE(15),
    [sym_command_substitution] = STATE(15),
    [sym_process_substitution] = STATE(15),
    [aux_sym_program_repeat1] = STATE(1322),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(3072),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [anon_sym_DQUOTE] = ACTIONS(38),
    [sym_raw_string] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(44),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(46),
    [anon_sym_BQUOTE] = ACTIONS(48),
    [anon_sym_LT_LPAREN] = ACTIONS(50),
    [anon_sym_GT_LPAREN] = ACTIONS(50),
    [sym_word] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
  },
  [1324] = {
    [sym__concat] = ACTIONS(2941),
    [anon_sym_in] = ACTIONS(2943),
    [anon_sym_SEMI_SEMI] = ACTIONS(2943),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_LF] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2943),
  },
  [1325] = {
    [sym__concat] = ACTIONS(2945),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_SEMI_SEMI] = ACTIONS(2947),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
  },
  [1326] = {
    [sym__concat] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2941),
    [anon_sym_RBRACK] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_raw_string] = ACTIONS(2941),
    [anon_sym_DOLLAR] = ACTIONS(3074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2941),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [anon_sym_LT_LPAREN] = ACTIONS(2941),
    [anon_sym_GT_LPAREN] = ACTIONS(2941),
    [sym_word] = ACTIONS(2943),
    [sym_comment] = ACTIONS(54),
  },
  [1327] = {
    [sym__concat] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_RBRACK] = ACTIONS(3076),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(3076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [sym_word] = ACTIONS(2947),
    [sym_comment] = ACTIONS(54),
  },
  [1328] = {
    [sym__concat] = ACTIONS(2941),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_raw_string] = ACTIONS(2941),
    [anon_sym_DOLLAR] = ACTIONS(3074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2941),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [anon_sym_LT_LPAREN] = ACTIONS(2941),
    [anon_sym_GT_LPAREN] = ACTIONS(2941),
    [sym_word] = ACTIONS(2943),
    [sym_comment] = ACTIONS(54),
  },
  [1329] = {
    [sym__concat] = ACTIONS(2945),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3076),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(3076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [sym_word] = ACTIONS(2947),
    [sym_comment] = ACTIONS(54),
  },
  [1330] = {
    [anon_sym_RBRACK] = ACTIONS(3078),
    [sym_comment] = ACTIONS(54),
  },
  [1331] = {
    [anon_sym_RBRACK] = ACTIONS(3080),
    [sym_comment] = ACTIONS(54),
  },
  [1332] = {
    [anon_sym_RBRACE] = ACTIONS(3082),
    [sym_comment] = ACTIONS(54),
  },
  [1333] = {
    [sym__concat] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2289),
    [anon_sym_RPAREN] = ACTIONS(2289),
    [anon_sym_SEMI_SEMI] = ACTIONS(2289),
    [anon_sym_PIPE_AMP] = ACTIONS(2289),
    [anon_sym_AMP_AMP] = ACTIONS(2289),
    [anon_sym_PIPE_PIPE] = ACTIONS(2289),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_LF] = ACTIONS(2289),
    [anon_sym_AMP] = ACTIONS(2289),
  },
  [1334] = {
    [anon_sym_RBRACE] = ACTIONS(3084),
    [sym_comment] = ACTIONS(54),
  },
  [1335] = {
    [sym__concat] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_RPAREN] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LF] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
  },
  [1336] = {
    [sym_file_descriptor] = ACTIONS(2941),
    [sym__concat] = ACTIONS(2941),
    [sym_variable_name] = ACTIONS(2941),
    [anon_sym_LT] = ACTIONS(3074),
    [anon_sym_GT] = ACTIONS(3074),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_AMP_GT] = ACTIONS(3074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2941),
    [anon_sym_LT_AMP] = ACTIONS(2941),
    [anon_sym_GT_AMP] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_raw_string] = ACTIONS(2941),
    [anon_sym_DOLLAR] = ACTIONS(3074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2941),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [anon_sym_LT_LPAREN] = ACTIONS(2941),
    [anon_sym_GT_LPAREN] = ACTIONS(2941),
    [sym_word] = ACTIONS(3074),
    [sym_comment] = ACTIONS(54),
  },
  [1337] = {
    [sym_file_descriptor] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2945),
    [sym_variable_name] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(3076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(3076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [sym_word] = ACTIONS(3076),
    [sym_comment] = ACTIONS(54),
  },
  [1338] = {
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(3074),
    [anon_sym_DOLLAR] = ACTIONS(2943),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2943),
    [anon_sym_BQUOTE] = ACTIONS(2943),
    [sym_comment] = ACTIONS(156),
  },
  [1339] = {
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(3076),
    [anon_sym_DOLLAR] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2947),
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [sym_comment] = ACTIONS(156),
  },
  [1340] = {
    [anon_sym_RBRACK] = ACTIONS(3086),
    [sym_comment] = ACTIONS(54),
  },
  [1341] = {
    [anon_sym_RBRACK] = ACTIONS(3088),
    [sym_comment] = ACTIONS(54),
  },
  [1342] = {
    [anon_sym_RBRACE] = ACTIONS(3090),
    [sym_comment] = ACTIONS(54),
  },
  [1343] = {
    [sym_file_descriptor] = ACTIONS(2287),
    [sym__concat] = ACTIONS(2287),
    [sym_variable_name] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2629),
    [anon_sym_RPAREN] = ACTIONS(2287),
    [anon_sym_PIPE_AMP] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2287),
    [anon_sym_PIPE_PIPE] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_AMP_GT] = ACTIONS(2629),
    [anon_sym_AMP_GT_GT] = ACTIONS(2287),
    [anon_sym_LT_AMP] = ACTIONS(2287),
    [anon_sym_GT_AMP] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [sym_raw_string] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [anon_sym_LT_LPAREN] = ACTIONS(2287),
    [anon_sym_GT_LPAREN] = ACTIONS(2287),
    [sym_word] = ACTIONS(2289),
    [sym_comment] = ACTIONS(54),
  },
  [1344] = {
    [anon_sym_RBRACE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(54),
  },
  [1345] = {
    [sym_file_descriptor] = ACTIONS(2293),
    [sym__concat] = ACTIONS(2293),
    [sym_variable_name] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_PIPE_AMP] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2633),
    [anon_sym_LT] = ACTIONS(2633),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_AMP_GT] = ACTIONS(2633),
    [anon_sym_AMP_GT_GT] = ACTIONS(2293),
    [anon_sym_LT_AMP] = ACTIONS(2293),
    [anon_sym_GT_AMP] = ACTIONS(2293),
    [anon_sym_DQUOTE] = ACTIONS(2293),
    [sym_raw_string] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2293),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [anon_sym_LT_LPAREN] = ACTIONS(2293),
    [anon_sym_GT_LPAREN] = ACTIONS(2293),
    [sym_word] = ACTIONS(2295),
    [sym_comment] = ACTIONS(54),
  },
  [1346] = {
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_RPAREN] = ACTIONS(3096),
    [anon_sym_PIPE_AMP] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_PIPE_PIPE] = ACTIONS(3096),
    [anon_sym_BQUOTE] = ACTIONS(3096),
    [sym_comment] = ACTIONS(54),
  },
  [1347] = {
    [anon_sym_PIPE] = ACTIONS(3098),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [anon_sym_PIPE_AMP] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_PIPE_PIPE] = ACTIONS(3100),
    [anon_sym_BQUOTE] = ACTIONS(3100),
    [sym_comment] = ACTIONS(54),
  },
  [1348] = {
    [sym__concat] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [anon_sym_PIPE_AMP] = ACTIONS(1680),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_PIPE_PIPE] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [sym_comment] = ACTIONS(54),
  },
  [1349] = {
    [anon_sym_AT] = ACTIONS(3102),
    [sym_comment] = ACTIONS(54),
  },
  [1350] = {
    [sym__concat] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_PIPE_AMP] = ACTIONS(1686),
    [anon_sym_AMP_AMP] = ACTIONS(1686),
    [anon_sym_PIPE_PIPE] = ACTIONS(1686),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(54),
  },
  [1351] = {
    [anon_sym_AT] = ACTIONS(3104),
    [sym_comment] = ACTIONS(54),
  },
  [1352] = {
    [anon_sym_RBRACK] = ACTIONS(3106),
    [sym_comment] = ACTIONS(54),
  },
  [1353] = {
    [sym__concat] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(1694),
    [anon_sym_PIPE_AMP] = ACTIONS(1694),
    [anon_sym_AMP_AMP] = ACTIONS(1694),
    [anon_sym_PIPE_PIPE] = ACTIONS(1694),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [sym_comment] = ACTIONS(54),
  },
  [1354] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(3108),
    [sym_comment] = ACTIONS(54),
  },
  [1355] = {
    [anon_sym_RBRACE] = ACTIONS(3108),
    [sym_comment] = ACTIONS(54),
  },
  [1356] = {
    [anon_sym_RBRACK] = ACTIONS(3110),
    [sym_comment] = ACTIONS(54),
  },
  [1357] = {
    [aux_sym_concatenation_repeat1] = STATE(838),
    [sym__concat] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(3112),
    [sym_comment] = ACTIONS(54),
  },
  [1358] = {
    [anon_sym_RBRACE] = ACTIONS(3112),
    [sym_comment] = ACTIONS(54),
  },
  [1359] = {
    [sym_file_descriptor] = ACTIONS(2941),
    [sym__concat] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(3074),
    [anon_sym_RPAREN] = ACTIONS(2941),
    [anon_sym_PIPE_AMP] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3074),
    [anon_sym_GT] = ACTIONS(3074),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_AMP_GT] = ACTIONS(3074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2941),
    [anon_sym_LT_AMP] = ACTIONS(2941),
    [anon_sym_GT_AMP] = ACTIONS(2941),
    [anon_sym_LT_LT] = ACTIONS(3074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_raw_string] = ACTIONS(2941),
    [anon_sym_DOLLAR] = ACTIONS(3074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2941),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [anon_sym_LT_LPAREN] = ACTIONS(2941),
    [anon_sym_GT_LPAREN] = ACTIONS(2941),
    [sym_word] = ACTIONS(2943),
    [sym_comment] = ACTIONS(54),
  },
  [1360] = {
    [sym_file_descriptor] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(3076),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3076),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(3076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(3076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(3076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [sym_word] = ACTIONS(2947),
    [sym_comment] = ACTIONS(54),
  },
  [1361] = {
    [anon_sym_RBRACK] = ACTIONS(3114),
    [sym_comment] = ACTIONS(54),
  },
  [1362] = {
    [anon_sym_RBRACK] = ACTIONS(3116),
    [sym_comment] = ACTIONS(54),
  },
  [1363] = {
    [anon_sym_RBRACE] = ACTIONS(3118),
    [sym_comment] = ACTIONS(54),
  },
  [1364] = {
    [sym_file_descriptor] = ACTIONS(2287),
    [sym__concat] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2629),
    [anon_sym_RPAREN] = ACTIONS(2287),
    [anon_sym_PIPE_AMP] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2287),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_AMP_GT] = ACTIONS(2629),
    [anon_sym_AMP_GT_GT] = ACTIONS(2287),
    [anon_sym_LT_AMP] = ACTIONS(2287),
    [anon_sym_GT_AMP] = ACTIONS(2287),
    [anon_sym_LT_LT] = ACTIONS(2629),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [sym_comment] = ACTIONS(54),
  },
  [1365] = {
    [anon_sym_RBRACE] = ACTIONS(3120),
    [sym_comment] = ACTIONS(54),
  },
  [1366] = {
    [sym_file_descriptor] = ACTIONS(2293),
    [sym__concat] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_PIPE_AMP] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_LT] = ACTIONS(2633),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_AMP_GT] = ACTIONS(2633),
    [anon_sym_AMP_GT_GT] = ACTIONS(2293),
    [anon_sym_LT_AMP] = ACTIONS(2293),
    [anon_sym_GT_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_DASH] = ACTIONS(2293),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_comment] = ACTIONS(54),
  },
  [1367] = {
    [anon_sym_RBRACE] = ACTIONS(3122),
    [sym_comment] = ACTIONS(54),
  },
  [1368] = {
    [anon_sym_RBRACE] = ACTIONS(3124),
    [sym_comment] = ACTIONS(54),
  },
  [1369] = {
    [sym_file_descriptor] = ACTIONS(2688),
    [sym__concat] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2690),
    [anon_sym_RPAREN] = ACTIONS(2690),
    [anon_sym_SEMI_SEMI] = ACTIONS(2690),
    [anon_sym_PIPE_AMP] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_GT] = ACTIONS(2690),
    [anon_sym_GT_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT_GT] = ACTIONS(2690),
    [anon_sym_LT_AMP] = ACTIONS(2690),
    [anon_sym_GT_AMP] = ACTIONS(2690),
    [anon_sym_LT_LT] = ACTIONS(2690),
    [anon_sym_LT_LT_DASH] = ACTIONS(2690),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_LF] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2690),
  },
  [1370] = {
    [sym_file_descriptor] = ACTIONS(2692),
    [sym__concat] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_RPAREN] = ACTIONS(2694),
    [anon_sym_SEMI_SEMI] = ACTIONS(2694),
    [anon_sym_PIPE_AMP] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_PIPE_PIPE] = ACTIONS(2694),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2694),
    [anon_sym_AMP_GT] = ACTIONS(2694),
    [anon_sym_AMP_GT_GT] = ACTIONS(2694),
    [anon_sym_LT_AMP] = ACTIONS(2694),
    [anon_sym_GT_AMP] = ACTIONS(2694),
    [anon_sym_LT_LT] = ACTIONS(2694),
    [anon_sym_LT_LT_DASH] = ACTIONS(2694),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_LF] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2694),
  },
  [1371] = {
    [anon_sym_RBRACK] = ACTIONS(3126),
    [sym_comment] = ACTIONS(54),
  },
  [1372] = {
    [anon_sym_RBRACK] = ACTIONS(3128),
    [sym_comment] = ACTIONS(54),
  },
  [1373] = {
    [anon_sym_RBRACE] = ACTIONS(3130),
    [sym_comment] = ACTIONS(54),
  },
  [1374] = {
    [sym__heredoc_middle] = ACTIONS(2287),
    [sym__heredoc_end] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2287),
    [sym_comment] = ACTIONS(54),
  },
  [1375] = {
    [anon_sym_RBRACE] = ACTIONS(3132),
    [sym_comment] = ACTIONS(54),
  },
  [1376] = {
    [sym__heredoc_middle] = ACTIONS(2293),
    [sym__heredoc_end] = ACTIONS(2293),
    [anon_sym_DOLLAR] = ACTIONS(2633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2293),
    [sym_comment] = ACTIONS(54),
  },
  [1377] = {
    [sym__concat] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(2941),
    [anon_sym_RPAREN] = ACTIONS(2941),
    [anon_sym_RBRACK] = ACTIONS(2941),
    [sym_comment] = ACTIONS(54),
  },
  [1378] = {
    [sym__concat] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_RBRACK] = ACTIONS(2945),
    [sym_comment] = ACTIONS(54),
  },
  [1379] = {
    [anon_sym_RBRACE] = ACTIONS(3134),
    [sym_comment] = ACTIONS(54),
  },
  [1380] = {
    [anon_sym_RBRACE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(54),
  },
  [1381] = {
    [sym__concat] = ACTIONS(2688),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [sym_raw_string] = ACTIONS(2688),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2688),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [anon_sym_LT_LPAREN] = ACTIONS(2688),
    [anon_sym_GT_LPAREN] = ACTIONS(2688),
    [sym_word] = ACTIONS(2913),
    [sym_comment] = ACTIONS(54),
  },
  [1382] = {
    [sym__concat] = ACTIONS(2692),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [sym_raw_string] = ACTIONS(2692),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2692),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [anon_sym_LT_LPAREN] = ACTIONS(2692),
    [anon_sym_GT_LPAREN] = ACTIONS(2692),
    [sym_word] = ACTIONS(2915),
    [sym_comment] = ACTIONS(54),
  },
  [1383] = {
    [sym_file_descriptor] = ACTIONS(2941),
    [sym__concat] = ACTIONS(2941),
    [sym_variable_name] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_SEMI_SEMI] = ACTIONS(2943),
    [anon_sym_PIPE_AMP] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(2943),
    [anon_sym_GT_GT] = ACTIONS(2943),
    [anon_sym_AMP_GT] = ACTIONS(2943),
    [anon_sym_AMP_GT_GT] = ACTIONS(2943),
    [anon_sym_LT_AMP] = ACTIONS(2943),
    [anon_sym_GT_AMP] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [sym_raw_string] = ACTIONS(2943),
    [anon_sym_DOLLAR] = ACTIONS(2943),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2943),
    [anon_sym_BQUOTE] = ACTIONS(2943),
    [anon_sym_LT_LPAREN] = ACTIONS(2943),
    [anon_sym_GT_LPAREN] = ACTIONS(2943),
    [sym_word] = ACTIONS(2943),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_LF] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2943),
  },
  [1384] = {
    [sym_file_descriptor] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2945),
    [sym_variable_name] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_SEMI_SEMI] = ACTIONS(2947),
    [anon_sym_PIPE_AMP] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_GT] = ACTIONS(2947),
    [anon_sym_AMP_GT_GT] = ACTIONS(2947),
    [anon_sym_LT_AMP] = ACTIONS(2947),
    [anon_sym_GT_AMP] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_raw_string] = ACTIONS(2947),
    [anon_sym_DOLLAR] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2947),
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2947),
    [anon_sym_GT_LPAREN] = ACTIONS(2947),
    [sym_word] = ACTIONS(2947),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
  },
  [1385] = {
    [anon_sym_RBRACE] = ACTIONS(3138),
    [sym_comment] = ACTIONS(54),
  },
  [1386] = {
    [anon_sym_RBRACE] = ACTIONS(3140),
    [sym_comment] = ACTIONS(54),
  },
  [1387] = {
    [sym__concat] = ACTIONS(2688),
    [anon_sym_SEMI_SEMI] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [sym_raw_string] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2690),
    [anon_sym_BQUOTE] = ACTIONS(2690),
    [anon_sym_LT_LPAREN] = ACTIONS(2690),
    [anon_sym_GT_LPAREN] = ACTIONS(2690),
    [sym_word] = ACTIONS(2690),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_LF] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2690),
  },
  [1388] = {
    [sym__concat] = ACTIONS(2692),
    [anon_sym_SEMI_SEMI] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [sym_raw_string] = ACTIONS(2694),
    [anon_sym_DOLLAR] = ACTIONS(2694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2694),
    [anon_sym_BQUOTE] = ACTIONS(2694),
    [anon_sym_LT_LPAREN] = ACTIONS(2694),
    [anon_sym_GT_LPAREN] = ACTIONS(2694),
    [sym_word] = ACTIONS(2694),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_LF] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2694),
  },
  [1389] = {
    [anon_sym_esac] = ACTIONS(3142),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [sym_raw_string] = ACTIONS(3144),
    [anon_sym_DOLLAR] = ACTIONS(3142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3144),
    [anon_sym_BQUOTE] = ACTIONS(3144),
    [anon_sym_LT_LPAREN] = ACTIONS(3144),
    [anon_sym_GT_LPAREN] = ACTIONS(3144),
    [sym_word] = ACTIONS(3146),
    [sym_comment] = ACTIONS(54),
  },
  [1390] = {
    [anon_sym_RBRACE] = ACTIONS(3148),
    [sym_comment] = ACTIONS(54),
  },
  [1391] = {
    [anon_sym_RBRACE] = ACTIONS(3150),
    [sym_comment] = ACTIONS(54),
  },
  [1392] = {
    [sym__concat] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2690),
    [anon_sym_RPAREN] = ACTIONS(2690),
    [anon_sym_SEMI_SEMI] = ACTIONS(2690),
    [anon_sym_PIPE_AMP] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_LF] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2690),
  },
  [1393] = {
    [sym__concat] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_RPAREN] = ACTIONS(2694),
    [anon_sym_SEMI_SEMI] = ACTIONS(2694),
    [anon_sym_PIPE_AMP] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_PIPE_PIPE] = ACTIONS(2694),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_LF] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2694),
  },
  [1394] = {
    [anon_sym_RBRACE] = ACTIONS(3152),
    [sym_comment] = ACTIONS(54),
  },
  [1395] = {
    [anon_sym_RBRACE] = ACTIONS(3154),
    [sym_comment] = ACTIONS(54),
  },
  [1396] = {
    [sym_file_descriptor] = ACTIONS(2688),
    [sym__concat] = ACTIONS(2688),
    [sym_variable_name] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_PIPE_AMP] = ACTIONS(2688),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2688),
    [anon_sym_AMP_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT_GT] = ACTIONS(2688),
    [anon_sym_LT_AMP] = ACTIONS(2688),
    [anon_sym_GT_AMP] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [sym_raw_string] = ACTIONS(2688),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2688),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [anon_sym_LT_LPAREN] = ACTIONS(2688),
    [anon_sym_GT_LPAREN] = ACTIONS(2688),
    [sym_word] = ACTIONS(2690),
    [sym_comment] = ACTIONS(54),
  },
  [1397] = {
    [sym_file_descriptor] = ACTIONS(2692),
    [sym__concat] = ACTIONS(2692),
    [sym_variable_name] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_PIPE_AMP] = ACTIONS(2692),
    [anon_sym_AMP_AMP] = ACTIONS(2692),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2692),
    [anon_sym_LT_AMP] = ACTIONS(2692),
    [anon_sym_GT_AMP] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [sym_raw_string] = ACTIONS(2692),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2692),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [anon_sym_LT_LPAREN] = ACTIONS(2692),
    [anon_sym_GT_LPAREN] = ACTIONS(2692),
    [sym_word] = ACTIONS(2694),
    [sym_comment] = ACTIONS(54),
  },
  [1398] = {
    [anon_sym_RBRACK] = ACTIONS(3156),
    [sym_comment] = ACTIONS(54),
  },
  [1399] = {
    [anon_sym_RBRACK] = ACTIONS(3158),
    [sym_comment] = ACTIONS(54),
  },
  [1400] = {
    [anon_sym_RBRACE] = ACTIONS(3160),
    [sym_comment] = ACTIONS(54),
  },
  [1401] = {
    [sym__concat] = ACTIONS(2287),
    [anon_sym_PIPE] = ACTIONS(2629),
    [anon_sym_RPAREN] = ACTIONS(2287),
    [anon_sym_PIPE_AMP] = ACTIONS(2287),
    [anon_sym_AMP_AMP] = ACTIONS(2287),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [sym_comment] = ACTIONS(54),
  },
  [1402] = {
    [anon_sym_RBRACE] = ACTIONS(3162),
    [sym_comment] = ACTIONS(54),
  },
  [1403] = {
    [sym__concat] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_PIPE_AMP] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_comment] = ACTIONS(54),
  },
  [1404] = {
    [anon_sym_RBRACE] = ACTIONS(3164),
    [sym_comment] = ACTIONS(54),
  },
  [1405] = {
    [anon_sym_RBRACE] = ACTIONS(3166),
    [sym_comment] = ACTIONS(54),
  },
  [1406] = {
    [sym_file_descriptor] = ACTIONS(2688),
    [sym__concat] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_PIPE_AMP] = ACTIONS(2688),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2688),
    [anon_sym_AMP_GT] = ACTIONS(2913),
    [anon_sym_AMP_GT_GT] = ACTIONS(2688),
    [anon_sym_LT_AMP] = ACTIONS(2688),
    [anon_sym_GT_AMP] = ACTIONS(2688),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_LT_LT_DASH] = ACTIONS(2688),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [sym_comment] = ACTIONS(54),
  },
  [1407] = {
    [sym_file_descriptor] = ACTIONS(2692),
    [sym__concat] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_PIPE_AMP] = ACTIONS(2692),
    [anon_sym_AMP_AMP] = ACTIONS(2692),
    [anon_sym_PIPE_PIPE] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_AMP_GT] = ACTIONS(2915),
    [anon_sym_AMP_GT_GT] = ACTIONS(2692),
    [anon_sym_LT_AMP] = ACTIONS(2692),
    [anon_sym_GT_AMP] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_LT_LT_DASH] = ACTIONS(2692),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [sym_comment] = ACTIONS(54),
  },
  [1408] = {
    [sym_file_descriptor] = ACTIONS(2941),
    [sym__concat] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_SEMI_SEMI] = ACTIONS(2943),
    [anon_sym_PIPE_AMP] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(2943),
    [anon_sym_GT_GT] = ACTIONS(2943),
    [anon_sym_AMP_GT] = ACTIONS(2943),
    [anon_sym_AMP_GT_GT] = ACTIONS(2943),
    [anon_sym_LT_AMP] = ACTIONS(2943),
    [anon_sym_GT_AMP] = ACTIONS(2943),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_LT_LT_DASH] = ACTIONS(2943),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_LF] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2943),
  },
  [1409] = {
    [sym_file_descriptor] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_SEMI_SEMI] = ACTIONS(2947),
    [anon_sym_PIPE_AMP] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_GT] = ACTIONS(2947),
    [anon_sym_AMP_GT_GT] = ACTIONS(2947),
    [anon_sym_LT_AMP] = ACTIONS(2947),
    [anon_sym_GT_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_LT_LT_DASH] = ACTIONS(2947),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
  },
  [1410] = {
    [anon_sym_RBRACE] = ACTIONS(3168),
    [sym_comment] = ACTIONS(54),
  },
  [1411] = {
    [anon_sym_RBRACE] = ACTIONS(3170),
    [sym_comment] = ACTIONS(54),
  },
  [1412] = {
    [sym__heredoc_middle] = ACTIONS(2688),
    [sym__heredoc_end] = ACTIONS(2688),
    [anon_sym_DOLLAR] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2688),
    [sym_comment] = ACTIONS(54),
  },
  [1413] = {
    [sym__heredoc_middle] = ACTIONS(2692),
    [sym__heredoc_end] = ACTIONS(2692),
    [anon_sym_DOLLAR] = ACTIONS(2915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2692),
    [sym_comment] = ACTIONS(54),
  },
  [1414] = {
    [sym__concat] = ACTIONS(2941),
    [anon_sym_RPAREN] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_raw_string] = ACTIONS(2941),
    [anon_sym_DOLLAR] = ACTIONS(3074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2941),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [anon_sym_LT_LPAREN] = ACTIONS(2941),
    [anon_sym_GT_LPAREN] = ACTIONS(2941),
    [sym_word] = ACTIONS(3074),
    [sym_comment] = ACTIONS(54),
  },
  [1415] = {
    [sym__concat] = ACTIONS(2945),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(3076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [sym_word] = ACTIONS(3076),
    [sym_comment] = ACTIONS(54),
  },
  [1416] = {
    [sym__concat] = ACTIONS(2941),
    [anon_sym_SEMI_SEMI] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [sym_raw_string] = ACTIONS(2943),
    [anon_sym_DOLLAR] = ACTIONS(2943),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2943),
    [anon_sym_BQUOTE] = ACTIONS(2943),
    [anon_sym_LT_LPAREN] = ACTIONS(2943),
    [anon_sym_GT_LPAREN] = ACTIONS(2943),
    [sym_word] = ACTIONS(2943),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_LF] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2943),
  },
  [1417] = {
    [sym__concat] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_raw_string] = ACTIONS(2947),
    [anon_sym_DOLLAR] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2947),
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2947),
    [anon_sym_GT_LPAREN] = ACTIONS(2947),
    [sym_word] = ACTIONS(2947),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
  },
  [1418] = {
    [sym__concat] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_SEMI_SEMI] = ACTIONS(2943),
    [anon_sym_PIPE_AMP] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_LF] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2943),
  },
  [1419] = {
    [sym__concat] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_SEMI_SEMI] = ACTIONS(2947),
    [anon_sym_PIPE_AMP] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [sym_comment] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2947),
  },
  [1420] = {
    [sym_file_descriptor] = ACTIONS(2941),
    [sym__concat] = ACTIONS(2941),
    [sym_variable_name] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(3074),
    [anon_sym_RPAREN] = ACTIONS(2941),
    [anon_sym_PIPE_AMP] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3074),
    [anon_sym_GT] = ACTIONS(3074),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_AMP_GT] = ACTIONS(3074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2941),
    [anon_sym_LT_AMP] = ACTIONS(2941),
    [anon_sym_GT_AMP] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_raw_string] = ACTIONS(2941),
    [anon_sym_DOLLAR] = ACTIONS(3074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2941),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [anon_sym_LT_LPAREN] = ACTIONS(2941),
    [anon_sym_GT_LPAREN] = ACTIONS(2941),
    [sym_word] = ACTIONS(2943),
    [sym_comment] = ACTIONS(54),
  },
  [1421] = {
    [sym_file_descriptor] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2945),
    [sym_variable_name] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(3076),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(3076),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(3076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(3076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [sym_word] = ACTIONS(2947),
    [sym_comment] = ACTIONS(54),
  },
  [1422] = {
    [anon_sym_RBRACE] = ACTIONS(3172),
    [sym_comment] = ACTIONS(54),
  },
  [1423] = {
    [anon_sym_RBRACE] = ACTIONS(3174),
    [sym_comment] = ACTIONS(54),
  },
  [1424] = {
    [sym__concat] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_PIPE_AMP] = ACTIONS(2688),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [sym_comment] = ACTIONS(54),
  },
  [1425] = {
    [sym__concat] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_PIPE_AMP] = ACTIONS(2692),
    [anon_sym_AMP_AMP] = ACTIONS(2692),
    [anon_sym_PIPE_PIPE] = ACTIONS(2692),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [sym_comment] = ACTIONS(54),
  },
  [1426] = {
    [sym_file_descriptor] = ACTIONS(2941),
    [sym__concat] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(3074),
    [anon_sym_RPAREN] = ACTIONS(2941),
    [anon_sym_PIPE_AMP] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_PIPE_PIPE] = ACTIONS(2941),
    [anon_sym_LT] = ACTIONS(3074),
    [anon_sym_GT] = ACTIONS(3074),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_AMP_GT] = ACTIONS(3074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2941),
    [anon_sym_LT_AMP] = ACTIONS(2941),
    [anon_sym_GT_AMP] = ACTIONS(2941),
    [anon_sym_LT_LT] = ACTIONS(3074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2941),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [sym_comment] = ACTIONS(54),
  },
  [1427] = {
    [sym_file_descriptor] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(3076),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(3076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(3076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [sym_comment] = ACTIONS(54),
  },
  [1428] = {
    [sym__heredoc_middle] = ACTIONS(2941),
    [sym__heredoc_end] = ACTIONS(2941),
    [anon_sym_DOLLAR] = ACTIONS(3074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2941),
    [sym_comment] = ACTIONS(54),
  },
  [1429] = {
    [sym__heredoc_middle] = ACTIONS(2945),
    [sym__heredoc_end] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(3076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [sym_comment] = ACTIONS(54),
  },
  [1430] = {
    [sym__concat] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(3074),
    [anon_sym_RPAREN] = ACTIONS(2941),
    [anon_sym_PIPE_AMP] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_PIPE_PIPE] = ACTIONS(2941),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [sym_comment] = ACTIONS(54),
  },
  [1431] = {
    [sym__concat] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(3076),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [sym_comment] = ACTIONS(54),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false, .depends_on_lookahead = false},
  [1] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(),
  [5] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(), RECOVER(),
  [8] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, RECOVER(),
  [10] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2),
  [12] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(3),
  [14] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 0),
  [16] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(4),
  [18] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(5),
  [20] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(6),
  [22] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(7),
  [24] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(8),
  [26] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(9),
  [28] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(10),
  [30] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(11),
  [32] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(12),
  [34] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(13),
  [36] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(13),
  [38] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(14),
  [40] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(15),
  [42] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(16),
  [44] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(17),
  [46] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(18),
  [48] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(19),
  [50] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(20),
  [52] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(21),
  [54] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT_EXTRA(),
  [56] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(32),
  [58] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(32),
  [60] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(33),
  [62] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(34),
  [64] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(36),
  [66] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(41),
  [68] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(42),
  [70] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(43),
  [72] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(44),
  [74] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(45),
  [76] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(46),
  [78] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(47),
  [80] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(42),
  [82] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(49),
  [84] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(50),
  [86] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(51),
  [88] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(52),
  [90] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(53),
  [92] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(54),
  [94] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(61),
  [96] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(62),
  [98] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(63),
  [100] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(64),
  [102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(65),
  [104] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(66),
  [106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(67),
  [108] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(62),
  [110] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(70),
  [112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(71),
  [114] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(72),
  [116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(73),
  [118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(74),
  [120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(75),
  [122] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(76),
  [124] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(71),
  [126] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(79),
  [128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(80),
  [130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(81),
  [132] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(82),
  [134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(83),
  [136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(84),
  [138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(85),
  [140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(86),
  [142] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(81),
  [144] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(88),
  [146] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(89),
  [148] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(90),
  [150] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(91),
  [152] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(92),
  [154] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(93),
  [156] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(),
  [158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(95),
  [162] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [164] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(97),
  [166] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(98),
  [168] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(97),
  [170] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(100),
  [172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(101),
  [174] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(102),
  [176] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(100),
  [178] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(104),
  [180] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(105),
  [182] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(106),
  [184] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(107),
  [186] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(108),
  [188] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(109),
  [190] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(110),
  [192] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(111),
  [194] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(112),
  [196] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(113),
  [198] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(114),
  [200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(115),
  [202] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(116),
  [204] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(117),
  [206] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(118),
  [208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(119),
  [210] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(120),
  [212] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(121),
  [214] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(128),
  [216] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(129),
  [218] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(130),
  [220] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(131),
  [222] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(132),
  [224] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(140),
  [226] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(141),
  [228] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, ACCEPT_INPUT(),
  [230] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [232] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 1),
  [234] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [236] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(143),
  [238] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(144),
  [240] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(145),
  [242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(146),
  [244] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [246] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(147),
  [248] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(148),
  [250] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(14),
  [252] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(149),
  [254] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(16),
  [256] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(17),
  [258] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(18),
  [260] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(19),
  [262] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(20),
  [264] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [266] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [268] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [270] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 1),
  [272] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(155),
  [274] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(15),
  [276] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(159),
  [278] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(159),
  [280] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(161),
  [282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(162),
  [284] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(163),
  [286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(164),
  [288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(165),
  [290] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(166),
  [292] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(167),
  [294] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(162),
  [296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(169),
  [298] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(170),
  [300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(171),
  [302] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(172),
  [304] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(173),
  [306] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(174),
  [308] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(175),
  [310] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(176),
  [312] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(177),
  [314] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(172),
  [316] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_environment_variable_assignment, 2),
  [318] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_environment_variable_assignment, 2),
  [320] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(178),
  [322] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(179),
  [324] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(181),
  [326] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(182),
  [328] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(183),
  [330] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(185),
  [332] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(186),
  [334] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(187),
  [336] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(189),
  [338] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(190),
  [340] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(189),
  [342] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(192),
  [344] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(193),
  [346] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(201),
  [348] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(141),
  [350] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(203),
  [352] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(204),
  [354] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(205),
  [356] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(207),
  [358] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(209),
  [360] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(210),
  [362] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(211),
  [364] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(212),
  [366] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(213),
  [368] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(214),
  [370] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(215),
  [372] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(53),
  [374] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(222),
  [376] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(224),
  [378] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [380] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [382] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [384] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(226),
  [386] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(227),
  [388] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(226),
  [390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(229),
  [392] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(230),
  [394] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(238),
  [396] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(62),
  [398] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(240),
  [400] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(242),
  [402] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(244),
  [404] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(245),
  [406] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(244),
  [408] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(247),
  [410] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(248),
  [412] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(71),
  [414] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_local_variable_declaration, 2),
  [416] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(257),
  [418] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(259),
  [420] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [422] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(261),
  [424] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2),
  [426] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(263),
  [428] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(264),
  [430] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(263),
  [432] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(266),
  [434] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(267),
  [436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [438] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [440] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 1),
  [442] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 1),
  [444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(275),
  [446] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(276),
  [448] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(275),
  [450] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(278),
  [452] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(279),
  [454] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(285),
  [456] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(287),
  [458] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(287),
  [460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [462] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [464] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [466] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [468] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 1),
  [470] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 1),
  [472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [474] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [476] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_special_variable_name, 1),
  [478] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(289),
  [480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(291),
  [482] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(292),
  [484] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(293),
  [486] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(293),
  [488] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(294),
  [490] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(295),
  [492] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(296),
  [494] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(296),
  [496] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(297),
  [498] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(299),
  [500] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(302),
  [502] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(302),
  [504] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(304),
  [506] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(310),
  [508] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(311),
  [510] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(313),
  [512] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_name, 1),
  [514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(315),
  [516] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(316),
  [518] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(315),
  [520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(318),
  [522] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(319),
  [524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(327),
  [526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(328),
  [528] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(330),
  [530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(331),
  [532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(330),
  [534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(332),
  [536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(333),
  [538] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 1),
  [540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [542] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(334),
  [544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(334),
  [546] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(335),
  [548] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(335),
  [550] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(336),
  [552] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(336),
  [554] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(332),
  [556] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(115),
  [558] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(342),
  [560] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(343),
  [562] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(344),
  [564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(346),
  [566] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(348),
  [568] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(348),
  [570] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(349),
  [572] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(350),
  [574] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(351),
  [576] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(351),
  [578] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(352),
  [580] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(352),
  [582] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(349),
  [584] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(131),
  [586] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(356),
  [588] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(357),
  [590] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(358),
  [592] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(360),
  [594] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 2),
  [596] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(361),
  [598] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [600] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2),
  [602] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [604] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(367),
  [606] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(367),
  [608] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(368),
  [610] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(369),
  [612] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(370),
  [614] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(371),
  [616] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(372),
  [618] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(373),
  [620] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(374),
  [622] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(369),
  [624] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(376),
  [626] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(377),
  [628] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [630] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [632] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [634] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [637] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [640] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2),
  [642] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [645] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [648] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [651] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [654] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [657] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [660] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [663] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [666] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [669] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [672] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [675] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [678] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [681] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [684] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [687] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [690] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [693] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [696] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [699] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(382),
  [701] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [704] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(155),
  [707] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(13),
  [710] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(13),
  [713] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2),
  [715] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2),
  [717] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [719] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3),
  [721] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(385),
  [723] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(387),
  [725] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(388),
  [727] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(390),
  [729] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(391),
  [731] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(390),
  [733] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(393),
  [735] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(394),
  [737] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2),
  [739] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2),
  [741] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(402),
  [743] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(403),
  [745] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(404),
  [747] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(405),
  [749] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(406),
  [751] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(407),
  [753] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(408),
  [755] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(409),
  [757] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(404),
  [759] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(412),
  [761] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(414),
  [763] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(416),
  [765] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(417),
  [767] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(416),
  [769] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(419),
  [771] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(420),
  [773] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(428),
  [775] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(429),
  [777] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(430),
  [779] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(431),
  [781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(432),
  [783] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(433),
  [785] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(434),
  [787] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(429),
  [789] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(437),
  [791] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [793] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(442),
  [795] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(443),
  [797] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(444),
  [799] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(452),
  [801] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(453),
  [803] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(453),
  [805] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(454),
  [807] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(455),
  [809] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(457),
  [811] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(459),
  [813] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(460),
  [815] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(461),
  [817] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(461),
  [819] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(462),
  [821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(463),
  [823] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(464),
  [825] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(464),
  [827] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(465),
  [829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(466),
  [831] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(467),
  [833] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3),
  [835] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(469),
  [837] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(469),
  [839] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(470),
  [841] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(472),
  [843] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(474),
  [845] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(475),
  [847] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(476),
  [849] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [851] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(477),
  [853] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(480),
  [855] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(480),
  [857] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(481),
  [859] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(481),
  [861] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(477),
  [863] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(485),
  [865] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 2),
  [867] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(487),
  [869] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(488),
  [871] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(488),
  [873] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_concatenation, 2),
  [875] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 1),
  [877] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2),
  [879] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(490),
  [881] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(492),
  [883] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(493),
  [885] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(494),
  [887] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(494),
  [889] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(495),
  [891] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(496),
  [893] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(497),
  [895] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(497),
  [897] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(498),
  [899] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(499),
  [901] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [903] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [905] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(61),
  [908] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(62),
  [911] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(63),
  [914] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(64),
  [917] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(65),
  [920] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(66),
  [923] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(67),
  [926] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(62),
  [929] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(500),
  [931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(501),
  [933] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(501),
  [935] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(503),
  [937] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(505),
  [939] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(506),
  [941] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(507),
  [943] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(507),
  [945] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(508),
  [947] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(509),
  [949] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(510),
  [951] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(510),
  [953] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(511),
  [955] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(512),
  [957] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(70),
  [960] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(71),
  [963] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(72),
  [966] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(73),
  [969] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(74),
  [972] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(75),
  [975] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(76),
  [978] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(71),
  [981] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(513),
  [983] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(514),
  [985] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(515),
  [987] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(516),
  [989] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(517),
  [991] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(518),
  [993] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(519),
  [995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(520),
  [997] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(521),
  [999] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(516),
  [1001] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_local_variable_declaration, 3),
  [1003] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(522),
  [1005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(523),
  [1007] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(523),
  [1009] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(525),
  [1011] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(527),
  [1013] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(528),
  [1015] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(529),
  [1017] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(529),
  [1019] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(530),
  [1021] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(531),
  [1023] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(532),
  [1025] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(532),
  [1027] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(533),
  [1029] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(534),
  [1031] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(535),
  [1033] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(537),
  [1035] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(538),
  [1037] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(539),
  [1039] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(539),
  [1041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(540),
  [1043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(541),
  [1045] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(542),
  [1047] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(542),
  [1049] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(543),
  [1051] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [1053] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [1055] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1057] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(89),
  [1060] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(90),
  [1063] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(91),
  [1066] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(92),
  [1069] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(93),
  [1072] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1074] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1076] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(95),
  [1079] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(544),
  [1081] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(545),
  [1083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(546),
  [1085] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(547),
  [1087] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 1),
  [1089] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 1),
  [1091] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(548),
  [1093] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(549),
  [1095] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(550),
  [1097] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(550),
  [1099] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [1101] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [1103] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(552),
  [1105] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(553),
  [1107] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(553),
  [1109] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(555),
  [1111] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(556),
  [1113] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(557),
  [1115] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(558),
  [1117] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(559),
  [1119] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(560),
  [1121] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(561),
  [1123] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(562),
  [1125] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(563),
  [1127] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(558),
  [1129] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_environment_variable_assignment, 2),
  [1131] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(564),
  [1133] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(565),
  [1135] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(567),
  [1137] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(568),
  [1139] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(569),
  [1141] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(570),
  [1143] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(572),
  [1145] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(573),
  [1147] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(576),
  [1149] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_local_variable_declaration, 2),
  [1151] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_local_variable_declaration, 2),
  [1153] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(577),
  [1155] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(579),
  [1157] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(580),
  [1159] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(580),
  [1161] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(582),
  [1163] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(584),
  [1165] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(585),
  [1167] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(586),
  [1169] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(586),
  [1171] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(587),
  [1173] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(588),
  [1175] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(589),
  [1177] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(589),
  [1179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(590),
  [1181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(591),
  [1183] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(592),
  [1185] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(593),
  [1187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(595),
  [1189] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 2),
  [1191] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 2),
  [1193] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(596),
  [1195] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(596),
  [1197] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1199] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1201] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(602),
  [1203] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(602),
  [1205] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(603),
  [1207] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(604),
  [1209] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(605),
  [1211] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(606),
  [1213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(607),
  [1215] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(608),
  [1217] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(609),
  [1219] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(604),
  [1221] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(611),
  [1223] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(612),
  [1225] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 1),
  [1227] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2),
  [1229] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [1231] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(618),
  [1233] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(618),
  [1235] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(619),
  [1237] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(621),
  [1239] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(623),
  [1241] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(624),
  [1243] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(625),
  [1245] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(625),
  [1247] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(629),
  [1249] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(629),
  [1251] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(630),
  [1253] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(630),
  [1255] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1257] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1259] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1261] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1263] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(636),
  [1265] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(638),
  [1267] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(638),
  [1269] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(639),
  [1271] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(639),
  [1273] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [1275] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1277] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(641),
  [1279] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(641),
  [1281] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(643),
  [1283] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(645),
  [1285] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [1287] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(647),
  [1289] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(648),
  [1291] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(647),
  [1293] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(650),
  [1295] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(651),
  [1297] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1299] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1301] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(659),
  [1303] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(660),
  [1305] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(661),
  [1307] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(662),
  [1309] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1311] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1315] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1317] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(14),
  [1320] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(149),
  [1323] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(16),
  [1326] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(17),
  [1329] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(18),
  [1332] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(19),
  [1335] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(20),
  [1338] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1340] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(146),
  [1343] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1345] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(147),
  [1348] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(148),
  [1351] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(664),
  [1353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(665),
  [1355] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(666),
  [1357] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(666),
  [1359] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(668),
  [1361] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(669),
  [1363] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(669),
  [1365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4),
  [1367] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(671),
  [1369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(673),
  [1371] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(674),
  [1373] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(675),
  [1375] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(675),
  [1377] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(676),
  [1379] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(677),
  [1381] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(678),
  [1383] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(678),
  [1385] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(679),
  [1387] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(680),
  [1389] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1391] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1393] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(681),
  [1395] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(683),
  [1397] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(685),
  [1399] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(686),
  [1401] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(685),
  [1403] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(688),
  [1405] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(689),
  [1407] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(697),
  [1409] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(699),
  [1411] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(700),
  [1413] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(700),
  [1415] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(702),
  [1417] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(704),
  [1419] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(705),
  [1421] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(706),
  [1423] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(706),
  [1425] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(707),
  [1427] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(708),
  [1429] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(709),
  [1431] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(709),
  [1433] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(710),
  [1435] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(711),
  [1437] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(712),
  [1439] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(714),
  [1441] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(716),
  [1443] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(717),
  [1445] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(716),
  [1447] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(719),
  [1449] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(720),
  [1451] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(728),
  [1453] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(428),
  [1455] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(429),
  [1457] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(430),
  [1459] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(431),
  [1461] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(432),
  [1463] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(433),
  [1465] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(434),
  [1467] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [1469] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(730),
  [1471] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(731),
  [1473] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [1475] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 1),
  [1477] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(738),
  [1479] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [1481] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(739),
  [1483] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(739),
  [1485] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(443),
  [1487] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(444),
  [1489] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(744),
  [1491] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(745),
  [1493] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(745),
  [1495] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(749),
  [1497] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(185),
  [1500] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(750),
  [1502] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(751),
  [1504] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(752),
  [1506] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(753),
  [1508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(754),
  [1510] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(755),
  [1512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(756),
  [1514] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(756),
  [1516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(758),
  [1518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(759),
  [1520] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(759),
  [1522] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [1524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(763),
  [1526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(764),
  [1528] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(764),
  [1530] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(766),
  [1532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(766),
  [1534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(767),
  [1536] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(767),
  [1538] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [1540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(768),
  [1542] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(768),
  [1544] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(215),
  [1547] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(213),
  [1550] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(214),
  [1553] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(770),
  [1555] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 3),
  [1557] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1559] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(224),
  [1562] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(772),
  [1564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(773),
  [1566] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(774),
  [1568] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(775),
  [1570] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 1),
  [1572] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(776),
  [1574] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(777),
  [1576] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(778),
  [1578] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(778),
  [1580] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3),
  [1582] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(780),
  [1584] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(781),
  [1586] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(781),
  [1588] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_substitution, 3),
  [1590] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_process_substitution, 3),
  [1592] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(242),
  [1595] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(783),
  [1597] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(784),
  [1599] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(785),
  [1601] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(786),
  [1603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(787),
  [1605] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(788),
  [1607] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(789),
  [1609] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(789),
  [1611] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(791),
  [1613] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(792),
  [1615] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(792),
  [1617] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(794),
  [1619] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(796),
  [1621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(798),
  [1623] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(800),
  [1625] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(801),
  [1627] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(800),
  [1629] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(803),
  [1631] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(804),
  [1633] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(261),
  [1636] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(812),
  [1638] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(813),
  [1640] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(814),
  [1642] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(815),
  [1644] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(816),
  [1646] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(817),
  [1648] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(818),
  [1650] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(818),
  [1652] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(820),
  [1654] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(821),
  [1656] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(821),
  [1658] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(823),
  [1660] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(824),
  [1662] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(825),
  [1664] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(826),
  [1666] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(827),
  [1668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(828),
  [1670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(829),
  [1672] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(829),
  [1674] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(831),
  [1676] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(832),
  [1678] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(832),
  [1680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 2),
  [1682] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 2),
  [1684] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(834),
  [1686] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [1688] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [1690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(835),
  [1692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(836),
  [1694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 1),
  [1696] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 1),
  [1698] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(837),
  [1700] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(839),
  [1702] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(840),
  [1704] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__assignment, 2),
  [1706] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(841),
  [1708] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(843),
  [1710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(845),
  [1712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(847),
  [1714] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(848),
  [1716] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(847),
  [1718] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(850),
  [1720] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(851),
  [1722] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(860),
  [1724] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_while_statement, 3),
  [1726] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [1728] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(862),
  [1730] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(866),
  [1732] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(867),
  [1734] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(868),
  [1736] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 3),
  [1738] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3),
  [1740] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 3),
  [1742] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [1744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(870),
  [1746] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(870),
  [1748] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(871),
  [1750] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_bracket_command, 3),
  [1752] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [1754] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(872),
  [1756] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(873),
  [1758] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(874),
  [1760] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(875),
  [1762] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(876),
  [1764] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(877),
  [1766] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(878),
  [1768] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(879),
  [1770] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(880),
  [1772] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(875),
  [1774] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_local_variable_declaration, 3),
  [1776] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_local_variable_declaration, 3),
  [1778] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(313),
  [1781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(881),
  [1783] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(882),
  [1785] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(883),
  [1787] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(884),
  [1789] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(885),
  [1791] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(886),
  [1793] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(887),
  [1795] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(887),
  [1797] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(889),
  [1799] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(890),
  [1801] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(890),
  [1803] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 2),
  [1805] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(893),
  [1807] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(894),
  [1809] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(894),
  [1811] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(895),
  [1813] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(895),
  [1815] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_pipeline, 3),
  [1817] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [1819] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1821] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_list, 3, .fragile = true),
  [1823] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(897),
  [1825] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(897),
  [1827] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(899),
  [1829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(901),
  [1831] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(903),
  [1833] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(904),
  [1835] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(903),
  [1837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(906),
  [1839] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(907),
  [1841] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 1),
  [1843] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(915),
  [1845] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc_redirect, 2),
  [1847] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(114),
  [1850] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(336),
  [1853] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(116),
  [1856] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(117),
  [1859] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(118),
  [1862] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(119),
  [1865] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(120),
  [1868] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(336),
  [1871] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3),
  [1873] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1875] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(333),
  [1878] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2),
  [1880] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1882] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(334),
  [1885] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(334),
  [1888] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(335),
  [1891] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(335),
  [1894] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(919),
  [1896] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(920),
  [1898] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(920),
  [1900] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(922),
  [1902] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(922),
  [1904] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(923),
  [1906] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(923),
  [1908] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(924),
  [1910] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(924),
  [1912] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(352),
  [1915] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(352),
  [1918] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(350),
  [1921] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(351),
  [1924] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(351),
  [1927] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [1929] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [1931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(928),
  [1933] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(928),
  [1935] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [1937] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(930),
  [1939] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(931),
  [1941] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(931),
  [1943] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(933),
  [1945] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(935),
  [1947] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(936),
  [1949] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(937),
  [1951] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(937),
  [1953] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(938),
  [1955] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(939),
  [1957] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(940),
  [1959] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(940),
  [1961] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(941),
  [1963] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(942),
  [1965] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [1967] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [1969] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [1971] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [1973] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(943),
  [1975] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(944),
  [1977] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(943),
  [1979] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(946),
  [1981] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(947),
  [1983] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(949),
  [1985] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(951),
  [1987] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [1989] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(387),
  [1992] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(953),
  [1994] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(954),
  [1996] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(955),
  [1998] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(956),
  [2000] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(957),
  [2002] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(958),
  [2004] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(959),
  [2006] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(959),
  [2008] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(961),
  [2010] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(962),
  [2012] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(962),
  [2014] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(964),
  [2016] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(965),
  [2018] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(965),
  [2020] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(967),
  [2022] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(969),
  [2024] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(970),
  [2026] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(971),
  [2028] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(971),
  [2030] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(972),
  [2032] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(973),
  [2034] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(974),
  [2036] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(974),
  [2038] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(975),
  [2040] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(976),
  [2042] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [2044] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [2046] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(403),
  [2049] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(404),
  [2052] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(405),
  [2055] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(406),
  [2058] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(407),
  [2061] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(408),
  [2064] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(409),
  [2067] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(404),
  [2070] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(414),
  [2073] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(977),
  [2075] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(978),
  [2077] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(979),
  [2079] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(980),
  [2081] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(981),
  [2083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(982),
  [2085] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(983),
  [2087] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(983),
  [2089] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(985),
  [2091] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(986),
  [2093] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(986),
  [2095] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(988),
  [2097] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(989),
  [2099] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(989),
  [2101] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(991),
  [2103] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(993),
  [2105] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(994),
  [2107] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(995),
  [2109] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(995),
  [2111] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(996),
  [2113] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(997),
  [2115] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(998),
  [2117] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(998),
  [2119] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(999),
  [2121] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1000),
  [2123] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(428),
  [2126] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(429),
  [2129] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(430),
  [2132] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(431),
  [2135] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(432),
  [2138] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(433),
  [2141] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(434),
  [2144] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [2146] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2),
  [2148] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1002),
  [2150] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1003),
  [2152] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 2),
  [2154] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [2156] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1005),
  [2158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [2160] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(443),
  [2163] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [2165] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1007),
  [2167] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1008),
  [2169] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [2171] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [2173] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [2175] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1011),
  [2177] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1014),
  [2179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1015),
  [2181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1016),
  [2183] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1017),
  [2185] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1018),
  [2187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1019),
  [2189] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [2191] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1024),
  [2193] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1024),
  [2195] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [2197] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 2),
  [2199] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1026),
  [2201] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4),
  [2203] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1027),
  [2205] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1028),
  [2207] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 1),
  [2209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1029),
  [2211] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1030),
  [2213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1031),
  [2215] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1032),
  [2217] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1033),
  [2219] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1034),
  [2221] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1035),
  [2223] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1036),
  [2225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1037),
  [2227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1038),
  [2229] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1039),
  [2231] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1040),
  [2233] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1040),
  [2235] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1042),
  [2237] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1044),
  [2239] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1045),
  [2241] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1046),
  [2243] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1046),
  [2245] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1047),
  [2247] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1048),
  [2249] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1049),
  [2251] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1049),
  [2253] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1050),
  [2255] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1051),
  [2257] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1052),
  [2259] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1053),
  [2261] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1054),
  [2263] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1055),
  [2265] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1056),
  [2267] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1057),
  [2269] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1058),
  [2271] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1059),
  [2273] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1060),
  [2275] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1061),
  [2277] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1062),
  [2279] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1063),
  [2281] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1064),
  [2283] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1065),
  [2285] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1066),
  [2287] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 1),
  [2289] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 1),
  [2291] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1068),
  [2293] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [2295] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [2297] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 2),
  [2299] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1069),
  [2301] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1070),
  [2303] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1071),
  [2305] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1071),
  [2307] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1073),
  [2309] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1075),
  [2311] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1076),
  [2313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1077),
  [2315] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1077),
  [2317] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1078),
  [2319] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1079),
  [2321] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1080),
  [2323] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1080),
  [2325] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1081),
  [2327] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1082),
  [2329] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1083),
  [2331] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 2),
  [2333] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [2335] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1084),
  [2337] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 4),
  [2339] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [2341] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1085),
  [2343] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1085),
  [2345] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1088),
  [2347] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1090),
  [2349] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 4),
  [2351] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [2353] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 4),
  [2355] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [2357] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1092),
  [2359] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1093),
  [2361] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1095),
  [2363] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1097),
  [2365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1099),
  [2367] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1100),
  [2369] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1099),
  [2371] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1102),
  [2373] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1103),
  [2375] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1111),
  [2377] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1112),
  [2379] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1113),
  [2381] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1114),
  [2383] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1115),
  [2385] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1116),
  [2387] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 3),
  [2389] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1118),
  [2391] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1118),
  [2393] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1120),
  [2395] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1121),
  [2397] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1121),
  [2399] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1123),
  [2401] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1125),
  [2403] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1126),
  [2405] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1127),
  [2407] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1127),
  [2409] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1128),
  [2411] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1129),
  [2413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1130),
  [2415] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1130),
  [2417] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1131),
  [2419] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1132),
  [2421] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 2),
  [2423] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1133),
  [2425] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4),
  [2427] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [2429] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1137),
  [2431] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1137),
  [2433] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(645),
  [2436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1139),
  [2438] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1140),
  [2440] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1141),
  [2442] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1142),
  [2444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1143),
  [2446] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1144),
  [2448] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1145),
  [2450] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1145),
  [2452] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1147),
  [2454] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1148),
  [2456] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1148),
  [2458] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1150),
  [2460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1152),
  [2462] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1153),
  [2464] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1154),
  [2466] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1154),
  [2468] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1155),
  [2470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1156),
  [2472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1157),
  [2474] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1157),
  [2476] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [2478] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [2480] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(659),
  [2483] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2),
  [2485] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(661),
  [2488] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(662),
  [2491] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1158),
  [2493] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1159),
  [2495] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1160),
  [2497] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1161),
  [2499] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1162),
  [2501] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1163),
  [2503] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1164),
  [2505] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(683),
  [2508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1165),
  [2510] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1166),
  [2512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1167),
  [2514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1168),
  [2516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1169),
  [2518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1170),
  [2520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1171),
  [2522] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1171),
  [2524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1173),
  [2526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1174),
  [2528] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1174),
  [2530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1176),
  [2532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1177),
  [2534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1178),
  [2536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1179),
  [2538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1180),
  [2540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1181),
  [2542] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(714),
  [2545] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1182),
  [2547] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1183),
  [2549] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1184),
  [2551] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1185),
  [2553] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1186),
  [2555] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1187),
  [2557] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1188),
  [2559] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1188),
  [2561] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1190),
  [2563] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1191),
  [2565] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1191),
  [2567] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6),
  [2569] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3),
  [2571] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [2573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1194),
  [2575] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1195),
  [2577] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1195),
  [2579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1197),
  [2581] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1199),
  [2583] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [2585] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [2587] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(161),
  [2590] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(745),
  [2593] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(163),
  [2596] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(164),
  [2599] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(165),
  [2602] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(166),
  [2605] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(167),
  [2608] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(745),
  [2611] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1202),
  [2613] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1203),
  [2615] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1204),
  [2617] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1205),
  [2619] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1206),
  [2621] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6),
  [2623] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1208),
  [2625] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1209),
  [2627] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1210),
  [2629] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 1),
  [2631] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1211),
  [2633] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5),
  [2635] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1212),
  [2637] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1213),
  [2639] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1214),
  [2641] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1215),
  [2643] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(798),
  [2646] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1216),
  [2648] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1217),
  [2650] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1218),
  [2652] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1219),
  [2654] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1220),
  [2656] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1221),
  [2658] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1222),
  [2660] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1222),
  [2662] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1224),
  [2664] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1225),
  [2666] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1225),
  [2668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1227),
  [2670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1228),
  [2672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1229),
  [2674] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1230),
  [2676] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1231),
  [2678] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1232),
  [2680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1233),
  [2682] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1234),
  [2684] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1235),
  [2686] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1236),
  [2688] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 1),
  [2690] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 1),
  [2692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [2694] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [2696] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 3),
  [2698] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(845),
  [2701] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1237),
  [2703] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1238),
  [2705] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1239),
  [2707] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1240),
  [2709] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1241),
  [2711] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1242),
  [2713] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1243),
  [2715] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1243),
  [2717] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1245),
  [2719] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1246),
  [2721] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1246),
  [2723] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 3),
  [2725] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [2727] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 5),
  [2729] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [2731] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1249),
  [2733] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5),
  [2735] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [2737] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1251),
  [2739] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 5),
  [2741] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [2743] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 5),
  [2745] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [2747] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1254),
  [2749] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1255),
  [2751] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1256),
  [2753] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1256),
  [2755] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1258),
  [2757] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1260),
  [2759] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1261),
  [2761] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1262),
  [2763] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1262),
  [2765] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1263),
  [2767] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1264),
  [2769] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1265),
  [2771] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1265),
  [2773] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1266),
  [2775] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1267),
  [2777] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1268),
  [2779] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1269),
  [2781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1270),
  [2783] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1271),
  [2785] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(901),
  [2788] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1272),
  [2790] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1273),
  [2792] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1274),
  [2794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1275),
  [2796] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1276),
  [2798] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1277),
  [2800] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1278),
  [2802] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1278),
  [2804] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1280),
  [2806] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1281),
  [2808] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1281),
  [2810] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 3),
  [2812] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1284),
  [2814] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1285),
  [2816] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1286),
  [2818] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1287),
  [2820] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1288),
  [2822] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1289),
  [2824] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1290),
  [2826] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1291),
  [2828] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1292),
  [2830] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1293),
  [2832] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1294),
  [2834] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1295),
  [2836] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1296),
  [2838] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1296),
  [2840] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1298),
  [2842] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1299),
  [2844] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1299),
  [2846] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1301),
  [2848] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1302),
  [2850] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1303),
  [2852] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1304),
  [2854] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1305),
  [2856] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1306),
  [2858] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1307),
  [2860] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1308),
  [2862] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1309),
  [2864] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1310),
  [2866] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1311),
  [2868] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1312),
  [2870] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1313),
  [2872] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1314),
  [2874] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1315),
  [2876] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1316),
  [2878] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1317),
  [2880] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1318),
  [2882] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1319),
  [2884] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1320),
  [2886] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4),
  [2888] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [2890] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2),
  [2892] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3),
  [2894] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [2896] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [2898] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1321),
  [2900] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1007),
  [2903] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [2905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1324),
  [2907] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1325),
  [2909] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1326),
  [2911] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1327),
  [2913] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 1),
  [2915] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6),
  [2917] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1328),
  [2919] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1329),
  [2921] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1330),
  [2923] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1331),
  [2925] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1332),
  [2927] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1333),
  [2929] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1334),
  [2931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1335),
  [2933] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1336),
  [2935] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1337),
  [2937] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1338),
  [2939] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1339),
  [2941] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 2),
  [2943] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 2),
  [2945] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7),
  [2947] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7),
  [2949] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1340),
  [2951] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1341),
  [2953] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1342),
  [2955] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1343),
  [2957] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1344),
  [2959] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1345),
  [2961] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_for_statement, 6),
  [2963] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6),
  [2965] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 6),
  [2967] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [2969] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1346),
  [2971] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6),
  [2973] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [2975] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1347),
  [2977] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 6),
  [2979] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6),
  [2981] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1097),
  [2984] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1348),
  [2986] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1349),
  [2988] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1350),
  [2990] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1351),
  [2992] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1352),
  [2994] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1353),
  [2996] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1354),
  [2998] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1354),
  [3000] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1356),
  [3002] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1357),
  [3004] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1357),
  [3006] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1359),
  [3008] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1360),
  [3010] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1361),
  [3012] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1362),
  [3014] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1363),
  [3016] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1364),
  [3018] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1365),
  [3020] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1366),
  [3022] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1367),
  [3024] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1368),
  [3026] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1369),
  [3028] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1370),
  [3030] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1371),
  [3032] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1372),
  [3034] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1373),
  [3036] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1374),
  [3038] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1375),
  [3040] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1376),
  [3042] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1377),
  [3044] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1378),
  [3046] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1379),
  [3048] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1380),
  [3050] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1381),
  [3052] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1382),
  [3054] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1383),
  [3056] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1384),
  [3058] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1385),
  [3060] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1386),
  [3062] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1387),
  [3064] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1388),
  [3066] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4),
  [3068] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [3070] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [3072] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1389),
  [3074] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 2),
  [3076] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 7),
  [3078] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1390),
  [3080] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1391),
  [3082] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1392),
  [3084] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1393),
  [3086] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1394),
  [3088] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1395),
  [3090] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1396),
  [3092] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1397),
  [3094] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 7),
  [3096] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [3098] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7),
  [3100] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [3102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1398),
  [3104] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1399),
  [3106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1400),
  [3108] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1401),
  [3110] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1402),
  [3112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1403),
  [3114] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1404),
  [3116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1405),
  [3118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1406),
  [3120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1407),
  [3122] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1408),
  [3124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1409),
  [3126] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1410),
  [3128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1411),
  [3130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1412),
  [3132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1413),
  [3134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1414),
  [3136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1415),
  [3138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1416),
  [3140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1417),
  [3142] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 5),
  [3144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [3146] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [3148] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1418),
  [3150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1419),
  [3152] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1420),
  [3154] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1421),
  [3156] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1422),
  [3158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1423),
  [3160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1424),
  [3162] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1425),
  [3164] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1426),
  [3166] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1427),
  [3168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1428),
  [3170] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1429),
  [3172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1430),
  [3174] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1431),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
